INCLUDE erromid.h
INCLUDE cas2extdec.h
INCLUDE keydefs.h
INCLUDE global.s

	STITLE	Checking and Converting


**********************************************************************
* Matrix checking and numeric<->symbolic conversion
*
* TYPEMATRIX?	( obj -> flag )
*		flag is true is obj is a symbolic matrix 1 or 2-d
*
* DTYPEMATRIX?	( obj -> obj flag )
*		flag is true is obj is a symbolic matrix 1 or 2-d
*
* 2DMATRIX?	( matrix -> matrix flag )
*		flag is true if symbolic matrix is 2-d (i.e. a matrix)
*
* MDIMS		( M -> #m #n TRUE | #n FALSE )
*		Return dimensions like 48MDIMS but works for symbolic arrays 
*
* SAMEMATRIX	( M2 M1 -> M2 M1 flag )
*		If M2 and M1 are symbolic matrices of same type returns
*		true if symbolic and false otherwise
*		Otherwise converts M1 and M2 to symbolic, returns true
*
* SAMEMATSCTYPE		( M obj -> M obj flag )
*		Converts M to symbolic form if obj is not a numeric real/cmplx
*
* ARRAY2MATRIX	( array -> list )
*		Numeric to symbolic matrix conversion
* 
* MATRIX2META	( list -> array )
*		Symbolic to numeric vector/matrix conversion [if possible]
*
*	CKFPOLYext	( obj -> obj ) 
*			SIZEERR error if :: or NULL{} in object
*	CK2FPOLY	( obj2, obj1 )
*			SIZEERR if obj2 or obj1 contains :: or NULL{}
*	DTYPENDO?	( obj -> obj, flag ) 
*			tests if obj is a square symbolic matrix
*	DTYPFMAT?    ( obj -> obj, flag ) 
*			tests if obj is a symbolic matrix
**********************************************************************



**********************************************************************
* Stack:	( obj -> flag )
**********************************************************************
NULLNAME TYPEIRRQ?
::
**********************************************************************
* Stack:	( obj -> obj flag )
**********************************************************************
  NULLNAME DTYPEIRRQ?
  LABEL DUPTYPEIRRQ?
  CODE
	C=DAT1	A
	CD1EX
	A=DAT1	10
	CD1EX
	C=A	W
	LCIRRQ
	?A=C	W
	GOYES	+
	GOVLNG	=PushFLoop
+	GOVLNG	=PushTLoop
  ENDCODE
  SWAPDROP
;

**********************************************************************
* Desc:		Like dLISTcase for matrices
* Stack:	( obj -> obj  )
*		moved to bank 1
**********************************************************************
*LABEL dMATRIXcase
*::
*  DTYPEMATRIX? COLAcase
*;

**********************************************************************
* Desc:		Like NOTLISTcase for matrices
* Stack:	( obj -> obj  )
**********************************************************************
LABEL NOTMATRIXcase
::
  DTYPEMATRIX? COLANOTcase
;

**********************************************************************
* Desc:		Convert symbolic matrix with real/cmplx entries
*		to a numeric array
* Stack:	( obj -> obj  )
**********************************************************************
NULLNAME BESTMATRIXTYPE
::
  DUP 
ASSEMBLE
	IF	f39
RPL
  ListToArry
ASSEMBLE
	ELSE	f39
RPL
  FLASHPTR ListToArry
ASSEMBLE
	ENDIF	f39
RPL		
					( obj newob true | obj false )
  case SWAPDROP				( obj|newob )
;

**********************************************************************
* Desc:		Change type from list to array
* Stack:	( {} --> [] )
* Note:		no checks on the element type
**********************************************************************
NULLNAME {}TO[]
::
  TYPEMATRIX CHANGETYPE
;

**********************************************************************
* Desc:		Change type from array to list
* Stack:	( [] --> {} )
**********************************************************************
NULLNAME []TO{}
::
  TYPELIST
  CHANGETYPE
;


**********************************************************************
* Desc:		Tests null array
* Stack:	( obj --> obj flag )
**********************************************************************
NULLNAME DUPNULL[]?
::
  DUP NULL[]
  EQUAL
;

**********************************************************************
* Desc:		Size of an array
* Stack:	( arry --> array #n [#m] false[true] )
* Note:		like 48 MDIMS
**********************************************************************
NULLNAME MDIMS
::
  dARRYcase 48MDIMS
  DTYPEMATRIX? NcaseTYPEERR
  DUPLENCOMP SWAP CARCOMP		( #n obj )
  DTYPEMATRIX? NOTcase DROPFALSE
  LENCOMP TRUE
;

**********************************************************************
* Desc:		Size of an array
* Stack:	( arry --> {} )
* Note:		like 48 DIMLIMITS (i.e. like SIZE but length are #, not %)
**********************************************************************
NULLNAME DIMLIMITS
:: 
  NOTMATRIXcase 48DIMLIMITS
  DUPLENCOMP SWAP CARCOMP 		( # obj )
  DTYPEMATRIX? NOTcasedrop ONE{}N 	( -> {#} )
  LENCOMP TWO{}N 			( { # # } )
;

**********************************************************************
* Desc:		Test if arry1 and 2 have the same size
* Stack:	( arry1 arry2 --> arry1 arry2 flag )
**********************************************************************
NULLNAME CKSAMESIZE
::
  OVER DIMLIMITS
  OVER DIMLIMITS
  EQUAL
;

**********************************************************************
* Desc:		Test if object is a square symbolic matrix.
* Stack:	( ob --> ob flag )
* Note:		Convert numeric array to symbolic matrix
**********************************************************************
NULLNAME DTYPENDO?
::
  ARRAY2MATRIX
  DTYPFMAT? NOTcaseFALSE
  DUPLENCOMP OVER CARCOMP LENCOMP #=
;

**********************************************************************
* Desc:		Test if object is a symbolic matrix
* Stack:	( ob --> ob flag )
**********************************************************************
NULLNAME DTYPFMAT?
::
  ( obj -> matrice formelle, true ou obj, false )

  NOTMATRIXcase FALSE
  CKFPOLYext
  INNERDUP #1-SWAP
  ZERO_DO	 
     get1 DUPTYPETAG? IT STRIPTAGS
  SWAPLOOP
  #1+ []N
  DUP CARCOMP
  NOTMATRIXcase DROPFALSE
  OVERSWAP LENCOMP

  ( matrix, matrix, length of 1st comp of matrix )
  '
    :: ( obj, longueur -> false si obj est une liste de longueur #= )
       SWAP DTYPEMATRIX? NOTcase2drop TRUE
       LENCOMP #<>
    ;
  POSCOMP
  ( matrix, 1st occurence )
  #0=
  ( matrix, flag )
;

**********************************************************************
* Desc:		Test if obj is a numeric array
* Stack:	( obj --> obj  )
* Note:		Tries to convert symbolic array to numeric array
**********************************************************************
NULLNAME CKNUMARRY
::
  DTYPEMATRIX? IT MATRIX2ARRAY
  DUP TYPERARRY? ?SEMI
  DUP TYPECARRY? NcaseTYPEERR
;

**********************************************************************
* Desc:		Test if object is a 2-d matrix
* Stack:	( obj --> obj flag  )
**********************************************************************
NULLNAME 2DMATRIX?
::
  DTYPEMATRIX? NOTcaseFALSE
  DUP CARCOMP TYPEMATRIX?
;

**********************************************************************
* Desc:		Return symbolic matrix dimensionnality of an object
* Stack:	( obj --> #  )
**********************************************************************
NULLNAME MATRIXDIM
::
  DTYPEMATRIX? NOTcase DROPZERO
  CARCOMP TYPEMATRIX? case TWO ONE
;

**********************************************************************
* Desc:		If one object is a symbolic array, convert both
*		arrays to symbolic form 
*		Returns TRUE for symbolic matrices and FALSE for numeric
* Stack:	( M1 M2 -> M1 M2 flag )
**********************************************************************
NULLNAME SAMEMATRIX
::
  DTYPEMATRIX? 3PICK TYPEMATRIX?	( M1 M2 flag2 flag1 )
  XOR NOTcase DTYPEMATRIX?		( -> M1 M2 flag )
  SWAP ARRAY2MATRIX
  SWAP ARRAY2MATRIX			( M1 M2 as symbolic matrices )
  TRUE					( M1 M2 true )
;

**********************************************************************
* Desc:		If M is a numeric matrix and obj is not float, convert matrix
*		to symbolic form 
*		Returns TRUE for symbolic and FALSE for numeric
* Stack:	( M obj -> M obj flag )
**********************************************************************
NULLNAME SAMEMATSCTYPE
::
  CKMATRIXELEM
  OVER TYPEMATRIX? caseTRUE	( -> M obj true )
				( M obj )
  FLOAT? caseFALSE		( -> M obj FALSE )
				( M obj )
  SWAP ARRAY2MATRIX SWAPTRUE	( M obj true )
;

**********************************************************************
* Desc:		Checks that obj is a valid internal matrix element
* Stack:	( obj -> obj )
* Note:		look for CK[]NCK for user matrix element
**********************************************************************
NULLNAME CKMATRIXELEM
::
  CK&DISPATCH1
  sym NOP
  real NOP
  TWO NOP
  ereal NOP
  ecmp NOP
  EXT NOP
  list NOP
  seco NOP  ( necessary for internal square-root )
* note that zint is here for 48 compatibility
*  zint NOP
;

**********************************************************************
* Desc:		Try to convert a symbolic matrix to a numeric one
* Stack:	( matrix --> array|matrix )
**********************************************************************
NULLNAME MATRIX2ARRAY
::
  QOBJext CASCRUNCH XEQARRY> XEQ>ARRY
;

**********************************************************************
* Desc:		Convert a symbolic matrix to a list
* Stack:	( matrix --> list )
*		( obj --> obj )
**********************************************************************
NULLNAME MATRIX2LIST
::
  MATRIX2LIST49 
* LIST2LIST39
;

LABEL MATRIX2LIST49
::
  ARRAY2MATRIX DTYPEMATRIX? NOT?SEMI
  DUP >R LENCOMP ZEROSWAP	( meta #n )
  ZERO_DO (DO)
    RSWAP 'R RSWAP		( meta ak )
    MATRIX2LIST SWAP#1+
  LOOP
  {}N
;

LABEL LIST2LIST39
::
ASSEMBLE
	IF	f39
RPL
  DUPTYPELIST? NOT?SEMI
  INNERDUP ' xFmList SWAP #2+ SYMBN
ASSEMBLE
	ENDIF	f39
RPL
;

**********************************************************************
* Desc:		Convert a symbolic list to a matrix
* Stack:	( list --> matrix )
*		( obj --> obj )
* Note:		does not check that matrix is a valid one
*		use DTYPFMAT? to do that
**********************************************************************
NULLNAME LIST2MATRIX
::
  CK&DISPATCH1
ASSEMBLE
	IF	f39
RPL
  symb list2matrix
ASSEMBLE
	ENDIF	f39
RPL
  sym  NOP
  list list2matrix
  real NOP
  cmp  NOP
  EXT  NOP
  arry NOP
;

LABEL list2matrix
::
  DUPNULL{}? NOT NOT?DIMERR
ASSEMBLE
	IF	f39
RPL
  DUP LASTCOMP EQ: xFmList
  IT :: EXPR> DROP COERCE {}N ;
  DUPTYPESYMB? ?SEMI
ASSEMBLE
	ENDIF	f39
RPL
  DUP >R LENCOMP ZEROSWAP	( meta #n )
  ZERO_DO (DO)
    RSWAP 'R RSWAP		( meta ak )
    LIST2MATRIX SWAP#1+
  LOOP
				( meta )
  []N 

  ( * now check that all element have the same length * )
  CKCOHERENTLIST
;

NULLNAME LENMATRIX
::
  NOTMATRIXcase DROPZERO LENCOMP
;

**********************************************************************
* Desc:		Explode a matrix a la ARRY->
* Stack:	( {} --> meta-arry )
**********************************************************************
NULLNAME XEQARRY>
::
  DUPTYPEARRY? case 48XEQARRY>
  DTYPEMATRIX? NcaseTYPEERR
  DUPNULL[]? caseSIZEERR
  MATEXPLODE
  DIMLIMITS UNCOERCELIST
;

NULLNAME MATEXPLODE
( matrix/vector -> a11..anm M )
::
  DUP1LAMBIND LENCOMP			( # )
  #1+_ONE_DO (DO)			( ... )
    1GETLAM INDEX@ NTHCOMPDROP		( ... line )
    DTYPEMATRIX? IT INCOMPDROP		( ... )
  LOOP
  1GETABND 
;

**********************************************************************
* Desc:		Convert array to symbolic array if necessary
* Stack:	( arry --> matrix )
*		( matrix -> matrix )
**********************************************************************
NULLNAME ARRAY2MATRIX
::
  DUPTYPETAG? IT STRIPTAGS
  DUPTYPEARRY? NOT?SEMI
  XEQARRY> CKARRYLIST			( ob1 ... obn { # [#] } )	
  BUILDMATRIX				( [] )
;

**********************************************************************
* Desc:		Builds a matrix a la ->ARRY
* Stack:	( ob1...obn { % [%] } --> meta-arry )
**********************************************************************
NULLNAME XEQ>ARRY
LABEL XEQ>ARRAY
::
  CKARRYLIST 					( ob1 ... obn { # [#] } )
  DUPINCOMP #1=?SKIP #*OVF 			( ob1 ... obn { # [#] } # )
  XEQ>ARRAY1					( array )
;

NULLNAME XEQ>ARRAY1
::						( ob1 ... obn { # [#] } # )
  >ARRAYCHECK					( ob1 ... obn { # [#] } # obj )
  DUPEQ: ZERO casedrop CK&MKMATRIX		( -> symbolic matrix )
  ROTSWAP 					( ob1 ... obn # { # [#] } obj )
  ( * make constant array * )
  MAKEARRY 					( ob1 ... obn # array )
  ( * move ob1 .. obn in the array in place * )
  !>ARRAY 					( array )
;

LABEL CK&MKMATRIX
::					( ob1 ... obn { # [#] } # )
  DEPTH #2- #>case SETSTACKERR
  					( ob1 ... obn { # [#] } )
  BUILDMATRIX
;

LABEL BUILDMATRIX
( ob1 ... obn { # [#] } -> matrix )	
::				( ob1 ... obn { # [#] } )
  INNER#1=			( a11 ... anm #m #n false | a1 .. an #n true )
  case CK[]N			( -> vector )
				( a11 ... anm #n #m )
  ZERO ROT			( a11 ... anm #m #0 #n )
  ZERO_DO (DO)			( a11 ... anm #m meta )
     psh DUP			( a11 ... an-1m meta an1 ... anm #m #m )
     OBJ>R CK[]N SWAP#1+ R>OBJ	( a11 ... an-1m meta #m )
     OVER#2+UNROLL		( a11 ... an-1m #m meta )
  LOOP
  reversym []N SWAPDROP		( [] )
;

LABEL CK[]N
* Like []N but checks that element are valid vector entries
* (real, cmplx, sym )
::			( meta )
  dup			( meta meta )
  ZERO_DO (DO)
    CK[]NCK		( meta o1..ok )
  LOOP
  []N			( -> vector )
;

LABEL CK[]NCK
:: 
  CK&DISPATCH1
  real DROP
  TWO  DROP
  sym  DROP
;

**********************************************************************
* Stack:	( obj -> obj )
* Desc:		checks that an object is real/cmplx/unit or idnt/lam/symbolic
**********************************************************************
NULLNAME CKALG
::
  CKALG? NcaseTYPEERR
;

LABEL CKALG?
::
  CK&DISPATCH1
  real TRUE
  cmp  TRUE
  sym  TRUE
  EXT  TRUE
  any  FALSE
;

**********************************************************************
* Stack:	( obj -> flag )
**********************************************************************
NULLNAME TYPEZ?
::
**********************************************************************
* Stack:	( obj -> obj flag )
**********************************************************************
NULLNAME DUPTYPEZ?
  CODE
	GOSBVL	=a=stk1
	LC(5)	=DOINT
	?A=C	A
	GOYES	+
	GOVLNG	=PushFLoop
+	GOVLNG	=PushTLoop
  ENDCODE
  SWAPDROP
;


**********************************************************************
* Desc:		Object conversions with validity checks.
* Stack:	( ob1 .. obn --> Z1 .. Zn / Error )
**********************************************************************

NULLNAME CK1Z
::
  CK&DISPATCH0
	zint	H>Z
	real	R>Z
	str	S>Z
;

NULLNAME CK2Z
::
  CK1Z SWAP CK1Z SWAP
;

NULLNAME CK3Z
::
  CK1Z ROT CK1Z ROT CK1Z ROT
;

**********************************************************************
* Desc:		Check object is integer or Gaussian integer.
* Stack:	( ob --> ob )
**********************************************************************
NULLNAME CK1Cext
::
  DUPTYPEZ? ?SEMI
  DUPTYPECOL? NcaseTYPEERR
  DUPLENCOMP #2= NcaseTYPEERR	
;

**********************************************************************
* Desc:		Convert Gaussian integer to long complex
* Stack:	( C --> C%% )
**********************************************************************
NULLNAME C2C%%
::
  CXRIext
  ZZ2C%%ext
;

**********************************************************************
* Desc:		Convert Gaussian integer to long complex
* Stack:	( Zre Zim --> C%% )
**********************************************************************
NULLNAME ZZ2C%%ext
::
  Z2%% SWAP
  Z2%% SWAP
  E%%>C%%
;

**********************************************************************
* Desc:		Convert integer to long real
* Stack:	( Z --> %% )
**********************************************************************
NULLNAME Z2%%
::
  Z>R %>%%
;

**********************************************************************
* Desc:		Convert complex to long complex
* Stack:	( C% --> C%% )
**********************************************************************
NULLNAME C%>C%%
::	
  CLREXACT
  C%>%% E%%>C%%
;

*********************************************************************
* Desc:		Convert long reals to long complex
* Stack:	( %%re %%im --> C%% )
*********************************************************************
NULLNAME E%%>C%%
CODE
L%%>C%%	GOSBVL	=SAVPTR
	C=DAT1	A
	D0=C
	D0=D0+	5
	A=DAT0	W
	R0=A
	D1=D1+	5
	C=DAT1	A

	D0=D0+	16
	A=DAT0	A
	R1=A
	D0=C
	D0=D0+	5
	A=DAT0	W
	R2=A
	D0=D0+	16
	A=DAT0	A
	R3=A
	LC(5)	#2F
	GOSBVL	=GETTEMP
	LC(5)	=DOECMP
	DAT0=C	A
	AD0EX
	D1=A
	D1=D1+	5
	C=R2
	DAT1=C	W
	C=R3
	D1=D1+	16
	DAT1=C	A
	D1=D1+	5
	C=R0
	DAT1=C	W
	D1=D1+	16
	C=R1
	DAT1=C	A
	GOSBVL	=GETPTR
	D1=D1+	5
	D=D+1	A
	DAT1=A	A
	A=DAT0	A
	D0=D0+	5
	PC=(A)
ENDCODE

**********************************************************************
* Desc:		Convert real to integer and adjust internal
*		mode if number is not an integer.
* Stack:	( % --> %%/Z )
**********************************************************************
NULLNAME R2Zext
::
  DUPDUP %FLOOR %= 		( % flag )
  case R>Z			( -> Z )
  EXACTOFF %>%%			( --> %% and internal mode adjusted )
;

**********************************************************************
* Desc:		Convert Z to string number. The number is embedded
*		in a symbolic to enable using it in algebraics.
* Stack:	( Z --> '$Z' )
**********************************************************************
NULLNAME Z2Sext
::
*  Z0 EQUALcasedro "0"		( Bernard: How come not '"0"' ? )
  Z>S ONE SYMBN
;

***********************************************************************
*	Non integer checking
***********************************************************************

**********************************************************************
* Desc:		Error if list contains secondaries or empty lists.
* Stack:	( obj -> obj ou ERROR )
**********************************************************************
NULLNAME CKFPOLYext
::
  DUP
  DUPTYPECOL? caseSIZEERR
  DUPTYPELIST? NOTcaseDROP
  '
    :: DUPTYPECOL? caseSIZEERR
       DUPTYPELIST? NOTcaseDROP
       DUPNULL{}? caseSIZEERR
       INNERCOMP
       ZERO_DO (DO)
          1GETLAM EVAL
       LOOP
     ;
  DUP1LAMBIND EVAL ABND
;

**********************************************************************
* Desc:		Validity check for two lists.
* Stack:	( obj obj --> obj obj OR error )
**********************************************************************
NULLNAME CK2FPOLY ( -> )
::
  CKFPOLYext SWAP
  CKFPOLYext SWAP
;


**********************************************************************
* Desc:		Test if obj is idnt or lam
* Stack:	( obj --> obj flag )
**********************************************************************
NULLNAME IDNTLAM?
::
  CK&DISPATCH1
  idnt TRUE
  lam  TRUE
  any  FALSE
;

**********************************************************************
* Desc:		Test if obj is real or complex
* Stack:	( obj --> obj flag )
**********************************************************************
NULLNAME FLOAT?
::
  CK&DISPATCH1
  real 	   TRUE
  TWO      TRUE
  zint     FALSE
  sym      FALSE
  list	   FALSE
  SIXTYTHREE ( %% ) TRUE
  # 4F TRUE
;

**********************************************************************
* Desc:		Bad arg type if obj is not a real/cmp/symp
* Stack:	( obj --> obj  )
**********************************************************************
NULLNAME CKSYMREALCMP
::
  CK&DISPATCH1
  real 	   NOP
  TWO      NOP
  sym      NOP
;

LABEL INTERNFLOAT?
::
  CK&DISPATCH1
  seco FALSE
  any FLOAT?
;

**********************************************************************
* Desc:		Test if obj is idnt or lam
* Stack:	( obj --> flag )
**********************************************************************
NULLNAME TYPEIDNTLAM?
::
  IDNTLAM? SWAPDROP
;

**********************************************************************
* Desc:		Test if obj is real, zint or hxs
* Stack:	( obj --> obj flag )
**********************************************************************
NULLNAME REAL?
::
  CK&DISPATCH1
  zint TRUE
  real TRUE
  hxs  TRUE
  any  FALSE
;

**********************************************************************
* Desc:		Test if obj is real, zint or hxs
* Stack:	( obj --> flag )
**********************************************************************
NULLNAME TYPEREALZINT?
::
  REAL? SWAPDROP
;

**********************************************************************
* Desc:		Transform obj in real
* Stack:	( obj --> obj )
**********************************************************************
NULLNAME OBJ2REAL
::
  CK&DISPATCH1
  zint	Z>R
  real	NOP
;


**********************************************************************
* Desc:		Test if Meta is an integer
* Stack:	( Meta --> Meta flag )
**********************************************************************
NULLNAME METAINT?
::
  DUP#1= NOTcaseFALSE
  DROP OBJINT? ONESWAP
;

**********************************************************************
* Desc:		Test if Meta is a positive integer smaller than Zsmall
* Stack:	( Meta --> Meta flag )
**********************************************************************
NULLNAME METAPOSINT?
::
  DUP#1= NOTcaseFALSE
  DROP OBJPOSINT? ONESWAP
;

**********************************************************************
* Desc:		Test if Obj is an integer
* Stack:	( Obj --> Obj flag )
**********************************************************************
NULLNAME OBJINT?
::
  CLEANIDLAM
  DUPTYPEBINT? IT #>Z
  DUPTYPEZ? caseTRUE
  DUPTYPEREAL? NOTcaseFALSE
  DUPDUP %FLOOR %= NOTcaseFALSE
  R>Z TRUE
;

**********************************************************************
* Desc:		Test if Obj is a positive integer smaller than Zsmall
* Stack:	( Obj --> Obj flag )
**********************************************************************
NULLNAME OBJPOSINT?
::
  OBJINT? NOTcaseFALSE
  DupZIsNeg? caseFALSE
  DUP Zsmall ZNLT? 
;

**********************************************************************
* Desc:		Test if Obj is a strictly positive integer
* Stack:	( Obj --> Obj flag )
**********************************************************************
NULLNAME CKINT>0
::
  OBJINT? NcaseTYPEERR
  Z># DUP#0<>
;


**********************************************************************
* Desc:		Coerce Z to #, overflow error if Z<0 or Z> 99 999 
* Stack:	( zint --> # )
* Note:		10000 is used to insure that the #*6 can be represented
*		in BCD on a 5 nibbles field
**********************************************************************
NULLNAME Z>#
::
  DupZIsNeg? case Z<0ERR
  DUP ZINT 10000 ZNLT? NOTcase Z>#ERR
  Z2BIN
;


**********************************************************************
* Desc:		Like dREALNcase but for integers
* Stack:	( obj -> obj )
* Note:		if obj is zint then skip else cola next object
**********************************************************************
LABEL dZINTNcase
::
  DUPTYPEZ? NOT COLAcase
;

**********************************************************************
* Desc:		A generic 0=case dispatch with polynomial trimming
* Stack:
**********************************************************************
LABEL num0case
::
  NOTLISTcase num#0=case
  TRIMOBJext
  DUP Z0 EQUAL COLAcase
;

**********************************************************************
* Desc:		Generic num0=case
* Stack:
**********************************************************************
LABEL num#0=case
::
  NEWTRIMext
  CK&DISPATCH0
  zint  Z0=case
  real  %0=case
  TWO   C%0=case
  ereal :: DUP %%0= COLAcase ;
  ecmp  :: DUP C%%0= COLAcase ;
  any   SKIP
;

**********************************************************************
* Desc:		Generic num1=case
* Stack:
**********************************************************************
LABEL num#1=case
::
  NEWTRIMext
  CK&DISPATCH0
  zint  Z1=case
  real  %1=case
  TWO   C%1=case
  ereal :: DUP %%1 EQUAL COLAcase ;
  ecmp  :: DUP C%%1 EQUAL COLAcase ;
  any   SKIP
;

**********************************************************************
* Desc:		Generic num-1=case
* Stack:
**********************************************************************
LABEL num#-1=case
::
  NEWTRIMext
  CK&DISPATCH0
  zint  Z-1=case
  real  %-1=case
  TWO   C%-1=case
  ereal :: DUP %% -1 EQUAL COLAcase ;
  ecmp  :: DUP C%% 0 -1 EQUAL COLAcase ;
  any   SKIP
;

**********************************************************************
* Desc:		Integer num0=case
* Stack:
**********************************************************************
LABEL Z0=case
::
  DUP Z0 EQUAL COLAcase
;
**********************************************************************
* Desc:		Integer num1=case
* Stack:
**********************************************************************
LABEL Z1=case
::
  DUP Z1 EQUAL COLAcase
;
**********************************************************************
* Desc:		Integer num-1=case
* Stack:
**********************************************************************
LABEL Z-1=case
::
  DUP Z-1 EQUAL COLAcase
;

* --------------------------------------------------------------------
* Desc:		Like j%0=case but handles all objects
* Stack:	( obj -> )
* --------------------------------------------------------------------
LABEL j#0=case
::
  CK&DISPATCH0
  real j%0=case
  zint jZ0=case
  any  :: 'R 2DROP ;
;

* --------------------------------------------------------------------
* Desc:		Like j%0=case for integers
* Stack:	( obj -> )
* --------------------------------------------------------------------
LABEL jZ0=case
::
  Z0 EQUAL COLAcase
;

* --------------------------------------------------------------------
* Desc:		Like j%1=case but handles all objects
* Stack:	( obj -> )
* --------------------------------------------------------------------
LABEL j#1=case
::
  CK&DISPATCH0
  real j%1=case
  zint jZ1=case
  any  'R2DROP
;

LABEL 'R2DROP
:: 
  'R 2DROP 
;

* --------------------------------------------------------------------
* Desc:		Like j%1=case for integers
* Stack:	( obj -> )
* --------------------------------------------------------------------
LABEL jZ1=case
::
  Z1 EQUAL COLAcase
;

* --------------------------------------------------------------------
* Desc:		Like j%0=case for %1
* Stack:	( % -> )
* --------------------------------------------------------------------
LABEL j%1=case
::
  %1 %= COLAcase
;

* --------------------------------------------------------------------
* Desc:		Like j%-1=case but handles all objects
* Stack:	( obj -> )
* --------------------------------------------------------------------
LABEL j#-1=case
::
  CK&DISPATCH0
  real j%-1=case
  zint  jZ-1=case
  any  'R2DROP
;

* --------------------------------------------------------------------
* Desc:		Like j%-1=case for integers
* Stack:	( obj -> )
* --------------------------------------------------------------------
LABEL jZ-1=case
::
  Z-1 EQUAL COLAcase
;

* --------------------------------------------------------------------
* Desc:		Like j%0=case for -1
* Stack:	( obj -> )
* --------------------------------------------------------------------
LABEL j%-1=case
::
  %-1 %= COLAcase
;

* --------------------------------------------------------------------
* Desc:		Suppress SYMB if not needed
* Stack:	( obj -> obj )
* --------------------------------------------------------------------
NULLNAME CLEANIDLAM
::				( obj )
  DUPTYPESYMB? NOT?SEMI
  DUPLENCOMP #1= NOT?SEMI
				( symb )
  DUP CARCOMP 			( symb ob )
  CK&DISPATCH1
  idnt	SWAPDROP
  lam	SWAPDROP
  zint	SWAPDROP
  any	DROP
;

