	STITLE System RPL version of the user words (eruser.s)

INCLUDE keydefs.h
INCLUDE erromid.h
INCLUDE cas2extdec.h
INCLUDE global.s

**********************************************************************
* EXPORT:
**********************************************************************

ASSEMBLE
	IF	f39
RPL
LABEL NOT40case
* on the 40 skip next object
* on the 39 evaluate next object and remove the rest of the calling prg
* to be used as
* ... NOT40case old38code symboliccode ;
::
  'R				( ... prg )
* put here the code to test for 40 wrt to 39
  IsEurope?			( ... prg ? )
  caseDROP			( -> )
  RDROP EVAL
;

LABEL NOTEQWcase
* on the 40 if EQW skip next object
* on the 39 or not in EQW
* evaluate next object and remove the rest of the calling prg
* to be used as
* ... NOTEQWcase old38code symboliccode ;
::
  'R				( ... prg )
* put here the code to test for 40 wrt to 39
  InCASApplication?		( ... prg ? )
  caseDROP			( -> )
  RDROP EVAL
;

ASSEMBLE
	ENDIF	f39
RPL


**********************************************************************
* Desc:		Erable version number
* Stack:	( --> %version )
**********************************************************************
NULLNAME VERNUMext
:: VERSION% TOTEMPOB ;

**********************************************************************
* Desc:		Make list of Erable commands between the given numbers.
* Stack:	( #2 #1 --> {} )
**********************************************************************
NULLNAME MENUXYext
::
  2DUP #MAX # 8C #MIN #1+ UNROT #MIN # 8C #MIN		( #max+1, #min )
  2DUP #- UNROT
  [DO]
     [#] ALROMID INDEX@ #>ROMPTR 
  SWAPLOOP
  {}N 
;

**********************************************************************
* Desc:		Save CAS flags and current var
* Stack:	( -> )
**********************************************************************
NULLNAME SAVECASFLAGS
::
  ( * first insure that some internal system flags are cleared * )
  fnResults SWITCHOFF
ASSEMBLE
	IF 	f39
RPL
  fnConstants ClrSysFlag 
ASSEMBLE
	ELSE	f39
RPL
  fnConstants SWITCHOFF
ASSEMBLE
	ENDIF	f39
RPL
  nogcdflag approxflag SysITE SetSysFlag ClrSysFlag
  vxxlflag ClrSysFlag
  invlnflag ClrSysFlag
  modularflag ClrSysFlag
  divflag ClrSysFlag
  iisirrqflag ClrSysFlag
  sqrtflag sturmflag SysITE SetSysFlag ClrSysFlag
  keepintflag ClrSysFlag
  div0by0flag ClrSysFlag
  noswitchflag ClrSysFlag
  ( * insure RAD mode * )
ASSEMBLE
	IF 	f39
RPL
  RAD? ?SKIP :: "Setting RAD mode" DISPROW1 SETRAD ;
ASSEMBLE
	ELSE	f39
RPL
  RADON
ASSEMBLE
	ENDIF	f39
RPL
  ( * purge the cur. var. if bound to a value * )
  RCLVX 				( ... x )
ASSEMBLE
	IF	f39
RPL
  InCASApplication? IT :: DUP SAFEPURGE ;	( ... x )
ASSEMBLE
	ELSE	f39
RPL
  DUP SAFEPURGE				( ... x )
ASSEMBLE
	ENDIF	f39
RPL
  RCLSYSF2 CASVX CASFLAGS TWO{}N BIND
;

LABEL RADON
:: fnAngle1 SWITCHON ;

**********************************************************************
* Desc:		Purge idnt if it exists, error for lam
* Stack:	( idnt/lam -> )
**********************************************************************
NULLNAME SAFEPURGE
::					( idnt/lam )
  DUP@ 					( [ idntlam ob true | idntlam false] )
  SWAPDROP 				( [ idntlam true | false] )
  NOT?SEMI				( -> )
					( idnt/lam )
  DUPTYPELAM? case :: BINT81 ERABLEERROR ;
  switchflag TestSysFlag case PURGE	( no confirmation -> )
					( idnt/lam )
  BINT81 GETERABLEMSG OVER DO>STR &$	( idnt/lam $ )
ASSEMBLE
	IF	f39
RPL
  DoQueryBox
ASSEMBLE
	ELSE	f39
RPL
  % 5000 % 0.3 DOBEEP
  AskQuestion
ASSEMBLE
	ENDIF	f39
RPL
  NOTcase :: BINT49 ERABLEERROR	;	( idnt )
  PURGE					( )
;

**********************************************************************
* Desc:		Restore CAS flags and current var
* Stack:	( -> )
**********************************************************************
NULLNAME RESTORECASFLAGS
::
  CASVX SAFE@ IT STOVX
  CASFLAGS SAFE@ IT STOSYSF2 ABND
;

LABEL CASFLAGS
:: ' LAM CASFLAGS TOTEMPOB ;

LABEL CASVX
:: ' LAM CASVX TOTEMPOB ;

**********************************************************************
* Desc:		Execute next runstream object with flag protection
* Stack:	( -> )
**********************************************************************
LABEL CASFLAGEVAL:
::
  'R CASFLAGEVAL
;

NULLNAME CASFLAGEVAL
::
  SAVECASFLAGS
  PushVStack
  ERRSET 
    EVAL
  ERRTRAP TCASFLAGEVAL
  DropVStack
  ABND
ASSEMBLE
	IF 	f39
RPL
  fnConstants SetSysFlag
  iflag SetSysFlag
ASSEMBLE
	ELSE	f39
RPL
ASSEMBLE
	ENDIF	f39
RPL
;

LABEL TCASFLAGEVAL
:: PopVStack DROP CK0NOLASTWD RESTORECASFLAGS ERRJMP ;

**********************************************************************
* Desc:		Internal xEXPAND
* Stack:	
**********************************************************************
NULLNAME FLAGEXPAND
::
  DUPTYPEARRY? ?SEMI 
  CASFLAGEVAL: FLAGEXPAND1
;

LABEL FLAGEXPAND1
::
  EQUATION? ITE EXPANDBOTH SIMP1ext
  ( * convert back exp[n*ln to ^ * )
  EXP2POW
;

NULLNAME EXPANDBOTH
::
  EXLR 
  SWAP SIMP1ext SWAP SIMP1ext SYM=
;

**********************************************************************
* Desc:		Internal xFACTOR
* Stack:	
**********************************************************************
NULLNAME FLAGFACTOR
::
  DUPTYPEARRY? ?SEMI CASFLAGEVAL: :: QOBJext COLCext ;
;

**********************************************************************
* Desc:		Internal SUBST
* Stack:	
**********************************************************************
NULLNAME FLAGLISTEXEC
::
  CASFLAGEVAL: LISTEXEC
;

NULLNAME FLAGSYMBEXEC
::
  CASFLAGEVAL: SYMBEXEC
;

NULLNAME FLAGIDNTEXEC
::
  CASFLAGEVAL: IDNTEXEC
;

**********************************************************************
* Desc:		Internal xINTVX
* Stack:	
**********************************************************************
NULLNAME FLAGINTVX
:: CASFLAGEVAL: INTVX ;

LABEL INTVX
:: QOBJext :: RCLVX RISCHext ; ;

**********************************************************************
* Desc:		Internal xDERVX
* Stack:	
**********************************************************************
NULLNAME DERVX
:: RCLVX DERIVext ;

**********************************************************************
* Desc:		SOLVEX for a float
* Stack:	( float -> list of solutions )
**********************************************************************
NULLNAME SOLVEXFLOAT
:: num0=case :: DROP ?ext ONE{}N ; DROP NULL{} ;

**********************************************************************
* Desc:		Internal LIMIT for scalars
* Stack:	
**********************************************************************
NULLNAME SYMLIMIT
:: 
  EXACTON CASFLAGEVAL: 
  :: 
    COMMONLIMIT LIMIText
ASSEMBLE
	IF	f39
RPL
  STRIPTAGS
ASSEMBLE
	ENDIF	f39
RPL
   ; 
;

**********************************************************************
* Desc:		Internal LIMIT for matrices
* Stack:	
**********************************************************************
NULLNAME FLAGMATRIXLIMIT
::
  EXACTON CASFLAGEVAL: MATRIXLIMIT
;

LABEL MATRIXLIMIT
::
  COMMONLIMIT 				( matrix var a z3 )
  ' LIMIText FOUR ::N			( matrix )
*  1LAMBIND LISTSECOext ABND		( matrix )
  rpnQOBJext
;

LABEL COMMONLIMIT
::
  EXLR Zlimit
;

**********************************************************************
* Desc:		Internal TAYLOR0
* Stack:	
**********************************************************************
NULLNAME TAYLOR0
::
  EXACTON CASFLAGEVAL: :: QOBJext TAYLOR0ext ; 
;

LABEL TAYLOR0ext
::
  RCLVX Z4 			( symb id order )
  SYMTAYLOR1			( symb )
;

**********************************************************************
* Desc:		Internal SERIES
* Stack:	
**********************************************************************
NULLNAME FLAGSERIES
::
  EXACTON CASFLAGEVAL: SERIES
					( { lim equiv DL reste } h=X )
  ASSEMBLE
	IF	f39
  RPL
  SWAPINCOMP DROP 2SWAP 2DROP		( h=X Dl reste )
  STRIPTAGS OBJ>R STRIPTAGS SYMBINCOMP R>OBJ 	( h=X Dl-meta reste )
  ' ID O ONE SYMBN ONE ' xFCNAPPLY FOUR MetaAdd	( h=X DL+O[reste]-meta )
  SYMBN SWAP SYMBINCOMP 		( DL+O h X = #3 )
  SWAPDROP THREE SWAP			( DL+O h X three #3 )
  #1- get1 ONE SYMBN OVER#2+UNROLL #2+	( DL+O 'h' X three #4 )
  addt: xWHERE SYMBN			( DL+O[reste]|h=X )
  ASSEMBLE
	ENDIF	f39
  RPL
;

LABEL SERIES
::
  COMPLEXOFF
  LIMSERIES! OBJ>R		( a lim DL-l rest-l num/deno-l equiv-l lvar # )

  ( * remark: we will return absolute DL and rest instead of relative * )
  ( * warning: equivalent is invalid if the remainder is not a o[equiv] * )

  ROTDROP SLVARext		( a lim DL-l rest-l equiv-l lvar )


  ( * multiply relative rest by equiv to get an absolute rest * )
  ROT 3PICK QMul UNROT		( a lim DL-l rest-l equiv-l lvar )

  ( * truncate expansion * )
  2SWAP DUPUNROT		( a lim equiv-l lvar rest-l DL-l rest-l )
  TRUNCDL RISCH13 		( a lim equiv-l lvar rest-l DL-l )
  SWAP				( a lim equiv-l lvar DL-l rest-l )
  2SWAP				( a lim DL-l rest-l equiv-l lvar )

  RCLVX DUPUNROT		( a lim DL-l rest-l equiv-l x lvar x )
  ' ID h MEVALext		( a lim DL-l rest-l equiv-l x lvar[h] )
  THREE ZERO_DO (DO)
     ZERO 6ROLL 3PICK
     VAL2ext UNROT
  LOOP
				( a lim DL rest equiv x lvar[h] )
  DROP 5UNROLL			( a x lim DL rest equiv )

  4ROLL "Limit" >TAG		( a x DL rest equiv lim )
  SWAP "Equiv" >TAG		( a x DL rest lim equiv )
  4ROLL "Expans" >TAG		( a x rest lim equiv DL )
  4ROLL "Remain" >TAG		( a x lim equiv DL reste )
  FOUR {}N UNROTSWAP		( {}_result x a )

  R>OBJ				( {}_result x a # )
  SERIESMEVAL			( {}_result symb )

  ' ID h TOTEMPOB SWAP EXPR=	( {}_result h[x] )
;

LABEL SERIESMEVAL
( x a # -> x-a | a-x | 1/x | -1/x )
::
  ( * #>=4 for infinity * )
  DUP THREE #>case SERIESMEVALINF
  #1= IT SWAP x-ext
;

LABEL SERIESMEVALINF
::
  #5= ITE Z-1 Z1		( x a +-1 )
  SWAPDROPSWAP x/ext		( +-1/x )
;


**********************************************************************
* Desc:		Internal PLOTSTK
* Stack:	
**********************************************************************
NULLNAME PLOTSTK
::   
  DOERASE
  DUP DOSTOE
ASSEMBLE
	IF	f39
RPL
ASSEMBLE
	ELSE	f39
RPL
  FLASHPTR DoPLOT_SETUPInform
ASSEMBLE
	ENDIF	f39
RPL
;

**********************************************************************
* Desc:		Internal PLOTADD
* Stack:	
**********************************************************************
NULLNAME PLOTADD
::
  ' ID EQ DUP@			( fnct eq val TRUE | fnct eq FALSE )
  NOTcasedrop PLOTSTK
				( fnct eq val )
  SWAPDROP OVERSWAP		( fnct fnct val )
  :: CK&DISPATCH2
     2LIST &COMP
     list SWAP>HCOMP
     EIGHTY >HCOMP
     any TWO{}N
     ;
				( fnct { val fnc } )
 DOSTOE
ASSEMBLE
	IF	f39
RPL
ASSEMBLE
	ELSE	f39
RPL
  FLASHPTR DoPLOT_SETUPInform
ASSEMBLE
	ENDIF	f39
RPL
;

**********************************************************************
* Desc:		Internal IBP
* Stack:	
**********************************************************************
NULLNAME FLAGIBP
::
  CASFLAGEVAL: IBP
;

**********************************************************************
* Desc:		Internal PREVAL
* Stack:	
**********************************************************************
NULLNAME FLAGPREVAL
::
  CASFLAGEVAL: :: RCLVX PREVALext ; 
;

**********************************************************************
* Desc:		Internal RISCH
* Stack:	
**********************************************************************
NULLNAME MATRIXRISCH
::				( matrix idnt -> matrix )
  OVER DUPTYPEARRY? casedrop x*
				( matrix idnt matrix )
  TYPEMATRIX? NOTcase FLAGRISCH	( -> antiderivative )
  				( matrix idnt )
  1LAMBIND
  DUP >R LENCOMP ZEROSWAP	
  ZERO_DO (DO)
    RSWAP 'R RSWAP 		( recall n-th element )
    1GETLAM MATRIXRISCH SWAP#1+	( integrate and add to meta )
  LOOP
  ABND
  []N
;

LABEL SYM2IDNTLAM
::
  DUPTYPESYMB? IT CARCOMP
  IDNTLAM? NcaseSIZEERR
;

NULLNAME FLAGRISCH
::
  SYM2IDNTLAM
  CASFLAGEVAL: RISCHext
;

NULLNAME FLAGDERIV
:: SYM2IDNTLAM DERIVext ;
*:: CASFLAGEVAL: DERIVext ; 

**********************************************************************
* Desc:		Internal xLAP
* Stack:	
**********************************************************************
NULLNAME FLAGLAP
::
  DUPTYPEARRY? caseSIZEERR
  CASFLAGEVAL: :: QOBJext LAPext ;
;

**********************************************************************
* Desc:		Internal xILAP
* Stack:	
**********************************************************************
NULLNAME FLAGILAP
::
  DUPTYPEARRY? caseSIZEERR
  CASFLAGEVAL: ILAP
;

LABEL ILAP
:: QOBJext ILAPext ;

**********************************************************************
* Desc:		Internal xDESOLVE
* Stack:	
**********************************************************************
NULLNAME FLAGDESOLVE
::						( obj1 symb2 )
  CASFLAGEVAL: 
  ::   
    SWAPDUP LASTCOMP EQ: xAND IT SYMB2MATRIX	( symb2 obj1' )
    SWAP DESOLVE				( liste_of_sol )
  ;
ASSEMBLE
	IF	f39
RPL
  SOLUTION2SYMB
ASSEMBLE
	ENDIF	f39
RPL
;

**********************************************************************
* Desc:		Internal LDEC
* Stack:	
**********************************************************************
NULLNAME FLAGLDSSOLV
::
  CASFLAGEVAL: LDSSOLVext
;

NULLNAME FLAGLDECSOLV
::
  CASFLAGEVAL: LDECSOLV
;

**********************************************************************
* Desc:		Internal xTEXPAND
* Stack:	
**********************************************************************
NULLNAME FLAGTEXPAND
:: 
  DUPTYPEARRY? ?SEMI 
  CASFLAGEVAL: TEXPAND
;

LABEL TEXPAND
:: QOBJext TEXPAext ;

**********************************************************************
* Desc:		Internal xLIN
* Stack:	
**********************************************************************
NULLNAME FLAGLIN
:: 
  DUPTYPEARRY? ?SEMI
  CASFLAGEVAL: LIN
;

LABEL LIN
::
  QOBJext SIGMAEXPext 
;

**********************************************************************
* Desc:		Internal xTSIMP
* Stack:	
**********************************************************************
NULLNAME FLAGTSIMP
:: 
  DUPTYPEARRY? ?SEMI
  CASFLAGEVAL: TSIMP
;

LABEL TSIMP
::  QOBJext TSIMPext ;

**********************************************************************
* Desc:		Internal xLNCOLLECT
* Stack:	
**********************************************************************
NULLNAME FLAGLNCOLLECT
:: 
  DUPTYPEARRY? ?SEMI 
  CASFLAGEVAL: LNCOLLECT
;

LABEL LNCOLLECT
:: QOBJext LNCOLCext ;

**********************************************************************
* Desc:		Internal xEXPLN
* Stack:	
**********************************************************************
NULLNAME FLAGEXPLN
::
  DUPTYPEARRY? ?SEMI
  CASFLAGEVAL: EXPLN
;

LABEL EXPLN
::
  QOBJext EXPLNext
;

**********************************************************************
* Desc:		Internal xSINCOS
* Stack:	
**********************************************************************
NULLNAME FLAGSINCOS
::
  CASFLAGEVAL: SINCOS
;

LABEL SINCOS
::
  DUPTYPEARRY? ?SEMI 
  QOBJext SINCOSext 
;

**********************************************************************
* Desc:		Internal xTLIN
* Stack:	
**********************************************************************
NULLNAME FLAGTLIN
::
  CASFLAGEVAL: TLIN
;

LABEL TLIN
::
  DUPTYPEARRY? ?SEMI 
  QOBJext :: LINEXPA MTRIG2SYMB ;
;

**********************************************************************
* Desc:		Internal TCOLLECT
* Stack:	
**********************************************************************
NULLNAME FLAGTCOLLECT
::
  CASFLAGEVAL: MATTCOLLECT
;

LABEL MATTCOLLECT
::
  DUPTYPEARRY? ?SEMI 
  QOBJext TCOLLECT
;

**********************************************************************
* Desc:		Internal xTRIG
* Stack:	
**********************************************************************
NULLNAME FLAGTRIG
::
  CASFLAGEVAL: TRIG
;

LABEL TRIG
::
  DUPTYPEARRY? ?SEMI 
  QOBJext :: SINCOSext TAN2SC2ext TRIGext ;
;

**********************************************************************
* Desc:		Internal xTRIGCOS
* Stack:	
**********************************************************************
NULLNAME FLAGTRIGCOS
::
  prefersinflag ClrSysFlag
  CASFLAGEVAL: MATTRIG
;

LABEL MATTRIG
::
  DUPTYPEARRY? ?SEMI 
  QOBJext TRIGext
;

**********************************************************************
* Desc:		Internal xTRIGSIN
* Stack:	
**********************************************************************
NULLNAME FLAGTRIGSIN
::
  prefersinflag SetSysFlag
  CASFLAGEVAL: MATTRIG
;

**********************************************************************
* Desc:		Internal xTRIGTAN
* Stack:	
**********************************************************************
NULLNAME FLAGTRIGTAN
::
  CASFLAGEVAL: MATTRIGTAN
;

LABEL MATTRIGTAN
::
  DUPTYPEARRY? ?SEMI 
  QOBJext TRIGTAN
;

**********************************************************************
* Desc:		Internal xTAN2SC
* Stack:	
**********************************************************************
NULLNAME FLAGTAN2SC
::
  CASFLAGEVAL: TAN2SCNOCK
;

LABEL TAN2SCNOCK
:: 
  DUPTYPEARRY? ?SEMI 
  QOBJext TAN2SCext
;

**********************************************************************
* Desc:		Internal xHALFTAN
* Stack:	
**********************************************************************
NULLNAME FLAGHALFTAN
::
  CASFLAGEVAL: HALFTAN
;

**********************************************************************
* Desc:		Internal xTAN2SC2
* Stack:	
**********************************************************************
NULLNAME FLAGTAN2SC2
::
  CASFLAGEVAL: TAN2SC2NOCK
;

LABEL TAN2SC2NOCK
:: 
  DUPTYPEARRY? ?SEMI 
  QOBJext TAN2SC2ext 
;

**********************************************************************
* Desc:		Internal xATAN2S
* Stack:	
**********************************************************************
NULLNAME FLAGATAN2S
:: 
  CASFLAGEVAL: ATAN2S
;

LABEL ATAN2S
::
  DUPTYPEARRY? ?SEMI 
  QOBJext ATAN2Sext 
;

**********************************************************************
* Desc:		Internal xASIN2T
* Stack:	
**********************************************************************
NULLNAME FLAGASIN2T
:: 
  CASFLAGEVAL: ASIN2T
;

LABEL ASIN2T
::
  DUPTYPEARRY? ?SEMI 
  QOBJext ASIN2Text 
;

**********************************************************************
* Desc:		Internal xASIN2C
* Stack:	
**********************************************************************
NULLNAME FLAGASIN2C
::
  CASFLAGEVAL: ASIN2C
;

LABEL ASIN2C
:: 
  DUPTYPEARRY? ?SEMI 
  QOBJext ASIN2Cext 
;

**********************************************************************
* Desc:		Internal xACOS2S
* Stack:	
**********************************************************************
NULLNAME FLAGACOS2S
:: 
  CASFLAGEVAL: ACOS2S
;

LABEL ACOS2S
::
  DUPTYPEARRY? ?SEMI 
  QOBJext ACOS2Sext 
;

**********************************************************************
* Desc:		Check that a sym is a zint or Gauss integer, convert it
* Stack:	sym -> zint or :: zint zint ;
**********************************************************************
NULLNAME CK&CONVINT
::
  CASFLAGEVAL: 
  ::
  DUPTYPEZ? ?SEMI
					( sym )
  LVARext DUPNULL{}? NcaseTYPEERR
					( sym null{} )
  VXXLext SWAPDROP			( internal_obj )
  DUPTYPECOL? NcaseTYPEERR		( seco )
  DUPTYPEIRRQ? case SETTYPEERR
					( -> C )
  ; 
;

**********************************************************************
* Desc:		Check that 2 sym are zint or Gauss integer, convert them
* Stack:	sym sym -> zint or :: zint zint ; twice
**********************************************************************
NULLNAME CK&CONV2INT
::
  SWAP CK&CONVINT SWAP CK&CONVINT
;

**********************************************************************
* Desc:		
* Stack:	zint|c zint|c -> sym sym
**********************************************************************
NULLNAME CONVBACK2INT
::
  NULL{} ROT R2SYM NULL{} ROT R2SYM
;

**********************************************************************
* Desc:		
* Stack:	zint|c -> sym 
**********************************************************************
NULLNAME CONVBACKINT
::
  NULL{} SWAP R2SYM
;

**********************************************************************
* Desc:		Internal IDIV2
* Stack:	
**********************************************************************
NULLNAME STEPIDIV2
::
  CK&CONV2INT
  num#0=case ErrUndefRes
  INTSTEPIDIV2
  CONVBACK2INT
;


LABEL INTSTEPIDIV2
::
  stepflag TestSysFlag NOTcase IDIV2
  CK&DISPATCH1
  zintzint POTENCEext
  any CDIV2ext
;

**********************************************************************
* Desc:		Internal DIV2
* Stack:	
**********************************************************************
NULLNAME FLAGDIV2
::
  CASFLAGEVAL: DIV2NOCK
;

LABEL DIV2NOCK
::
  2POLYNOMIAL? NOTcase TRANSCERROR
  BIN2EVAL STEPDIV2
*ASSEMBLE
*	IF	f39
*RPL
*  NEWDIVext
*ASSEMBLE
*	ELSE	f39
*RPL
*  STEPDIV2
*ASSEMBLE
*	ENDIF	f39
*RPL
;

LABEL STEPDIV2
::						( lvar Q1 Q2 )
  EXACTON stepflag TestSysFlag NOTcase NEWDIVext
  ( * test for univar poly * )
  3PICK LENCOMP #1= NOTcase NEWDIVext

  CK&DISPATCH1
  2LIST PDIV2ext
  any NEWDIVext
;

**********************************************************************
* Desc:		Internal GCD1
* Stack:	
**********************************************************************
NULLNAME FLAGGCD
::
  EXACTON CASFLAGEVAL: GCD1
;

LABEL GCD1
::  ZERO BINEVAL GCDext ;


**********************************************************************
* Desc:		Internal EGCD for polynomials
* Stack:	
**********************************************************************
NULLNAME PEGCD
::
  EXACTON 2POLYNOMIAL? NOTcase TRANSCERROR
  CASFLAGEVAL: :: COMMONGCD3 REGCDext ;
ASSEMBLE
	IF	f39
RPL
  EGCD39
ASSEMBLE
	ENDIF	f39
RPL

;

**********************************************************************
* Desc:		Internal EGCD for integers
* Stack:	
**********************************************************************
NULLNAME IEGCD
::
  EXACTON CASFLAGEVAL: :: COMMONGCD3 IEGCDext ;
ASSEMBLE
	IF	f39
RPL
  				( d u v )
  EGCD39
ASSEMBLE
	ENDIF	f39
RPL
;

LABEL EGCD39
::
  2SYMBINCOMP top& addtANDonly 
  get1 SYMBINCOMP top& addt: x= CKSYMBN
;

LABEL COMMONGCD3
::
  TWO TOLISText
  'REVAL
  ZEROZEROZERO THREE{}N FROMLISText
;

**********************************************************************
* Desc:		Internal poly ABCUV
* Stack:	
**********************************************************************
NULLNAME ABCUV
::
  QPI EXACTON UNROT 				( c a b )
  2POLYNOMIAL? NOTcase TRANSCERROR		
						( c a b )
  ROT CASFLAGEVAL: :: COMMONABCUV REGCDext NEWDIVext ;
ASSEMBLE
	IF	f39
RPL
  					( u v )
  AND39					( u_AND_v )
ASSEMBLE
	ENDIF	f39
RPL
;

**********************************************************************
* Desc:		Internal integer ABCUV
* Stack:	
**********************************************************************
NULLNAME IABCUV
::
  EXACTON CASFLAGEVAL: :: COMMONABCUV IEGCDext IDIV2 ;
ASSEMBLE
	IF	f39
RPL
  					( u v )
  AND39					( u_AND_v )
ASSEMBLE
	ENDIF	f39
RPL
;

LABEL COMMONABCUV
::
  UNROT					( c, a, b )
  THREE TOLISText			( lvar, c, a, b )
  'REVAL				( lvar, c, d, u, v )
  2SWAP 'REVAL				( lvar, u, v, c div d, c mod d )
  Z0 EQUALNOTcase NONINTERR		( -> no integer solution )
					( lvar, u, v, c div d )
  ROTOVER RMULText
  UNROT RMULText
  { ZERO ZERO } FROMLISText
;


**********************************************************************
* Desc:		Internal LGCD
* Stack:	
**********************************************************************
NULLNAME FLAGLGCD
::
  EXACTON CASFLAGEVAL: LGCD
ASSEMBLE
	IF	f39
RPL
  SWAPDROP
ASSEMBLE
	ENDIF	f39
RPL
;

LABEL LGCD
::				( list/matrix )
  DUPLENCOMP			( list/matrix # )
  ZERO_DO (DO)
	DUPINDEX@ #1+ NTHCOMPDROP	( list/matrix element )
	TYPELIST? caseSIZEERR	( -> error )
	LOOP			( list/matrix )
  DUPONE TOLISText 		( matrix lvar internal-list )
  LPGCDext			( matrix lvar internal-list gcd )
  SWAPDROP R2SYM		( matrix gcd )
;

**********************************************************************
* Desc:		Internal LCM1
* Stack:	
**********************************************************************
NULLNAME FLAGLCM
::
  EXACTON CASFLAGEVAL: LCM1
;

LABEL LCM1
:: 
  BIN2EVAL :: 	2DUP GCDext 		( a b gcd )
		num#0=case SWAPDROP 	( -> a 0 )
		RDIVext 		( a b/gcd )
		;
  x*ext
;

**********************************************************************
* Desc:		Internal SIMP2
* Stack:	
**********************************************************************
NULLNAME FLAGSIMP2
:: 
  EXACTON num#0=case ErrUndefRes
  SETEXACT
  CASFLAGEVAL: SIMP2
ASSEMBLE
	IF	f39
RPL
  TWO{}N
ASSEMBLE
	ENDIF	f39
RPL
;

LABEL SIMP2
:: BIN2EVAL SIMPext ;

**********************************************************************
* Desc:		Internal PARTFRAC
* Stack:	
**********************************************************************
NULLNAME FLAGPARTFRAC
::
*  EXACTON 
  CASFLAGEVAL: PARTFRACNOCK
;

LABEL PARTFRACNOCK
::
  DUPTYPEARRY? ?SEMI
  DUPTYPESYMB? case STEPPARTFRAC
  QOBJext PARTFRAC
;

LABEL STEPPARTFRAC
::
ASSEMBLE
	IF	f39
RPL
  InCASApplication? NOTcase PARTFRAC
ASSEMBLE
	ENDIF	f39
RPL
  stepflag TestSysFlag NOTcase PARTFRAC
  ZEROZERO MAKEGROB			( obj, grob )
  PFSTEP3ext				( grob, obj )
  SWAPDROP
;


**********************************************************************
* Desc:		Internal PROPFRAC
* Stack:	
**********************************************************************
NULLNAME FLAGPROPFRAC
::
  EXACTON CASFLAGEVAL: PROPFRACNOCK
;

LABEL PROPFRACNOCK
::
  DUPTYPEARRY? ?SEMI
  QOBJext PROPFRAC
;

LABEL PROPFRAC
:: 
  FXNDext DUPUNROT
  BIN2EVAL BESTDIV2
  ROT x/ext x+ext
;

**********************************************************************
* Desc:		Internal PTAYL
* Stack:	P(X) r -> P(X+r)
**********************************************************************
NULLNAME FLAGPTAYL
::
  CKPTAYL
  CASFLAGEVAL: PTAYL 
;

LABEL PTAYL
:: TWO TOLISText CKCARCOMP PTAYLext R2SYM ;

LABEL CKPTAYL
( P r -> P r )
* check that r is indep of cur var and P polyn wrt cur var
::
  VXINDEP? NOTcase VXINDEPERR
  SWAP ISPOLYNOMIAL? NOTcase TRANSCERROR
  SWAP 
;

**********************************************************************
* Desc:		Internal HORNER
* Stack:	
**********************************************************************
NULLNAME FLAGHORNER
::
  CKPTAYL
  CASFLAGEVAL: HORNERSYMOB
ASSEMBLE
	IF	f39
RPL
  SWAPDROP AND39
ASSEMBLE
	ENDIF	f39
RPL
;

LABEL HORNERSYMOB
:: 
  TWO TOLISText CKCARCOMP
  FHORNER				( P_div_X-r r P[r] )
  TWICEONE>POLY
  ZEROZEROZERO THREE{}N FROMLISText
;


**********************************************************************
* Desc:		Internal EULER
* Stack:	
**********************************************************************
NULLNAME EULER
::
  OBJINT? NcaseSIZEERR
  DupZIsNeg? case Z<0ERR
  Z0 EQUALcasedro Z0  
  MZSQFF Z1 SWAP #2/
  ZERO_DO (DO)				( a1 m1 ...ap mp z_euler )
    UNROT COERCE 			( a1 m1 ... z_euler ap #mp )
    OVERSWAP #1- RPext			( ... z_euler ap ap^[mp-1] )
    DUPUNROT QMul 			( ... z_euler ap^[mp-1] ap^mp )
    SWAP QSub 				( ... z_euler ap^mp-ap^[mp-1] )
    QMul				( ... z_euler )
  LOOP
;

**********************************************************************
* Desc:		Internal PA2B2
* Stack:	
**********************************************************************
NULLNAME PA2B2
::
  OBJINT? NcaseSIZEERR
  COMPLEXON SUMSQRext
  SWAPDROP ZEROSWAP NULL{} VAL2ext
;


**********************************************************************
* Desc:		Internal CHINREM
* Stack:	
**********************************************************************
NULLNAME FLAGCHINREM
::
  DUPTYPESYMB? IT 2SYMB2MATRIX
  EXACTON CASFLAGEVAL: CHINREM
  ONE SWAPROT VAL2ext
ASSEMBLE
	IF 	f39
RPL
  INCOMPDROP AND39
ASSEMBLE
	ENDIF	f39
RPL
;

LABEL CHINREM
::
  SWAP ARRAY2MATRIX SWAP ARRAY2MATRIX
  TWO TOLISText
  SWAP CKCHINREM			( [] a b true | [] false )
  NOT?SEMI
					( [] a b )
  ROT CKCHINREM				( a b a' b' true | a b false )
  NOTcase TWO[]N			( -> [ a b ] )
					( a b a' b' )
  CHINREMext EGCDext NEWDIVext		( a" b" )
  TWO[]N
;

LABEL CKCHINREM
* [ a b ] -> [ a b true | false ]
* true if b is a non cst polynomial
* false if b is invertible
* error if [] length>2
::
  INNERCOMP #2= NcaseSIZEERR
  ( * test that second poly is not a constant poly * )
					( a b )
  DUPTYPESYMB? caseSIZEERR
  DTYPEMATRIX? caseSIZEERR
					( a b )
  DUPTYPELIST? NOTcase2drop FALSE	( -> false )
					( a b )
  DUPLENCOMP #1= case2drop FALSE	( -> false )
  TRUE					( -> a b true )
;

**********************************************************************
* Desc:		Internal ICHINREM
* Stack:	
**********************************************************************
NULLNAME ICHINREM
::
  DUPTYPESYMB? IT 2SYMB2MATRIX
  EXACTON SWAP QPI SWAP QPI
  SWAPINCOMP #2= NcaseSIZEERR
  CK&CONV2INT
  ROT INNERCOMP #2= NcaseSIZEERR
  CK&CONV2INT
  CHINREMext IEGCDext IDIV2 
  CONVBACK2INT
ASSEMBLE
	IF 	f39
RPL
  AND39
ASSEMBLE
	ELSE	f39
RPL
  TWO []N
ASSEMBLE
	ENDIF	f39
RPL
;

**********************************************************************
* Desc:		Internal ISPRIME
* Stack:	
**********************************************************************
NULLNAME ISPRIME
::
  OBJINT? NcaseSIZEERR
  ZABS
  DupQIsZero? casedrop %0		( 0 is not prime )
  DupZIsOne?  casedrop %0		( 1 is not prime )
  ZPrime? ITE %1 %0			( Regular test )
;

**********************************************************************
* Desc:		Internal SOLVE
* Stack:	
**********************************************************************
NULLNAME SOLVE1EQ
:: 
  CASFLAGEVAL: SOLVE1EQCK
;

LABEL SOLVE1EQCK
::
  OVER DUPTYPESYMB? 				( eq var eq ? )
  ITE :: 
          LASTCOMP { x< x<= x> x>= xAND } ListPos 
          ;
      DROPZERO 
						( eq var # )
  DUP#0=csedrp SOLVE1EQ1
  ( * solve the inequation * )
  						( eq var # )
  FIVE EQUALcasedro SOLVE39
  #1- TWO #/ #0=				( eq var #rem ?< )
  4ROLL EXPR> 2DROP				( var #rem ?< arg1 arg2 )
  ROT IT SWAP x-ext				( var #rem eq>0 )
  RCLVX 4UNROLLROT 				( vx #rem eq>0 var )
  IDNTLAM? NcaseTYPEERR STOVX			( vx #rem eq>0 )
  SIGNEext SWAP #0=				( vx {} ?strict ) 
  SIGNTABTOSYMB SWAP STOVX			( symb )
;

LABEL SOLVE39
* solve the system given with symb input using AND as equation separator
::						( symb-eq symb-var )
  2SYMB2MATRIX SOLVEMANYEQ			( array )
  SOLUTION2SYMB					( symb )
;

LABEL 2SYMB2MATRIX
::
  SWAP SYMB2MATRIX SWAP SYMB2MATRIX		( array-eq array-eq )
;

LABEL SYMB2MATRIX
* symb -> matrix
::
  SYMBINCOMP symb2matrix []N
;

LABEL symb2matrix
* meta-symb -> meta
::
  AEQ1stcase xAND symb2matsplit
  CKSYMBN ONE				( symb one )
;

LABEL symb2matsplit
::
  plDRPpZparg				( meta-symb1 meta-symb2 )
  symb2matrix psh symb2matrix top&	( meta )
;

LABEL SOLVE1EQ1
::
  ISOLALL VAR=LIST 
  DUPLENCOMP #1= IT CARCOMP
* on the 39, must return a symbolic expression
ASSEMBLE
	IF	f39
RPL
  SOLUTION2SYMB
ASSEMBLE
	ENDIF	f39
RPL
;

NULLNAME SOLVEMANYEQ
::
  SWAP 2DMATRIX? caseSIZEERR
  SWAP 2DMATRIX? caseSIZEERR  
  CASFLAGEVAL: BEZOUTMSOLV		( lvar, l-lsol )
  DUP NULLCOMP? case SWAPDROP
  INNERCOMP get1
  SWAPDUP ZERO_DO (DO)			( sol1, ..., soln, lvar, #n )
    get1 3PICKSWAP ' SYM= VBINARYOP UNROT
  LOOP
  SWAPDROP {}N
;

**********************************************************************
* Desc:		Internal ZEROS
* Stack:	
**********************************************************************
NULLNAME ZEROS1EQ
:: 
  CASFLAGEVAL: ISOLALL SWAPDROP 
  DUPLENCOMP #1= IT CARCOMP
;

NULLNAME ZEROSMANYEQ
:: CASFLAGEVAL: BEZOUTMSOLV SWAPDROP ;

**********************************************************************
* Desc:		Internal FCOEF
* Stack:	
**********************************************************************
NULLNAME FCOEF
::
  ARRAY2MATRIX INNERCOMP TWO #/
  SWAP #1=case SETSIZEERR
  Z1 DUPROT
  ZERO_DO (DO)			( rac1, num1, ..., rack, numk, num, deno )
    2SWAP OBJINT? NcaseSIZEERR 
				( rac1, num1, ..., num, deno, rack, numk )
    RCLVX ROT x-ext		( rac1, num1, ..., num, deno, numk, x-rack )
    OVER ZAbs			( .., num, deno, mult, factk, | mult | )
    x^ext
    SWAP ZIsNeg?		( ..., num, deno, factk, mult<0? )
    ITE
       x*ext
       :: ROTSWAP x*ext SWAP ;
  LOOP
  NDXFext
;

**********************************************************************
* Desc:		Internal FROOTS
* Stack:	
**********************************************************************
NULLNAME FROOTS
::				( symb )
  ISPOLYNOMIAL? NOTcase TRANSCERROR
  CASFLAGEVAL: FACT1ext		( lvar, poly-l, root-l )
  DUPNULL{}? case UNROT2DROP	( -> null{} )
				( lvar, poly-l, root-l )
  SWAPDROP ONE SWAPROT		( #1 root-l lvar )
  CDRCOMP VAL2ext		( roots )
  TYPEMATRIX CHANGETYPE
;

**********************************************************************
* Desc:		Internal FACTORS
* Stack:	
**********************************************************************
NULLNAME FACTORS
::
  CASFLAGEVAL: FACTOext		( lvar, poly-liste, liste des facteurs )
  DIVISKILL1 SWAPDROP 		( lvar fact-list )
  ONESWAP ROT
  VAL2ext			( facteurs )
;

**********************************************************************
* Desc:		Internal DIVIS
* Stack:	
**********************************************************************
NULLNAME DIVIS
::  
  CASFLAGEVAL: DIVISNOCK 
ASSEMBLE
	IF	f39
RPL
* list to symbolic for the 39
  SOLUTION2SYMB
ASSEMBLE
	ENDIF	f39
RPL
;

LABEL DIVISNOCK
:: ONE MONOEVALext DIVISext ;

**********************************************************************
* Desc:		Internal STUDMULT
* Stack:	
**********************************************************************
NULLNAME STUDMULT
:: 
  STUDOP VSTUDMULT
;

LABEL VSTUDMULT
::
  ' QMul VBINARYOP
;

**********************************************************************
* Desc:		Internal STUDDIV
* Stack:	
**********************************************************************
NULLNAME STUDDIV
:: 
  STUDOP VSTUDDIV
;

LABEL VSTUDDIV
::
  ' QDiv VBINARYOP
;


LABEL STUDOP
( arry2, arry1 -> arry )
* checks that dim of arry are equal
* calls next runstream op for a vector or
::
  ( * insure symbolic arrays * )
  SWAP ARRAY2MATRIX SWAP ARRAY2MATRIX	( arry2 arry1 )
  'R 3PICK DIMLIMITS 3PICK DIMLIMITS	( arry2 arry1 prg size2 size1 )
  OVER EQUAL NOT?DIMERR			( arry2 arry1 prg size2 )
  LENCOMP  				( arry2 arry1 prog #size2 )
  #1=case EVAL VBINARYOP
; 

**********************************************************************
* Desc:		Internal rref
* Stack:	
**********************************************************************
NULLNAME rref
::
ASSEMBLE
	IF	f39
RPL
  EXACT?QPI
  STOMAText ONE MATREFRREF
  SWAP STRIPTAGS SWAP TWO{}N
ASSEMBLE
	ELSE	f39
RPL
  STOMAText ONE MATREFRREF
ASSEMBLE
	ENDIF	f39
RPL
;

LABEL EXACT?QPI
::
ASSEMBLE
	IF	f39
RPL
  EXACT? IT QPI
ASSEMBLE
	ENDIF	f39
RPL
;

**********************************************************************
* Desc:		Internal QXA
* Stack:	( symb lidnt -> matrix lidnt )
**********************************************************************
NULLNAME FLAGQXA
:: 
  CKLISTOFIDNT
  LIST2MATRIX
  CASFLAGEVAL: QXA		( matr lvar )
ASSEMBLE
	IF	f39
RPL
  DROP
ASSEMBLE
	ENDIF	f39
RPL
;

**********************************************************************
* Desc:		Internal AXQ
* Stack:	( matrix lidnt -> symb lidnt )
**********************************************************************
NULLNAME FLAGAXQ
:: 
  CKLISTOFIDNT
  CASFLAGEVAL: AXQ		( symb lvar )
ASSEMBLE
	IF	f39
RPL
  DROP
ASSEMBLE
	ENDIF	f39
RPL
;

LABEL CKLISTOFIDNT
::
  DUPTYPEMATRIX? OVER TYPELIST? OR NcaseSIZEERR
  DUP' :: 
           TYPEIDNT? NOT 
  ; 
  Find1stTrue 	( composite ob true | false )
  caseSIZEERR
;

**********************************************************************
* Desc:		Internal GAUSS
* Stack:	( symb lidnt -> D P symb' lvar )
**********************************************************************
NULLNAME FLAGGAUSS
:: 
  CKLISTOFIDNT
  SWAP QPI SWAP CASFLAGEVAL: GAUSS		( D P symb lvar )
ASSEMBLE
	IF	f39
RPL
  DROP UNROT2DROP				( symb )
ASSEMBLE
	ENDIF	f39
RPL
;

**********************************************************************
* Desc:		Internal SYLVESTER
* Stack:	( M -> P D )
**********************************************************************
NULLNAME FLAGSYLVESTER
:: 
   EXACT?QPI
   DUPDUP MATTRAN EQUALNOTcase :: BINT55 ERABLEERROR ;
   CASFLAGEVAL: SYLVESTER	( P D )
ASSEMBLE
	IF 	f39
RPL
  TWO{}N
ASSEMBLE
	ENDIF	f39
RPL

;

**********************************************************************
* Desc:		Internal PCAR
* Stack:	
**********************************************************************
NULLNAME PCAR
::
  EXACT?QPI
  VXINDEP? NOTcase VXINDEPERR
  ARRAY2MATRIX
  DTYPENDO? NcaseSIZEERR
  DUPLENCOMP FLASHPTR EXACTMATIDN
  RCLVX MAT*SCL
  SWAP MAT-
  MATDET
;

**********************************************************************
* Desc:		Internal MAD
* Stack:	
**********************************************************************
NULLNAME MADNOCK
::
  EXACT?QPI
  VXINDEP? NOTcase VXINDEPERR
  DUP MDIMS NcaseSIZEERR
					( M # # )
  #= NOT?DIMERR
					( M )
  LVARext VXXLext MADJ
  { ZERO TWO THREE ONE } FROMLISText
  ZEROSWAP RCLVX ONE{}N
  VAL2ext
ASSEMBLE
	IF	f39
RPL
  FOUR {}N
ASSEMBLE
	ENDIF	f39
RPL
;

**********************************************************************
* Desc:		Internal LINSOLVE
* Stack:	
**********************************************************************
NULLNAME SYSTEM
::
  DUPTYPESYMB? case SYSTEM39
  OVER TYPEMATRIX? NcaseSIZEERR
  DTYPEMATRIX? NcaseSIZEERR     
  STOSYSText
  SYSText
  SWAP ROTDROP ROTDROP ROTDROP
;

LABEL SYSTEM39
::
  2SYMB2MATRIX SYSTEM 
ASSEMBLE
	IF	f39
RPL
* returns only 1 stack level on the 39
  UNROT2DROP 
ASSEMBLE
	ENDIF	f39
RPL
  solution2symb CKSYMBN
;

LABEL SOLUTION2SYMB
* list -> OR-symb
::
  DUPNULL{}? casedrop EMPTYSOLUTION
  CKINNERCOMP ZEROSWAP		( s1..sn meta-symb #n )
  ZERO_DO (DO)			( s1..sn meta-symb )
    get1 solution2symb top&	( s1..sn-1 meta-symb meta-symb )
    INDEX@ #0= ?SKIP addtORonly	( s1..sn-1 meta-symb )
  LOOP
  CKSYMBN
;

LABEL EMPTYSOLUTION
:: ' ID NO_SOLUTION TOTEMPOB ;

LABEL solution2symb
* array -> AND-symb-meta
* obj -> obj ONE
::
  DUPTYPEMATRIX? NOTcase ONE
  INNERCOMP ZEROSWAP
  ZERO_DO (DO)
    get1 SYMBINCOMP pshtop&		( s1..sn-1 meta-symb meta-symb )
    INDEX@ #0= ?SKIP addtANDonly	( s1..sn-1 meta-symb )
  LOOP
;

**********************************************************************
* Desc:		Internal VANDERMONDE
* Stack:	
**********************************************************************
NULLNAME VANDERMONDE
::
  DUPTYPELIST? IT LIST2MATRIX
  ARRAY2MATRIX DUPDUP MDIMS 			( v v # false )
  caseSIZEERR
  DROP						( v v )
  1LAMBIND					( v )
  LENCOMP UNCOERCE
  DUP'
    ::
      2DROP
      6GETLAM JINDEX@ #1+ NTHCOMPDROP		( vj )
      INDEX@ DUP#0= case2drop Z1		( -> 1 )
						( vj #i-1 )
      #>Z SYM^					( vj^i-1 )
    ;
  LCPROG2M
  ABND
;

**********************************************************************
* Desc:		Internal HILBERT
* Stack:	
**********************************************************************
NULLNAME HILBERTNOCK
::
  DUP' :: QAdd Z1 DUPUNROT QSub NDXFext ;
  LCPROG2M
  EXACT? ?SEMI
  'EvalNoCK: x->NUM
;


**********************************************************************
* Desc:		Internal JORDAN
* Stack:	matrix ->
**********************************************************************
NULLNAME FLAGJORDAN
::
  VXINDEP? NOTcase VXINDEPERR
  DUP MDIMS NcaseSIZEERR
  #= NOT?DIMERR
  CASFLAGEVAL: :: COMPLEXEVAL JORDAN ;
ASSEMBLE
	IF	f39
RPL
  ( * strip eigenvectors tags * )
  SWAP ' STRIPTAGS 1LAMBIND LISTSECOext ABND SWAP
  FOUR {}N
ASSEMBLE
	ENDIF	f39
RPL
;

**********************************************************************
* Desc:		Internal curl
* Stack:	
**********************************************************************
NULLNAME CURL
::
     INNERDUP #3= NOT?DIMERR
     get1
     INNERDUP #3= NOT?DIMERR			( V1 V2 V3 #3 1 2 3 )
     get1 2DROP					( V1 V2 V3 1 2 3 )
     DUP 6PICK DERIVext			( V1 V2 V3 1 2 3 D2_3 )
     3PICK 6PICK DERIVext RSUBext		( V1 V2 V3 1 2 3 C1 )
     4PICK 6ROLL DERIVext			( V1 V2 1 2 3 C1 D3_1 )
     ROT 7PICK DERIVext RSUBext		( V1 V2 1 2 C1 C2 )
     ROT 6ROLL DERIVext			( V2 1 C1 C2 D1_2 )
     4ROLL 5ROLL DERIVext RSUBext
     THREE[]N
;

**********************************************************************
* Desc:		Internal divergence
* Stack:	
**********************************************************************
NULLNAME DIVERGENCE
::
      INNERCOMP get1 INNERCOMP		( V1 V2 V3 #3 1 2 3 )
      get1 OVER#= NOT?DIMERR			( V1 ... VN F1 ... FN #N )
      get1 ROTSWAP DERIVext
      SWAPDUP
      DUP#1= case2DROP
      ONE_DO (DO)			( V1 . VK F1 . FK DIV #K+1 )
         get1 4ROLLSWAP			( V1 . VK-1 F1 . FK-1 DIV #K+1 VK FK )
         DERIVext ROT RADDext
         SWAP#1-
      LOOP
      DROP
;

**********************************************************************
* Desc:		Internal laplacian
* Stack:	
**********************************************************************
NULLNAME LAPLACIAN
::
  LIST2MATRIX
  DUPUNROT DERIVext SWAP DIVERGENCE
;

**********************************************************************
* Desc:		Internal hessian
* Stack:	
**********************************************************************
NULLNAME HESSIAN
::					( fnct, lvar )
  LIST2MATRIX DUPUNROT DERIVext		( lvar gradient )
  2DUPSWAP DERIVext			( lvar gradient hessian )
  UNROTSWAP				( hessian grad lvar )
ASSEMBLE
	IF	f39
RPL
  THREE{}N
ASSEMBLE
	ENDIF	f39
RPL
;

**********************************************************************
* Desc:		Internal Hermite polynomial
* Stack:	
**********************************************************************
NULLNAME HERMITE
::
  OBJINT? NcaseSIZEERR
  Z>#
  DUP#0=csedrp Z1
  :: Z1 { ZINT 2 ZINT 0 }
     ROT DUP#1= casedrop TOTEMPOB
     ONE_DO (DO)			( H_n-1, H_n )
       DUP Z2 RMULText
       Z0 >TPOLY			( H_n-1, H_n, 2xH_n )
       ROT INDEX@ #2* #>Z RMULText
       RSUBext				( H_n, H_n+1 )
     LOOP
  ;
  SWAPDROP ZEROSWAP RCLVX ONE{}N VAL2ext
;

**********************************************************************
* Desc:		Internal Tchebycheff polynomial
* Stack:	
**********************************************************************
NULLNAME TCHEBNOCK
:: 
  OBJINT? NcaseSIZEERR
  TCHEBext ZEROSWAP RCLVX ONE{}N VAL2ext 
;

**********************************************************************
* Desc:		Internal Legendre polynomial
* Stack:	
**********************************************************************
NULLNAME LEGENDRE
::
  OBJINT? NcaseSIZEERR
    Z>#
    DUP#0=csedrp Z1
    DUP#1= casedrop RCLVX
    Z1 { ZINT 2 ZINT 0 } 
    3PICK ONE_DO (DO)				( #n, T_k-1 T_k )
       INDEX@ #>Z
       2DUP
       Z4 RMULText
       Z2 RADDext
       RMULText
       Z0 >TPOLY				( T_k-1 T_k k P )
       4ROLL 3PICK
       Z4 RMULText
       RMULText RSUBext
       SWAP Z1 RADDext
       RDIVext
    LOOP
    SWAPDROP					( #n, TN )
    Z2 ROT UNCOERCE RPext RDIVext
    ZEROSWAP RCLVX ONE{}N VAL2ext
;

**********************************************************************
* Desc:		Internal LAGRANGE
* Stack:	
**********************************************************************
NULLNAME LAGRANGE
::
  ARRAY2MATRIX
  2DMATRIX? NcaseSIZEERR
  DUPLENCOMP #2= NOT?DIMERR
  VXINDEP? NOTcase VXINDEPERR
  CASFLAGEVAL: LAGRANGEext
;

**********************************************************************
* Desc:		Internal FOURIER
* Stack:	
**********************************************************************
NULLNAME FOURIER
::
  CASFLAGEVAL: FOURIERext
;

**********************************************************************
* Desc:		Internal SIGNE
* Stack:	
**********************************************************************
NULLNAME SIGNE
::
  CASFLAGEVAL: SIGNEext TOTEMPOB
ASSEMBLE
	IF	f39
RPL
  SOLUTION2SYMB
ASSEMBLE
	ENDIF	f39
RPL
;

**********************************************************************
* Desc:		Internal table of variations
* Stack:	
**********************************************************************
NULLNAME TABVAR
:: 
  CASFLAGEVAL: DOTABVAR
;


**********************************************************************
* Desc:		Internal DIVPC
* Stack:	
**********************************************************************
NULLNAME FLAGDIVPC
:: CASFLAGEVAL: DIVPCNOCK ;

LABEL DIVPCNOCK
::				( num, deno, ordre )
  increaseflag SWITCHON
  OBJINT? NcaseSIZEERR
  Z># UNROT x/ext 
  FindCurVar LIMVAR040 VXXLext	( ordre lvar n/d )
  ROTSWAP FXNDext 		( lvar order n d ) 

  ( * check that valuations of both poly is 0 * )
  OVER LISTLASTCOMP j#0=case VALMUSTBE0
  DUP LISTLASTCOMP j#0=case VALMUSTBE0

  LIMDIVPC!			( lvar quot-n quot-d )
  CKCARCOMP DIVOBJext
  R2SYM
;

LABEL LISTLASTCOMP
::
  dLISTcase LASTCOMP
;

**********************************************************************
* Desc:		Internal TRUNC
* Stack:	
**********************************************************************
NULLNAME FLAGTRUNC
:: CASFLAGEVAL: TRUNCNOCK ;

LABEL TRUNCNOCK
::					( symb, reste )
  FindCurVar TWO{}N
  LIMVAR040 VXXLext			( lvar { symb reste } )
  INCOMPDROP				( lvar symb reste )
  TRUNCDL RISCH13			( lvar quotient )
  R2SYM
;

LABEL LIMVAR040
* like LIMVAR! but we have to bind { LAMLIMTYPE LAMLIMORDRE LAMLIMOK }
::
  ONE FOUR ZERO { LAMLIMTYPE LAMLIMORDRE LAMLIMOK } BIND
  LIMVAR!
  ABND
;

**********************************************************************
* Desc:		Internal SEVAL
* Stack:	
**********************************************************************
NULLNAME FLAGSEVAL
:: CASFLAGEVAL: SEVAL ;

LABEL SEVAL
::
  LVARext DUP SLVARext MEVALext
;


**********************************************************************
* Desc:		Internal XNUM
* Stack:	
**********************************************************************
NULLNAME XNUM
::
  CLREXACT
  nogcdflag SetSysFlag
  STRIPTAGS 
  CK&DISPATCH1
  sym CASCRUNCHNUM
  arry XNUMALLARRY
  list XNUMALLLIST
  any NOP
;

LABEL XNUMALLLIST
::
  DUPNULL{}? ?SEMI
  DUP >R LENCOMP ZEROSWAP     ( null-meta # )
  ZERO_DO (DO)
    RSWAP 'R RSWAP            ( meta obj )
    XNUM SWAP#1+              ( meta )
  LOOP
  {}N
;

LABEL XNUMALLARRY
::
  ' CASCRUNCHNUM rpnQOBJext
  BESTMATRIXTYPE
;

LABEL CASCRUNCHNUM
:: REPLACEZBYR CRUNCHNUM ;

**********************************************************************
* Desc:		Internal REORDER
* Stack:	
**********************************************************************
NULLNAME REORDER
:: 
  DUPTYPESYMB? IT SYMB2MATRIX
  LIDNTLVAR SWAPDROP			( obj lvar )
  CASFLAGEVAL: VXXLext R2SYM
;

**********************************************************************
* Desc:		Internal LVAR
* Stack:	
**********************************************************************
NULLNAME USERLVAR
:: LVARext DUPNULL{}? NOTcase {}TO[] ;

**********************************************************************
* Desc:		Internal LNAME
* Stack:	
**********************************************************************
NULLNAME USERLIDNT
:: DUP LIDNText ' IsV>V? SortList DUPNULL{}? NOTcase {}TO[] ;

**********************************************************************
* Desc:		Internal equation splitter
* Stack:	'a=b' -> a, b
* 		obj -> X obj
**********************************************************************
NULLNAME EXLR
::
  symcomp DUP EXPR> 
  DUPEQ: x= SWAP EQ: x== OR 	( obj o1..on %n flag )
  casedrop ROTDROP		( -> o1 o2 )
  COERCE NDROP RCLVX SWAP	( -> x obj )
;

**********************************************************************
* Desc:		Operator is the next object in the runstream, supposed
*		to be binary. 
* Stack:	( o1 o2 --> o1 operator o2 )
**********************************************************************
LABEL BINMODULO
::
  EXACTON CASFLAGEVAL: :: TWO TOLISText ; 	( o1 o2 )
  RCLMODULO 				( o1 o2 mod )
  DUP 4ROLL ModExpa			( o2 mod o1 )
  OVER 4ROLL ModExpa			( mod o1 o2 ) 
  ROT 'REVAL R2SYM
;

**********************************************************************
* Desc:		Internal ADDTMOD
* Stack:	
**********************************************************************
NULLNAME ADDTMOD
:: BINMODULO ModAdd ;

**********************************************************************
* Desc:		Internal ADDTMOD for matrices
* Stack:	
**********************************************************************
NULLNAME MADDTMOD
:: MAT+ EXPAMOD ;

**********************************************************************
* Desc:		Internal SUBTMOD
* Stack:	
**********************************************************************
NULLNAME SUBTMOD
:: BINMODULO ModSub ;

**********************************************************************
* Desc:		Internal SUBTMOD for matrices
* Stack:	
**********************************************************************
NULLNAME MSUBTMOD
:: MAT- EXPAMOD ;

**********************************************************************
* Desc:		Internal MULTMOD
* Stack:	
**********************************************************************
NULLNAME MULTMOD
:: BINMODULO ModMul ;

**********************************************************************
* Desc:		mat*scalar modulo
* Stack:	
**********************************************************************
NULLNAME MAT*SCMOD
:: MAT*SCL EXPAMOD ;

**********************************************************************
* Desc:		scalar*mat modulo
* Stack:	
**********************************************************************
NULLNAME SC*MATMOD
:: SWAP MAT*SCMOD ;

**********************************************************************
* Desc:		mat*mat modulo
* Stack:	
**********************************************************************
NULLNAME MAT*MATMOD
:: ARRAY2MATRIX MAT* EXPAMOD ;

**********************************************************************
* Desc:		division modulo
* Stack:	
**********************************************************************
NULLNAME DIVMOD
:: EvalNoCKx/ EXPAMOD ;

**********************************************************************
* Desc:		GCD modulo
* Stack:	
**********************************************************************
NULLNAME GCD1MOD
:: BINMODULO ModGcd ;

**********************************************************************
* Desc:		Inversion modulo for zint
* Stack:	
**********************************************************************
NULLNAME INVMOD
:: Z1 SWAP x/ext FLAGEXPAMOD ;

**********************************************************************
* Desc:		Inversion modulo for matrix of zint
* Stack:	
**********************************************************************
NULLNAME MINVMOD
::
  EXACTON RCLMODULO
  { LAM MODULO } BIND
  modularflag SetSysFlag
  MATINV
  modularflag ClrSysFlag
  FLAGEXPAMOD
;

**********************************************************************
* Desc:		Euclidean division modulo
* Stack:	
**********************************************************************
NULLNAME FLAGDIV2MOD
:: 
  EXACTON CASFLAGEVAL: DIV2MOD
ASSEMBLE
	IF	f39
RPL
  AND39
ASSEMBLE
	ENDIF	f39
RPL

;

LABEL DIV2MOD
::
  BIN2EVAL ::   RCLMODULO 	( o1 o2 mod )
		DUPROT ModExpa	( o1 mod o2 )
		SWAP ModDiv2	
		;
;

**********************************************************************
* Desc:		Power modulo
* Stack:	
**********************************************************************
NULLNAME FLAGPOWMOD
:: CASFLAGEVAL: POWMOD ;

LABEL POWMOD
:: 
  RCLMODULO 					( sym z_pow z_mod )
  3PICK TYPEZINT? case ModPowSym
  1LAMBIND					( sym z_pow )
  ZERO BINEVAL :: ' :: 1GETLAM ModMul ; MPext ;	( sym^z_pow )
  ABND 
;

LABEL ModPowSym
( z ^ mod -> z^ )
::
  DUP4UNROLL ModPow SWAP QMod
;

**********************************************************************
* Desc:		Matrix Power modulo
* Stack:	
**********************************************************************
NULLNAME FLAGMPOWMOD
:: EXACTON CASFLAGEVAL: MPOWMOD ;

LABEL MPOWMOD
::
  OVER DUPTYPEMATRIX? NcaseTYPEERR 
  MDIMS NcaseTYPEERR
  #= NOT?DIMERR
				( arry zint )
  TWO BINEVAL :: ' :: MMMULT EXPAMOD ; MPext ;
;

**********************************************************************
* Desc:		expand modulo
* Stack:	
**********************************************************************
NULLNAME EXPAMOD
:: ARRAY2MATRIX QOBJext FLAGEXPAMOD ;

NULLNAME FLAGEXPAMOD
:: EXACTON CASFLAGEVAL: SYMEXPAMOD ;

LABEL SYMEXPAMOD
:: MONOEVAL :: RCLMODULO SWAP ModExpa ; ;  

**********************************************************************
* Desc:		FACTOR modulo
* Stack:	symb -> symb
**********************************************************************
NULLNAME FLAGFACTORMOD
::
  EXACTON CASFLAGEVAL: FACTORMOD
;

LABEL FACTORMOD
::
  VXLVARext			( symb lvar )
  VXXLext			( lvar P-list )
  RCLMODULO ModFctr		( lvar meta )
  SYMCOLCTEND			( symb )
;

**********************************************************************
* Desc:		FACTOR modulo for amtrices
* Stack:	matrix -> matrix
**********************************************************************
NULLNAME MFACTORMOD
::
  ARRAY2MATRIX QOBJext FLAGFACTORMOD
;

**********************************************************************
* Desc:		RREF modulo
* Stack:	
**********************************************************************
NULLNAME RREFMOD
:: 
  QPI DUPTYPEMATRIX? NcaseSIZEERR
  2DMATRIX?  NcaseSIZEERR
  RCLMODULO
  { LAM MODULO } BIND
  modularflag SetSysFlag
  ONE TOLISText
  MODULOMAText
  ONESWAP INXREDext
  modularflag ClrSysFlag
  SWAPDROP TWO SWAPROT VAL2ext
  ABND
;

**********************************************************************
* Desc:		Keystroke evaluation
* Stack:	% -> ?
* Note:		if % is negative, the standard key is always evaluated
**********************************************************************
NULLNAME KEYEVAL
:: 
  CKREAL
  DUP %ABS Ck&DecKeyLoc
  ROT %0> ITE Key>U/SKeyOb Key>StdKeyOb
  DoKeyOb ( EVAL )
;


**********************************************************************
* Desc:		Convert continued fraction to rational
* Stack:	( {contfrac} --> fraction )
**********************************************************************
NULLNAME LIFCext
::
  DTYPELIST? NcaseTYPEERR
  '
  ::
    DUP CARCOMP VXXL1ext
    SWAP CDRCOMP
    DUPNULL{}? casedrop Z1 
    1GETLAM EVAL
    SWAP DUP4UNROLL
    ROT RMULText RADDext
    SWAP
  ;
  DUP1LAMBIND EVAL ABND
  RDIVext
  HSECO2RCext
;
