	STITLE Eval

INCLUDE keydefs.h
INCLUDE erromid.h
INCLUDE cas2extdec.h
INCLUDE global.s
	
********************************************************************
*
* RMSYMext	( symb -> symb )
*		Removes all embedded SYMBOL ; in a symbolic
*
*
* TABVALext	( symb, idnt, {} -> {}' )
*		Evaluates symb with idnt=to each element of {}
*		and returns the result in {}'
*
* NOSIMPEVALext	( -> )
*		Next runstream object is executed WITHOUT simplifications
*
* SIMPEVALext	( -> )
*		Next runstream object is executed WITH simplifications
*
*
* TOLISText	( meta -> {}, Q1, .., Qn )
*		Conversion to internal form of a meta of symbolic objects
*
* FROMLISText	( lvar, meta', {} -> {}' )
*		Conversion of elements of meta' to user format
*		meta' does not contain the #n number of element
*		{} is the list of depth of the elements of meta
*		For example to convert a polyn, a vector and a matrix
*		{ X }, { Z1 Z3 }, { Z0 Z1 },
*		{ { Z1 { Z1 Z0 } } }
*		{ #0 #1 #2 }
*		will return {  'X+3'  { 0 1 }  { { 1 X } }  }
*
* BINEVAL	( o1, o2, #depth -> o1 operator o2 )
*		like MONOEVALext for a binary operator
*
* BIN2EVAL	( o1, o2 -> o1', o2' )
*		like DMONOEVALext for an operator taking 2 args
*		and returning 2 args, depth is supposed to be 0
*
* COMPLEXEVAL	( ? )
*		Evaluate next runstream object in complex mode
*
* APPROXEVAL	( ? )
*		Evaluate next runstream object in numeric mode
*
* PFEXECext	( symb, prg -> symb )
*		Execute a prg which is linear with respect to +, - and NEG
*
**********************************************************************

NULLNAME EvalNoCKx*
:: 2SIMPLEFLOAT 'EvalNoCK: x* ;

NULLNAME EvalNoCKx+
:: 2SIMPLEFLOAT 'EvalNoCK: x+ ;

NULLNAME EvalNoCKx-
:: 2SIMPLEFLOAT 'EvalNoCK: x- ;

NULLNAME EvalNoCKx/
:: 2SIMPLEFLOAT 'EvalNoCK: x/ ;

NULLNAME EvalNoCKx^
:: 2SIMPLEFLOAT 'EvalNoCK: x^ ;

NULLNAME EvalNoCKxCHS
:: 'EvalNoCK: xNEG ;

NULLNAME EvalNoCKxINV
:: 'EvalNoCK: xINV ;

NULLNAME EvalNoCKxMOD
:: 'EvalNoCK: xMOD ;

NULLNAME EvalNoCKxPERM
:: 'EvalNoCK: xPERM ;

NULLNAME EvalNoCKxCOMB
:: 'EvalNoCK: xCOMB ;

NULLNAME EvalNoCKxOR
:: 'EvalNoCK: xOR ;

NULLNAME EvalNoCKxAND
:: 'EvalNoCK: xAND ;

NULLNAME EvalNoCKxXOR
:: 'EvalNoCK: xXOR ;

NULLNAME EvalNoCKxXROOT
:: 'EvalNoCK: xXROOT ;

LABEL 2SIMPLEFLOAT
:: SWAP SIMPLEFLOAT SWAP SIMPLEFLOAT ;

LABEL SIMPLEFLOAT
::
  CK&DISPATCH1
  ereal %%>%
  ecmp C%%>C%
  any NOP
;

**********************************************************************
* Desc:		Table of value
* Stack:	( fnct, x, liste -> fnc liste )
**********************************************************************
NULLNAME TABVALext
* calcule la 2eme ligne d'un tableau de variations
( fnct, x, liste -> liste )
::					( fnc x liste )
   DUPLENCOMP TWO #<case DOTABVAL
   DUPTWO NTHCOMPDROP ?ext EQUAL	        ( fnc x list obj=undef? )
   NOTcase TABVALOK-INF
					( fnc x list )
   INNERCOMP #2- {}N			( fnc x o1 o2 list' )
   UNROT OBJ>R OBJ>R			( fnc x list' )
   TABVALOK-INF INCOMPDROP		( fnc list1 list2 )
   ?ext DUPROT INNERCOMP #2+ {}N		( fnc list1 list2' )
   R>OBJ R>OBJ 4ROLL INNERCOMP #2+ {}N	( fnc list2' list1' )
   SWAP TWO{}N				( fnc tabval )
;

LABEL TABVALOK-INF
::
  DUPDUP LENCOMP 			( fnc x list list # )
  DUP#1= case2drop TABVALTRIVIAL
					( fnc x list list # )
  #1- NTHCOMPDROP			( fnc x list obj )
  ?ext EQUALNOTcase DOTABVAL		( -> fcn {} )
  ( * remove +inf part * )
  					( fnc x list )
  INNERCOMP #2- UNROT OBJ>R OBJ>R {}N	( fnc x list' )
  DOTABVAL INCOMPDROP			( fnc list1 list2 )
  INNERCOMP ?ext DUPROT #2+ {}N		( fnc list1 list2' )
  SWAPINCOMP R>OBJ R>OBJ ROT #2+ {}N	( fnc list2' list1' )
  SWAP TWO{}N				( fnc tabval )
;

LABEL TABVALTRIVIAL
:: 					( fnc x list )
  SWAPDROP ?ext ONE{}N TWO{}N		( -> fnc {} )
;

LABEL DOTABVAL
* fnc x list -> fnc {}
::
  3PICK ROT IDNTLAM? NcaseSIZEERR
					( fnct, list, fnct, id )
  ' TABVALLIM THREE ::N			( fnct, list, :: symb id ROT LIMIT ; )
  1LAMBIND DUP LISTSECOext ABND		( fnct, list, list_val )
  TWO{}N				( fnct {} )
;

LABEL TABVALLIM
:: 						( [a | +/-], fnct, id ) 
  ROT DUPTYPECOL? NOTcase :: Z3 LIMIText ;	( -> lim )
  UNROT2DROP 
  { x+ "" x- "" } EQLookup
  DROP $>ID					( variation type )
;

**********************************************************************
* Desc:		Convert meta of symbolic objects to internal form.
* Stack:	( o1..on #n -> Lvar Q1..Qn )
**********************************************************************
NULLNAME TOLISText
::
  dup LISTOPRAC
  LVARDext VX!			( o1, ..., on, #n, lvar )
  DUP1LAMBIND OVER#2+UNROL
  METALISTVXXL DROP ABND
;


**********************************************************************
* Desc:		Conversion of elements of Meta objec to user format.
*		Meta does not contain the #n number of element.
*		L is the list of depth of the elements of Meta.
*		For example to convert a polynomial, a vector and
*		a matrix:
*
*			Lvar	= { X }
*			Meta	= { Z1 Z3 }
*				  { Z0 Z1 }
*				  { { Z1 { Z1 Z0 } } }
*			L	= { #0 #1 #2 }
*
*			L'	= { 'X+2' { 0 1 } { { 1 X } } }
*
* Stack:	( Lvar Meta L --> L' )
**********************************************************************
NULLNAME FROMLISText
::
  DUPLENCOMP #2+ROLL
  SWAPINCOMP get1 OVER
  ZERO_DO			( pile prof1..profn #n lvar )
      ROT 3PICK #3+ ROLL	( pile prof1.. #n lvar profn on )
      ROTDUP			( pile prof1.. #n profn on lvar lvar )
      5UNROLL			( pile' prof1..profn-1 lvar #n profn on lvar  )
      VAL2ext			( pile' prof1..profn-1 lvar #n on  )
      OVER#2+UNROL		( pile' on prof1..profn-1 lvar #n  )
  SWAPLOOP
  2DROP
;

**********************************************************************
* Desc:		Operator is the next object in the runstream, supposed
*		to be unary. #depth is the list depth of o. o is
*		converted to internal format before call of operator
*		and converted back to user format after.
* Stack:	( o #depth --> operator[o] )
**********************************************************************
LABEL MONOEVALext 
::
  SWAP VX>LVARext
  VXXLext
  'REVAL SWAP 
  VAL2ext 
;

**********************************************************************
* Desc:		Operator is the next object in the runstream, supposed
*		to be unary. 
* Stack:	( o --> operator[o] )
**********************************************************************
LABEL MONOEVAL
::
  VX>LVARext VXXLext 'REVAL R2SYM
;

**********************************************************************
* Desc:		Finds depth of o and then calls MONOEVALext
* Stack:	( o --> operator[o] )
**********************************************************************
*LABEL DMONOEVALext
*::
*  DUP DEPTHext
*  COLA MONOEVALext
*;

**********************************************************************
* Desc:		Like MONOEVALext but for a binary operator.
* Stack:	( o1, o2, #depth -> o1 operator o2 )
**********************************************************************
LABEL BINEVAL
::
  UNROT TWO TOLISText
  'REVAL SWAP
  VAL2ext
;

**********************************************************************
* Desc:		Like DMONOEVALext for an operator taking 2 args
*		and returning 2 args, depth is supposed to be 0
* Stack:	( o1, o2 -> o1', o2' )
**********************************************************************
LABEL BIN2EVAL
::
  TWO TOLISText
  'REVAL
  ZEROZERO TWO{}N FROMLISText
;

**********************************************************************
* Desc:		Evaluate next runstream object in complex mode.
* Stack:
**********************************************************************
LABEL COMPLEXEVAL
::
  'R
  COMPLEX?
  OBJ>R
  SETCOMPLEX
  EVAL
  R>OBJ ?SEMI
  CLRCOMPLEX
;

**********************************************************************
* Desc:		Evaluate next runstream object in real mode.
* Stack:
**********************************************************************
LABEL REALEVAL
::
  'R
  COMPLEX?
  OBJ>R
  CLRCOMPLEX		( prg )
  EVAL			( )
  R>OBJ NOT?SEMI	
  SETCOMPLEX
;

**********************************************************************
* Desc:		Execute runstream object WITHOUT simplifications
* Stack:	( --> ? )
**********************************************************************
LABEL NOSIMPEVALext
::
  'R
  nogcdflag TestSysFlag case EVAL
  nogcdflag SetSysFlag
  EVAL
  nogcdflag ClrSysFlag
;

**********************************************************************
* Desc:		Execute runstream object in approx mode
* Stack:	( --> ? )
**********************************************************************
LABEL APPROXEVAL
::
  'R
  approxflag TestSysFlag case PIAPPROXEVAL
  approxflag SetSysFlag
  nogcdflag SetSysFlag
  PIAPPROXEVAL
  nogcdflag ClrSysFlag
  approxflag ClrSysFlag
;

LABEL PIAPPROXEVAL
* prg ->
* eval prg with constant like pi,e,i evaluated to a numeric value
::
  fnConstants TestSysFlag case EVAL
  fnConstants SetSysFlag
  EVAL
  fnConstants ClrSysFlag
;

**********************************************************************
* Desc:		Execute runstream object WITH simplifications
* Stack:	( --> ? )
**********************************************************************
LABEL SIMPEVALext
::
  'R
  nogcdflag TestSysFlag NOTcase EVAL
  nogcdflag ClrSysFlag
  EVAL
  nogcdflag SetSysFlag
;

**********************************************************************
* Desc:		Evaluate next runstream object in step by step mode
* Stack:
**********************************************************************
LABEL STEPEVAL
::
  'R
  stepflag TestSysFlag case EVAL
  stepflag SetSysFlag
  EVAL
  stepflag ClrSysFlag
;

**********************************************************************
* Desc:		Evaluate next runstream object without step by step mode
* Stack:
**********************************************************************
LABEL NOSTEPEVAL
::
  'R
  stepflag TestSysFlag NOTcase EVAL
  stepflag ClrSysFlag
  EVAL
  stepflag SetSysFlag
;

**********************************************************************
* Desc:		Evaluate next runstream object in nocareflag mode
* Stack:
**********************************************************************
LABEL NOCAREEVAL
::
  'R
  nocareflag TestSysFlag case EVAL
  nocareflag SetSysFlag
  EVAL
  nocareflag ClrSysFlag
;

**********************************************************************
* Desc:		Evaluate next runstream object without switch warning
* Stack:
**********************************************************************
LABEL AUTOSWITCHEVAL
::
  'R
  switchflag TestSysFlag case EVAL
  switchflag SetSysFlag
  EVAL
  switchflag ClrSysFlag
;

**********************************************************************
* Desc:
* Stack:	( symb, prg -> symb )
**********************************************************************
NULLNAME PFEXECext
::
  ZERO			( LAM3/6 depth save )
  ' ::			( LAM2/5 obj -> obj )
       DEPTH 6PUTLAM
       7GETLAM EVAL
       DEPTH 6GETLAM #=
       NOTcase SETSTACKERR
    ;
  ' ::			( LAM1/4 OBJ -> OBJ )
       FXNDext SWAP
       DUPTYPESYMB? NOTcase
       :: SWAPNDXF 5GETLAM EVAL ;
       { x+ x- xNEG }
       OVER DUPLENCOMP NTHCOMPDROP		( D N L OP )
       EQUALPOSCOMP #0=case
       :: SWAPNDXF 5GETLAM EVAL ;
       EXPR> SWAP COERCEDUP
       ZERO_DO 
           get1 OVER #3+PICK NDXFext
           4GETLAM EVAL 
       SWAPLOOP
       get1 SWAPDROP
       EvalNoCK SWAPDROP
    ;
  4NULLLAM{} BIND
  QOBJext
  :: 4GETLAM EVAL ;
  ABND
;

**********************************************************************
* Desc:		Apply non-recursively << ob binop >> to the elements
*		of the list.
* Stack:	( {} ob binop --> {}' )
**********************************************************************
NULLNAME LOP1ext
::
  3PICK TYPELIST? NOTcase EVAL
  1LAMBIND
  SWAPINCOMP get1 OVER
  ZERO_DO (DO)				( o1, ..., on , #n, o )
     ROTOVER
     1GETLAM EVAL
     3PICK #2+UNROLL
  LOOP
  DROP {}N
  ABND
;

**********************************************************************
* Desc:		Apply recursively << op binop >> to the elements
*		of the list (not the list elements themselves).
* Stack:	( {} ob binop --> {}' )
**********************************************************************
NULLNAME LOPAext
::
  '
  ::
    dLISTcase LISTSECOext
    DUPTYPEIRRQ? case LOPAIRRQ
    3GETLAM 2GETEVAL
  ;
  3LAMBIND
  1GETLAM EVAL
  ABND
;

LABEL LOPAIRRQ
* if lam3 is not an irrq applies prg in lam1 to a and b of a+b*sqrt[c]
::
  ( * test if ob in lam3 is an irrq * )
  3GETLAM DUPTYPEIRRQ? case 2GETEVAL
			( irrq lam3 )
  DROP QXNDext		( a b c )
  ROT 1GETLAM EVAL
  ROT 1GETLAM EVAL
  ROT NDXQext
;

**********************************************************************
* Desc:		Apply 1LAM non-recursively to all elements of the list
* Stack:	( composite --> composite )
**********************************************************************
NULLNAME LISTSECOext
LABEL listsecoext!
*::
*  CK&DISPATCH1
*  list LISTSECO
*  symb LISTSECO
*  seco LISTSECO
*  matrix LISTSECO
*  any 1GETEVAL
*;
*
*LABEL LISTSECO
::
  DUPINCOMP			( liste, o1, ..., on, #n )
  DUP#0=csDROP
  DUP#0_DO			( liste, o1, ..., on, #n )
     DUP #1+ROLL
     1GETLAM EVAL
  SWAPLOOP
  get1 ERABLETYPE COMPN
;
*
*LABEL 1GETEVAL
*:: 1GETLAM EVAL ;

**********************************************************************
* Desc:		Apply prg to ob, recursively for lists and secos.
* Stack:	( ob --> ob' )
* Note:		The program is fetched from the runstream.
**********************************************************************
LABEL QOBJSECext
::
  'R
  CK1TONOext
  '
  :: CK&DISPATCH1
     zint   2GETEVAL
     list   LISTSECOext
     ereal  2GETEVAL
     real   2GETEVAL
     ecmp   2GETEVAL
     TWO    2GETEVAL
     sym    2GETEVAL
     seco   2GETEVAL
     TAGGED :: xOBJ\-> SWAP 1GETLAM EVAL SWAP x\->TAG ;
     arry   QOBJARRY
     any    NOP
  ;
  2LAMBIND
  1GETLAM EVAL
  ABND
;

**********************************************************************
* Desc:		Apply prg to ob, recursively for lists
* Stack:	( ob --> ob' )
* Note:		prg is fetched from the stack
**********************************************************************
NULLNAME rpnQOBJext
::
  ' QOBJ1 
  2LAMBIND
  QOBJ1
  ABND
;

**********************************************************************
* Desc:		Apply prg to ob, recursively for lists
* Stack:	( ob --> ob' )
* Note:		prg is fetched from runstream
**********************************************************************
LABEL QOBJext
::
  'R
  ' QOBJ1 
  2LAMBIND
  QOBJ1
  ABND
;

LABEL QOBJ1
:: 
  CK&DISPATCH1
  zint   2GETEVAL
  list   LISTSECOext
  ereal  2GETEVAL
  ecmp   2GETEVAL
  real   2GETEVAL
  TWO    2GETEVAL
  sym    2GETEVAL
  TAGGED QOBJTAG
  arry   QOBJARRY
  seco   QOBJSEC
  str    2GETEVAL
  any    NOP
;

LABEL QOBJTAG
:: 'EvalNoCK: xOBJ> SWAP QOBJ1 SWAP >TAG ;

LABEL QOBJARRY
:: 
  ARRAY2MATRIX
  LISTSECOext
  ( * added check before rebuilding the array * )
  XEQARRY> CKARRYLIST			( ob1 ... obn { # [#] } )	
  BUILDMATRIX				( [] )
;

LABEL QOBJSEC
:: 
  INNERDUP #2= 
  casedrop QOBJCMPLX
  DUP #5= NOTcase ::POLY
  2DROP 4ROLLDROP
  THREE ZERO_DO (DO) 
    QOBJ1 UNROT 
  LOOP 
  NDXQext 
;

LABEL QOBJCMPLX
:: 
  QOBJ1 SWAP
  QOBJ1 RIXCext
;

**********************************************************************
* Desc:		Calls << ob2 binaryop >> on each element of M3.
*		prg1 must act like a binary operator.
*		#depth=2 if M3 is a matrix, 1 for a vector
*		For example ob2=%5 & prg1=RMULText
*		For example ob2='X' & prg1=VALext
* Stack:	( M3 ob2 #depth [runstream binaryop] --> M )
**********************************************************************
LABEL DEPTHEVAL:
::
  'R				( M ob #depth binop )
  '
  ::				( LAM1: obj -> obj )
    3GETLAM DUP#0=csedrp
    :: 4GETLAM 2GETEVAL ;
    #1- 3PUTLAM 
    INNERDUP #1-SWAP
    ZERO_DO
       get1 1GETLAM EVAL
    SWAPLOOP
    #1+ []N
    3GETLAM #1+ 3PUTLAM
  ;				
				( M ob #depth binop prg )
  4NULLLAM{} BIND		
  1GETLAM EVAL
  ABND
;

**********************************************************************
* Desc:		Replace first CK<n>&Dispatch by CK&DISPATCH1
*		where n is 1 or 2.
* Stack:	( seco --> seco' )
**********************************************************************
NULLNAME CK1TONOext
::
  DUPTYPECOL? NOT?SEMI
  DUP CARCOMP
  { CK1&Dispatch CK2&Dispatch }
  matchob?				( seco, [ first, FALSE ] | TRUE )
  NOTcaseDROP
					( o1, ..., on, #n )
  CDRCOMP
  ' CK&DISPATCH1
  >HCOMP
;

