RPL
* dispatching constants
DEFINE cmp              TWO
DEFINE lam              SEVEN
DEFINE hxs              ELEVEN
DEFINE romptr           FIFTEEN
DEFINE ereal            SIXTYTHREE
DEFINE ecmp             SEVENTYNINE
DEFINE realcmp          EIGHTEEN
DEFINE cmpreal          THIRTYTHREE
DEFINE cmpcmp           THIRTYFOUR
DEFINE realhxs          TWENTYSEVEN
DEFINE hxsreal          HXSREAL
DEFINE symbsym          SYMBSYM
DEFINE symsym           SYMSYM
DEFINE symlist          SYMLIST
DEFINE listsymb         #_59
DEFINE symbany          #90
DEFINE bin              THIRTYONE
DEFINE grob             TWELVE
DEFINE 2ARRY            SIXTYEIGHT
DEFINE cmpidnt		THIRTYEIGHT
DEFINE cmplam		THIRTYNINE
DEFINE realidnt		TWENTYTWO
DEFINE reallam		TWENTYTHREE
DEFINE realsym		TWENTYSIX
DEFINE symidnt		SYMID
DEFINE symlam		SYMLAM
DEFINE symsymreal	SYMSYMREAL
DEFINE symsymb		SYMSYMB
DEFINE listsym		BINT90
DEFINE zint		BINT255d
* Vger specific dispatchees, comment for 48
DEFINE matrix		arry		
DEFINE symmatrix	SYMARRY		
DEFINE 2matrix		2ARRY		
DEFINE matrixob		SIXTYFOUR
DEFINE matrixidnt	ARRYID
DEFINE matrixlam	BINT71
DEFINE matrixsymb	BINT73
DEFINE realmatrix	TWENTY
DEFINE cmpmatrix	THIRTYSIX
DEFINE zintzint         #FFFF 
DEFINE realzint	        #1FF 
DEFINE zintreal	        #FF1
* 48 specific dispatchees, comment for Vger
*DEFINE matrix		list
*DEFINE symmatrix	SYMLIST
*DEFINE 2matrix		2LIST		
*DEFINE matrixob		EIGHTY
*DEFINE zint		hxs
*DEFINE zintzint		#BB
*DEFINE realzint		realhxs
*DEFINE zintreal		hxsreal

**********************************************************************
* Compilation flags
**********************************************************************
ASSEMBLE
	CLRLIST ALL
fSVERSION	EQU 1
fDISTDIV	EQU 2		Set this flag for ALG48 distdiv
fABSOLU		EQU 3
fALG48FCTR	EQU 4		Setting fALG48FCTR require setting fDISTDIV
fVGER		EQU 5		Indicates compilation for Vger
f39		EQU 6		Indicates compilation for HP39
*	SETFLAG	f39
* 	SETFLAG    fSVERSION
	SETFLAG    fDISTDIV
	SETFLAG    fABSOLU
	SETFLAG	   fALG48FCTR
RPL

DEFINE	LENZ		LENHXS		remains correct for Vger too
*DEFINE	SUBZ		SUBHEX		not used at all


**********************************************************************
*			Help Macros
**********************************************************************
ASSEMBLE
	IFNOPC	LCZ0
* Load Z0 into C
LCZ0		MACRO
		LC(N)	11
		CON(5)	=DOINT
		CON(5)	6
		CON(1)	0
LCZ0		ENDM
* Load Z1 into C
LCZ1		MACRO
		LC(N)	12
		CON(5)	=DOINT
		CON(5)	7
		CON(1)	1
		CON(1)	0
LCZ1		ENDM

* Load Gaussian integer prolog into C
LCCMP		MACRO
		LC(N)	10
		CON(5)	=DOCOL
		CON(5)	=DOINT
LCCMP		ENDM

* Load quadratic extension prolog into C
LCIRRQ		MACRO
		LC(N)	10
		CON(5)	=DOCOL
		CON(5)	=x<<
LCIRRQ		ENDM

* Macro to create a ram-word predicate

RAMWORD MACRO   $name
        CON(2)  (($1fin)-($1deb))/2
$1deb   NIBASC  /$1/
$1fin   CON(2)  (($1fin)-($1deb))/2
RAMWORD ENDM

* Macro to create a ram-word link

RAMWEND MACRO   $name
$1link  CON(5)  ($1link)-($1deb)+2
RAMWEND ENDM

* Global status flag use

sALG48		EQU 5	Indicate ALG48 polynomial operations
sTRIM		EQU 5	Trimmin status flag
s2META		EQU 5	Indicate search of object in 2 metas instead of 1
sQMULREG	EQU 6	Flag for marking register QMul
sQSUB		EQU 7	Flag for marking sub/add
sRE		EQU 7	Drapeau pour re/im
sDUMMYCOEFF	EQU 8	Flag dummy coefficients
sQSWAP		EQU 8	Flag for marking swapped D0/D1
sSWAP		EQU 8
sMODULAR	EQU 9	Flag modular division
sQSWAP*		EQU 9	Flag for marking swapped D0/D1 in QMUL
sSHORTMOD	EQU 9	Help flag for modular math
sGARB		EQU 10	Global GC-done flag
sTRASH		EQU 11  Global trash topmost tempob flag
sMETACOMPRIM	EQU 7	Flag for METACOMPRIM0: allow/ removal of \"factor\" Z1

*=aATTNFLG       EQU #01888 * was 4226C * Hook
*=aDSKTOP	EQU #067AA * Hook
*=aAVMEM		EQU #067C6 * Hook

* ROMPTR used in matrix.s
~laRANK		EQU	#360C2
~laEGVL		EQU	#020C2
~laRANM		EQU	#000C3
~laRREF		EQU	#5B0C2
~laRanInt	EQU	#010C3
~laTRACE	EQU	#4C0C2
~laEGV		EQU	#040C2
* in eruser.s
~xINPUT		EQU	#85004
* ROMPTR used in factor.s
~proot		EQU	#010C0
* 

	ENDIF	(macro LCZ0 defined)
RPL




* If Z>Zsmall then OBJPOSINT? returns false. this is useful not to
* expand e.g. sin(100*x) or (x+50)!
DEFINE Zsmall		ZINT 11
* Zlimit is the order for series expansion for LIMIT
DEFINE Zlimit		Z3

* bint
DEFINE BINT0		ZERO
DEFINE BINT1		ONE
DEFINE BINT2		TWO
DEFINE BINT3		THREE
DEFINE BINT4		FOUR
DEFINE BINT5		FIVE
DEFINE BINT6		SIX
DEFINE BINT7		SEVEN
DEFINE BINT8		EIGHT
DEFINE BINT9		NINE
DEFINE BINT10		TEN
DEFINE BINT11		ELEVEN
DEFINE BINT12		TWELVE
DEFINE BINT13		THIRTEEN
DEFINE BINT14		FOURTEEN
DEFINE BINT15		FIFTEEN
DEFINE BINT16		SIXTEEN
DEFINE BINT17		SEVENTEEN
DEFINE BINT18		EIGHTEEN
DEFINE BINT19		NINETEEN
DEFINE BINT20		TWENTY
DEFINE BINT21		TWENTYONE
DEFINE BINT22		TWENTYTWO
DEFINE BINT23		TWENTYTHREE
DEFINE BINT24		TWENTYFOUR
DEFINE BINT25		TWENTYFIVE
DEFINE BINT26		TWENTYSIX
DEFINE BINT27		TWENTYSEVEN
DEFINE BINT28		TWENTYEIGHT
DEFINE BINT29		TWENTYNINE
DEFINE BINT30		THIRTY
DEFINE BINT31		THIRTYONE
DEFINE BINT32		THIRTYTWO
DEFINE BINT33		THIRTYTHREE
DEFINE BINT34		THIRTYFOUR
DEFINE BINT35		THIRTYFIVE
DEFINE BINT36		THIRTYSIX
DEFINE BINT37		THIRTYSEVEN
DEFINE BINT38		THIRTYEIGHT
DEFINE BINT39		THIRTYNINE
DEFINE BINT40		FORTY
DEFINE BINT41		FORTYONE
DEFINE BINT42		FORTYTWO
DEFINE BINT43		FORTYTHREE
DEFINE BINT44		FORTYFOUR
DEFINE BINT45		FORTYFIVE
DEFINE BINT46		FORTYSIX
DEFINE BINT47		FORTYSEVEN
DEFINE BINT48		FORTYEIGHT
DEFINE BINT49		FORTYNINE
DEFINE BINT50		FIFTY
DEFINE BINT51		FIFTYONE
DEFINE BINT52		FIFTYTWO
DEFINE BINT53		FIFTYTHREE
DEFINE BINT54		FIFTYFOUR
DEFINE BINT55		FIFTYFIVE
DEFINE BINT56		FIFTYSIX
DEFINE BINT57		FIFTYSEVEN
DEFINE BINT58		FIFTYEIGHT
DEFINE BINT59		FIFTYNINE
DEFINE BINT60		SIXTY
DEFINE BINT61		SIXTYONE
DEFINE BINT62		SIXTYTWO
DEFINE BINT63		SIXTYTHREE
DEFINE BINT64		SIXTYFOUR
DEFINE BINT65		ARRYREAL

* user flags
DEFINE fnResults	THREE		( known as Numeric flag )
DEFINE fnConstants	TWO
DEFINE fnAngle1		SEVENTEEN
DEFINE fnAlgebraicMode	BINT95

DEFINE displayflag      BINT99
DEFINE VerboseFlag      BINT99		( set for informations )
DEFINE stepflag		BINT100  	( set for step by step mode on )
DEFINE vxxlflag         BINT101		( internal use: true if VXXL success )
DEFINE nogcdflag        BINT102		( set for no gcd computations )
DEFINE complexflag      BINT103		( set for complex mode )
DEFINE invlnflag        BINT104		( internal use:	LN->-INV[-LN]] )
DEFINE approxflag       BINT105		( set for approx mode )
DEFINE tsimpflag        BINT106		( set if no TSIMP call inside SERIES )
DEFINE modularflag      BINT107  	( internal use:	modular computation )
DEFINE divflag          BINT108 	( internal use:	testing remainder=0 )
DEFINE numfactorflag    BINT109 	( set to allow numeric factorization )
DEFINE bigdataflag      BINT110		( set for large matrices )
DEFINE nonrecurflag     BINT111  	( set: don't simpl. inside non rat op )
DEFINE iisirrqflag      BINT112  	( set to see i as an irrquad c=-1 )
DEFINE pfexpaflag       BINT113    	( set to disable linearity simplif. )
DEFINE increaseflag     BINT114   	( set for increasing power x+1 -> 1+x )
DEFINE sqrtflag         BINT115   	( internal use:	sqrt not as irrquad )
DEFINE prefersinflag    BINT116  	( set if sin are prefered to cos )
DEFINE chooseflag       BINT117    	( set for menu as choosebox )
DEFINE keepintflag	BINT118    	( set if xINT is not simplified ) 
DEFINE nocareflag       BINT119   	( set if non rigourous mode )
DEFINE switchflag       BINT120		( set to allow silent mode switch )
DEFINE lnabsflag	BINT121  	( set if xLN returns LN[ABS[]] )
DEFINE div0by0flag	BINT122		( set by / if 0 divided 0 occurs )
DEFINE noswitchflag	BINT123		( set to forbid mode switch )
DEFINE cascompevalflag	BINT124		( set to forbid non alg. CASCOMPEVAL )
DEFINE sturmflag	BINT125		( set to forbid Sturm sign research )
DEFINE lastcolflag	BINT126		( set for row reduction w/ last col )
DEFINE allrealflag	BINT128		( all var are real var )

* systems flags
DEFINE isolflag         ONE		( set to find only 1 solution )
DEFINE iflag            TWENTYSEVEN	
DEFINE polarflag	SIXTEEN		( set for polar cordinate mode )
DEFINE overflowflag	TWENTYONE

* Alias names
DEFINE POP2%SPLITAC POP2%SPLTAC
DEFINE cmp_i	SYMi
DEFINE %%SQR	%%X^2+Y^2
DEFINE splitup	SCANAHEAD
DEFINE larg	splitonearg
DEFINE 3SKIP	3skip
DEFINE EXPR=	SYM=
DEFINE CKSYMBN	unsyminner
DEFINE LIDNT	FINDVAR
DEFINE DROPdrop DROPNDROP
DEFINE drop	NDROP
DEFINE M1st+case MEQ+case
DEFINE M1st-case MEQ-case
DEFINE M1st*case MEQ*case
DEFINE M1st/case MEQ/case
DEFINE M1stNEGcase MEQCHScase
DEFINE M1stINVcase MEQINVcase
DEFINE M1st^case MEQ^case
DEFINE M1stSQcase MEQSQcase
DEFINE M1stFcncase MEQFCNcase
DEFINE addt*	onlyputop*
DEFINE addt-	putop-
DEFINE addt+	putop+
DEFINE addtNEG	MetaNeg
DEFINE meta+	putop+
DEFINE meta-	putop-
DEFINE meta*	putop*
DEFINE meta/	putop/
DEFINE metainv	putopINV
DEFINE SYM^	ssSYM^
DEFINE SYM+	ssSYM+
DEFINE SYM-	ssSYM-
DEFINE SYM*	ssSYM*
DEFINE SYM/	ssSYM/
DEFINE SYMNEG	SYMCHS
DEFINE x\->Q	x->Q
DEFINE x\->TAG	x->TAG
DEFINE x\.S	rpnINTG
DEFINE x\.S_ALGEBRAIC xINTEGRAL
DEFINE x\.d	rpnDER
DEFINE x\pi	xPI
DEFINE x\v/	xSQRT
DEFINE xe	xCONSTANTe
DEFINE x|	rpnWHERE
DEFINE x<=	x<=?
DEFINE x>=	x>=?
DEFINE x!=	x#?
DEFINE xD\->R	xD>R
DEFINE xR\->D	xR>D
DEFINE dup	metaDUP
DEFINE swap	psh
DEFINE rot	ROTUnits
DEFINE unrot	rolltwo
DEFINE 4roll	roll3RD
DEFINE 4unroll	rollthree
DEFINE N+1roll	rollNTH
DEFINE N+1unroll	rolln
DEFINE swapdrop	SWAPUnNDROP
DEFINE rotswap	argswap
DEFINE rotdup	metaROTDUP
DEFINE 4rollunrot	argswapnext
DEFINE rottop&	ROTUntop&
DEFINE unrottop&	roll2top&
DEFINE pick1	DUP#2+PICK
DEFINE addt	SWAP#1+
DEFINE pulldrop	#1-SWAPDROP
DEFINE addt:	'RSWP1+
DEFINE addt2:	'R'RROT2+
DEFINE psh1&rev:	'Rpsh1&rev
DEFINE EQUALcasedro EQUALcasedrop
DEFINE OVER#2+UNROL OVER#2+UNROLL
DEFINE x!	xFACT
DEFINE xARRY\-> xARRY>
DEFINE x\->ARRY x>ARRY
DEFINE x\->GROB x>GROB
DEFINE xOBJ\-> xOBJ>


*DEFINE SHALT            ROMPTR 3E0 7
DEFINE xSHALT           ROMPTR 3E0 7

* AUFR linear algebra external definitions
*EXTERNAL laRREF		
*EXTERNAL laTRACE	
*EXTERNAL laEGV		
*EXTERNAL laEGVL		
*EXTERNAL laRANK		
*EXTERNAL laRANM		
*EXTERNAL laRanInt	

ASSEMBLE
OverfActFl   EQU 21
InfResActFl  EQU 22
UnderfNegFl  EQU 23
UnderfPosFl  EQU 24
OverflowFl   EQU 25

OverfActNib  EQU ((OverfActFl)-1)/4
OverfActBit  EQU ((OverfActFl)-1)%4

OverflowNib  EQU ((OverflowFl)-1)/4
OverflowBit  EQU ((OverflowFl)-1)%4

sotype  EQU 0       stand-alone macro - has parser
toptype EQU 1       beginning macro - has parser
midtype EQU 2       middle macro - doesn't have parser
bottype EQU 3       ending macro - doesn't have parser

** the equates below, and the ordering of the elements must correspond
** with that given in CALR/proplists.s

hasSST EQU 8        SST data corresponds with the high bit

**miscdoc+**************************************************
************************************************************ 
**
**	Equates for Property-List Bits
**
**	These equates (and the implied order of the properties) 
**	must be consistent with the property-list bits for 
**	macros as defined elsewhere.
**
************************************************************
**+miscdoc**************************************************
ASSEMBLE

* most significant nibble equates:

nonALG EQU 8			not-allowed-in-algebraics flag 
hasHELP EQU 4			has-help-data flag
hasPROMPTM EQU 4		same as above
hasALIAS EQU 2			has-algebraic-alias flag
hasPDATA EQU 1			has-parse-data flag

* the remaining equates are only relevant for algebraic functions.
* next most significant nibble equates:

hasDER EQU 8			has-derivative flag
hasINV EQU 4			has-inverse flag
hasCOLCT EQU 2			has-COLCT-data flag
hasEXPND EQU 1			has-EXPND-data flag

* least significant nibble equates:

hasFORM EQU 8			has-FORM-menu flag
hasINTG EQU 4			has-Integral-data flag
hasWHERE EQU 2			has-WHERE-code flag
hasVUNS EQU 1			has-veryunsymin-code flag

**miscdoc+**************************************************
************************************************************ 
**
**	Equates for Parse-Data
**
**	Each equate name has the structure:
**
**		 pd<component abbreviation>
**
**	where the component abbreviation is that of the ERS
**	section on parsing symbolic objects.
**
************************************************************
**+miscdoc**************************************************

pdEX EQU #0		general expression
pdOP EQU #1		operator
pdQE EQU #2		quoted expression
pdQN EQU #3		quoted name
pdLP EQU #4		left parenthesis
pdRP EQU #5		right parenthesis
pdCM EQU #6		comma (non-radix)
pdEQ EQU #7		equal-sign separator
pdOS0 EQU #8		optional repeat 0
pdOS1 EQU #9		optional repeat 1
pdOS2 EQU #A		optional repeat 2
pdOS3 EQU #B		optional repeat 3
pdOS4 EQU #C		optional repeat 4
pdOS5 EQU #D		optional repeat 5
pdOS6 EQU #E		optional repeat 6
pdOS7 EQU #F		optional repeat 7

RPL

**********************************************************************
