INCLUDE erromid.h
INCLUDE cas2extdec.h
INCLUDE global.s
INCLUDE keydefs.h

	STITLE  Modular Univariate Factorization

NULLNAME ModFctr
( P Z -> meta )
::
  ( * Z must be lower than 97 * )
  ZABS DUP ZINT 98 ZNLT? NOTcase CANTFACTOR

  ( * first square-free factorization * )
  Z1 SWAP 2LAMBIND			( P )
  CheckPNoExt				( P flag )
  NOTcase CANTFACTOR
  Univar? NOTcase CANTFACTOR
					( P )
  ONESWAP				( #1 P )
  DUP DERext				( #1 P P' )
  ModSimp3				( #1 R1 P/R1 P'/R1 )
  DROPSWAP				( #1 T1 R1 )

* T1= Pi_{i} q_i, R1= Pi_{i>=2} q_i^{i-1}

  BEGIN					( S1..Si-1 %i-1 i Ti Ri )
     3PICK UNCOERCE 4UNROLL
     ?ATTNQUIT
     DUPCKLEN{} #1<>			( S1..Si-1 %i-1 %i i Ti Ri flag )
  WHILE
     ROT#1+UNROT			( S1..Si-1 %i-1 %i i+1 Ti Ri )
     ModSimp3

* Tk=Pi_{i>=k} q_k, Sk=q_k, R_k=Pi_{i>k} q_i^{i-k}

					( S1..Si-1 %i-1 %i i+1 Ti+1 Si Ri+1 )
    SWAP 5UNROLL		( S1, .., Si-1, %i-1, Si, %i, i+1, Ti+1, Ri+1 )
  REPEAT			
				( S1..Se-1 %e-1 %e e Te Re )
  2SWAP ROT			( S1..Se-1 %e-1 Te %e e Re )
  %1 ROT#1+ #2*			( S1 %1 ... Se %e #2e )
  
  ( * now berlekamp on each factor * )
  #2/ ZEROSWAP
  ZERO_DO (DO)			( S1 %1 ... Se %e meta-res )
    get1 rotomo			( S1 %1 ... meta-res %e Se )
    ModFctrB			( S1 %1 ... meta-res meta ) 
    top&
  LOOP
  2GETLAM %1 ROT #2+		( meta )
  ABND
;

LABEL ModSimp3
* lam1 must contain modulo
( P, Q -> G, P/G, Q/G )
::
  2DUP 1GETLAM ModGcd		( P Q G )
  DUP4UNROLL 1GETLAM ModDiv2	( G P Q/G 0 )
  DROPSWAP 3PICK		( G Q/G P G )
  1GETLAM ModDiv2 DROPSWAP	( G Q/G P/G )
;

LABEL ModFctrB
( %k Sk -> meta )
::
  NOTLISTcase ModFctrNotB
					( %k P )
  1GETLAM Z># BerlekampP 
  NOTcase CANTFACTOR			( * unable to factor * )
					( %e P Lf #p )
  DROPSWAP DROPDUP >R LENCOMP		( %e # )
  ZERO UNROT				( meta %e # )
  ZERO_DO (DO)
    RSWAP 'R RSWAP			( meta %e fact )
    OVER 4ROLL 				( meta' %e fact %e # )
    #2+ 4ROLL				( meta %e )
  LOOP
  DROP					( meta )
;

LABEL ModFctrNotB
:: 
  SWAP RP#			( Sk^k )
  2GETLAM QMul 2PUTLAM		( )
  ZERO				( meta )
;