INCLUDE erromid.h
INCLUDE cas2extdec.h
INCLUDE keydefs.h
INCLUDE global.s

	STITLE Conversion to internal form

**********************************************************************
* EXPORT:
*
* VXXLext	( obj, {} -> Q )
*		obj is a symbolic or a symb vector or a symb matrix
*		{} is a list of idnt
*		If the conversion was not successfull, error
*
* METAVXXLext	( meta -> {} )
*		meta is a list-meta, do not confuse for VXXL2
*		the list of idnt must be in LAM1
*
* VXXLFext	( n/d -> Z1/Z2 )
*		Conversion of a fraction which does not depend of any variables
*
* VXXL1ext	( n -> Z )
*
* VXXL0		( obj -> Q )
*		Conversion of obj w.r.t. LAM1
*
* VXXL2		( meta -> Q )
*		meta is a symb-meta
*
* LIDNText	( obj -> {} )
*		List of all idnt present in obj
*
* RLVARext	( obj -> {} )
*		Recursive search of all variables
*
* VXLVARext	( obj -> obj, {} )
*		Like LVARext but the current variable is >HCOMPed
*		Square roots ARE NOT included in the list of rat. operators
*
* LVARext	( obj -> obj, {} )
*		liste of variables
*		Square roots ARE  included in the list of rat. operators
*
* VX>LVARext	( obj -> obj, {} )
*		Like LVARext but the current variable is >HCOMPed
*		Square roots ARE  included in the list of rat. operators
*
* VX>		( {} -> {} )
*		If VX is in lthe list then moves it at the beginning
*		Otherwise does nothing
*
* VX!		( {} -> {} )
*		If VX is in the list then moves it at the beginning
*		Otherwise >HCOMP VX to the list
*
* LIDNTLVAR	( obj, list1 -> obj, list1, list2 )
*		list2 is the list of var of obj but elements of list1
*		are moved to the beginning of list2
*
* LISTOPRAC	( -> {} )
*		Returns the list of rational operator with sqrt >TCOMPed
*
* LISTOPext	( -> {} )
*		A list of rational operators
*
* LVARDext	( obj, list1 -> list2 )
*		( meta, list1 -> list2 )
*		list1 is a list of "rational" operators used to
*		determine the list of "variables" of obj (or meta)
*
* IsV>V?	( v1 v2 --> flag )
*		True if v1 is lexicographically after v2
*
* DEPTHext	( obj -> # )
*		Returns the max number of embedded lists of obj
**********************************************************************

**********************************************************************
* Desc:		Convert object to internal form. The object can be
*		a symbolic, a symbolic vector or a symbolic matrix.
*		If the conversion was not successfull, vxxxlflag
*		is cleared.
* Stack:	( ob Lvar --> Q )
**********************************************************************
NULLNAME VXXLext
::
  DUPTYPELIST? ?SKIP ONE{}N		( ob lvar )
  DUPUNROT				( lvar objet lvar )
  1LAMBIND VXXL0
  ABND
;

**********************************************************************
* Desc:		Conversion of all elements of a meta object with
*		respect to the variables in LAM1.
* Stack:	( Meta --> Meta )
**********************************************************************
NULLNAME METALISTVXXL
::				( o1, ..., on, #n )
  DUP#0= ?SEMI
  DUP#0_DO			( o1, ..., on, #n )
     DUP #1+ROLL VXXL0
  SWAPLOOP
;

**********************************************************************
* Desc:		Conversion of a fraction which does not depend on
*		any variables.
* Stack:	( n/d --> Z1/Z2 )
**********************************************************************
NULLNAME VXXLFext
::
  FXNDext
  VXXL1ext SWAP VXXL1ext
  SWAPNDXF
;

**********************************************************************
* Desc:		Conversion of an object which does not depend on
*		any variables.
* Stack:	( n --> Z )
**********************************************************************
NULLNAME VXXL1ext
CODE
		GOSBVL	=a=stk1
		LC(5)	=DOREAL
		?A=C	A
		GOYES	tovxxl0
		LC(5)	=DOCMP
		?A=C	A
		GOYES	tovxxl0
		LC(5)	=DOINT
		?A=C	A
		GOYES	tovxxl0
		LC(5)	=DOCSTR
		?A=C	A
		GOYES	tovxxl0
		LC(5)	=DOBINT
		?A#C	A
		GOYES	tovxxl1lp
		GOVLNG	=bin2z
tovxxl1lp	GOVLNG	=Loop
tovxxl0		
vxxl0		LA(5)	=VXXL0
		PC=(A)
ENDCODE

**********************************************************************
* Desc:		Conversion of object with respect to Lvar in LAM1.
* Stack:	( ob --> Q )
**********************************************************************
NULLNAME VXXL0
:: 
   CK&DISPATCH0
   zint vxxlzint!
   list vxxllist!
   symb vxxlsymb!
   idnt vxxlsym!
   lam  vxxlsym!
   real vxxlreal!
   cmp	vxxlcmp!
   seco vxxlseco!
   TAGGED  vxxltag!
   arry vxxlarry!
   ereal EXACTOFF
   ecmp EXACTOFF
   EXT EXACTOFF
   romptr EvalNoCK
*  str vxxlstr!
;


**********************************************************************
* Desc:		Convert symbolic meta to internal form (LAM1=Lvar)
* Stack:	( Meta --> Q )
* Note:		tempo. set nocareflag to avoid sqrt problems
**********************************************************************
NULLNAME VXXL2NR
::
  nocareflag TestSysFlag case VXXL2
  nocareflag SetSysFlag VXXL2
  nocareflag ClrSysFlag
;

**********************************************************************
* Desc:		Convert symbolic meta to internal form (LAM1=Lvar)
* Stack:	( Meta --> Q )
**********************************************************************
NULLNAME VXXL2
CODE
vxxl2		C=DAT1	A
		CD1EX
		D1=D1+	5
		A=DAT1	A	A=length of meta
		CD1EX
		LC(5)	1
		?A#C	A
		GOYES	vxxl2!3
		D1=D1+	5
		D=D+1	A
		GOTO	vxxl0
vxxl2!3		D1=D1+	5
		A=DAT1	A
		D1=D1-	5
		LC(5)	=x+
		?A#C	A
		GOYES	vxxld
vxxlbinary	LA(5)	=vxxlbinary!
		PC=(A)
vxxld		LC(5)	=x*
		?A=C	A
		GOYES	vxxlbinary
		LC(5)	=x-
		?A=C	A
		GOYES	vxxlbinary
		LC(5)	=x/
		?A=C	A
		GOYES	vxxlbinary
		LC(5)	=x=
		?A=C	A
		GOYES	vxxlbinary
		LC(5)	=x^
		?A#C	A
		GOYES	vxxlf
		D1=D1+	10
		C=DAT1	A
		D1=D1-	10
		CD1EX
		A=DAT1	A
		CD1EX
		LC(5)	=DOINT
		?A=C	A
		GOYES	vxxl^z
		LC(5)	=DOREAL		
		?A#C	A
		GOYES	vxxl^nr
vxxl^z		LA(5)	=vxxl^!
		PC=(A)
vxxl^nr		LA(5)	=vxxl^nr!
		PC=(A)
vxxlf		LC(5)	=xNEG
		?A#C	A
		GOYES	vxxlg
vxxlunary	LA(5)	=vxxlunary!
		PC=(A)
vxxlg		LC(5)	=xSQ
		?A=C	A
		GOYES	vxxlunary
		LC(5)	=xNEGNEG
		?A=C	A
		GOYES	vxxlunary
vxxltest	LA(5)	=vxxltest!
		PC=(A)
ENDCODE

LABEL vxxlzint!
::
  EXACT? case ZTrim
  Z2%%
;
	
LABEL vxxlreal!
::
ASSEMBLE
	IF	f39
RPL
*  TESTEUROPE
  EXACT? NOTcase %>%%
  R2Zext
ASSEMBLE
	ELSE	f39
RPL
  %>%% EXACTOFF
ASSEMBLE
	ENDIF	f39
RPL
;

LABEL vxxlcmp!
::
ASSEMBLE
	IF	f39
RPL
  EXACT? NOTcase C%>C%%			( --> C%% )
  DUP C%>% R2Zext
  DUPTYPEZ? NOTcase2drop C%>C%%			( --> C%% )
  SWAP R2Zext
  DUPTYPEZ? NOTcase2drop C%>C%%			( --> C%% )
  IRXC2
  SWAPDROP
ASSEMBLE
	ELSE	f39
RPL
  EXACTOFF COMPLEXON C%>C%%
ASSEMBLE
	ENDIF	f39
RPL
;

LABEL vxxltag!
::
  STRIPTAGS VXXL0
;

LABEL vxxlarry!
::
  DUPTYPEMATRIX? NOTcase EXACTOFF
  vxxllist!
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
LABEL vxxllist!
::
  DUP NULLCOMP? ?SEMI
  DUPDUP >R LENCOMP ZEROSWAP		( composite meta # )
  ZERO_DO (DO)
    RSWAP 'R RSWAP VXXL0 SWAP#1+ 	( composite meta )
  LOOP
  get1
  ( * I don't know why, but TYPE does not work?? * )
LABEL ERABLETYPE
CODE
	C=DAT1	A
	CD1EX
	A=DAT1	A
	CD1EX
	D1=D1+	5
	D=D+1	A
	GOSBVL	=SAVPTR
	GOVLNG	=PUSH#ALOOP
ENDCODE
  COMPN			( composite )
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
LABEL vxxlsymb!
::
  VXXL_ISVAR? ?SEMI
*  simpvxxlflag SysITE 
     INNERCOMP
*     ::
*       nogcdflag TestSysFlag
*       nogcdflag SetSysFlag
*       SWAPINCOMP
*     ;
					( [flag,] meta )
  VXXL2					( [flag,] internal object ) 
*  simpvxxlflag TestSysFlag ?SEMI
*					( flag, object )
*  SWAP ?SEMI
*					( object )
*  ( * caution: internal conversion might switch nogcdflag off * )
*  ( * we can test this since it switch approxflag off as well * )
*  approxflag TestSysFlag ?SEMI
*  nogcdflag ClrSysFlag
*  FXNDext SIMPNDXFext
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
LABEL vxxlsym!
::
  VXXL_ISVAR? ?SEMI
  VXXL_{}
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
LABEL vxxlseco!
::	
  DUP CARCOMP
  DUPTYPEZ? caseDROP
  EQ: x<< case
  ::
    INNERCOMP #5= NOTcase INTERNALERR
    4UNROLL THREE
    ZERO_DO (DO)
       VXXL0 UNROT
    LOOP
    4ROLL FIVE ::POLY
  ;

  DUPEQ: xi casedrop
  ::
    COMPLEXON
    EXACT? NOTcase C%% 0 1
    Z1Z0 IRXC2
  ;

  EvalNoCK 
  VXXL_ISVAR? ?SEMI
  DUPTYPESYMB? ?SEMI
  DUPTYPECOL? NOTcase VXXL0
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
LABEL vxxlsqrt!
::					( LAM9 xSQRT )
  sqrtflag TestSysFlag case Z0Z1ROTNDXQ
    NEWTRIMext DUPTYPELIST? ITE Z0Z1ROTNDXQ 
    XSQRext
    DUPTYPESYMB? NOT?SEMI
    ' xABS Contains? SWAPDROP
    NOT?SEMI
    BINT72 ERABLEERROR
*    ZEROSWAP 1GETLAM VAL2ext
*    vxxlflag ClrSysFlag
*    VXXL_{}
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
* LABEL vxxl=!
* ::					( LAM8 x= )
*   RSUBext
*   ZEROSWAP 1GETLAM VAL2ext
*   %0 EXPR=
*   vxxlflag ClrSysFlag 
*   VXXL_{}
* ;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
LABEL vxxlinv!
::					( LAM7 xINV ) 
  FXNDext SWAP RDIVext 
;

* --------------------------------------------------------------------
* Desc:		Search for stk1 in LAM1, return object and FALSE
*		if not found. Return internal object if found.
* Stack:	( ob --> ob FALSE )
*		( ob --> {} TRUE )
* --------------------------------------------------------------------	
LABEL VXXL_ISVAR?
::	
  DUP 1GETLAM ListPos			( obj, # )
  DUP#0=csedrp FALSE
  SWAPDROP				( #pos )
  DUP#1= casedrop VXXL_X
  ONE MKPOLY
  TRUE
;

LABEL VXXL_X
:: INTERNALX TOTEMPOB TRUE ;
* should be:
*:: EXACT? ITE INTERNALX { %%1 %%0 } TRUE ;
* but MKPOLY does not check for exact/numeric mode


* --------------------------------------------------------------------
* Desc:		Embedd object in lists (depth=#length of LAM1 )
* Stack:	( obj -> {..{ obj }...} )
* --------------------------------------------------------------------	
LABEL VXXL_{}
::
  1GETLAM LENCOMP
  DUP#0=csDROP
  ZERO_DO (DO) ONE{}POLY LOOP
;

* --------------------------------------------------------------------
* Desc:
* Stack:	( LAM3 o1,..., on-1, x^, #n -> liste ou objet )
* --------------------------------------------------------------------	
LABEL vxxl^!
::	
  3PICK OBJINT?			( o1, ..., on-1, x^, #n, on-1, ?on-1=bint )
  NOTcasedrop vxxl^nr!
				( o1, ..., on-1, x^, #n, on-1 )
  4ROLLDROP DUP4UNROLL		( o1, ..., on-1, x^, #n, on-1 )
  ZIsNeg? OBJ>R			( o1, ..., on-1, x^, #n )
  SWAPDROPSWAP ZABS Z>#		( o1, ..., on-2, #n, #exposant )
  OVER UNROLL			( #exposant, o1, ..., on-2, #n )
  #2-				( #exposant, meta )
  dup CKSYMBN			( #exposant, meta, symb )
  1GETLAM ListPos		( #exposant o1...on-2 #n-2 #pos )
  CODE
		A=DAT1	A
		LC(5)	=ZERO
		?A#C	A
		GOYES	vxxl^idnt
		D=D+1	A
		D1=D1+	5
		LA(5)	=vxxl^nidnt!
		PC=(A)
vxxl^idnt	LA(5)	=vxxl^idnt!
		PC=(A)
  ENDCODE
				( objet )
  R>OBJ NOT?SEMI
  FXNDext SWAPRDIV
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
LABEL vxxl^nr!
::				( o1, ..., on-1, on=x^, #n )
  SYMBN VXXL_ISVAR? ?SEMI
  TRANSCERROR
*  vxxlflag ClrSysFlag
*  VXXL_{}
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
LABEL vxxl^nidnt!
::				( #exposant, o1, ..., on-2, #n-2 )
  VXXL2
  SWAP RP#
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
LABEL vxxl^idnt!
::				( #exp, meta, #pos )
  OBJ>R NDROP R>OBJ		( #exp, #pos )
  SWAP MKPOLY
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
LABEL vxxltest!
::
  ( teste si le meta compose en un symb est dans la liste )
  DUP#1+ NDUP SYMBN VXXL_ISVAR?
  NOTcasedrop

  CODE
vxxl2b		D1=D1+	5	( teste l'oprateur xSQRT  au niveau 2 )
vxxl2b1		A=DAT1	A	( au cas ou LVAR contient des racines )
		D1=D1-	5
		LC(5)	=xSQRT
		?A#C	A
		GOYES	vxxl2b2
tovxxlunary	GOTO	vxxlunary
vxxl2b2		LC(5)	=xINV	( INV peut provenir de INV[-LN]] de SERIES )
		?A=C	A	( d'ou une place anormale pour un op. rat. )
		GOYES	tovxxlunary
		LC(5)	=xRE
		?A=C	A
		GOYES	tovxxlunary
		LC(5)	=xIM
		?A=C	A
		GOYES	tovxxlunary
		LC(5)	=xCONJ
		?A=C	A
		GOYES	tovxxlunary
vxxlunknown	LA(5)	=vxxlunknown!
		PC=(A)
  ENDCODE
  OVER#2+UNROL NDROP
;

* --------------------------------------------------------------------
* Desc:		Binary operators
* Stack:
* --------------------------------------------------------------------	
LABEL vxxlbinary!
::					( o1, ..., on, #n )
  #1-SWAP OBJ>R 			( o1, ..., on-1, #n-1 )
  splitonearg				( meta1, meta2 )
  VXXL2					( meta1, liste2 )
  OBJ>R VXXL2				( list1 )
  R>OBJ R>OBJ				( list1 list2 op )
  CODE
		A=DAT1	A
		D1=D1+	5
		D=D+1	A
		LC(5)	=x+
		?A#C	A
		GOYES	vxxlm
		GOVLNG	=radd
vxxlm		LC(5)	=x*
		?A#C	A
		GOYES	vxxln
		GOVLNG	=rmult
vxxln		LC(5)	=x-
		?A#C	A
		GOYES	vxxlo
vxxln-		GOVLNG	=rsub
vxxlo		LC(5)	=x/
		?A#C	A
		GOYES	vxxln-
*		GOYES	vxxlp
		GOVLNG	=rdiv
*vxxlp		A=PC
*		LC(5)	(vxxl=!)-(*)
*		GOTO	vxxlb
  ENDCODE
;

* --------------------------------------------------------------------
* Desc:		Unary operators
* Stack:
* --------------------------------------------------------------------	
LABEL vxxlunary!
::					( o1, ..., on, #n )
  #1-SWAP OBJ>R				( meta1 )
  VXXL2					( liste1 )
  CODE
		GOSBVL	=r>objml
		A=DAT1	A
		D1=D1+	5
		D=D+1	A
		LC(5)	=xSQRT
		?A#C	A
		GOYES	vxxlq0
		LA(5)	=vxxlsqrt!
		PC=(A)
vxxlq0		LC(5)	=xNEG
		?A#C	A
		GOYES	vxxlq
		GOVLNG	=rneg
vxxlq		LC(5)	=xSQ
		?A#C	A
		GOYES	vxxlr
		A=DAT1	A
		D1=D1-	5
		D=D-1	A
		DAT1=A	A
		GOVLNG	=rmult	
vxxlr		LC(5)	=xINV
		?A#C	A
		GOYES	vxxlt
		LA(5)	=vxxlinv!
		PC=(A)
vxxlt		LC(5)	=xRE
		?A#C	A
		GOYES	vxxlu
		GOVLNG	=rre
vxxlu		LC(5)	=xIM
		?A#C	A
		GOYES	vxxlv
		GOVLNG	=rim
vxxlv		LC(5)	=xCONJ
		?A=C	A
		GOYES	rconj
		GOVLNG	=Loop		( do nothing for xNEGNEG )
rconj		LA(5)	=rconjext!
		PC=(A)
  ENDCODE
;
	
* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
LABEL vxxlunknown!
::					( o1, ..., on, #n )
  ( operateur non reconnu )
  SYMBN					( symb )

  ( teste si symb est dans la liste LAM22 )

  VXXL_ISVAR?				( symb, false ou liste, true )
  ?SEMI
					( symb )
  POSUNDEFext #0<> case VXXL_{}
  POSINFext #0<> case VXXL_{}
  TRANSCERROR
*  vxxlflag ClrSysFlag
*  VXXL_{}
;

**********************************************************************
* Desc:		Get list of all ids present in ob
* Stack:	( ob --> {} )
* Note:		This would be fairly easy to write in assembly (M.H)
**********************************************************************
NULLNAME LIDNText
::
  '
  ::					( LAM2 liste, comp -> liste )
    DUPTYPEARRY? caseDROP
    INNERCOMP
    DUP#0=csDROP
    get1 SWAP				( o1, .., on, liste, #n )
    ZERO_DO (DO)			( o1, .., on, liste )
       SWAP 1GETLAM EVAL		( o1, .., on-1, liste )
    LOOP
  ;
  '
  ::				( LAM1 liste, obj -> liste )
    CK&DISPATCH1
    list 2GETEVAL
    symb 2GETEVAL
    matrix 2GETEVAL
    idnt AppendList
    lam  AppendList
    any  DROP
  ;
  2LAMBIND
  NULL{} SWAP
  1GETLAM EVAL
  ABND
;

**********************************************************************
* Desc:		Find var of symb depending on cur var and other var
* Stack:	( symb -> symb, x, lvarnx, lvarx )
* Note:		using LVAR is impossible here because of sqrt
**********************************************************************
NULLNAME LVARXNXext
::	
  DUP LISTOPext LVARXNX2ext
;

**********************************************************************
* Desc:		Returns true if symb is polynomial with respect to cur var
* Stack:	( symb -> symb flag )
**********************************************************************
NULLNAME ISPOLYNOMIAL?
:: 
  POSUNDEFext #0<> caseFALSE	( -> undef false )
  LVARXNXext			( symb x lvarnx lvarx )
  DUPNULL{}? case2drop DROPTRUE	( -> symb true )
				( symb x lvarnx lvarx )
  SWAPDROPSWAP			( symb lvarx x )
  ONE{}N EQUAL			( symb flag )
;

**********************************************************************
* Desc:		Returns true if symb1 and symb2 are polynomial w.r.t. cur var
* Stack:	( symb1 symb2 -> symb1 symb2 flag )
**********************************************************************
NULLNAME 2POLYNOMIAL?
::
  ISPOLYNOMIAL? NOTcaseFALSE 	( -> P1 P2 false )
  SWAP ISPOLYNOMIAL? 		( P2 P1 ? )
  ROTSWAP			( P1 P2 ? )
;


**********************************************************************
* Desc:		Returns true if symb is indep of cur var
* Stack:	( symb -> symb flag )
**********************************************************************
NULLNAME VXINDEP?
::
  LVARXNXext		( symb x lvarnx lvarx )
  UNROT2DROP NULLCOMP?	( symb flag )
;


**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME LVARXNX2ext
::
  LVARDext SWAP				( lvar symb )
  RCLVX ROT				( symb x lvar )
  DUPNULL{}? case DUP
  INNERCOMP				( symb v1...vn #n )
  get1 NULL{} DUP 4ROLL
  ZERO_DO (DO)				( symb v1...vk x lvarnx lvarx )
     3PICK 5ROLL			( symb v1...vk-1 x lvarnx lvarx x vk )
     DUPUNROT  				( symb v... x lvarnx lvarx vk x vk )
     LVARXNX2SYMB			( symb v... x lvarnx lvarx vk ?xinvk )
     ITE >HCOMP >HCOMPstk3		( symb v1...vk x lvarnx lvarx )
  LOOP
					( symb x lvarnx lvarx )
  SWAP LVARext SWAPDROPSWAP		( symb x lvarnx lvarx )
;

LABEL LVARXNX2SYMB
:: 					( x vk -> ?xinvk )
  DUPTYPESYMB? NOTcase EQUAL		( -> ? )
					( x vk )
  DUPDUP LENCOMP NTHCOMPDROP EQ: xSIGN 	( x vk ? )
  casedrop DROPFALSE			( -> false )
					( x vk )
  SWAP EQUALPOSCOMP #0<> 		( ? )
;


**********************************************************************
* Desc:		Recursive search of all variables.
* Stack:	( ob --> {} )
**********************************************************************
NULLNAME RLVARext
::
  DUP LISTOPext LVARDext		( obj, lvar )
  DUPNULL{}? ?SEMI
  DUPINCOMP get1 SWAP
  ZERO_DO (DO)				( obj var1...varn, {} )
     SWAP RLVARLP			( obj var1...varn-1, {} )
  LOOP
					( obj {} )
;

LABEL RLVARLP
::					( {} var )
  DUPTYPESYMB? NOTcaseDROP		( -> {} )
  EXPR> DROP				( {} o1..on %n )
  COERCE				( {} o1..on #n )
  DUP#0=csDROP				( -> {} )
					( {} o1..on #n )
  get1 SWAP				( o1..on {} #n )
  ZERO_DO (DO)				( o1..on {} )
    SWAP RLVARext			( o1..on-1 {} on rlvar_on )
    SWAPDROP &COMP			( o1..on-1 {} )
  LOOP					( {} )
;


**********************************************************************
* Desc:		liste des identificateurs, racines carrees considerees
*		comme op arithmetique
* Stack:	( o -> #depth, o, lvar )
**********************************************************************
NULLNAME LLVARDext
::
  LVARext
  OVER TWO DEPTHOBJext
  UNROT
;

**********************************************************************
* Desc:		identique a LVAR mais en positionnant le contenu de
*		VX en tete
* Stack:	( symb -> symb, lvar )
**********************************************************************
NULLNAME VXLVARext
::
  DUP LISTOPext LVARDext VX>
;

**********************************************************************
* Desc:		List of variables. Square roots ARE included in the
*		list of rational operators.
* Stack:	( ob --> ob {} )
**********************************************************************
NULLNAME LVARext
::
  DUP LISTOPRAC
  LVARDext
;

**********************************************************************
* Desc:		Like LVARext but the current variable is added using
*		>HCOMP. Square roots ARE included in the list of
*		rational operators.
* Stack:	( ob --> ob {} )
**********************************************************************
NULLNAME VX>LVARext
::
  LVARext VX>
;

**********************************************************************
* Desc:		If VX is in the list then moves it to the beginning
*		of the list. Otherwise does nothing.
* Stack:	( {} --> {}' )
**********************************************************************
NULLNAME VX>
::
  RCLVX					( lvar, vx )
  DUP3PICK ListPos			( lvar, vx, #pos )
  DUPTWO #< case2DROP			( lvar, vx, #pos )
  SWAPDROPSWAP				( #pos, lvar )
  INNERCOMP get1			( v1, ..., vn, #n, #m avec vm=x )
  OVERSWAP #-				( v1, ..., vn, #n, #n-m avec vm=x )
  #2+ROLL				( v1, ..., vn, #n, vm )
  OVER #1+UNROLL {}N			( lvar )
;

**********************************************************************
* Desc:		If VX is in the list then moves it at the beginning.
*		Otherwise VX is added to the beginning of the list.
* Stack:	( {} --> {} )
**********************************************************************
NULLNAME VX!
::					( lvar )
  RCLVX 
  prepvarlist
;

**********************************************************************
* Desc:		Adds obj at the beginning of the list if not present
*		If obj is in list, move obj at the beginning of list
* Stack:	( {} obj --> {} )
**********************************************************************
NULLNAME prepvarlist
::
  DUP3PICK ListPos			( lvar, vx, #pos )
  DUP#0= casedrop >HCOMP
  ROTDUP CARCOMP			( vx, #pos, lvar, 1st of lvar )
  UNROT PUTLIST				( vx, lvar sans 1er element )
  ONESWAP PUTLIST
;

**********************************************************************
* Desc:		lvar is the list of variables in symb, but elements
*		of lidnt are moved to the beginning of lvar.
* Stack:	( symb lidnt --> symb lidnt lvar )
**********************************************************************
NULLNAME LIDNTLVAR
::					( obj lidnt )
  MATRIX2LIST49				( obj lidnt )
  DUPTYPELIST? ?SKIP ONE{}N		( obj lidnt )
  DUP CARCOMP TYPELIST? case SETTYPEERR	
					( obj lidnt )
  SWAP LVARext				( lidnt obj lvar )
  ROTDUP				( obj lvar lidnt newlvar )
  ROT INNERCOMP get1 SWAP
  ZERO_DO (DO)				( obj lidnt o1..ok newlvar )
     SWAP AppendList
  LOOP
					( obj lidnt lvar )
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME LISTOPRAC
::
  sqrtflag SysITE LISTOPext LISTOPSQRT
;

**********************************************************************
* Desc:		List of basic "rational" operators without square root
* Stack:	( --> {} )
**********************************************************************
NULLNAME LISTOPext
:: COMPLEX? ITE LISTOPCMPLX LISTOPRE TOTEMPOB ;

LABEL LISTOPCMPLX
{
  x+ x* x- x/ x^
  x= xNEG xSQ xi xINV xNEGNEG
}

LABEL LISTOPRE
{
  x+ x* x- x/ x^
  x= xNEG xSQ xi xINV xNEGNEG
  xRE xIM xCONJ
}

**********************************************************************
* Desc:		List of basic "rational" operators with square root
* Stack:	( --> {} )
**********************************************************************
NULLNAME LISTOPSQRT
::
  COMPLEX? ITE LISTOPSQRTC LISTOPSQRTR TOTEMPOB
;

LABEL LISTOPSQRTC
{
  x+ x* x- x/ x^
  x= xNEG xSQ xi xINV xNEGNEG
  xSQRT
}

LABEL LISTOPSQRTR
{
  x+ x* x- x/ x^
  x= xNEG xSQ xi xINV xNEGNEG
  xRE xIM xCONJ xSQRT
}

LABEL LISTOPSIMP
{
  x+ x* x- x/ x^
  x= xNEG xSQ xi xPI xe xINV xNEGNEG
  xRE xIM xCONJ xSQRT
}

**********************************************************************
* Desc:		Determine list of variables in ob (or Meta) using the
*		given list of basic "rational" operators.
* Stack:	( ob listop --> lidnt )
*		( Meta listop --> lidnt )
**********************************************************************
NULLNAME LVARDext 
::					( ob listop )
  ZERO					( LAM2 profondeur actuelle )
  NULL{}				( LAM1 liste des identificateurs )
  3LAMBIND
  DEFINE lvarop		3GETLAM
  DEFINE lvarlist	1GETLAM		( # )
  DEFINE lvarlist!	1PUTLAM
  DEFINE profact	2GETLAM		( # )
  DEFINE profact!	2PUTLAM

					( obj  )

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	

  LABEL lvar1!
  CODE
lvar1		GOSUB	lvar1s
		?C#A	A
		GOYES	lvar1!1
lvarsymb	LA(5)	=lvarsymb!
		PC=(A)
lvar1!1		LC(5)	=DOLIST
		?C#A	A
		GOYES	lvar1!2
lvar3		LA(5)	=lvarlst!
		PC=(A)
lvar1!2		LC(5)	=DOMATRIX
		?A=C	A
		GOYES	lvar3
		LC(5)	=DOCOL
		?C#A	A
		GOYES	lvar1!3
lvar4		GOSUB	A=stk5
		LC(5)	=x<<
		?A#C	A
		GOYES	lvar4!1
		LA(5)	=lvarirrq!
		PC=(A)
lvar4!1		LC(5)	=DOINT
		?A=C	A
		GOYES	lvar1!6
		LA(5)	=lvarseco!
		PC=(A)
lvar1!3		LC(5)	=DOIDNT
		?C#A	A
		GOYES	lvar1!5
lvaridnt	LA(5)	=lvaridnt!
		PC=(A)
lvar1!5		LC(5)	=DOLAM
		?C=A	A
		GOYES	lvaridnt
		LC(5)	=DOBINT
		?C#A	A
		GOYES	lvar1!6
lvarmeta	LA(5)	=lvarmeta!
		PC=(A)
lvar1!6		GOVLNG	=DropLoop
lvar1s		C=DAT1	A
		CD1EX
		A=DAT1	A
		CD1EX
		LC(5)	=DOSYMB
		RTN
=A=stk5		C=DAT1	A
		CD1EX
		D1=D1+	5
		A=DAT1	A	A=@obj1 du seco
		CD1EX
		RTN
  ENDCODE
  1GETABND
					( Lidnt )
  ' IsV>V? SortList
;

* --------------------------------------------------------------------
* Desc:
* Stack:	( lvar3 liste ->  )
* --------------------------------------------------------------------	
LABEL lvarlst!
::
  profact #1+ profact!
  INNERCOMP lvarmeta!
  profact #1- profact!
;

* --------------------------------------------------------------------
* Desc:
* Stack:	( comp ->  )
* --------------------------------------------------------------------	
LABEL lvarsymb!
::	
  POSUNDEFext #0<> caseDROP
  INNERCOMP				( o1, ..., on, #n )
  lvarmeta!
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
LABEL lvarmeta!
::
  DUP#0=csDROP
  ZERO_DO (DO)				( o1, ..., on )
     lvar1!
  LOOP
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
LABEL lvarexp!
::					( o1, ..., on-1=%, on= x^ )
  OVERDUP %FLOOR %=			( o1, ..., on-1=%, on= x^, flag )
  caseDROP
  lvarsecon!
;

* --------------------------------------------------------------------
* Desc:
* Stack:	( lvar4 seco d'un meta ->  )
* --------------------------------------------------------------------	
LABEL lvarseco!
::
  lvarop
  CODE
		D1=D1+	5	( drop lvarop )
		D=D+1	A
		A=D1
		R1=A	A	R1=sauvegarde D1
		A=DAT1	A
		R0=A	A	R0=seco
		D1=D1-	5
		A=DAT1	A
		AD1EX
eqlkloop	D1=D1+	5	D1-> liste d'operateurs
		C=DAT1	A
		LA(5)	=SEMI
		?A#C	A
		GOYES	eqlk1
		C=R1	A
		CD1EX		restaure D1
eqlksecon	LA(5)	=lvarsecon!
		PC=(A)
eqlk1		A=R0	A
		?A#C	A
		GOYES	eqlkloop
		LC(5)	=x^
		?A#C	A
		GOYES	eqtoloop
		C=R1	A
		CD1EX		restaure D1
		D1=D1+	5	on regarde si le niveau 2 est entier
		C=DAT1	A
		D1=D1-	5
		CD1EX
		A=DAT1	A
		CD1EX
		LC(5)	=DOINT
		?A=C	A
		GOYES	eqtoloop
		LC(5)	=DOREAL
		?A#C	A
		GOYES	eqlksecon	(exposant non reel -> lvarsecn!)
		LA(5)	=lvarexp!
		PC=(A)	-> teste si l'exposant est entier
eqtoloop	C=R1	A	operateur reconnu
		CD1EX		restaure D1
		GOTO	lvar1!6
  ENDCODE
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
LABEL lvarsecon!
::				( o1, ..., ok-1, ok=seco )
  ISTOP-INDEX			( o1,...,ok, #k )
  larg				( o1, ..., oj, #j, oj+1,...,ok, #k-j )
  SYMBN				( o1,...,oj, #j, "seco[idnt]" )
  SWAP#1+ ISTOPSTO
  ZERO INDEXSTO			( o1,...,oj, "seco[idnt]" )
  lvaridnt!
;

* --------------------------------------------------------------------
* Desc:
* Stack:	( lvar5 sym -> )
* --------------------------------------------------------------------	
LABEL lvaridnt!
::
  lvarlist			( sym, lvarlist )

**********************************************************************
* Desc:
* Stack:
**********************************************************************

  NULLNAME >VARLIST
  CODE
* si la liste est null{} -> drop ONE{}N
		A=DAT1	A
		LC(5)	=NULL{}
		?A#C	A
		GOYES	lvaridnt!1
		D=D+1	A
		D1=D1+	5
		LA(5)	=ONE{}N
		PC=(A)
lvaridnt!1	GOSUB	matchob
		GONC	lvaridnt!2
* carry set -> not found, -> insert
		LA(5)	=hcomplist!
		PC=(A)
* carry clear -> swapdrop
lvaridnt!2	LA(5)	=SWAPDROP
		PC=(A)
matchob		GOSBVL	=SAVPTR
		A=DAT1	A	A=@stk1
		D1=D1+	5
		C=DAT1	A	C=@stk2
		AD0EX		
		CD1EX
		D0=D0+	5	D1= @sym, D0=@ 1er objet de list
* teste si on est en fin de liste
lvaridnt!l	A=DAT0	A
		LC(5)	=SEMI
		?A#C	A
		GOYES	lvaridnt!t
		GOSBVL	=GETPTR
		RTNSC
* on n'est pas en fin de liste: @D1 EQUAL @D0?
* attention si A n'est pas un prologue, il faut tester @A EQUAL @DO
* car c'est l'adresse de la variable et non la variable qui est dans la liste
lvaridnt!t	AD0EX
		R4=A.F	A	sauvegarde du D0 pointant dans la liste
		A=DAT0	A
		LC(5)	=PRLG
		?A#C	A
		GOYES	lvarinrom
		A=R4.F	A
		AD0EX		restaure le pointeur D0 avant comparaison
		GOSBVL	=EQUAL?	* carry clear=EQUAL
		GONC	lvaridnt!true
* @D1 <> @D0 -> skipob
lvarskip	GOSBVL	=SKIPOB
		GOTO	lvaridnt!l
lvarinrom	GOSBVL	=EQUAL?
		A=R4
		AD0EX		restaure le pointeur apres comparaison
		GOC	lvarskip
lvaridnt!true	GOSBVL	=GETPTR
		RTNCC
  ENDCODE
					( lvarlist )
  lvarlist!
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
LABEL lvarirrq!
::
  INNERCOMP #5= NOTcase INTERNALERR
  DROP 4ROLLDROP THREE
  ZERO_DO (DO)
     lvar1!
  LOOP
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
LABEL hcomplist!
::
  INNERCOMP #1+ {}N
;


**********************************************************************
* Desc:		Returns the max number of embedded lists in ob.
* Stack:	( ob --> # )
**********************************************************************
NULLNAME DEPTHext
CODE
depth		GOSUB	depth0
		LC(5)	=DOINT
		?A#C	A
		GOYES	depth0!1
depth0!0	LA(5)	=DROPZERO
		PC=(A)
depth0!1	LC(5)	=DOIDNT
		?A=C	A
		GOYES	depth0!0
		GOTO	depthobj0
ENDCODE

**********************************************************************
* Desc:
* Stack:	( objet, # -> profondeur )
**********************************************************************
NULLNAME DEPTHOBJext
CODE
depthst		EQU	9
depthobj	ST=0	depthst
		GOSBVL	=POP#
		LC(5)	1
		?A#C	A
		GOYES	depthobj1
depthobj0	ST=1	depthst
depthobj1	LA(5)	=depthobj!
		PC=(A)
ENDCODE

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	
DEFINE action		3GETLAM		( # )
DEFINE pmaxi		1GETLAM		( # )
DEFINE pmaxi!		1PUTLAM
DEFINE pact		2GETLAM		( # )
DEFINE pact!		2PUTLAM

LABEL	depthobj!
::
  ZEROZERO		( LAM2 et 1 profondeur maxi et actuelle )
  2LAMBIND

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------	

  LABEL depth1!
  CODE
depth1		GOSUB	depth0
		LC(5)	=DOSYMB
		?A#C	A
		GOYES	depth1!1
depth9		?ST=0	depthst
		GOYES	depth1!4
		LA(5)	=depthcomp!
		PC=(A)
depth1!1	LC(5)	=DOLIST
		?A#C	A
		GOYES	depth1!2
depth5		LA(5)	=depthlist!
		PC=(A)
depth1!2	LC(5)	=DOMATRIX
		?A=C	A
		GOYES	depth5
		LC(5)	=DOCOL
		?A#C	A
		GOYES	depth1!3
		LA(5)	=depthseco!
		PC=(A)
depth1!3	LC(5)	=DOARRY
		?A#C	A
		GOYES	depth1!4
		LA(5)	=deptharry!
		PC=(A)
depth1!4	D=D+1	A	( DROP )
		D1=D1+	5
		GOVLNG	=Loop
depth0		C=DAT1	A
		CD1EX
		A=DAT1	A
		CD1EX
		RTN
  ENDCODE
  1GETABND
;

* --------------------------------------------------------------------
* Desc:
* Stack:	( depth5 liste -> )
* --------------------------------------------------------------------	
LABEL depthlist!
::
  pact #1+DUP pact!
  pmaxi #MAX pmaxi!
  depthcomp!
  pact #1- pact!
;

* --------------------------------------------------------------------
* Desc:
* Stack:	( comp -> )
* --------------------------------------------------------------------	
LABEL depthcomp!
::
  INNERCOMP DUP#0=csDROP
  ZERO_DO (DO)
     depth1!
  LOOP
;

* --------------------------------------------------------------------
* Desc:
* Stack:	( arry -> )
* --------------------------------------------------------------------	
LABEL deptharry!
::
  MDIMS SWAPDROP ITE DROPONE ZERO
  #1+
  pact #+ pmaxi #MAX pmaxi!
;

* --------------------------------------------------------------------
* Desc:
* Stack:	( depth7 seco -> )
* --------------------------------------------------------------------	
LABEL depthseco!
::
  DUP CARCOMP EQ: x<< NOTcaseDROP
  INNERCOMP #5= NOTcase INTERNALERR
  DROP 4ROLLDROP THREE
  ZERO_DO (DO)
     depth1!
  LOOP
;
**********************************************************************

