INCLUDE erromid.h
INCLUDE cas2extdec.h
INCLUDE erext.h
INCLUDE keydefs.h
INCLUDE global.s

	STITLE Unary operators 

**********************************************************************
* EXPORT:
*
* SWAPRNEG	( o2, o1 -> o1-o2 )
*
* QSub, RNEG	( o2, o1 -> o2-o1 ) 
*
* SWAPRRE	( o2, o1 -> o1, re[o2] )
*
* RREext	( o1 -> re[o1] )
*
* SWAPRIM	( o2, o1 -> o1, im[o2] )
*
* RIMext	( o1 -> im[o1] )
*
* RCONJext	( o1 -> conj[o1] )
*
* QABSext	( irrq1 -> abs(irrq1) )
*
* RABSext	( o1 -> abs(o1) )
*		internal representation
* ZABS		( Z -> Z )
* CZABS		( C -> Z )
* xABSext	( o1 -> abs(o1) )
*		symbolic representation
*
* CNORMext	( C -> |C|^2 )
*
* QNORMext	( irrq -> a^2-b*c^2 )
*
* SXSQRext	( o -> sqrt[o] )
*		does not take care of the sign
*
* XSQRext	( o -> sqrt[o] )
*		returns a positive square root if nocareflag is cleared
*
* LNATANext	( o -> ln[o] )
*		for a complex returns ln(|c|^2)/2+i*atan[im/re]
*
* ARG		( o -> arg[o] )
*
* QUADRANText	( ?re>0, ?im>0 -> % )
*		returns %0, %1, %-2 or %-1 s.t. arg of a corresponding complex 
*		is  % * pi/2 + theta where theta is in [0,pi/2]
*
* xSQext	( o -> SQ[o] )	
*		symbolic square
*
* xLNext	( o -> LN[num]-LN[deno] )
*		o=num/deno, symbolic LN
*
* CKLN		( o -> LN[o] )
*		symbolic LN, tests for 0, 1 and infinity
*
* LISTLN	( list -> o )
*		logarithm of an object whose factorization is list
*		see sqff.s for the format of list
*
* EXPANDLN	( obj -> ln[obj] )
*		complex symbolic LN, 
*		in real mode tests if obj=EXP[...]
*		otherwise switch to internal representation and
*		tries to return ln[obj] as ln(|obj|^2)/2+i*arg(obj)
*
* xEXPext	( o -> EXP[o] )
*		symbolic EXP, tests for 0, infinity, i*k*pi/12 [k integer]
*
* TESTLNXext	( x -> n, d, TRUE if x=n/d*i*pi where n/d is a rational )
*		( x -> ?, ?, FALSE otherwise )
*
* EXPPIext	( y, d, n -> exp[y*n/d*i*pi] )
*		tests for d=1,2,3,4,6
*
* xINVext	( o -> 1/o )
*		symbolic inversion, no tests
*
* xvext		( o -> sqrt[o] )
*		symbolic square root, tests for 0 and 1
*
* xCOSext	( o -> COS(o) )
*		symbolic COS, tests for 0 and multiple of pi/12
*		tests if o=ACOS[...] or o=ASIN[...]
*
* xSINext	( o -> COS(o) )
*		symbolic SIN, tests for 0 and multiple of pi/12
*		tests if o=ACOS[...] or o=ASIN[...]
*
* xTANext	( o -> TAN(o) )
*		symbolic TAN, tests for 0 and multiple of pi/12
*		tests if o=ATAN[...] 
*
* xCOSHext	( o -> COSH(o) )
*		symbolic COSH, tests for 0 and infinity
*		tests if o=ACOSH[...] 
*
* xSINHext	( o -> SINH(o) )
*		symbolic SINH, tests for 0 and infinity
*		tests if o=ASINH[...]
*
* xTANHext	( o -> TAN(o) )
*		symbolic TANH, tests for 0 
*		tests if o=ATANH[...] 
*
* xASINext	( o -> ASIN(o) )
*		symbolic ASIN, tests for 0, infinity
*		and value stored in TABLECOSext, 
*
* xACOSext	( o -> ACOS(o) )
*		symbolic ACOS, tests for 0, infinity
*		and value stored in TABLECOSext, 
*
* xATANext	( o -> ATAN(o) )
*		symbolic ATAN, tests for 0, infinity, 
*		and value stored in TABLETANext, 
*
* xTABLECOSext	( -> {} )
*		list of cosines of multiples of pi/12, ZERO if too complicated
*
* xTABLETANext	( -> {} )
*		list of tan of multiples of pi/12, ZERO if too complicated
*
* addtCOS, addtSIN, addtTAN, addtASIN, addtACOS, addtATAN, addtSINH,
* addtCOSH, addtTANH, addtLN, addtSQRT, addtSQ, addtEXP
*		( meta -> meta )
*		symbolic unary operations on meta-objects
*
* addtSINACOS	( meta -> meta' )
*		if meta stands for x, meta' stands for sqrt[1-x^2]
*
*
* factorial	( obj -> obj! )
*		Factorial
*
* factr		( % -> %! )
*		Factorial of a real
*
* FORI_I*	( #end, #begin -> Z )
*		product from #begin+1 to #end
*
* addt!		( meta -> meta&x! )
**********************************************************************

**********************************************************************
* Desc:		Symbolic negation
* Stack:	( ob2 ob1 --> ob1 -ob2 )
**********************************************************************
NULLNAME SWAPRNEG
CODE
=swaprneg	GOSBVL	=swapml
		GOTO	rneg
ENDCODE

**********************************************************************
* Desc:		Symbolic negation
* Stack:	( ob --> -ob )
**********************************************************************
NULLNAME QNeg
NULLNAME RNEGext
*:: SHALT
CODE		
=rneg		GOSBVL	=SAVPTR
		A=DAT1	A		->Q1
		R0=A.F	A
		B=A	A
		D0=A
		ST=1	sALG48
		GOSBVL	=QSKIP		D0=@end
		?ST=0	sALG48
		GOYES	rneg!notalg
		D0=D0+	6	link
		C=D0
		C=C-B	A
		GOSBVL	=GETTEMP	D0=debut, D1=fin
		A=D0
		D1=A			D1=target
		AR0EX.F	A		R0=debut target, A= debut origine
		D0=A			D0=origine
		GOSBVL	=MOVEDOWN	recopie de l'objet avant appel NEG
		A=R0.F	A
		D0=A
		GOSBVL	=QNEG
		C=D0
		GOSBVL	=ShrinkQ
		GOVLNG	=OverWrALoop		
rneg!notalg	GOSBVL	=GETPTR
		LA(5)	=rnegck!
		PC=(A)
ENDCODE
*;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL rneglist!
::
  INNERDUP #1-SWAP
  ZERO_DO
    get1 RNEGext
  SWAPLOOP
  #1+ >POLYTRIM
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL rnegseco!
::
  INNERCOMP			( <<, a, b, c, >>, FIVE )
  DUP #5= NOTcase INTERNALERR
  5ROLL RNEGext 5UNROLL
  4ROLL RNEGext 4UNROLL
  ::POLY
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL rnegsymb!
::
  SYMBINCOMP
  M1st/case rnegsymb/
  MetaNeg CKSYMBN
;

LABEL rnegsymb/
::
  plDRPpZparg		( deno, num )
  MetaNeg		( deno, -num )
  pshtop& addt/ CKSYMBN	( -num/deno )
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL rnegstr!
::
  CHR_- OVER CAR$ EQUALcasedro CDR$
  >H$
;

* --------------------------------------------------------------------
* Desc:
* Stack:
* --------------------------------------------------------------------
LABEL rnegck!
::
  CK&DISPATCH1
  real	%CHS
  cmp	C%CHS
  ereal	%%CHS
  ecmp  C%%CHS
  EXT   UMCHS
  str	rnegstr!
  symb	rnegsymb!
  list	rneglist!
  seco	rnegseco!
  idnt  EvalNoCKxCHS
  any   SYMNEG
;

* --------------------------------------------------------------------
* Desc:		internal real part for non Z/C/Q input
* Stack:	( obj -> re(obj) )
* --------------------------------------------------------------------
LABEL rreext!
::
  CK&DISPATCH1
  ecmp  C%%RE
  list	LISTRE
  seco	SECORE
  symb  SYMBRE 
  str	NOP
  any	SYMRE
;

LABEL C%%RE
:: C%%>%% DROP ;

LABEL LISTRE
:: LISTREext >POLYTRIM ;

LABEL SECORE
::
  INNERCOMP			( x<<, a, b, c, x>>, FIVE )
  #5= NOTcase INTERNALERR
  4ROLL RREext			( x<<, b, c, x>>, a )
  4ROLL RREext			( x<<, c, x>>, a, b )
  Z0 EQUALcasedro 4UNROLL3DROP
  2SWAP FIVE ::POLY
;

LABEL SYMBRE
:: 
  FXNDext
  Z1 EQUALcasedro SYMRE
  DUPTYPEZ? 
  case :: SWAPRRE SWPSIMPNDXF ;
  2DUP RREext SWAPRRE
  RMULText UNROT	        (  aa' z z')
  DUP4UNROLL
  RIMext SWAP RIMext
  RMULText RADDext	        ( z' aa'+bb')
  RREIM
;

* --------------------------------------------------------------------
* Desc:		internal imaginary part for non Z/C/Q input
* Stack:	( obj -> im(obj) )
* --------------------------------------------------------------------
LABEL rimext!
::
  CK&DISPATCH1
  ecmp  C%%IM
  cmp   C>Im%
  list  LISTIM
  seco  SECOIM
  symb  SYMBIM
  str  :: DROP "0" TOTEMPOB ;
  any  SYMIM
;

LABEL C%%IM
:: C%%>%% SWAPDROP ;

LABEL LISTIM
:: LISTIMext >POLYTRIM ;

LABEL SECOIM
:: 
  INNERCOMP			( x<<, a, b, c, x>>, FIVE )
  #5= NOTcase INTERNALERR
  4ROLL RIMext			( x<<, b, c, x>>, a )
  4ROLL RIMext			( x<<, c, x>>, a, b )
  Z0 EQUALcasedro 4UNROLL3DROP
  2SWAP FIVE ::POLY
;

LABEL SYMBIM
:: 
  FXNDext
  Z1 EQUALcasedro SYMIM
  DUPTYPEZ? case :: SWAPRIM SWPSIMPNDXF ;
  2DUP RREext SWAPRIM
  RMULText UNROT DUP4UNROLL
  RIMext SWAP RREext RMULText RSUBext
  RREIM
;

* Code common for re and im of a fraction
LABEL RREIM
::
  SWAPDUP RREext DUP RMULText 
  SWAPRIM DUP RMULText RADDext
  SIMPNDXFext
;

**********************************************************************
* Desc:
* Stack:	( ob2 ob1 --> ob1 Re(ob2) )
**********************************************************************
NULLNAME SWAPRRE
CODE
=swaprre	GOSBVL	=swapml
		GOTO	rre
ENDCODE

**********************************************************************
* Desc:		Internal real part
* Stack:	( ob --> Re(ob) )
**********************************************************************
NULLNAME RREext
* ::
  CODE
=rre		ST=1	sRE
		C=DAT1	A
		CD1EX
		A=DAT1	10
		CD1EX
		LC(5)	=DOINT
		?A#C	A
		GOYES	rre1
rreexit		GOVLNG	=Loop
rre1		LCCMP
		P=	9
		?A#C	WP
		GOYES	rre2
		P=	0
		C=DAT1	A	C=@stk1
		CD1EX		C=@stk, D1=@stk1
		D1=D1+	10
		A=DAT1	A	A=longueur
		CD1EX		C=@stk1+10, D1=@stk
		C=C+A	A
		DAT1=C	A
		GOTO	rreexit
rre2		P=	0
		LC(5)	=DOEREL
		?A=C	A
		GOYES	rreexit
		LC(5)	=DOREAL
		?A=C	A
		GOYES	rreexit
rre/im		GOSBVL	=SAVPTR
		C=DAT1	A
		D0=C		@ stk1
		R0=C.F	A
		B=C	A
		ST=1	sALG48
		GOSBVL	=QSKIP
		?ST=1	sALG48
		GOYES	rrealg48
		GOSBVL	=GETPTR
		?ST=1	sRE
		GOYES	rreext
		A=PC
		LC(5)	(rimext!)-(*)
rrebranch	A=A+C	A
		PC=(A)
rreext		A=PC
		LC(5)	(rreext!)-(*)
		GOTO	rrebranch
rrealg48	D0=D0+	6	link
		C=D0
		C=C-B	A
		GOSBVL	=GETTEMP	D0=debut, D1=fin
		C=D0
		D1=C			D1=target
		CR0EX.F	A		R0=debut target, C= debut origine
		D0=C			D0=origine
		ST=0	sTRIM
		C=0	A
		R4=C.F	A		complevel Z0
		B=0	A		complevel
rreloop		A=DAT0	A
		LC(5)	=DOINT
		?A#C	A
		GOYES	rreloop1
rreloop0	?ST=0	sRE
		GOYES	rreloop0i
rreloop0r	GOSUB	rrewzint
		GOTO	rretest
rreloop0i	?ST=1	sTRIM
		GOYES	+
		LCZ0
		P=	10
		DAT1=C	WP
		P=	0
		D1=D1+	11
+		GOSUB	rreloop0skip
rretest		?B#0	A
		GOYES	rreloop
		GOVLNG	=r0exit
rreloop1	LC(5)	=DOCOL
		?A=C	A
		GOYES	rreloopcol
		GOTO	rreloop2
rreloopcol	D0=D0+	5	D0=@im
		?ST=1	sRE
		GOYES	rreloop1r
rreloop1i	GOSUB	rrewzint
		GOSUB	rreloop0skip
		D0=D0+	5
		GOTO	rretest
rreloop1r	GOSUB	rreloop0skip	
		GOSUB	rrewzint
		D0=D0+	5
		GOTO	rretest
rreloop2	DAT1=A	A
		D1=D1+	5
		D0=D0+	5
		LC(5)	=DOLIST
		?A=C	A
		GOYES	rreloopl
		B=B-1	A
		?ST=0	sTRIM
		GOYES	rretest
		D1=D1-	10		efface DOLIST SEMI
		CR4EX.F	A
		C=C-1	A
		R4=C.F	A
		?C#0	A
		GOYES	rretest
		ST=0	sTRIM
		LCZ0
		P=	10
		DAT1=C	WP
		P=	0
		D1=D1+	11
		GOTO	rretest
rreloopl	ST=1	sTRIM
		CR4EX.F	A
		C=C+1	A
		CR4EX.F	A
		B=B+1	A
		GOTO	rretest

* recopie d'un entier de D0 vers D1 ou skip un entier nul en D0 selon sTRIM

rrewzint	?ST=0	sTRIM
		GOYES	rrewzint0
		D0=D0+	5
		C=DAT0	A
		D0=D0-	5
		LA(5)	6
		?A=C	A
		GOYES	rreloop0skip
		ST=0	sTRIM
		C=0	A
		R4=C.F	A
rrewzint0	D0=D0+	5
		C=DAT0	A	longueur zint
		C=C+CON	A,5	+prologue
		D0=D0-	5	
		GOVLNG	=MOVEDOWN
* skip un entier en D0
rreloop0skip	D0=D0+	5
		C=DAT0	A
		AD0EX
		A=A+C	A
		AD0EX
		RTN
  ENDCODE

*;

**********************************************************************
* Desc:
* Stack:	( ob1 ob2 --> ob2 Im(ob1) )
**********************************************************************
NULLNAME SWAPRIM
CODE
=swaprim	GOSBVL	=swapml
		GOTO	rim
ENDCODE

**********************************************************************
* Desc:		Internal imaginary part
* Stack:	( ob --> Im(ob) )
**********************************************************************
NULLNAME RIMext
*:: xSHALT
  CODE
=rim		ST=0	sRE
		C=DAT1	A
		CD1EX
		A=DAT1	10
		CD1EX
		LC(5)	=DOINT
		?A=C	A
		GOYES	rimzint
		LC(5)	=DOREAL
		?A#C	A
		GOYES	rim1
		LA(5)	=%0
rim0		GOVLNG	=OverWrALoop
rim1		LCCMP
		P=	9
		?A#C	WP
		GOYES	rim11
		P=	0
		C=DAT1	A	C=@stk1
		C=C+CON	A,5
		DAT1=C	A
		GOTO	rreexit
rim11		P=	0
		LC(5)	=DOEREL
		?A=C	A
		GOYES	rim2
		GOTO	rre/im
rim2		LA(5)	=%%0
		GOTO	rim0
rimzint		GOVLNG	=droppushhxs0
  ENDCODE

*;

LABEL LISTREext
::
  INNERDUP #1-SWAP
  ZERO_DO			( o1, ..., on, #n-1 )
     get1 RREext
  SWAPLOOP
  #1+
;

LABEL LISTIMext
::
  INNERDUP #1-SWAP
  ZERO_DO			( o1, ..., on, #n-1 )
    get1 RIMext
  SWAPLOOP
  #1+
;

**********************************************************************
* Desc:		Complex real part
* Stack:	( symb --> symb' )
* Note:		expands only + - * / ^
**********************************************************************
NULLNAME xREext
:: SYMBINCOMP addtRE CKSYMBN ;

**********************************************************************
* Desc:		Meta complex real part
* Stack:	( meta --> meta' )
* Note:		expands only + - * / ^
**********************************************************************
NULLNAME xSYMRE
LABEL addtRE
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMRE
ASSEMBLE
	ENDIF	f39
RPL
						( meta )
  COMPLEX? case inaddtRE
  ISMETACOMPLEX? NOT?SEMI			( -> meta )
  SETCOMPLEX
  allrealflag TestSysFlag OBJ>R
  allrealflag SetSysFlag			( meta )
  inaddtRE					( re )
  allrealflag R>OBJ ITE SetSysFlag ClrSysFlag	( re )
  CLRCOMPLEX 
;

LABEL inaddtRE
::						( meta )
  1metaundef? #0<> case addtREinf
  allrealflag SysITE ISMETACOMPLEX? TRUE 	( meta ?cmplx )
  NOT?SEMI
						( meta )
  DUP#1= case addtRE#1
  M1stNEGcase addtRENEG
  M1st+case addtRE+-
  M1st-case addtRE+-
  M1st*case addtRE*
  M1st/case addtRE/
  M1st^case addtRE^
  AEQ1stcase xRE NOP
  AEQ1stcase xIM NOP
  AEQ1stcase xABS NOP
  AEQ1stcase xARG NOP
  AEQ1stcase x\v/ addtRESQRT
  AEQ1stcase xCONJ addtRECONJ
  AEQ1stcase xEXP addtREEXP
  AEQ1stcase xCOS addtRECOS
  AEQ1stcase xSIN addtRESIN
  AEQ1stcase xATAN addtREATAN
  addtREonly
;

LABEL addtREinf
::
  DUP#1= case NDROPundef
;

LABEL addtRESQRT
::				( sqrt[z] )
  pulldrop			( z )
  REIM				( re im )
  OVER j#0=case NDROPaddtSQRTonly
  addtREIMSQRTend		( re[sqrt[z]] )
;
	
LABEL REIM
* z -> re[z], im[z] (meta-operation)
:: dup inaddtRE psh inaddtIM ;
	
LABEL addtREIMSQRTend
::				( re im )
  addtSQ psh dup addtSQ		( im^2 re re^2 )
  rot MetaAdd			( re rho^2 )
  addtSQRT MetaAdd meta/2	( [re+rho]/2 )
  addtSQRT			( sqrt[[re+rho]/2] )
;
	
LABEL addtRE^
::
  pulldrop larg			( meta1 meta2 )
  OVER TYPEZ? NOTcase :: MetaPow addtREonly ;
  				( meta1 z one )
  psh REIM			( z one meta-re meta-im )
  OVER j#0=case :: NDROP psh MetaPow ;
				( z one meta-re meta-im )
  metai MetaMul MetaAdd	( z one meta-re+i*meta-im )
  psh MetaPow metackundef	( -> meta-undef )
				( meta )
  dup LISTOPRAC LVARDext	( meta lvar )
  DUP 2LAMBIND			( meta )
  VXXL2NR RREext		( Q )
  ZERO 1PUTLAM			( Q )
  VAL1M				( meta )
  ABND
;


LABEL REALDOMAINOP
{ xATAN xSIGN }

LABEL addtRENEG
:: pulldrop inaddtRE MetaNeg ;

LABEL addtRECONJ
:: pulldrop inaddtRE ;

LABEL addtREEXP
:: pulldrop inexp2expre_im addtCOS metamult ;

LABEL inexp2expre_im
::
  dup inaddtRE addtEXP psh inaddtIM		( exp-re meta-im )
;

LABEL addtRESIN
:: 
  pulldropIM=0? case addtSINonly
  tmeta-meta metasub/2i inaddtRE 
;

LABEL addtRECOS
:: 
  pulldropIM=0? case addtCOSonly
  tmeta-meta metaadd/2 inaddtRE 
;

LABEL addtREATAN
::
  dup pulldrop metareal?
  case NDROP
  NDROP addtREonly
;

LABEL addtRE#1
::
  OVER TYPECMP? casedrop C>Re%ONE
  AEQ1stcase xi NDROPZ0ONE
  OVER IDNTLAM? NOTcaseDROP
					( id #1 id )
  ISIDREAL?				( id #1 id ob TRUE | id #1 id false )
  NOTcasedrop addtREonly		( -> id xRE #2 )
  2DROP					( id #1 )
;

LABEL C>Re%ONE
:: C>Re% ONE ;

LABEL addtREonly
:: addt: xRE ;


LABEL addtRE+-
::
  #1-SWAP OBJ>R
  pshzerpsharg inaddtRE		( meta1 RE[meta2] )
  psh inaddtRE
  R>OBJ 
  addtREIM+-
;

LABEL addtRE*		
::
  plDRPpZparg		( meta1 meta2 )
  addtRE*split
;

LABEL addtRE*split	( re[a*b]=re[a]*re[b]-im[b]*im[a] )
::			( meta1 meta2 )
  addtREIM		( meta2-im meta2-re meta1-im meta1-re )
  rot MetaMul		( meta2-im meta1-im meta1-re*meta2-re )
  unrot MetaMul		( meta1-re*meta2-re meta1-im*meta2-im )
  MetaSub		( meta )
;


LABEL addtRE/
* re[n/d]=(re[n]*re[d]+im[n]*im[d])/|d|^2
::
  addtREIM/ 		( meta-n meta-red meta-imd )
  OVER j#0=case addtRE/im=0
			( meta-n meta-red meta-imd )
  psh OVER j#0=case addtRE/re=0
			( meta-n meta-imd meta-red )
  addtREIM/2		( meta-imd meta-red meta-imn meta-ren )
  rot dup addtSQ	( meta-imd meta-imn meta-ren meta-red meta-red^2 )
  4unroll MetaMul	( meta-imd meta-red^2 meta-imn meta-ren*red  )
  psh 4roll dup	addtSQ ( meta-red^2 meta-ren*red met-imn met-imd met-imd^2 )
  4unroll MetaMul	( meta-red^2 met-imd^2 meta-ren*red meta-imn*imd )
  MetaAdd unrot		( meta-ren*red+imn*imd meta-red^2 meta-imd^2 )
  MetaAdd MetaDiv	( -> )
;

LABEL addtRE/re=0
* re[n/i*im[d]]=im[n]/im[d]
::				( meta-n meta-imd meta-red )
  2DROP psh inaddtIM psh MetaDiv ( -> )
;

LABEL addtRE/im=0
* re[n/re[d]]=re[n]/re[d]
::				( meta-n meta-red meta-imd )
  2DROP psh inaddtRE psh MetaDiv ( -> )
;

**********************************************************************
* Desc:		Complex imaginary part
* Stack:	( symb --> symb' )
* Note:		expands only + - * / ^
**********************************************************************
NULLNAME xIMext
:: SYMBINCOMP addtIM CKSYMBN ;

**********************************************************************
* Desc:		Meta complex imaginary part
* Stack:	( meta --> meta' )
* Note:		expands only + - * / ^
**********************************************************************
NULLNAME xSYMIM
LABEL addtIM
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMIM
ASSEMBLE
	ENDIF	f39
RPL
  COMPLEX? case inaddtIM
  ISMETACOMPLEX? NOTcase NDROPZ0ONE		( -> 0 )
  SETCOMPLEX
  allrealflag TestSysFlag OBJ>R
  allrealflag SetSysFlag			( meta )
  inaddtIM					( im )
  allrealflag R>OBJ ITE SetSysFlag ClrSysFlag	( im )
  CLRCOMPLEX 
;

LABEL inaddtIM
::
						( meta )
  1metaundef? #0<> case addtIMinf
						( meta )
  allrealflag SysITE ISMETACOMPLEX? TRUE 	( meta ?cmplx )
  NOTcase NDROPZ0ONE
						( meta )
  DUP#1= case addtIM#1
  M1stNEGcase addtIMNEG
  M1st+case addtIM+-
  M1st-case addtIM+-
  M1st*case addtIM*
  M1st/case addtIM/
  M1st^case addtIM^
  AEQ1stcase xRE NDROPZ0ONE
  AEQ1stcase xIM NDROPZ0ONE
  AEQ1stcase xABS NDROPZ0ONE
  AEQ1stcase xARG NDROPZ0ONE
  AEQ1stcase x\v/ addtIMSQRT
  AEQ1stcase xCONJ addtIMNEG
  AEQ1stcase xEXP addtIMEXP
  AEQ1stcase xSIN addtIMSIN
  AEQ1stcase xCOS addtIMCOS
  AEQ1stcase xATAN addtIMATAN
  addtIMonly
;

LABEL addtIMinf
::
  DUP#1= case NDROPundef
  NDROPZ0ONE
;

LABEL addtIMonly
:: addt: xIM ;

LABEL addtIMSQRT
::				( sqrt[z] )
  pulldrop			( z )
  REIM				( re im )
  OVER j#0=case pshNDROP	( -> return 0 )
				( re im )
  dup rot psh			( im re im )
  addtREIMSQRTend		( im re[sqrt[z]] )
  meta2* MetaDiv		( im/2*re[sqrt[z]] )
;

	
LABEL addtIM^
::
  pulldrop larg			( meta1 meta2 )
  OVER TYPEZ? NOTcase :: MetaPow addtIMonly ;
  				( meta1 z one )
  psh REIM			( z one meta-re meta-im )
  OVER j#0=case :: pshNDROP psh MetaPow ;
				( z one meta-re meta-im )
  metai MetaMul MetaAdd	( z one meta-re+i*meta-im )
  psh MetaPow metackundef	( -> meta-undef )
				( meta )
  dup LISTOPRAC LVARDext	( meta lvar )
  DUP 2LAMBIND			( meta )
  VXXL2NR RIMext		( Q )
  ZERO 1PUTLAM			( Q )
  VAL1M				( meta )
  ABND
;

LABEL addtIMNEG
:: pulldrop inaddtIM MetaNeg ;

LABEL addtIMEXP
:: pulldrop inexp2expre_im addtSIN metamult ;

LABEL addtIMSIN
:: 
  pulldropIM=0? case NDROPZ0ONE
  tmeta-meta metasub/2i inaddtIM 
;

LABEL pulldropIM=0?
::
  pulldrop dup inaddtIM 	( meta meta-im )
  DUP#1= NOTcase NDROPFALSE	( -> meta FALSE )
  				( meta meta-im )
  DROPZ0 EQUAL			( -> meta flag )
;


LABEL addtIMCOS
:: 
  pulldropIM=0? case NDROPZ0ONE
  tmeta-meta metaadd/2 inaddtIM 
;

LABEL addtIMATAN
::
  dup pulldrop metareal?
  case 2NDROPZ0ONE
  NDROP addtIMonly
;

LABEL addtIM#1
::
  OVER TYPECMP? casedrop C>Im%ONE
  AEQ1stcase xi NDROPZ1ONE
  OVER IDNTLAM?			( id #1 id flag )
  NOTcasedrop NDROPZ0ONE
				( id #1 id )
  ISIDREAL?			( id #1 id ob true | id #1 id false )
  NOTcasedrop addtIMonly
				( id #1 id ob )
  4DROP Z0ONE			( z0 #1 )
;

LABEL C>Im%ONE
:: C>Im% ONE ;

LABEL addtIM+-
::
  #1-SWAP OBJ>R
  pshzerpsharg inaddtIM		( meta1 im[meta2] )
  psh inaddtIM
  R>OBJ 
  addtREIM+-
;

LABEL addtREIM+-
:: EQ: x+ case MetaAdd MetaSub ;

LABEL addtIM*		( im[a*b]=im[a]*re[b]+im[b]*re[a] )
::
  plDRPpZparg		( meta1 meta2 )
  addtIM*split
;

LABEL addtIM*split
::			( meta1 meta2 )
  addtREIM		( meta2-im meta2-re meta1-im meta1-re )
  4roll MetaMul		( meta2-re meta1-im meta1-re*meta2-im )
  unrot MetaMul		( meta2-re*meta1-im meta1-re*meta2-im )
  MetaAdd		( meta )
;

LABEL addtIM/
* im[n/d]=im[n*d_b]/|d|^2=[im[n]*re[d]-im[d]*re[n]]/|d|^2
::
  addtREIM/ 		( meta-n meta-red meta-imd )
  OVER j#0=case addtIM/im=0
			( meta-n meta-red meta-imd )
  psh OVER j#0=case addtIM/re=0
			( meta-n meta-imd meta-red )
  addtREIM/2		( meta-imd meta-red meta-imn meta-ren )
  4roll dup addtSQ	( meta-red meta-imn meta-ren meta-imd meta-imd^2 )
  4unroll		( meta-red meta-imd^2 meta-imn meta-ren meta-imd )
  MetaMul psh		( meta-red meta-imd^2 meta-ren*imd meta-imn )
  4roll dup addtSQ	( meta-imd^2 meta-ren*imd meta-imn meta-red met-red^2 )
  4unroll MetaMul	( meta-imd^2 met-red^2 meta-ren*imd meta-imn*red )
  psh MetaSub		( meta-imd^2 met-red^2 meta-imn*red-ren*imd )
  psh rot MetaAdd	( meta-imn*red-ren*imd meta-red^2+imd^2 )
  MetaDiv		( -> meta )
;

LABEL addtREIM/
::
  pulldrop larg			( meta-n meta-d )
  dup inaddtRE psh inaddtIM	( meta-n metad-re metad-im )
;

LABEL addtREIM/2
::				( meta-n meta-red meta-imd )
  rot dup inaddtIM psh inaddtRE	( meta-imd meta-red meta1-imn meta1-ren )
;

LABEL addtIM/re=0
* im[n/i*im[d]]=-re[n]/im[d]
::				( meta-n meta-imd meta-red )
  2DROP psh inaddtRE MetaNeg	( meta-imd -meta-ren )
  psh MetaDiv			( -> )
;

LABEL addtIM/im=0
* im[n/re[d]]=im[n]/re[d]
::				( meta-n meta-red meta-imd )
  2DROP psh inaddtIM psh MetaDiv	( -> )
;

LABEL addtREIM
::				( meta1 meta2 )
  dup inaddtIM psh inaddtRE	( meta1 meta2-im meta2-re )
  rot dup inaddtIM psh inaddtRE	( meta2-im meta2-re meta1-im meta1-re )
;

	
**********************************************************************
* Desc:		Internal complex conjugate
* Stack:	( ob --> Conj(ob) )
**********************************************************************
NULLNAME RCONJext
ASSEMBLE
=rconjext!
RPL
::
  CK&DISPATCH1
  zint  NOP
  ereal NOP
  ecmp  C%%CONJ
  real  NOP
  cmp   C%CONJ
  list  QOBJCONJ
  str   NOP
  seco  SECOCONJ
  any   Q/QCONJ
;

LABEL Q/QCONJ
::
  FXNDext			( num deno )
  Z1 EQUALcasedro SYMCONJ
  SWAP RCONJext SWAP RCONJext	( num-conj deno-conj )
  NDXFext
;

LABEL SYMRCONJ
::
  SYMBINCOMP addtCONJ CKSYMBN
;

**********************************************************************
* Desc:		Meta complex conjugate
* Stack:	( meta --> meta' )
**********************************************************************
NULLNAME addtCONJ
NULLNAME xSYMCONJ
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMCONJ
ASSEMBLE
	ENDIF	f39
RPL
  TESTi
  COMPLEX? NOT?SEMI
  1metaundef? #0<> ?SEMI
  OVER TYPELIST? NOTcase addtCONJ1
  DROP QOBJCONJ ONE
;

LABEL addtCONJ1
::
  DUP#1= case addtCONJ#1
  AEQ1stcase xABS NOP
  AEQ1stcase xARG MetaNeg
  AEQ1stcase x\v/ NOP
  AEQ1stcase xCONJ pulldrop
  AEQ1stcase xRE NOP
  AEQ1stcase xIM NOP
  M1stFcncase addtCONJonly
  #1-SWAP enumargs		( ..., op, #args )
  DUP #5= case INTERNALERR
  SWAP OBJ>R			( meta #args )
  ZEROSWAP			( meta-in meta-out #args )
  ZERO_DO (DO)			( meta meta-out )
    psh larg			( meta-out meta2 meta1 )
    addtCONJ			( meta-out meta2 conj )
    rot top&			( meta' meta-out' )
    LOOP			( null-meta meta-out' )
  get1 DROP			( meta-out )
  R>OBJ SWAP#1+			( meta&op )
;

LABEL addtCONJonly
::
  addt: xCONJ
;

LABEL addtCONJ#1
::				( meta )
  OVER TYPECMP? casedrop C%CONJONE
  AEQ1stcase xi addtNEG
  OVER TYPECOL? ?SEMI
  DROP idntlamcase addtCONJID
  RCONJext SYMBINCOMP
;

LABEL C%CONJONE
:: C%CONJ ONE ;

LABEL addtCONJID
::			( id )
  ISIDREAL?		( id ob true | id false )
  casedrop ONE		( -> id #1 )
  ONE addtCONJonly	( -> id xCONJ #2 )
;
	
LABEL addtCONJ/
::
  plDRPpZparg addtCONJ psh addtCONJ MetaDiv
;

LABEL SECOCONJ
:: 
  INNERDUP DUP#1=		( meta # flag )
  case2DROP			( -> obj )
				( meta # )
  #2= casedrop CCONJ
  #5= NOTcase INTERNALERR
  DROP 4ROLLDROP UNROT RCONJext UNROT RCONJext
  UNROT NDXQext
;

LABEL CCONJ
:: SWAPRNEG RIXCext ;


**********************************************************************
* Desc:		execute internal complex conj. over element of composite
* Stack:	( composite -> composite )
**********************************************************************
LABEL QOBJCONJ
::
  QOBJSECext RCONJext
; 

**********************************************************************
* Desc:		irrq-conjugate of an irrq
* Stack:	( irrq -> irrq' )
* Note:		this is *not* the complex conjugate
**********************************************************************
NULLNAME QCONJext
LABEL qconjext!
::
  QXNDext SWAP RNEGext SWAP NDXQext
;

**********************************************************************
* Desc:		Find the sign of an irrq
* Stack:	( irrq -> irrq, sign )
* Note:		work always if irrq is made of Z
**********************************************************************
NULLNAME QABSext
::
  DUP QXNDext				( irrq, a, b, c )
  UNROT POSITIFext			( irrq, c, a, b, b>0? )
  3PICK POSITIFext SWAPDROP		( irrq, c, a, b, b>0?, a>0? )
  OVER XOR NOTcase 4UNROLL3DROP		( irrq, c, a, b, b>0? )
  4UNROLL DUP RMULText ROT RMULText	( irrq, b>0?, a, b^2*c )
  SWAPDUP RMULText RSUBext		( irrq, b>0?, b^2*c-a^2 )
  POSITIFext SWAPDROP			( irrq, b>0?, b^2*c>a^2? )

* if b^2c>a^2, the sign of the irrq is the sign of b

  ?SEMI NOT
;

**********************************************************************
* Desc:		User ABS
* Stack:	( ob --> abs(ob) )
* Note:		assumes all var are reals
**********************************************************************
*NULLNAME ABS
*:: 
*  CKFPOLYext
*  SINCOSext 
*  DMONOEVALext CZABS
*;

**********************************************************************
* Desc:		Internal ABS
* Stack:	( ob --> abs(ob) )
* Note:		Internal reprentation
**********************************************************************
NULLNAME RABSext
::
  NEWTRIMext
  CK&DISPATCH1
  zint   ZABS
  seco	 CZABS
  real   %ABS
  cmp    C%ABS
  ereal  %%ABS
  ecmp   C%%ABS
  any    xABSext
;

**********************************************************************
* Desc:		absolute value
* Stack:	( Z --> Z )
**********************************************************************
NULLNAME ZABS
:: DupZIsNeg? NOT?SEMI QNeg ;

**********************************************************************
* Desc:		absolute value
* Stack:	( complex --> real )
**********************************************************************
NULLNAME CZABS
:: DUP RCONJext RMULText REALEVAL XSQRext ;

**********************************************************************
* Desc:		Symbolic ABS function.
* Stack:	( ob --> abs(ob) )
**********************************************************************
NULLNAME xABSext
::	
  SYMBINCOMP addtABS CKSYMBN
;

**********************************************************************
* Desc:		Meta ABS
* Stack:	( Meta --> Meta' )
* Note:		does a CRUNCH first to find sign
**********************************************************************
NULLNAME addtABS
NULLNAME xSYMABS
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMABS
ASSEMBLE
	ENDIF	f39
RPL
  TESTi
  1metaundef? #0<> case NDROPplusinf
  ( * note: added EXACT? test for CASNUMEVAL otherwise plot of ABS[X] fails * )
  dup EXACT? IT approxmetasimp		( meta crunched-meta )
  OVER TYPEREAL? casedrop addtABSR
					( meta crunched-meta )
  NDROP					( meta )
  sturmflag TestSysFlag case addtABSonly
  EXACT? case addtABSEXACT addtABSonly
;

**********************************************************************
* Desc:		Meta ABS
* Stack:	( Meta --> Meta' )
* Note:		No crunch, sign is only found using exact methods
**********************************************************************
NULLNAME addtABSEXACT
::					( meta )
  dup zsigne 				( meta Z )
  Z-1 EQUALcasedro MetaNeg
  Z1 EQUAL ?SEMI
  M1stNEGcase addtABSNEG
  M1st*case addtABS*
  M1st/case addtABS/
  AEQ1stcase xABS NOP
  AEQ1stcase x\v/ addtABSSQRT
  AEQ1stcase xCONJ addtABSNEG	( -> pulldrop addtABS )
  AEQ1stcase xSIGN NDROPZ1ONE
  AEQ1stcase xi NDROPZ1ONE
					( meta )
  COMPLEX? case addtCABS
  AEQ1stcase xEXP NOP
  AEQ1stcase x^ addtABS^
  addtABSonly
;

LABEL addtABSSQRT
::						( sqrt[meta] )
  pulldrop dup addtIM				( meta im[meta] )
  OVER j#0=case NDROPaddtSQRTonly		( -> sqrt[meta] )
						( meta im[meta] )
  NDROP addtABS addtSQRT			( -> sqrt[abs[meta]] )
;

LABEL NDROPaddtSQRTonly
:: NDROP addtSQRTonly ;
	
LABEL addtABSonly
::   
  nocareflag TestSysFlag ?SEMI
  addt: xABS 
;

LABEL addtABSR
:: 			( meta % )
  %0< case MetaNeg 
;

LABEL addtABSNEG
::
  pulldrop addtABSEXACT
;

LABEL addtABS*
::
  plDRPpZparg addtABSEXACT psh addtABSEXACT MetaMul
;

LABEL addtABS/
::
  plDRPpZparg addtABSEXACT psh addtABSEXACT MetaDiv
;

LABEL addtABS^
::
  plDRPpZparg addtABSEXACT psh MetaPow
;

LABEL addtCABS
::					( meta )
  metareal?				( meta flag )
  case addtABSonly
  dup addtIM				( meta meta-im )
  OVER j#0=case :: NDROP addtABSonly ;
  addtSQ psh addtRE addtSQ MetaAdd	( meta-re[z]^2+im[z]^2 )
  addtSQRT				( meta-|z| )
  ( * added code to insure that numeric answer are at least correct * )
  dup approxmetasimp		( meta crunched-meta )
  OVER TYPEREAL? casedrop addtABSR
					( meta crunched-meta )
  NDROP					( meta )
;

**********************************************************************
* Desc:		Meta SIGN
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtSIGN
NULLNAME xSYMSIGN
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMSIGN
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0=case addtSIGN1
  metainftype DUP#0=csedrp metaundef
  #1=case Z1ONE Z-1ONE
;

LABEL addtSIGN1
::
  OVER TYPEZ? casedrop addtSIGNZ
  M1stNEGcase addtSIGNNEG
  AEQ1stcase xABS NDROPZ1ONE
  dup addtABS MetaDiv
;

LABEL addtSIGNZ
:: 
 num#0=case DROPundef
 ZIsNeg? case Z-1ONE Z1ONE 
;

LABEL DROPundef
:: DROP metaundef ;

LABEL addtSIGNNEG
::
  pulldrop addtSIGN1 metaneg
;

**********************************************************************
* Desc:		Meta ARG
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtARG
NULLNAME xSYMARG
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMARG
ASSEMBLE
	ENDIF	f39
RPL
  COMPLEXON
  1metaundef? #0=case addtARG1
  metainftype DUP#0=csedrp metaundef
  #1=case Z0ONE ARG-1
;

LABEL ARG-1
:: RAD? case metapi DEG?Z180Z200 ONE ;

LABEL DEG?Z180Z200
:: DEG? ITE Z180 Z200 ;

LABEL addtARG1
::
  OVER TYPEZ? casedrop addtARGZ	
  AEQ1stcase xABS NDROPZ0ONE
  RAD? NOTcase addtARGonly
  AEQ1stcase xi droppi/2
  dup addtRE metasimp			( z re )
  OVER j#0=case addtARGre0
  dup REALEVAL addtSIGN			( z re sign )
  rot addtIM rot MetaDiv		( sign im/re )
  metasimp addtATAN			( sign atan )
  Z1ONE rot MetaSub			( atan 1-sign )
  ckpi/2 MetaMul MetaAdd		( atan+[1-sign]*pi/2 )
;

LABEL addtARGre0
:: 
  2DROP addtIM 
  addtSIGN metapi/2 MetaMul 
;

LABEL addtARGZ
:: ZIsNeg? NOTcase Z0ONE ARG-1 ;
	

LABEL addtARGonly
::
  addt: xARG
;



**********************************************************************
* Desc:		ARG
* Stack:	( im re --> arg(ob) )
**********************************************************************
NULLNAME ARG2
::					( im re )
  INTERNALARG2 metasimp			( meta )
;

NULLNAME INTERNALARG2
::					( im re )
  SWAP num#0=case ARG2REAL
					( re im )
  POSITIFext				( re im ?im>0 )
  DUPUNROT ?SKIP RNEGext		( re ?im>0 abs[im] )
  SWAPROT				( abs[im] ?im>0 re )
  num#0=case
   ::
     DROPSWAPDROP			( ?im>0 )
     case metapi/2 meta-pi/2
   ;
  POSITIFext DUPUNROT ?SKIP RNEGext	( abs[im] ?im>0 ?re>0 abs[re] )
  SWAPROT				( im re re> im> )
  QUADRANT				( im re Z )
  UNROT RDIVext				( Z im/re )
  SYMBINCOMP addtATAN			( Z meta )
  get1 metapi/2 #1+ addt*		( meta meta-Z*pi/2 )
  MetaAdd 				( meta )
;

LABEL ARG2REAL
:: 					( re im )
  DROP POSITIFext SWAPDROP		( ?re>0 )
  case Z0ONE metapi
;

**********************************************************************
* Desc:		Returns Z0 Z1 Z-2 or Z-1 so that arg of corresponding
*		complex number is Z * pi/2 + theta where theta is
*		in the interval [0,pi/2]
* Stack:	( re im ?re>0 ?im>0 --> newre newim % )
**********************************************************************
NULLNAME QUADRANT
::	
  2DUP AND case2drop Z0		( first quadrant )
  OVER OR NOTcasedrop Z-2	( re<0, im<0: 3rd quadrant )
  ROTSWAP			( exchange re and im for 2nd and 4th quadr. )
  ITE Z-1 Z1			( re>0, im<0: 4th quadrant ) 
;

**********************************************************************
* Desc:		Square modulus of a Gauss integer
* Stack:	( C --> |C|^2 )
**********************************************************************
NULLNAME CNORMext
::
  CXIRext
  DUP RMULText
  SWAPDUP RMULText
  RADDext
;

NULLNAME CXIRext
CODE
	C=DAT1	A
	CD1EX
	A=DAT1	10
	CD1EX
	C=A	W
	LCIRRQ
	?A=C	W
	GOYES	+
	?A#C	A
	GOYES	+
	LA(5)	=INCOMPDROP
	PC=(A)
+	LA(5)	=C>ImRe
	PC=(A)
ENDCODE

LABEL C>ImRe
::
  DUP RIMext SWAP RREext
;

**********************************************************************
* Desc:		Irrq-norm of an irrquad
* Stack:	( Zirr --> a^2-b*c^2 )
* Note:		This is *not* the complex modulus
**********************************************************************
NULLNAME QNORMext 
LABEL qnormext!
::
  QXNDext
  SWAPDUP RMULText
  RMULText
  SWAPDUP RMULText
  SWAP RSUBext
;

**********************************************************************
* Desc:
* Stack:	( ob --> sqrt(ob) )
* Note:		Does not take care of the sign.
**********************************************************************
NULLNAME SXSQRext
::
  nocareflag TestSysFlag SWAP
  nocareflag SetSysFlag
  XSQRext
  nocareflag ROT ITE_DROP ClrSysFlag
;

**********************************************************************
* Desc:
* Stack:	( ob --> sqrt(ob) )
* Note:		Tries to return a positive square root if nocareflag is cleared
**********************************************************************
NULLNAME XSQRext
LABEL xsqr!
::

* modifier la recherche pour des seco, afin de donner la priorite aux complexes

  TRIMOBJext
  CK&DISPATCH1
  ereal  CK%%SQRT
  ecmp   C%%SQRT
  real   %SQRT
  TWO    C%SQRT
  zint 	 ZINTSQRT
  seco   SECOSQRT
  list   POLYSQRT
  sym    SYMBSQRT
  EXT    UMSQRT
;

LABEL SYMBSQRT
::
  FXNDext 				( n d )
  Z1 EQUALcasedro xvext			( -> sqrt[n] )
  DUPUNROT RMULText XSQRext 		( d sqrt[n*d] )
  SWAP COMPLEX? ?SKIP xABSext QDiv	( sqrt[n*d]/d )
;

NULLNAME CK%%SQRT
* like %%SQRT but handles %%<0
:: 
  DUP %%0< NOTcase %%SQRT
  COMPLEXON
  %%CHS %%SQRT %%0 SWAP E%%>C%%
;

NULLNAME C%%SQRT
* sqrt for C%%
:: C%%>%% %%R>P %%.5 %%* SWAP %%SQRT SWAP %%P>R E%%>C%% ;

NULLNAME ZINTSQRT
::
  Z0 EQUALcasedro Z0
  DupZIsNeg? DUPUNROT IT RNEGext
  NFactor			( negatif?, liste facteurs )
  Z0 Z1 DUP 4ROLL		( flag, zint#1, rac_s, rac_d, liste_rac )
  [BEGIN]
     DUPNULL{}?
  NOT_WHILE
     ZINTSQRTLP
  [REPEAT]
				( flag zint#1 list_s list_d null{} )
  DROP				( flag zint#1 simples doubles )
  ROT 4ROLL
  ITE :: COMPLEXON IRXCext ; DROP	( simples doubles )
  SWAP				( doubles simples )
  Z1 EQUALcasedro NOP
  Z0 UNROT NDXQext
;

LABEL ZINTSQRTLP
::					( s d list_rac )
  NEXTPext				( s d rest root_act )
  DUPLENCOMP TWO #/ ROT CARCOMP		( s d rest mult_s mult_d rac )
  DUPROT RPext				( s d rest mult_s rac d )
  5ROLL RMULText 4UNROLL		( list_s list_d rest mult_s rac )
  SWAP #0=case DROP
					( list_s list_d rest rac )
  4ROLLSWAP RMULText UNROT
;

LABEL SECOSQRT
::
  ( * first test for irrq with a=0 and b=1  * )
  ( * since no further simplification occur in that case * )
  TESTA0B1 case Z0Z1ROTNDXQ

  ( * in complex mode wa apply an algorithm to find sqrt[a+ib] * )
  COMPLEX? case CSECOSQRT
  RSECOSQRT
;

LABEL RSECOSQRT
::
  ( * in real mode, since x is a seco it's an irrq * )
  ( * first test if x is positive * )
  DUP ZSIGNE				( x z )
  Z-1 EQUALcase SECOSQRTi
  ( * x is a positive irrq or an irrq of unknown sign * )
  PRSECOSQRT
;

LABEL PRSECOSQRT
::
  ( * x is a positive irrq or an irrq of unknown sign * )
					( x )
  DUP QNORMext			        ( x |x| )
  POSITIFext 				( x |x| ?>0 )
  NOTcase SECOSQRTNEG
  ( * |x| is positive, is x.b<0? * )
  					( x |x| )
  OVER THREE NTHCOMPDROP		( x |x| b )
  POSITIFext SWAPDROP			( x |x| ?b>0 )
  NOTcase SECOSQRTBAR
  ( * |x|>0 and x.b>0, note that x.a should be positive * )

  DUP SXSQRext			        ( x |x| sqrt[|x|] )
  SECOSQRTCK				( x |x| sqrt[|x|] flag )
  ROTDROP 				( x sqrt[|x|] flag )
  NOTcasedrop SECOSQRTNOTSQ
					( x sqrt[|x|] )
  ( * find a and b s.t. [a+b*sqrt[c]]^2=x.a+x.b*sqrt[c] * )
  ( * solve for a in 4*[a^2]^2 - 4*x.a*a^2 + [x.b]^2*c = 0 * )
  ( * a^2= [ x.a +/- sqrt[|q[x]|] ] / 2 * )
  SWAP QXNDext				( sqrt x.a x.b c )
  2SWAP					( x.b c sqrt x.a )
  2DUPSWAP RSUBext			( x.b c sqrt x.a x.a-sqrt )
  Z2 RDIVext SXSQRext			( x.b c sqrt x.a a )
  ::
				( avoid complex in a )
     NOTSECOcase UNROT2DROP
     DROP RADDext
     Z2 RDIVext SXSQRext
  ;
					( x.b c a )
  ROTSWAP DUP4UNROLL		        ( a c x.b a )
  Z2 RMULText RDIVext			( a c b=x.b/2a )
  SWAP					( a b c )

  ( * try to test positivity * )

  Z0Z1ROTNDXQ RMULText RADDext
  POSITIFext ?SEMI
  RNEGext
;

LABEL SECOSQRTi
::
  QNeg PRSECOSQRT 			( sqrt[-x] )
  COMPLEXON
  Zi QMul
;

LABEL SECOSQRTNEG
* |x| is negative, therefore x can not be of the form [a+b*sqrt[c]]^2
* We just have to test that a>0, and if not we return
* sqrt[-xbar]*sqrt[-q[x]]/-xbar
::					( x |x| )
* 09 april 03:	 commented to try avoiding TTRM for sqrt(-5-i*sqrt(95))
*  OVER TWO NTHCOMPDROP			( x |x| a )
*  POSITIFext SWAPDROP			( x |x| ?a>0 )
*  NOTcase SECOSQRTNEGBAR
					( x |x| )
  DROP SECOSQRTNOTSQ			( -> )
;

( * if x.b is negative, sqrt[x]=sqrt[xbar]*sqrt[q[x]]/xbar * )
LABEL SECOSQRTBAR
( x -> sqrt[xbar]*sqrt[q[x]]/xbar )
::
				( x |x| )
  SWAP QCONJext DUP		( |x| xbar xbar )
  SXSQRext			( |x| xbar sqrt[xbar] )
  ROT SXSQRext	QMul		( xbar sqrt[|x|]*sqrt[xbar] )
  SWAP QDiv			( -> )
;

LABEL SECOSQRTNEGBAR
::				( x |x| )
  SWAP QNeg			( -|x| x )
  SWAP QNeg			( -x -|x| )
  SECOSQRTBAR			( -> )
;

LABEL TESTA0B1
* obj -> obj, flag
* test if obj is an irrq of the form << 0 1 c >>
::
  DUPTYPEIRRQ? NOTcaseFALSE	( -> complex false )
				( <<>> )
  DUPTWO NTHCOMPDROP		( <<>> a )
  Z0 EQUAL 			( <<>> flag )
  NOTcaseFALSE			( -> <<>> false )
  DUP THREE NTHCOMPDROP		( <<>> b )
  Z1 EQUAL			( <<>> flag )
;

LABEL Z0Z1ROTNDXQ
* c -> 0+1*sqrt[c]
::
  Z0 Z1 ROT NDXQext
;

LABEL SECOSQRTCK
( x |x| sqrt[|x|] -> x |x| sqrt[|x|] flag )
::
  ( test if |x| is a "perfect square" )
  ( if sqrt|x| is of seco type, test that x.c is more complex than sqrt|x|.c )
  CK&DISPATCH1
  zint 	TRUE
  list  TRUE
  seco  SECOSECOCK
  any   FALSE
;

LABEL SECOSECOCK
::
  ( * commented test for a complex, since this case should never occur * )
*  DUPLENCOMP #2= NOTcaseFALSE
					( x |x| sqrt|x| )
  3PICK DUPTYPECOL? NOTcase DROPFALSE
					( x |x| sqrt|x| x )
* old code
*  FOUR NTHCOMPDROP 			( x |x| sqrt|x| x.c )
*  OVER FOUR NTHCOMPDROP 		( x |x| sqrt|x| x.c sqrt|x|.c )
*  ( * fails if x.c is lesscomplex or same than sqrt|x|.c * )
*  LESSCOMPLEX? case2drop FALSE		
*  EQUAL NOT				( x |x| sqrt|x| )
* end old code
  FOUR NTHCOMPDROP			( x |x| sqrt|x| x.c )
  IRRQ#ULTIMATE				( x |x| sqrt|x| #x.c x.c.c )
  DROPOVER FOUR NTHCOMPDROP		( x |x| sqrt|x| #x.c sqrt|x|.c )
  IRRQ#ULTIMATE DROP			( x |x| sqrt|x| #x.c #sqrt|x|.c )
  #>					( x |x| sqrt|x| ? )
;

LABEL SECOSQRTNOTSQ
::
  ( * extract the square part of the gcd of a and b * )
				( x )
  DUP QXNDext DROP		( x a b )
  GCDext 			( x c )
  SINGLE&DOUBLE 		( x s d )
  SWAPDROP DUPUNROT		( d x d )
  DUP QMul RDIVext 		( d x/d^2 )
  Z0 UNROT NDXQext
; 
	
LABEL CSECOSQRT
::
  DUP RREext SWAP RIMext		( x y )
  AUTOSWITCHEVAL INCSECOSQRT
;

LABEL INCSECOSQRT
::
  CLRCOMPLEX				( x y )
  num#0=case :: DROP XSQRext SETCOMPLEX ;
  SWAP2DUP DUP RMULText			( y x y x^2 )
  SWAPDUP RMULText RADDext SXSQRext	( y x rho )
* code change 11 July 99, old code was
*  2DUP RADDext Z2 RDIVext SXSQRext 	( y x rho sqrt[ [x+rho]/2] )
*  UNROTSWAP RSUBext 
*  Z2 RDIVext SXSQRext			( y sqrt[[x+rho]/2] sqrt[[rho-x]/2] )
*  SETCOMPLEX
*  Zi 4ROLL				( sqrt[[x+rho]/2] sqrt[[rho-x]/2] i y )
*  POSITIFext SWAPDROP ?SKIP RNEGext	( sqrt[[x+rho]/2] sqrt[[rho-x]/2] +-i )
*  RMULText RADDext
* replaced by
					( y x rho )
  QAdd Z2 QDiv SXSQRext			( y sqrt[[x+rho]/2] )
  DUPUNROT				( real y real )
  SETCOMPLEX Zi Z-2 QMul QMul QDiv	( real i*y/2*real )
  QAdd					( result )
* end change
;

LABEL SINGLE&DOUBLE
( obj -> s d with obj=s*d^2 and s square free )
* note that s may be not square free if obj contains or is an irrquad
::					( obj )
  EXACT? NOTcase Z1			( -> obj 1 )
					( obj )
  RFACTSTEP3				( meta )
  Z1 DUPROT #2/				( meta' 1 1 #/2 )
  ZERO_DO (DO)				( l1 m1.. lk mk rac_s rac_d )
    2SWAP				( ..rac_s rac_d lk mk )
    DUPTYPEREAL? IT COERCE 
    TWO #/				( ..rac_s rac_d lk p/i mk/2 )
    ::
       SWAP DUP#0=csDROP
       DROPOVER 5ROLL RMULText
       4UNROLL
    ;
					( ..rac_s rac_d lk mk/2 )
    RPext RMULText
  LOOP
					( rac_s rac_d )
;

LABEL POLYSQRT
::
  PPZ XSQRext			( poly sqrt[content] )
  SWAP PRIMPOLYSQRT		( sqrt[content] sqrt[poly] )
  POLYSQRTQMul
;

LABEL PRIMPOLYSQRT
::
  SINGLE&DOUBLE				( rac_s rac_d )
  ( * change sign of rac_d if necessary * )

  POSITIFext ?SKIP RNEGext 
  nocareflag TestSysFlag
  COMPLEX? OR ?SKIP RABSext		( rac_s rac_d )

  ( * sign of rac_d changed * )	
  SWAP 				( rac_d rac_s )
  dLISTcase POLYSQRT+
  POSITIFext			( rac_d rac_s >0? )
  case POLYSQRT+		( -> rac_d*sqrt[rac_s] )

				( rac_d rac_s )  
  COMPLEXON QNeg		( rac_d -rac_s )
  POLYSQRT1			( rac_d sqrt[-rac_s] )
  SWAP Zi QMul 			( i*rac_d -rac_s )
  POLYSQRTQMul			( -> i*rac_d*sqrt[-rac_s] )
;

LABEL POLYSQRT+
::				( rac_d rac_s )
  POLYSQRT1 			( rac_d sqrt[rac_s] )
  POLYSQRTQMul
;

LABEL POLYSQRT1
::
  DUPTYPELIST? NOTcase XSQRext
  Z0 Z1 ROT NDXQext
;

LABEL POLYSQRTQMul
* special multiplication
* the problem comes from symb list xABS ; times list
* QMul does not handle list embedded in symbolics
::
  ABS? case x*ext
  SWAP ABS? case x*ext
  NOSIMPEVALext QMul
;

LABEL ABS?
* obj -> obj, flag
* true if obj is a symbolic containing ABS
::
  DUPTYPESYMB? NOTcaseFALSE
  ' xABS Contains? SWAPDROP
;

( * added to emulate jazz SHALT command * )
NULLNAME SHALT
:: ;

* ====================================================================
* Transcendental symbolic operators
* ====================================================================


**********************************************************************
* Desc:		Symbolic LN with special handling for fractions
* Stack:	( ob --> ln(ob) )
* Note:		Does not use the internal representation
**********************************************************************
NULLNAME CKLN
::
  DUPTYPESYMB? NOTcase CKLN1
  DUP FXNDext LESSCOMPLEX?		( ob n d ?n<d )
  NOTcase2drop CKLN1
  ( * n is less complex than d, return -ln[d/n] )
					( ob n d )
  ROTDROPSWAP 				( d n )
  RDIVext CKLN1 SYMNEG
;


**********************************************************************
* Desc:		Symbolic LN, without fraction handling
* Stack:	( ob --> ln(ob) )
**********************************************************************
NULLNAME xLNext
LABEL CKLN1
::
  SYMBINCOMP addtLN CKSYMBN
;

LABEL NOCKLN
:: SYMBINCOMP addtLN2 CKSYMBN ;
	

**********************************************************************
* Desc:		Meta LN
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtLN
NULLNAME xSYMLN
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMLN
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef?
  #0=case addtLNnotinf
  addtLNinf
;

LABEL addtLNinf
::
  metainftype				( # )
  DUP#0=csedrp unsignedinf
  #1=case plusinf
  COMPLEXON plusinf addt2: xi xPI addt2: x* x+
;

LABEL addtLNnotinf
::					( meta )
  OVER j#1=case NDROPZ0ONE
  OVER j#0=case NDROPminusinf
  OVER EQ: xe case2drop Z1ONE
  OVER TYPEZ? casedrop ZLNMETA
  AEQ1stcase x\v/ addtLN\v/
  AEQ1stcase xEXP addtLNEXP
  COMPLEX? NOTcase addtLN2 addtLN1
;

LABEL addtLNEXP
::
  dup pulldrop addtIM			( exp[arg] im[arg] )
  OVER Z0 EQUAL				( exp[arg] im[arg] ? )
  case2drop pulldrop			( -> arg )
  NDROP addtLNonly			( ln[exp[arg]] )
;

LABEL ZLNMETA
::
  DUP ZAbs NLNMETA		( z meta-ln|| )
  get1 ZIsNeg? NOT?SEMI		( -> meta-ln|| )
				( meta-ln|| )
  COMPLEXON metaipi MetaAdd	( meta-ln )
;

LABEL NLNMETA
::
  Z1 EQUALcasedro Z0ONE
  Z0 EQUALcasedro minusinf
  DUP MZSQFF			( z meta )
  DUPTWO #=case NLNPOWER	( -> meta-k*ln[] )
  NDROP ' xLN TWO		( meta )
;

LABEL NLNPOWER
::				( z z_k %k #2 )
  DROP ROTDROP R>Z		( z_k k )
  ONE ROT			( k #1 z_k )
  ' xLN TWO MetaMul		( meta )
;

LABEL addtLN1
::
  invlnflag TestSysFlag case addt-1/INV-LN
  addtLNonly
;

LABEL addtLNonly
::
  ( * additional test for LN[z/z'] * )
  M1st/case addtLN/
  addtLNonly!
;

LABEL addtLNonly!
::
  addt: xLN 
;

LABEL addtLN/
::
  3PICK TYPEZINT? NOTcase addtLNonly!
  plDRPpZparg addtLN psh addtLN MetaSub
;

LABEL addt-1/INV-LN
::
  addt2: xLN xNEG addt: xINV Z-1 psh1 top&addt/
;

LABEL addtLN2
::
  AEQ1stcase xEXP pulldrop
* add ABS for integration or if original arg was ABS[...]
  lnabsflag TestSysFlag NOTcase addtLN1
  addtABS addtLNonly
;

LABEL addtLN\v/
::
  pulldrop addtLN meta/2
;

**********************************************************************
* Desc:		Symbolic LN using internal representation
* Stack:	( ob --> ln(ob) )
* Note:		Before switching to internal representation,
*		test for ABS, 0 and 1 and, in real mode, test if obj=exp(x), 
**********************************************************************
NULLNAME EXPANDLN
::
  SYMBINCOMP EXPANDLN0 CKSYMBN 
;

LABEL EXPANDLN0
::				( meta )
  AEQ1stcase xABS EXPANDLNABS	( -> )
  addtLN			( meta )
  AEQ1stcase xLN EXPANDLN1	( no simplification occured, call EXPANDLN1 )

  ( * addtLN was able to simplify the LN -> end here * )
				( meta-ln )
;

LABEL EXPANDLNABS
* caution, in complex mode it is assumed that ABS is ABS of a real argument
* simplifications should always take care of this.
::
  lnabsflag TestSysFlag OBJ>R
  lnabsflag SetSysFlag
  EXPANDLN1 
  R>OBJ ?SEMI lnabsflag ClrSysFlag
;

LABEL EXPANDLN1
::					( meta-ln | meta-ABS )
  pulldrop 				( meta )

  ( * first check that topmost operator is rational * )
  LISTOPext 3PICK Contains? UNROT2DROP	( meta flag ) 
  NOTcase addtLN1
  ( * operator was rational, try to simplify * )
					( meta )
  dup LISTOPRAC LVARDext		( meta lvar )
  DUP 2LAMBIND				( meta )
  VXXL2NR CMPLXLN			( ln[obj] )
  ZERO 1PUTLAM VAL1M ABND		( meta-ln[obj] )
;


**********************************************************************
* Desc:		Internal complex ln
* Stack:	( ob --> ln(ob) )
**********************************************************************
NULLNAME CMPLXLN
::
  CK&DISPATCH1
  zint	ZLN
  real  xLN
  TWO   C%LN
  ereal %%LN
  any   LNATANext
;

LABEL ZLN
::
  ZLNMETA CKSYMBN
;


**********************************************************************
* Desc:		Internal natural logarithm for complex
* Stack:	( ob --> ln(ob) )
**********************************************************************
NULLNAME LNATANext
::
  LNATANMETA
  CKSYMBN
;

LABEL LNATANMETA
::
  DUP RREext SWAP RIMext		( re im )
  num#0=case :: DROP REALLNMETA ;	( -> ln[re] )
					( re im )
  ( * we are in complex mode * )
  SWAP2DUP				( im re im re )
  DUP QMul SWAPDUP QMul			( im re re^2 im^2 )
  QAdd	UNROT				( ||^2 im re )
  INTERNALARG2 get1			( meta-arg ||^2 )
  LNSQRTMETA  				( meta-arg meta-ln )
  psh  					( meta-ln meta-arg )
  metai MetaMul MetaAdd 		( meta-res )
;

* return meta-ln(obj)/2, obj is the square of a modulus
* test if ln(obj)=0 or =even integer*something
LABEL LNSQRTMETA
::
  Z1 EQUALcasedro Z0ONE		( -> meta0 )
  REALLNMETA 			( meta-ln[obj] )
  M1st*case LNSQRT*
  meta/2			( meta )
;

LABEL LNSQRT*
::
  plDRPpZparg			( meta-last meta-rest )
  OVER TYPEZ? case LNSQRT*Z	( meta-last meta-rest )
  LNSQRT*/
;

LABEL LNSQRT*/
:: pshtop& addt* meta/2 ;

LABEL LNSQRT*Z
::
  OVER Z2 ZMod QIsZero?		( meta-last Z #1 flag )
  NOTcase LNSQRT*/
  DROP Z2 QDiv psh1top& addt*	( meta )
;

**********************************************************************
* Desc:		Internal natural logarithm for a real argument
* Stack:	( ob --> ln(ob) )
**********************************************************************
NULLNAME REALLN
::
  REALLNMETA
  CKSYMBN
;

LABEL REALLNMETA
::
  PPZZ 					( Q z )
  COMPLEX? lnabsflag TestSysFlag OR	( Q z flag )
  NOTcase LNMETANOSQFF			( -> meta )
  SWAP					( z Q )
  MSQFF					( z meta )
  get1 ZLNMETA  			( meta meta-lnz )
  get1 #2/
  ZERO_DO (DO)				( meta' meta-ln )
    get1 R>Z rotomo ONESWAP		( meta" meta-ln m ONE Q )
    ONE addtLNnotinf MetaMul		( meta" meta-ln meta-add-ln )
    MetaAdd				( meta" meta-ln )
  LOOP					( meta-ln )
;

LABEL LNMETANOSQFF
::					( Q z )
  ZLNMETA get1 ONE addtLNnotinf 	( meta-lnz meta-lnQ )
  MetaAdd				( -> meta )
;

**********************************************************************
* Desc:		Symbolic EXP, tests for 0, infinity and
*		i*k*pi/12 where k is an integer.
* Stack:	( y d n --> exp(y*n/d*i*pi) )
* Note:		Tests for d=1,2,3,4,6
**********************************************************************
NULLNAME xEXPext
::
  SYMBINCOMP addtEXP CKSYMBN
;


**********************************************************************
* Desc:		Symbolic inversion
* Stack:	( ob --> 1/ob )
**********************************************************************
NULLNAME xINVext
::
  Z1 ONE ROT SYMBINCOMP MetaDiv CKSYMBN
;

**********************************************************************
* Desc:		Symbolic square root, tests for 0 and 1.
* Stack:	( ob --> sqrt(ob) )
**********************************************************************
NULLNAME xvext
::	
  SYMBINCOMP addtSQRT CKSYMBN
;

**********************************************************************
* Desc:		Symbolic COS, tests for 0 and multiples of pi/12.
*		Also tests if ob=acos(x) or ob=asin(x)
* Stack:	( ob --> cos(ob) )
**********************************************************************
NULLNAME xCOSext
::
  SYMBINCOMP addtCOS CKSYMBN 
;

**********************************************************************
* Desc:		Symbolic SIN, tests for 0 and multiplies of pi/12.
*		Also tests if ob=acos(x) or ob=asin(x).
* Stack:	( ob --> sin(ob) )
**********************************************************************
NULLNAME xSINext
::
   SYMBINCOMP addtSIN CKSYMBN 
;
	
**********************************************************************
* Desc:		Symbolic TAN. Tests for 0 and multiplies of pi/12.
*		Also tests if ob=atan(x).
* Stack:	( ob --> tan(ob) )
**********************************************************************
NULLNAME xTANext
::
  SYMBINCOMP addtTAN CKSYMBN
;

**********************************************************************
* Desc:		Symbolic COSH. Tests for 0, infinite and acosh(x)
* Stack:	( ob --> cosh(ob) )
**********************************************************************
NULLNAME xCOSHext
::
  SYMBINCOMP addtCOSH CKSYMBN
;

**********************************************************************
* Desc:		Symbolic SINH. Tests for 0, infinity and asinh(x).
* Stack:	( ob --> sinh(ob) )
**********************************************************************
NULLNAME xSINHext
::
  SYMBINCOMP addtSINH CKSYMBN
;

**********************************************************************
* Desc:		Symbolic TANH. Tests for 0 and atanh(x).
* Stack:	( ob --> tanh(ob) )
**********************************************************************
NULLNAME xTANHext
::	
  SYMBINCOMP addtTANH CKSYMBN
;

**********************************************************************
* Desc:		Symbolic ASIN. Tests for 0, infinity and tables.
* Stack:	( ob --> asin(ob) )
**********************************************************************
NULLNAME xASINext
::
  SYMBINCOMP addtASIN CKSYMBN
;

**********************************************************************
* Desc:		Symbolic ACOS. Tests for 0, infinity and tables.
* Stack:	( ob --> acos(ob) )
**********************************************************************
NULLNAME xACOSext
::
  SYMBINCOMP addtACOS CKSYMBN
;

**********************************************************************
* Desc:		Symbolic ATAN. Tests for 0, infinity and tables.
* Stack:	( ob --> atan(ob) )
**********************************************************************
NULLNAME xATANext
::	
  SYMBINCOMP addtATAN CKSYMBN	
;


**********************************************************************
* Desc:		Meta COS.
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtCOS
NULLNAME xSYMCOS
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMCOS
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> case NDROPundef
  M1stZNEGcase addtCOSNEG
  OVER j#0=case NDROPZ1ONE
  AEQ1stcase xACOS pulldrop
  AEQ1stcase xASIN addtSINACOS
  AEQ1stcase xATAN addtCOSATAN
  DEG? case addtCOSDEG
  RAD? NOTcase addtCOSonly
  OVER 'xPI EQUALcase NDROPZ-1ONE
  DUP #3= case addtCOS3
  DUP #5= NOTcase addtCOSonly
  trig5dispatch cos?pi*?/
  addtCOSonly
;

LABEL addtCOSDEG
:: 
  OVER TYPEZINT? NOTcase addtCOSonly
  OVER Z15 ZDIVext			( z #1 quot rem )
  Z0 EQUAL NOTcasedrop addtCOSonly	( z #1 quot )
  sincos/?				( z #1 meta )
  OVER ZERO EQUAL case2drop addtCOSonly
  pshNDROP
;

LABEL addtCOSNEG
:: pulldrop addtCOS ;

LABEL addtCOSonly
:: addt: xCOS ;
	
LABEL addtCOS3
::
  trig3dispatch cospi?/ cos?pi* 
  addtCOSonly
;

LABEL cos?pi*
::				( zint pi * #3 )
  4PICK TYPEZ?	( zint pi * #3 flag )
  NOTcase addtCOSonly
				( zint pi * #3 )
  3DROP				( Z )
  coskpi			( +/-1 )
;

LABEL coskpi
:: Z2 ZMod j#0=case Z1ONE Z-1ONE ;

LABEL cospi?/
::
  3PICK TYPEZ?
  NOTcase addtCOSonly
				( pi int / THREE )
  Z1 5UNROLL			( 1 pi int / THREE )
  'x* 4UNROLL #2+		( 1 pi * int / FIVE )
  3PICK cosintpi*int/
;
	
LABEL cos?pi*?/
::
  6PICK TYPEZ?	( meta flag )
  NOTcase addtCOSonly
  3PICK OBJINT?		( meta d flag )
  NOTcasedrop addtCOSonly
  cosintpi*int/
;

LABEL cosintpi*int/
::				( int pi * int / FIVE )
  DISPATCH2346 cos/2 cos/3 cos/4 cos/6
				( meta d )
  DROP addtCOSonly
;
	
LABEL cos/2
::			( ? pi * 2 / FIVE )
  addtTRIGCOM		( Z )
  Z6 cos/?
;

LABEL cos/3
::
  addtTRIGCOM			( Z )
  Z4 cos/?
;

LABEL cos/4
::
  addtTRIGCOM			( Z )
  Z3 cos/?
;

LABEL cos/6
::
  addtTRIGCOM
  Z2 cos/?
;

LABEL cos/?
::				( Z Z )
  QMul				( Z )
  sincos/?
;

**********************************************************************
* Desc:		Meta SIN.
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtSIN
NULLNAME xSYMSIN
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMSIN
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> case NDROPundef
  M1stZNEGcase addtSINNEG
  OVER j#0=case NOP
  AEQ1stcase xASIN pulldrop
  AEQ1stcase xACOS addtSINACOS
  AEQ1stcase xATAN addtSINATAN
  DEG? case addtSINDEG
  RAD? NOTcase addtSINonly
  OVER 'xPI EQUALcase NDROPZ0ONE
  DUP #3= case addtSIN3
  DUP #5= NOTcase addtSINonly
  trig5dispatch sin?pi*?/
  addtSINonly
;

LABEL addtSINDEG
:: 
  OVER TYPEZINT? NOTcase addtSINonly
  OVER Z15 ZDIVext			( z #1 quot rem )
  Z0 EQUAL NOTcasedrop addtSINonly	( z #1 quot )
  Z6 QSub sincos/?			( z #1 meta )
  OVER ZERO EQUAL case2drop addtSINonly
  pshNDROP
;


LABEL addtSINNEG
:: pulldrop addtSIN addtNEG ;

LABEL addtSINonly
:: addt: xSIN ;
	
LABEL addtSIN3
::
  trig3dispatch sinpi?/ sin?pi* 
  addtSINonly
;

LABEL sin?pi*
::
  4PICK TYPEZ?
  NOTcase addtSINonly
  4DROP Z0ONE
;

LABEL sinpi?/
::
  3PICK TYPEZ?
  NOTcase addtSINonly
				( pi int / THREE )
  Z1 5UNROLL			( 1 pi int / THREE )
  'x* 4UNROLL #2+		( 1 pi * int / FIVE )
  3PICK sinintpi*int/
;
	
LABEL sin?pi*?/
::
  6PICK TYPEZ?	( meta flag )
  NOTcase addtSINonly
  3PICK OBJINT?		( meta d flag )
  NOTcasedrop addtSINonly
  sinintpi*int/
;

LABEL sinintpi*int/
::				( int pi * int / FIVE )
  DISPATCH2346 sin/2 sin/3 sin/4 sin/6
				( meta d )
  DROP addtSINonly
;
	
LABEL sin/2
::			( ? pi * 2 / FIVE )
  addtTRIGCOM		( Z )
  Z6 sin/?
;

LABEL sin/3
::
  addtTRIGCOM			( Z )
  Z4 sin/?
;

LABEL sin/4
::
  addtTRIGCOM			( Z )
  Z3 sin/?
;

LABEL sin/6
::
  addtTRIGCOM
  Z2 sin/?
;

LABEL sin/?
::				( Z Z )
  QMul Z6 QSub			( Z )
  sincos/?
;

LABEL DISPATCH2346
::
  Z2 EQUALcasedro COLA
  Z3 EQUALcasedro skipcola
  Z4 EQUALcasedro 2skipcola
  Z6 EQUALcasedro 3skipcola
  'R'R 'R'R 4DROP
;

LABEL sincos/?
::
  Z24 ZMod			( Z )
  DupZIsNeg? ITE Z24 Z0 QAdd
  Z>#
  TABLECOSext SWAP#1+ 
  NTHCOMPDROP cassyminner6
;
	
LABEL addtTRIGCOM
::
  5DROP OBJINT? NOTcase INTERNALERR
; 
	

**********************************************************************
* Desc:		Meta TAN.
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtTAN
NULLNAME xSYMTAN
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMTAN
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> case NDROPundef
  OVER j#0=case NOP
  M1stZNEGcase addtTANNEG
  AEQ1stcase xATAN pulldrop
  AEQ1stcase xASIN addtTANASIN
  AEQ1stcase xACOS addtTANACOS
  DEG? case addtTANDEG
  RAD? NOTcase addtTANonly
  				( meta )
  OVER 'xPI EQUALcase NDROPZ0ONE
  DUP #3= case addtTAN3
  DUP #5= NOTcase addtTANonly
  trig5dispatch tan?pi*?/
  addtTANonly
;

LABEL addtTANDEG
::
  OVER TYPEZINT? NOTcase addtTANonly
  OVER Z15 ZDIVext			( z #1 quot rem )
  Z0 EQUAL NOTcasedrop addtTANonly	( z #1 quot )
  Z1 tan/?				( z # quot )
  OVER ZERO EQUAL case2drop addtTANonly
  pshNDROP
;

LABEL addtTANNEG
:: pulldrop addtTAN addtNEG ;

LABEL addtTANonly
:: addt: xTAN ;
	
LABEL addtTAN3
::
  trig3dispatch tanpi?/ tan?pi* 
  addtTANonly
;

LABEL tan?pi*
::
  4PICK TYPEZ?
  NOTcase addtTANonly
  4DROP Z0ONE
;

LABEL tanpi?/
::
  3PICK TYPEZ?
  NOTcase addtTANonly
				( pi int / THREE )
  Z1 5UNROLL			( 1 pi int / THREE )
  'x* 4UNROLL #2+		( 1 pi * int / FIVE )
  3PICK tanintpi*int/
;
	
LABEL tan?pi*?/
::
  6PICK TYPEZ?	( meta flag )
  NOTcase addtTANonly
  3PICK OBJINT?		( meta d flag )
  NOTcasedrop addtTANonly
  tanintpi*int/
;

LABEL tanintpi*int/
::				( int pi * int / FIVE )
  DISPATCH2346 tan/2 tan/3 tan/4 tan/6
				( meta d )
  DROP addtTANonly
;
	
LABEL tan/2
::			( ? pi * 2 / FIVE )
  addtTRIGCOM		( Z )
  Z6 tan/?
;

LABEL tan/3
::
  addtTRIGCOM			( Z )
  Z4 tan/?
;

LABEL tan/4
::
  addtTRIGCOM			( Z )
  Z3 tan/?
;

LABEL tan/6
::
  addtTRIGCOM
  Z2 tan/?
;

LABEL tan/?
::				( Z Z )
  QMul Z12 ZMod			( Z )
  DupZIsNeg? ITE Z12 Z0 QAdd	( Z )
  Z>#				( # )
  TABLETANext SWAP#1+ 
  NTHCOMPDROP EVAL cassyminner6
;


LABEL addtTANASIN
:: dup pulldrop psh addtSINACOS MetaDiv ; 

LABEL addtTANACOS
:: dup addtSINACOS psh pulldrop MetaDiv ; 

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME addtSINACOS
::
  pulldrop
  Z1 psh1top&
  addt: xSQ
  addt-
  addtSQRT
;

LABEL addtSINATAN
::
  pulldrop		( meta )
  dup 			( meta meta )
  addtSCATAN
;

LABEL addtCOSATAN
::
  pulldrop
  Z1 psh1
  addtSCATAN
;

LABEL addtSCATAN
( meta1 meta2 -> meta1/sqrt[1+meta2^2] )
::
  Z1 psh1top& addt: xSQ addt+ addtSQRT top&addt/
;

**********************************************************************
* Desc:		Meta ASIN
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtASIN
NULLNAME xSYMASIN
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMASIN
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> case NDROPundef
  OVER num#0=case DROP
  RAD? DEG? OR NOTcasedrop addtASINonly
  j#1=case droppi/2
  OVER j#-1=case drop-pi/2
  M1stZNEGcase addtASINNEG
  asindispatch asin1/2 asin-1/2 asinsqrt2/2 asinsqrt3/2
  nocareflag TestSysFlag NOTcase addtASINonly
  AEQ1stcase xSIN pulldrop
  AEQ1stcase xCOS addtASINCOS
  addtASINonly
;

LABEL addtASINCOS
::
  pulldrop ckpi/2 psh MetaSub
;

LABEL addtASINonly
:: addt: xASIN ;

LABEL addtASINNEG
:: pulldrop addtASIN addtNEG ;

LABEL asin1/2
:: NDROP ckpi/6 ;

LABEL asin-1/2
:: asin1/2 metaneg ;

LABEL asinsqrt2/2
:: NDROP ckpi/4 ;

LABEL asinsqrt3/2
:: NDROP ckpi/3 ;


**********************************************************************
* Desc:		Meta ACOS
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtACOS
NULLNAME xSYMACOS
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMACOS
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> case NDROPundef
  OVER j#1=case NDROPZ0ONE
  RAD? DEG? OR NOTcase addtACOSonly
  OVER j#0=case droppi/2
  OVER j#-1=case droppi
  M1stZNEGcase addtACOSNEG
  asindispatch asinsqrt3/2 acos-1/2 asinsqrt2/2 asin1/2
  nocareflag TestSysFlag NOTcase addtACOSonly
  AEQ1stcase xCOS pulldrop
  AEQ1stcase xSIN addtASINCOS
  addtACOSonly
;

LABEL addtACOSonly
::  addt: xACOS ;

LABEL addtACOSNEG
:: pulldrop ckpi psh addtACOS metasub ;

LABEL acos-1/2
:: 
  NDROP ck2pi/3
;


**********************************************************************
* Desc:		Meta ATAN
* Stack:	( Meta --> Meta' )
* Improvements:	should test for atan(a/b)=sign(a/b)*pi/2-atan(b/a)
**********************************************************************
NULLNAME addtATAN
NULLNAME xSYMATAN
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMATAN
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> case addtATANINF
  OVER num#0=case DROP
  RAD? DEG? OR NOTcasedrop addtATANonly
  j#1=case droppi/4
  OVER j#-1=case drop-pi/4
  M1stZNEGcase addtATANNEG
  atandispatch asinsqrt3/2 asin1/2 
  addtATANonly
;

LABEL addtATANonly
:: addt: xATAN ;

LABEL addtATANNEG
:: pulldrop addtATAN addtNEG ;

LABEL addtATANINF
::				( meta )
  metainftype			( # )
  DUP#0=csedrp metaundef	( -> meta- undef )
  #1=case ckpi/2		( -> metapi/2 )
  ckpi/2 metaneg		( -> meta-pi/2 )
;

**********************************************************************
* Desc:		Meta SINH
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtSINH
NULLNAME xSYMSINH
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMSINH
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> ?SEMI
  OVER j#0=case NOP
  M1stZNEGcase :: pulldrop addtSINH addtNEG ;
  AEQ1stcase xASINH pulldrop
  addt: xSINH
;

**********************************************************************
* Desc:		Meta COSH
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtCOSH
NULLNAME xSYMCOSH
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMCOSH
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> case NDROPplusinf
  OVER j#0=case NDROPZ1ONE
  M1stZNEGcase :: pulldrop addtCOSH ;
  AEQ1stcase xACOSH pulldrop
  addt: xCOSH
;

**********************************************************************
* Desc:		Meta TANH
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtTANH
NULLNAME xSYMTANH
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMTANH
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0=case addtTANH0
  OVER j#0=case NOP
  metainftype DUP#0=csedrp metaundef
  #1= ITE Z1 Z-1 ONE
;

LABEL addtTANH0
::
  M1stZNEGcase :: pulldrop addtTANH addtNEG ;
  AEQ1stcase xATANH pulldrop
  addt: xTANH
;

**********************************************************************
* Desc:		Symbolic ATANH
* Stack:	( symb --> symb )
**********************************************************************
NULLNAME xATANHext
::
  SYMBINCOMP addtATANH CKSYMBN
;

**********************************************************************
* Desc:		Meta ATANH
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtATANH
NULLNAME xSYMATANH
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMATANH
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> case NDROPundef
  OVER j#0=case NOP
  AEQ1stcase xTANH pulldrop
  addt: xATANH
;

**********************************************************************
* Desc:		Symbolic ASINH
* Stack:	( symb --> symb )
**********************************************************************
NULLNAME xASINHext
::
  SYMBINCOMP addtASINH CKSYMBN
;

**********************************************************************
* Desc:		Meta ASINH
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtASINH
NULLNAME xSYMASINH
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMASINH
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> ?SEMI
  AEQ1stcase xNEG addtASINHNEG
  OVER j#0=case NOP
  AEQ1stcase xSINH pulldrop
  addt: xASINH
;

LABEL addtASINHNEG
:: pulldrop addtASINH addtNEG ;

**********************************************************************
* Desc:		Symbolic ACOSH
* Stack:	( symb --> symb )
**********************************************************************
NULLNAME xACOSHext
::
  SYMBINCOMP addtACOSH CKSYMBN
;

**********************************************************************
* Desc:		Meta ACOSH
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtACOSH
NULLNAME xSYMACOSH
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMACOSH
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0=case addtACOSH1
  metainftype			( # )
  DUP#0=csedrp unsignedinf
  #1=case plusinf metaundef
;

LABEL addtACOSH1
::
  OVER j#1=case NDROPZ0ONE
  AEQ1stcase xCOSH addtABSNEG
  addt: xACOSH
;


**********************************************************************
* Desc:		Meta SQRT
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtSQRT
NULLNAME xSYMSQRT
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMSQRT
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0=case addtSQRT0
  metainftype DUP#0=csedrp unsignedinf
  #1=case plusinf plusinf addt2: xi x*  
;

LABEL addtSQRT0
::					( meta )
  sturmflag TestSysFlag case addtSQRTonly
  EXACT? NOTcase addtSQRTonly
  AEQ1stcase xEXP addtSQRTEXP
					( meta )
  DUP#1= case addtSQRTSIMP

  ( * if topmost operator is not rational we can't expect simplification * )
  LISTOPext 3PICK			( meta list oper )
  Contains? UNROT2DROP			( meta flag )
  NOTcase addtSQRTonly
  ( * topmost op was rational, let's try to simplify * )
  addtSQRTSIMP
;

LABEL addtSQRTSIMP
::
  dup LISTOPRAC LVARDext		( meta lvar )
  DUP 2LAMBIND VXXL2NR			( Q )
  FXNDext DUPUNROT QMul			( d n*d )
  PPZ DUP ZSIGNE Z-1 EQUAL 		( d n*d z ? )
  IT :: SWAPRNEG SWAPRNEG ;
					( d n*d/z z )
  XSQRext SQRTCONTENU 2SWAP		( sqrt[z].z sqrt[z] d n*d/z )
  SINGLE&DOUBLE				( sqrt[z].z sqrt[z] d rac_s rac_d )
  5ROLL QMul ROT QDiv ZERO 1PUTLAM VAL1M 	( sqrt[z] rac_s meta_d )
  COMPLEX? ITE 
    :: dup addtRE metaEQUAL? case :: NDROP addtABS ; addtSIGN MetaMul ; 
    addtABS
  get1 VAL1M addtSQRTonly MetaMul	( sqrt[z] meta_d*meta_sqrt[s] )
  get1 VAL1M MetaMul			( meta_d*meta_sqrt[s]*sqrt[z] )
  ABND					( meta )
;

LABEL SQRTCONTENU
* sqrt -> sqrt.contenu sqrt/sqrt.contenu
:: 
  DUPTYPEIRRQ? NOTcase Z1
					( sqrt )
  DUP QXNDext DROP GCDext		( sqrt d )
  DUPUNROT QDiv				( d sqrt/d )
;

LABEL addtSQRTonly
:: OVER Z1 EQUAL ?SEMI addt: x\v/ ; 


LABEL addtSQRTEXP
:: meta/2 4ROLLSWAP ;


**********************************************************************
* Desc:		Symbolic square
* Stack:	( ob --> sq(ob) )
**********************************************************************
NULLNAME xSQext
::
  SYMBINCOMP addtSQ SYMBN
;

**********************************************************************
* Desc:		Meta SQ
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtSQ
NULLNAME xSYMSQ
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMSQ
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> case addtSQinf
					( meta )
  OVER TYPEZ? casedrop zsq
  OVER EQ: xNEG IT pulldrop
  AEQ1stcase x\v/ pulldrop
  addt: xSQ
;

LABEL addtSQinf
::
  COMPLEX? NOTcase NDROPplusinf
  ( * in complex mode unsigned_inf^2 remains unsigned_inf * )
  DUP#1= ?SEMI
  NDROPplusinf
;

LABEL zsq
* z -> z*z one
:: DUP QMul ONE ;

**********************************************************************
* Desc:		Meta INV
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtINV
NULLNAME xSYMINV
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMINV
ASSEMBLE
	ENDIF	f39
RPL
  M1st/case addtINV/
  Z1ONE psh MetaDiv
;

LABEL addtINV/
::
  plDRPpZparg metadiv
;

**********************************************************************
* Desc:		Meta EXP
* Stack:	( Meta --> Meta' )
* Note:		does not apply EXP[-..]=1/EXP[..]
**********************************************************************
NULLNAME addtEXP
::
  1metaundef?
  #0=case addtEXPNO-CK
  addtEXPinf
;

LABEL addtEXPinf
::
  metainftype DUP#0=csedrp metaundef
  #1=case plusinf Z0ONE
;

**********************************************************************
* Desc:		Meta EXP
* Stack:	( Meta --> Meta' )
* Note:		applies EXP[-..]=1/EXP[..]
**********************************************************************
NULLNAME xSYMEXP
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMEXP
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef?
  #0=case addtEXP0
  addtEXPinf
;

LABEL addtEXP0
::
  M1stNEGcase addtEXP0NEG
				( meta )
  addtEXPNO-CK
;

* added for SIGMAEXP2ext, since we do not want to linearize EXP(-X) to 1/EXP(X)
LABEL addtEXPNO-CK
::
  ZNEGcase addtEXP0NEG
  OVER j#0=case NDROPZ1ONE
  RAD? NOTcase addtEXP2
  metapi? #0=case addtEXP2
  DUP #3= case addtEXP3
  DUP #5= case addtEXP5
  M1st/case addtEXP7
  addtEXP1
;

LABEL addtEXP0NEG
::
  pulldrop addtEXP0 addtINV
;

LABEL addtEXP2
::
  TESTi COMPLEX? case addtEXP1
  OVER EQ: x/ NOTcase addtEXP1
  3PICK Z2 EQUALNOTcase addtEXP1
  UNROT2DROP #2-

  ( meta sans le divise par 2 )
  METAEXPEXPA
  addtSQRT
;
	
LABEL addtEXP1
::
  AEQ1stcase xLN pulldrop
  addtEXPonly
;

LABEL addtEXPonly
:: addt: xEXP ;
	
LABEL addtEXP3 ( for meta of length 3, test if it is i*pi )
::
  metaipi metaEQUAL? case 2NDROPZ-1ONE
  NDROP addtEXP2
;

LABEL addtEXP5 ( for meta of lenght 5, match for ? i * pi * )
::					( meta )
  exp5dispatch expipi*?/ exp?i*pi*
  addtEXP1
;

LABEL expipi*?/
::					( i pi * ? / #5 )
  3PICK TYPEZ?		( meta flag )
  NOTcase addtEXP1
  2DROP					( i pi * f )
  Z1 5UNROLL				( a=1 i pi * f )
  OVER 4UNROLL				( a i * pi * f )
  addtEXPINT
;

LABEL exp?i*pi*
::					( a i * pi * #5 )
  6PICK TYPEZ?		( meta flag )
  NOTcase addtEXP1
  DROP addtEXPPICOM			( a )
  coskpi
;

LABEL addtEXP7 ( for meta of length 7, match for ? i * pi * ? / )
::				( a b c d e f x/ #7 )
  DUP SEVEN #= NOTcase addtEXP2	
  3PICK	OBJINT?			( a b c d e f x/ #7 f flag )
  NOTcasedrop addtEXP2
  DROPSWAPDROP			( a b c d e f #7 )
  exp7dispatch addtEXP7INT?
  addtEXP7NOT
;

LABEL addtEXP7NOT
::				( a b c d e f #7 )
  #1- addt/ addtEXP2  
;

LABEL addtEXP7INT?
::				( a i * pi * f #7 )
  7PICK TYPEZ?	( a i * pi * f #7 flag )
  NOTcase addtEXP7NOT
  DROP				( a i * pi * f )
  addtEXPINT
;

LABEL addtEXPINT
::				( a i * pi * f )
  DISPATCH2346 addtEXPPI2 addtEXPPI3 addtEXPPI4 addtEXPPI6
  SEVEN addtEXP7NOT
;

LABEL addtEXPPI2
::				( a i * pi * )
  addtEXPPICOM			( a )
  Z4 ZMod Z>#
  LIST1i-1-i
  SWAP#1+ NTHCOMPDROP
  cassyminner6
;

LABEL addtEXPPI3
::
  addtEXPPICOM
  Z6 ZMod Z># THREE #/
  EXPPI3LIST
  ROT#1+ NTHCOMPDROP cassyminner6 get1 #0=?SEMI
  addtNEG
;

LABEL addtEXPPI4
::
  addtEXPPICOM
  Z8 ZMod Z># TWO #/
  EXPPI4LIST
  EXPPI4&6END
;

LABEL addtEXPPI6
::
  addtEXPPICOM
  Z12 ZMod Z># THREE #/
  EXPPI6LIST
  EXPPI4&6END	
;

LABEL EXPPI4&6END
::
  ROT#1+ NTHCOMPDROP
  LIST1i-1-i
  ROT#1+ NTHCOMPDROP cassyminner6 
  get1 cassyminner6 metamult
;


LABEL addtEXPPICOM
::
  4DROP OBJINT? NOTcase INTERNALERR
; 
	
LABEL exp7dispatch
::
  CODE
	LC(5)	=TRIGTABLE
	GOSBVL	=match&dptch2
	CON(1)	0			matches any
	CON(1)	3			matches *
	CON(1)	6			matches PI
	CON(1)	3			matches *
	CON(1)	7			matches i
	CON(5)	=COLA
	CON(1)	#F			end marker
  ENDCODE
  'R DROP
;

LABEL exp5dispatch
::
  CODE
	LC(5)	=TRIGTABLE
	GOSBVL	=match&dptch2
	CON(1)	4			matches /
	CON(1)	0			matches any
	CON(1)	3			matches *
	CON(1)	6			matches PI
	CON(1)	7			matches i
	CON(5)	=COLA
	CON(1)	3			matches *
	CON(1)	6			matches PI
	CON(1)	3			matches *
	CON(1)	7			matches i
	CON(1)	0			matches any
	CON(5)	=skipcola
	CON(1)	#F			end marker
  ENDCODE
  'R'R 2DROP
;

LABEL trig5dispatch
::
  CODE
	LC(5)	=TRIGTABLE
	GOSBVL	=match&dptch2
	CON(1)	4			matches /
	CON(1)	0			matches any
	CON(1)	3			matches *
	CON(1)	6			matches PI
	CON(1)	0			matches any
	CON(5)	=COLA
	CON(1)	#F			end marker
  ENDCODE
  'R DROP
;

LABEL trig3dispatch
::
  CODE
	LC(5)	=TRIGTABLE
	GOSBVL	=match&dptch2
	CON(1)	4			matches /
	CON(1)	0			matches any
	CON(1)	6			matches PI
	CON(2)	0			matches any
	CON(5)	=COLA
	CON(1)	3			matches *
	CON(1)	6			matches PI
	CON(3)	0			matches any
	CON(5)	=skipcola
	CON(1)	#F			end marker
  ENDCODE
  'R'R 2DROP
;

LABEL asindispatch
::
  CODE
	LC(5)	=TRIGTABLE
	GOSBVL	=match&dptch2
	CON(1)	4			matches /
	CON(1)	9			matches Z2
	CON(1)	8			matches Z1
	CON(2)	0			any
	CON(5)	=COLA
	CON(1)	4			matches /
	CON(1)	9			matches Z2
	CON(1)	2			matches Z-1
	CON(2)	0			any
	CON(5)	=skipcola
	CON(1)	4			matches /
	CON(1)	9			matches Z2
	CON(1)	5			matches x\v/
	CON(1)	9			matches Z2
	CON(1)	0			any
	CON(5)	=2skipcola
	CON(1)	4			matches /
	CON(1)	9			matches Z2
	CON(1)	5			matches x\v/
	CON(1)	#A			matches Z3
	CON(1)	0			any
	CON(5)	=3skipcola
	CON(1)	#F			end marker
  ENDCODE
  'R'R'R'R 4DROP
;

LABEL atandispatch
::
  CODE
	LC(5)	=TRIGTABLE
	GOSBVL	=match&dptch2
	CON(1)	5			matches x\v/
	CON(1)	#A			matches Z3
	CON(3)	0			any
	CON(5)	=COLA
	CON(1)	4			matches /
	CON(1)	#A			matches Z3
	CON(1)	5			matches x\v/
	CON(1)	#A			matches Z3
	CON(1)	0			any
	CON(5)	=skipcola
	CON(1)	#F			end marker
  ENDCODE
  'R'R 2DROP
;


LABEL 'R'R'R'R
:: RSWAP 'R 'R 'R 'R RSWAP ;

LABEL TRIGTABLE
( I think that Z12 at #E is valid, see match&dptach code in CSR/symutil.s )
x+
Z-1
x*
x/
x\v/
xPI
xi
Z1
Z2
Z3
Z4
Z5
Z6
Z12		


**********************************************************************
* Desc:		Meta D->R
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtD->R
NULLNAME xSYMD>R
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMD>R
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> ?SEMI
  FLOATEVAL xD\->R
;

**********************************************************************
* Desc:		Meta R->D
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtR->D
NULLNAME xSYMR>D
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMR>D
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> ?SEMI
  FLOATEVAL xR\->D
;

**********************************************************************
* Desc:		Meta FLOOR
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtFLOOR
NULLNAME xSYMFLOOR
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMFLOOR
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> ?SEMI
				( meta )
  OVER TYPEZINT? ?SEMI
  metafraction? case2drop fracfloor
  dup FLOATEVAL xFLOOR		( meta meta-floor )
  ( * now convert % #1 to zint #1 or return FLOOR of orig expr. * )
  OVER TYPEREAL?		( meta meta-floor ? )
  case CEILFLOOREND
  NDROP addt: xFLOOR
;

LABEL CEILFLOOREND
::
  pshNDROP			( % #1 )
  EXACT? NOT?SEMI
  SWAP R>Z SWAP			( z #1 )
;

LABEL fracfloor
::				( z1 z2 )
  IDIV2Z DROPONE
;

**********************************************************************
* Desc:		Meta CEIL
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtCEIL
NULLNAME xSYMCEIL
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMCEIL
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> ?SEMI
  OVER TYPEZINT? ?SEMI
  metafraction? case2drop ceilfloor
  dup FLOATEVAL xCEIL			( meta meta-ceil )
  OVER TYPEREAL?
  case CEILFLOOREND
  NDROP addt: xCEIL
;

LABEL ceilfloor
::				( znum zdeno )
  SIMPext Z1 EQUALcasedro ONE	( -> znum one )
  IDIV2Z DROP Z1 QAdd ONE
;

**********************************************************************
* Desc:		Meta IP
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtIP
NULLNAME xSYMIP
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMIP
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> ?SEMI
  FLOATEVAL xIP
;

**********************************************************************
* Desc:		Meta FP
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtFP
NULLNAME xSYMFP
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMFP
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> case NDROPundef
  FLOATEVAL xFP
;

**********************************************************************
* Desc:		Meta XPON
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtXPON
NULLNAME xSYMXPON
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMXPON
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> case NDROPplusinf
  FLOATEVAL xXPON
;

**********************************************************************
* Desc:		Meta MANT
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtMANT
NULLNAME xSYMMANT
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMMANT
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0<> case NDROPundef
  FLOATEVAL xMANT
;

LABEL FLOATEVAL
* added code to evaluate ONLY in approx mode
* this prevent CASNUMEVAL to evaluate e.g. FP(X)
::			( meta )
  EXACT? NOTcase addt:	( -> meta )
			( meta )
  approxmetasimp	( meta )
  'R			( meta op )
  CK&DISPATCH1
  #100 EVALONE
  #200 EVALONE
  any SWAP#1+
;

LABEL EVALONE
::			( real ONE op )
  SWAPDROP EvalNoCK ONE 
;


**********************************************************************
* Desc:		Meta LNP1
* Stack:	( meta -> meta )
**********************************************************************
NULLNAME addtLNP1
NULLNAME xSYMLNP1
:: 
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMLNP1
ASSEMBLE
	ENDIF	f39
RPL
  Z1ONE MetaAdd addtLN 
;

**********************************************************************
* Desc:		Meta LOG
* Stack:	( meta -> meta )
**********************************************************************
NULLNAME addtLOG
NULLNAME xSYMLOG
:: 
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMLOG
ASSEMBLE
	ENDIF	f39
RPL
  OVER TYPEZ? NOTcase addtLOGNZ
  DROP 					( z )
  Z0 EQUALcasedro minusinf
  Z1 EQUALcasedro Z0ONE
  ( * find number of trailing 0 in z * )
  CODE
		GOSBVL	=SAVPTR
		B=0	A	number of 0
		C=DAT1	A
		CD1EX		D1->Z
		D1=D1+	10	D1->Zbody
-		C=DAT1	S	test bit
		?C#0	S
		GOYES	+
		D1=D1+	1
		B=B+1	A
		GONC	-
+		A=B	A
		GOVLNG	=PUSH#ALOOP
  ENDCODE
					( z # )
  DUP #>Z UNROT				( z_log z # )
  ONE UNROT				( meta_log z # )
  ALOGbint QDiv 			( meta_log z' )
  num#1=case DROP			( -> meta_log )
  ONE addtLOGNZ				( meta_log meta_add )
  metaadd				( meta )
;

LABEL addtLOGNZ
::
  1metaundef?
  #0=case addtLOGtest
  addtLNinf
;

LABEL addtLOGtest
::
  COMPLEX? case addtLOGonly
  AEQ1stcase xALOG pulldrop
  addtLOGonly
;

LABEL addtLOGonly
::
  addt: xLOG
;

LABEL addtLN/LN10
::
  addtLN metaln10 MetaDiv 
;

**********************************************************************
* Desc:		Meta ALOG
* Stack:	( meta -> meta )
**********************************************************************
NULLNAME addtALOG
NULLNAME xSYMALOG
:: 
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMALOG
ASSEMBLE
	ENDIF	f39
RPL
  OVER TYPEZ? casedrop ALOGZ
  1metaundef?
  #0=case addtALOGonly
  addtEXPinf
;

LABEL addtALOGonly
::
  AEQ1stcase xLOG pulldrop
  addt: xALOG
;

LABEL ALOGZ
::				( z )
  DUP ZABS Z># SWAP ZIsNeg? 	( # sign )
  NOTcase :: ALOGbint ONE ;
  ALOGbint xINVext ONE
;

LABEL ALOGbint
CODE
		GOSBVL	=SAVPTR
		GOSBVL	=POP#		A=# of zeros to create
		C=A	A
		C=C+1	A		C=#_of_zeros+1(for first 1)+1(sign)
		C=C+1	A
		GOSBVL	=MAKEZ		D0 -> Zbody, D1->Ztail
		A=0	S		write sign
		D1=D1-	1
		DAT1=A	S
		A=A+1	S		write last nibble
		D1=D1-	1
		DAT1=A	S
		A=A-1	S		set A again to 0
		C=C-1	A
-		C=C-1	A
		?C=0	A
		GOYES	+
		D1=D1-	1
		DAT1=A	S		write + sign
		GOTO	-
+		D0=D0-	10		skip back prolog and length
		AD0EX
		GOVLNG	=GPOverWrALp
ENDCODE

LABEL addt*LN10EXP
::
  metaln10 MetaMul addtEXP
;

**********************************************************************
* Desc:		Meta EXPM
* Stack:	( meta -> meta )
**********************************************************************
NULLNAME addtEXPM
NULLNAME xSYMEXPM1
:: 
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMEXPM1
ASSEMBLE
	ENDIF	f39
RPL
  addtEXP Z1ONE MetaSub 
;


**********************************************************************
* Desc:		Erable FACTORIAL
* Stack:
**********************************************************************
NULLNAME factorial
::
  CK&DISPATCH1
  zint  factzint
  real	factr
  symb	facts
  any	x!
;

LABEL factr
::
  DUP %0> NOTcase %FACT
  DUP %FP %0= NOTcase %FACT
  COERCE factbint
;


**********************************************************************
* Desc:		Symbolic factorial
* Stack:
**********************************************************************
NULLNAME facts
::
  INNERCOMP
  addtFACT
  SYMBN
;

**********************************************************************
* Desc:		Meta FACT
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtFACT
NULLNAME xSYMFACT
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMFACT
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef? #0=case addtFACT1
  metainftype #1= NOTcase metaundef
  plusinf
;

LABEL addtFACT1
::
  OVER TYPEZ? 
  NOTcase factmeta
  DROP DupZIsNeg?		( z flag )
  casedrop unsignedinf		( -> inf #1 )
				
  factzint ONE			( -> z! #1 )
;


NULLNAME factzint
::
  Z># factbint
;

LABEL factbint
::
  DUP#0=csedrp Z1
  DUP#1= casedrop Z1
* change 3 June 99, replaced 
*  ONE
*  ( #m, #n )
*  FORI_I*
* by Mika's faster code
  #FACT
;

LABEL FORI_I*
( #m, #n -> product of integers from #n+1 to #m )
* note that we must convert #m and #n in BCD
* hence #m and #n must fit in # after BCD for FORI_I* to be correct
CODE
		GOSBVL	=SAVPTR
		GOSBVL	=POP2#		A= #end, C=#begin
		D=C	A		save #begin
		GOSBVL	=#2bcd#		convert #end to BCD
		R1=A.F	A
		C=D	A
		A=C	A
		GOSBVL	=#2bcd#		convert #begin to BCD
		R0=A.F	A
		ST=0	sGARB		Flag garbage collection not done
		ST=0	sTRIM
		ST=0	sQSWAP*
		ST=0	sQMULREG
doslow!		GOSBVL	=ROOM		C[A] = free mem
		LA(5)	400		Minimum total required
		?C>A	A
		GOYES	doslowmem!

slow!retry	GOSBVL	=DOGARBAGE
*		ST=1	sGARB		DOGARBAGE sets this
		GOTO	doslow!

doslowmem!	ASRB.F	A		200
		C=C-A	A		room-200
		GOSBVL	=GETTEMP	D0=->slot	D1=->slotend
		AD1EX
		R4=A.F	A		R4[A]=->stack
		A=D0
		R3=A.F	A		R3 must be initialized for Push[A]
		A=R1.F	A
		GOSBVL	=Push[A]	push end index
		A=R0.F	A
		GOSBVL	=Push[A]	push begin index
		A=D0
		GOSBVL	=Push[A]	save begin address on stack
		LCZ1
		DAT0=C	W		write Z1 begin of slot
		D0=D0+	12		skip Z1
* D0 -> end of first Z,
loop!		GOSBVL	=AttnAbort?GP
		GOSBVL	=Pop[A]		pop begin of slot
		D1=A			D1 -> first Z
		GOSBVL	=Pop[A]		pop current index
		B=A	A
		GOSBVL	=Pop[A]		pop end index
		?B<A	A
		GOYES	loopexec!

end!		A=D1	A
		R0=A	A		R0[A] = ->Q
		C=D0	A		C[A] = ->Qtail
		GOSBVL	=ShrinkQ
		D1=D1+	5
		D=D+1	A
		GOVLNG	=OverWrALoop
		
loopexec!	GOSBVL	=Push[A]	push back end index
		A=B	A
		SETDEC
		A=A+1	A
		SETHEX
		GOSBVL	=Push[A]	push back new current index
		LC(5)	=DOINT		write index as integer
		DAT0=C	A
		D0=D0+	5
		LC(5)	10
		DAT0=C	A
		D0=D0+	5
		DAT0=A	A
		D0=D0+	5
		A=D1			-> Z2
		GOSBVL	=Push[A]	push back begin of slot
		A=D0			
		R3=A.F	A		->output
		D0=D0-	15		-> Z1

		GOSBVL	=MULZZ		R3[A]=->result end, D0=result begin
		GOSBVL	=Pop[A]
		D1=A			begin of slot
		GOSBVL	=Push[A]
		A=D0
		C=R3.F	A
		C=C-A	A		length
		GOSBVL	=MOVEDOWN	copy D0 -> D1
		AD1EX
		AD0EX
		GOTO	loop!		D0 -> new result end
ENDCODE


LABEL factmeta
::
  M1st+case facts+
  M1st-case facts-
  addtFACTonly
;

LABEL addtFACTonly
::
  addt: x!
;

LABEL facts+
::
  plDRPpZparg
  METAPOSINT? casedrop facts++
  psh METAPOSINT? casedrop facts++
  top& addt+ addtFACTonly
;

LABEL facts-
::
  plDRPpZparg psh
  METAPOSINT? casedrop facts--
  top& addt- addtFACTonly
;

LABEL facts++
::
  Z># 1LAMBIND		( meta-s )
  dup addtFACTonly
  1GETABND
  #1+_ONE_DO (DO)		( meta, res )
      psh dup unrot		( meta, res, meta )
      INDEX@ #>Z
      SWAP#1+ addt+ top&addt*	( meta, res )
  LOOP
  psh NDROP
;

LABEL facts--
::
  Z># 1LAMBIND		( meta-s )
  dup addtFACTonly
  1GETABND
  ZERO_DO (DO)			( meta, res )
     psh dup unrot		( meta, res, meta )
     INDEX@ #>Z
     SWAP#1+ addt- top& addt/	( meta, res )
  LOOP
  psh NDROP
;
**********************************************************************

**********************************************************************
* Desc:		Meta NOT
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME addtNOT
NULLNAME xSYMNOT
::
ASSEMBLE
	IF	f39
RPL
  NOT40case 48xSYMNOT
ASSEMBLE
	ENDIF	f39
RPL
  1metaundef# #0<> ?SEMI
  oneflag 			( meta FALSE | flag TRUE )
  NOTcase addtNOTonly
  NOTcase Z1ONE Z0ONE
;

LABEL addtNOTonly
::
  addt: xNOT
;

**********************************************************************
* Desc:		coerce meta to flag
* Stack:	( Meta --> flag TRUE )
*		( Meta --> meta FALSE )
**********************************************************************
LABEL oneflag
::
  1metainf# #0= case oneflag1
  NDROP TrueTrue			( -> true true )
;

LABEL oneflag1
::					( meta )
  OVER REAL? SWAPDROP 			( meta flag )
  NOTcase FALSE				( -> meta false )
					( real #1 )
  DROP					( real )
  j#0=case FalseTrue TrueTrue
;


