INCLUDE cas2romid.h
INCLUDE erextdec.h
INCLUDE cas2ext.h
INCLUDE keydefs.h
INCLUDE global.s

        STITLE Airthmetic utilities

* Cyclotomic polynomial
* Algorithm base sur les relations suivantes
* soit p premier, si p ne divise pas n alors 
* cyclo_{n}(X^p)=cyclo_{np}(X)*cyclo_{n}(X)
* si p divise n alors
* cyclo_{n}(X^p)=cyclo_{np}(X)
*
* poser f(x)=x-1
* parcourir la liste des facteurs premiers de n ordonnee par ordre croissant
* et pour chaque facteur premier p effecter f(x)=f(x^p)/f(x).
* Le polynome cyclotomique P_n est alors f(x^n/pi) ou pi est le produit
* des facteurs premiers.
* Par exemple
* n=6 donne la liste { 2 3 }
* p=2: f(x)=(x^2-1)/(x-1)=x+1
* p=3: f(x)=(x^3+1)/(x+1)=x^2-x+1
* n/pi=1 c'est fini
*
* n=100 donne { 2 5 }
* p=2: f(x)=x+1
* p=5: f(x)=(x^5+1)/(x+1)=x^4-x^3+x^2-x+1
* n/pi=10 donc f(x)=x^40-x^30+x^20-x^10+1

******************************************************************
* Desc.:        compute the n-th cyclotomic polynomial
* Stack:        z -> P
* Note:         
******************************************************************
NULLNAME CYCLOTOMIC
::                              ( z )
  OBJINT? NcaseSIZEERR
  DupZIsNeg? case Z<0ERR
  Z0 EQUALcasedro Z1
                                ( z )
  INCYCLOTOMIC                  ( cyclotomic )
  ZEROSWAP RCLVX ONE{}N         ( #0 Q lvar )
  VAL2ext                       ( phi )
;

LABEL INCYCLOTOMIC
::
  INTERNALX Z1 QSub             ( z phi )
  OVER Z1 EQUALcasedro SWAPDROP ( -> phi )
                                ( z phi z ) 
  MZSQFF                        ( z phi f1 m1.. fk mk #2k )
  DUP#0=csedrp SWAPDROP         ( -> phi )
                                ( z phi f1 m1.. fk mk #2k )
  REMOVEMULT                    ( z phi f1..fk #k )
  dup metaproduct OVER#2+UNROLL ( z phi pi f1..fk #k )
  {}N                           ( z phi pi {} )
  DUP >R LENCOMP                ( z phi pi # )
  ROTSWAP                       ( z pi phi # )
  ZERO_DO (DO)                  ( z pi phi )
    DUP RSWAP 'R RSWAP Z>#      ( z pi phi phi #p )
    POLYATX^#                   ( z pi phi phi[x^p] )
    SWAP QDiv                   ( z pi newphi )
  LOOP                          ( z pi newphi )
  UNROT QDiv Z># POLYATX^#      ( cyclotomic )
;

******************************************************************
* Desc.:        compute the product of the meta
* Stack:        meta -> obj
* Note:         
******************************************************************
NULLNAME metaproduct
::                              ( meta )
  DUP#0=csedrp Z1               ( -> 1 )
                                ( meta )
  DUP#1= caseDROP               ( -> obj )
                                ( meta )
  ONE_DO (DO)                   ( f1..fk )
    QMul
  LOOP                          ( product )
;

******************************************************************
* Desc.:        return P[X^#]
* Stack:        P #p -> P[X^#p]
* Note:         
******************************************************************
NULLNAME POLYATX^#
::                              ( P #p )
  DUP#0=csedrp :: Z1 PEval ;
  DUP#1= caseDROP               
                                ( P #p )
  OVER DUPTYPELIST?             ( P #p P ? )
  NOTcase2DROP                  ( -> P )
                                ( P #p P )
  LENCOMP #1=case DROP          ( -> P )
                                ( P #p )
  #1- 1LAMBIND                  ( P )
  DUP >R LENCOMP                ( #size )
  ZEROSWAP                      ( meta #size )
  ONE_DO (DO)                   ( meta )
    RSWAP 'R RSWAP              ( meta ak )
    Z0 1GETLAM NDUPN            ( meta ak 0..0 #p-1 )
    #1+ top&                    ( meta )
  LOOP                          ( meta )
  ( * add cst coeff * )
  'R SWAP#1+                    ( meta )
  ABND {}POLY                   ( meta )
;

LABEL REMOVEMULT
* fk mk ... f1 m1 #2k -> fk...f1 #k
::
  DUP#0= ?SEMI          ( -> )
  #2/ DUP
  #1+_ONE_DO            ( fk mk ... fj mj fj-1 fj-2 ... f1 #k )
    INDEX@ #1+ROLL      ( fk mk ... fj fj-1 fj-2 ... f1 #k mj )
  DROPLOOP
;

NULLNAME POWEXPAND
::
  { x^ xSQ } TOTEMPOB
  { FLASHPTR powexpand :: dup metamult ; } TOTEMPOB
  REPLACE2BY1
;

NULLNAME powexpand
::                              ( meta-arg meta-pow )
  ( * monomials are left unchanged * )
  DUP #2+PICK #1=case x^only
  ( * test for small positive power * )
  OVER OBJPOSINT?               ( meta-arg meta-pow obj flag )
  NOTcasedrop x^only
                                ( meta-arg meta-pow obj )
  UNROT2DROP Z>#                ( meta-arg # )
  DUP#0=csedrp NDROPZ1ONE7
                                ( meta-arg # )
  DUP#1= caseDROP               ( -> meta-arg )
  OBJ>R dup R>OBJ               ( meta-res meta-arg # )
  ONE_DO (DO)
    dup rot MetaMul             ( meta-arg meta-arg*meta-res )
    psh                         ( meta-res' meta-arg )
  LOOP
  NDROP
;

LABEL NDROPZ1ONE7
:: NDROP Z1 ONE ;

NULLNAME DISTRIB
:: SYMBINCOMP DISTRIB*&/ DROP MYCKSYMBN ;

( exp to power )
NULLNAME EXP2POW
::
  { xEXP x^ } TOTEMPOB
  { FLASHPTR exp2pow :: top& addt^ ; } TOTEMPOB
  REPLACE2BY1
;

NULLNAME exp2pow
::
  M1st*case exp2pow*
  M1st/case exp2pow/
  ' xEXP SWAP#1+
;

NULLNAME exp2pow*
::
  plDRPpZparg                           ( v u )
  AEQ1stcase xLN exp2pow*LN
  psh AEQ1stcase xLN exp2pow*LN
  top&addt* addt: xEXP
;

NULLNAME exp2pow/
::
  plDRPpZparg
  AEQ1stcase xLN exp2pow/LN
  pshtop& addt/ addt: xEXP
;

NULLNAME exp2pow*LN
::                                      ( u LN )
  #1-SWAPDROP psh x^only                ( arg[LN]^u )
;

NULLNAME exp2pow/LN
::                                      ( u LN )
  #1-SWAPDROP psh                       ( meta u )
  OVER Z2 EQUAL case2drop addtSQRT      ( -> sqrt )
  pshtop& ' xXROOT SWAP#1+              ( -> xroot )
;

NULLNAME x^only
::
  top& ' x^ SWAP#1+
;

( sym -> sym )
NULLNAME FDISTRIB
::
  SYMBINCOMP FULLDISTRIB MYCKSYMBN
;

* meta -> meta
NULLNAME FULLDISTRIB
::
  [BEGIN]
    ?ATTNQUIT
    DISTRIB*&/
  NOT_UNTIL
;

* meta -> meta, flag
* distribute * or /, return true if at least one distrib done
NULLNAME DISTRIB*&/
::
  AEQ1stcase x* DISTRIB*
  AEQ1stcase x/ DISTRIB/
  AEQ1stcase xNEG DISTRIBNEG
  AEQ1stcase x- DISTRIB-
  DUP#1= caseFALSE
  OVER enumargs SWAPDROP                ( meta # )
  DUP#1= casedrop DISTRIB*&/UNARY
  #2= NOTcaseFALSE                      ( -> meta false )
  #1-SWAP 1LAMBIND pshzerpsharg         ( arg2 arg1 )
  DISTRIB*&/ OBJ>R                      ( arg2 arg1' )
  psh DISTRIB*&/ R>OBJ OR OBJ>R         ( arg1 arg2 )
  top& 1GETABND SWAP#1+ R>OBJ           ( arg1&arg2&op flag )
;

NULLNAME DISTRIB-
::
  plDRPpZparg DISTRIB*&/ OBJ>R psh      ( a b )
  MetaNeg DISTRIB*&/ OBJ>R              ( a -b )
  top& ' x+ SWAP#1+ R>OBJ R>OBJ OR      ( a+-b flag )
;

NULLNAME DISTRIBNEG
::
  #1- SWAPDROP                          ( meta )
  AEQ1stcase xNEG :: #1- SWAPDROP TRUE ;
  AEQ1stcase x+ DISTRIB+NEG
  AEQ1stcase x- DISTRIB-NEG
  DISTRIB*&/ OBJ>R MetaNeg R>OBJ        ( meta flag )
;

NULLNAME DISTRIB+NEG
::
  plDRPpZparg MetaNeg psh
  MetaSub TRUE
;

NULLNAME DISTRIB-NEG
::
  plDRPpZparg MetaNeg psh 
  MetaAdd TRUE
;


NULLNAME DISTRIB*&/UNARY
::
  #1-SWAP OBJ>R DISTRIB*&/              ( arg' flag )
  R>OBJ ROT                             ( arg' flag op # )
  #1+ ROT                               ( arg flag )
;

NULLNAME MYCKSYMBN
::
  DUP#1= NOTcase SYMBN
  DROP
  CK&DISPATCH1
  real NOP
  zint NOP
  cmp  NOP
  any  :: ONE SYMBN ;
;

NULLNAME FLAGTAN2CS2
::
  ' FLASHPTR TAN2CS2NOCK TOTEMPOB CASFLAGEVAL
;

NULLNAME TAN2CS2NOCK
:: 
  DUPTYPEARRY? ?SEMI 
  ' FLASHPTR TAN2CS2ext TOTEMPOB rpnQOBJext 
;

NULLNAME TAN2CS2ext
::
  ' xTAN
  ' 2*1-cos/sin TOTEMPOB
  REPLACE2BY1
;

* ====================================================================
*                       Permutations
* ====================================================================

**********************************************************************
* Desc:         
* Stack:
**********************************************************************
NULLNAME CKPERMext
::
  NOTLISTcase SETTYPEERR
  DUPLENCOMP
  #1+_ONE_DO (DO)
     DUPINDEX@ #>Z
     EQUALPOSCOMP
     #0= IT SETTYPEERR
  LOOP
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME CIRCext
::
  SWAP DUPLENCOMP ROT 
  DUPLENCOMP DUP 4ROLL 
  #= NOT?DIMERR
  #1+_ONE_DO (DO)
     2DUP INDEX@ NTHCOMPDROP
     Z># NTHCOMPDROP UNROT
  LOOP
  DROP LENCOMP {}N
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME P2Cext
::
  Z1 1LAMBIND
  DUPLENCOMP TRUE SWAP
  NDUPN {}N NULL{}                      ( P DRAPEAU RES )
  BEGIN
     OVER TRUE EQUALPOSCOMP
     DUP#0<>
  WHILE                                 ( P DRAPEAU RES #1ST )
     4PICKSWAP
     2DUP NTHCOMPDROP Z>#               ( P DRAPEAU RES P #1ST # )

     ( MISE A JOUR DE DRAPEAU )

     FALSE OVER 7ROLL PUTLIST 5UNROLL

     ( DEBUT DE RESULTAT )

     2DUP SWAP #>Z SWAP #>Z ( instead of UNCOERCE2 )
     2DUP EQUAL
     ITE :: DROP ONE{}N ; TWO{}N        ( P DRAPEAU RES P #1ST # {} )
     4ROLLROT                           ( P DRAPEAU RES 1ST {} P # )
     [BEGIN]
        OVERSWAP NTHCOMPDROP Z>#        ( P DRAPEAU RES 1ST {} P # )
        FALSE OVER 8ROLL PUTLIST
        6UNROLL
        DUP 5PICK EQUAL
     NOT_WHILE
     ::                                 ( P DRAPEAU RES 1ST {} P #  )
       ROTOVER #>Z >TCOMP UNROT
     ;
     [REPEAT]
                                        ( P DRAPEAU RES 1ST {} P # EL )
     2DROP SWAPDROP DUPLENCOMP
     TWO #/ 
     ::
       DROP #0= NOT?SEMI
       1GETLAM QNeg 1PUTLAM 
     ;
     >TCOMP
  REPEAT
                                        ( P DRAPEAU RES )
  DROPSWAPDROP 1GETABND                 ( P C S )
;

**********************************************************************
* Desc:
* Stack:
**********************************************************************
NULLNAME C2Pext
::
  DUPTYPELIST? NcaseTYPEERR
  DUPINCOMP ZEROSWAP
  ZERO_DO (DO)
     SWAP DUPTYPELIST? NcaseTYPEERR
     LENCOMP DUP#0=ITE SETDIMERR #+
  LOOP
                                                ( C # )
  DUP1LAMBIND                                   ( C # )
  Z0 SWAP NDUPN {}N                             ( C P )
  SWAPINCOMP get1 SWAP
  ZERO_DO (DO)                                  ( CK .. C1 P )
     SWAPDUP CARCOMP >TCOMP                     ( ... P C1CIRC )
     INNERCOMP get1 SWAP
     ONE_DO (DO)                                ( CE0 CE1 ... CEK P )
        ( CEK en pos CEK-1 dans P )
        3PICK OBJINT? NcaseTYPEERR
        ZABS Z># DUP 1GETLAM #> caseSIZEERR
        SWAP PUTLIST                            ( CE0 CE1 ... CEK-1 P )
     LOOP
     SWAPDROP
  LOOP
  ABND
;


**********************************************************************
* Desc:
* Stack:        ( grob, obj -> grob, obj )
**********************************************************************
NULLNAME PFSTEP1ext
::
  FXNDext                               ( grob, n, d )
  Z1 OVER
  BEGIN
  ::
    DUPTYPESYMB? NOTcase FALSETRUE
    DUPDUP LENCOMP NTHCOMPDROP EQ: x*
    NOTcase FALSETRUE                   ( n d d1 d2 )
    EXPR> 2DROP                         ( n d d1 d2.1 d2.2 )
    LVARext ROT LVARext                 ( n d d1 d2.2 l2 d2.1 l1 )
    ROT 2DUP EQUAL                      ( n d d1 d2.2 d2.1 l1 l2 l1=l2? )
    case2drop :: ROT RMULText TrueTrue ;
                                        ( n d d1 d2.2 d2.1 l1, l2 avec l1!=l2 )
    NULLCOMP? SWAPDROP                  ( n d d1 d2.2 d2.1 l2={}? )
    ITE SWAPROT ROT
    RMULText SWAP FALSE
  ;
  UNTIL
                                        ( grob, n, d, d1, d2, flag )
  NOTcase2drop :: NDXFext FALSE ;
                                        ( grob, n, d, d1, d2 )
  4PICK "Bezout AU+BV=" >TAG XGROBext   ( grob, n, d, d1, d2, grob )
  3PICK SIMPLIFY DUP "A" >TAG XGROBext
  ROTSWAP GROBADDext                    ( grob, n, d, d1, d2, d1, grob )
  3PICK SIMPLIFY DUP "B" >TAG XGROBext
  ROTSWAP GROBADDext                    ( grob, n, d, d1, d2, d1, d2, grob )
  8ROLL SWAP GROBADDext DUP SCROLLext
  7UNROLL                               ( grob, n, d, d1, d2, d1, d2 )
  6ROLL xABCUV 
ASSEMBLE
        IF      f39
RPL 
  EXPR> 2DROP           
ASSEMBLE
        ENDIF   f39
RPL
                                        ( grob, d, d1, d2, u, v )
  4ROLL ROTSWAP x*ext
  UNROTSWAP x*ext x+ext
  SWAPNDXF TRUE                         ( grob, obj, flag )
;

**********************************************************************
* Desc:
* Stack:        ( grob, obj -> grob, obj )
**********************************************************************
NULLNAME PFSTEP2ext
::
  SWAPOVER DISPLAYext                   ( obj, grob )
  SWAPFXND                              ( grob, n, d )
  OVER TYPESYMB? NOTcase NDXFext
  OVERDUP LENCOMP NTHCOMPDROP
  { x+ x- } SWAP' EQ POSCOMP
  #0=case NDXFext
  SWAP EXPR> SWAPDROP
  EQ: x- IT RNEGext                     ( d, n1, n2 )
  SIMPLIFY 3PICK SIMPLIFY 
  xDIV2 
ASSEMBLE
        IF      f39
RPL 
  EXPR> 2DROP           
ASSEMBLE
        ENDIF   f39
RPL
                                        ( d, n1, q2, r2 )
  4PICK NDXFext SIMP1ext                ( d, n1, q2, r2/d )
  2SWAP SIMPLIFY OVER SIMPLIFY xDIV2 
ASSEMBLE
        IF      f39
RPL 
  EXPR> 2DROP           
ASSEMBLE
        ENDIF   f39
RPL
                                        ( q2, r2/d, d, q1, r1 )
  ROT NDXFext SIMPLIFY                  ( q2, r2/d, q1, r1/d )
  ROT x+ext                             ( q2, q1, res )
  UNROTSWAP x+ext SIMPLIFY              ( res, q1+q2 )
  SWAP x+ext
;

**********************************************************************
* Desc:         partie recursive de la dec es simples pas a pas
* Stack:        ( obj, grob -> grob, obj )
**********************************************************************
NULLNAME PFSTEP3ext
::
  OVER "Factorizing" >TAG
  XGROBext GROBADDext                   ( obj, grob )
  SWAPFXND                              ( grob, n, d )
  COLCext
  ROTOVER "Deno." >TAG
  XGROBext GROBADDext                   ( n, d, grob )
  UNROT NDXFext                         ( grob, obj )
  PFSTEP1ext                            ( grob, obj, a_decomposer? )
  NOT?SEMI
                                        ( grob, obj )
  PFSTEP2ext                            ( grob, obj )
  EXPR> SWAPDROP                        ( grob, obj1, obj2, op )
  ROT 4ROLL                             ( obj2, op, obj1, grob )
  PFSTEP3ext                            ( obj2, op, grob, obj1 )
  4ROLLROT PFSTEP3ext                   ( op, ob1, grob, ob2 )
  ROTSWAP 4ROLL EVAL                    ( grob, o1 op o2 )
;

NULLNAME GCDSTEP
* z1, z2 -> z
* step by step
::
  stepflag TestSysFlag NOTcase ZGCDext
  2DUP SWAP DO>STR ", " &$ SWAP DO>STR &$ XGROBext      ( z1 z2 grob )
  [BEGIN]
    UNROT DUP Z0 EQUAL                          ( grob z1 z2 ? )
  NOT_WHILE
    ::
    2DUP ZDIVext SWAPDROP                       ( grob z1 z2 z1_mod_z2  )
    ROT DO>STR " mod " &$                       ( grob z2 z1_mod_z2 $ )
    3PICK DO>STR &$ " = " &$                    ( grob z2 z1_mod_z2 $ )
    OVER DO>STR &$ 4ROLLSWAP DISPLAYext ( z2 z1_mod_z2 grob )
    ;
  [REPEAT]                                      
                                                ( grob z1 z2 )
  GCDSTEPEND                                    ( z1 )
;

LABEL GCDSTEPEND
::                                              ( grob z1 z2 )
  DROP DUPUNROT                                 ( z1 grob z1 )
  DO>STR BINT23 GETERABLEMSG SWAP&$             ( z1 grob str )
  DISPLAYext DROP                               ( z1 )
;

NULLNAME IEGCDSTEP
* z1, z2 -> u, v, d
::
  2DUP "[z,u,v]: z= u*" ROT DO>STR &$ " + v*" &$ 
  SWAP DO>STR &$ XGROBext                       ( z1 z2 grob )
  ROT Z1 Z0 THREE []N DUP4UNROLL                ( Z1 z2 grob Z1 )
  XGROBext GROBADDext                           ( Z1 z2 grob )
  UNROT Z0 Z1 THREE []N                         ( grob Z1 Z2 )
  [BEGIN]
    DUP CARCOMP Z0 EQUAL                        ( grob Z1 Z2 ? )
  NOT_WHILE
    ::                                          ( grob Z1 Z2 )
    OVER CARCOMP OVER CARCOMP ZDIVext DROP      ( grob Z1 Z2 z1/z2  )
    4ROLL 3PICK DO>STR " *-" &$                 ( Z1 Z2 z1/z2 grob str )
    3PICK DO>STR &$                             ( Z1 Z2 z1/z2 grob str )
    DISPLAYext 4UNROLL                          ( grob Z1 Z2 z1/z2  )
    SWAP DUP4UNROLL                             ( grob Z2 Z1 z1/z2 Z2  )
    SCL*MAT MAT-                                ( grob Z2 Z1-z1/z2*Z2 )
    ;
  [REPEAT]                                      
                                                ( grob Z1 Z2 )
  GCDSTEPEND                                    ( Z1 )
  INCOMPDROP                                    ( d u v )
;


**********************************************************************
* Desc:         domain of def of a function
* Stack:        ( symb -> list )
* Note:         does not look at rat frac singularities
**********************************************************************
NULLNAME DOMAIN
::
  LVARXNXext 4UNROLL3DROP       ( lvar )
  INNERCOMP
  DUP#0=csedrp SIGNPLUS         ( -> always defined )
                                ( var1 .. varn #n )
  #1-SWAP VARDOMAIN             ( var1 .. varn-1 #n-1 {} )
  SWAP DUP#0=csDROP             ( -> {} )
                                ( var1 .. varn-1 {} #n-1 )
  ZERO_DO (DO)                  ( var1 .. varn-1 {} )
    SWAP VARDOMAIN SIGNMULText  ( var1 .. varn-2 {} )
  LOOP
;

LABEL VARDOMAIN
* for unary op: 
::
  DUPTYPESYMB? NOTcasedrop SIGNPLUS
  EXPR>                         ( arg1..argn %n op )
  { 
    xEXP DOMAIN xLN DOMAIN+ x\v/ DOMAIN+
    xSIN DOMAIN xCOS DOMAIN xTAN DOMAIN
    xASIN DOMAIN-11 xACOS DOMAIN-11 xATAN DOMAIN
  }
  EQLookup                      ( arg1..argn %n [ op FALSE | prg TRUE ] )
  NOTcase :: BINT91 ERABLEERROR ;
                                ( arg1 %1 prg )
  SWAPDROP EVAL
;

LABEL DOMAIN+
::
  SIGNEext 
  ' :: DUPEQ: x- casedrop ?ext ; TOTEMPOB 1LAMBIND
  LISTSECOext ABND
;

LABEL DOMAIN-11
::
  Z1 SWAPDUP x*ext x-ext
  DOMAIN+
;

**********************************************************************
* Desc:         multivar solver
* Stack:        ( F lvar guess -> F lvar guess )
* Note:         
**********************************************************************
NULLNAME MSLV
::					( F lvar guess )
  ' FLASHPTR DOMSLV TOTEMPOB CASFLAGEVAL
;

**********************************************************************
* Desc:         Simplification of symbolic expr
* Stack:        ( obj -> obj )
* Note:         
**********************************************************************
NULLNAME FLAGSIMPLIFY
::
  ' FLASHPTR CKSIMPLIFY TOTEMPOB CASFLAGEVAL
;

**********************************************************************
* Desc:         Simplification of symbolic expr
* Stack:        ( obj -> obj )
* Note:         
**********************************************************************
NULLNAME CKSIMPLIFY
::
  DUPTYPEARRY? ?SEMI
  ' FLASHPTR INSIMPLIFY TOTEMPOB rpnQOBJext
;

**********************************************************************
* Desc:         Simplification of symbolic expr
* Stack:        ( symb -> symb )
* Note:         
**********************************************************************
NULLNAME INSIMPLIFY
::                                      ( symb )
  VXLVARext DUP SLVARext DUP4UNROLL     ( lvar' symb lvar lvar' )
  MEVALext SWAP                         ( symb lvar )
  DUPLENCOMP TWO #< casedrop SIMPLIFY   ( -> symb' )
                                        ( symb lvar )
  { xSIN xCOS xTAN } HOWMANY            ( symb lvar # )
  ONE #> casedrop SIMPLIFYSINCOS
                                        ( symb lvar )
  DROP SIMPLIFYEXPLN SIMPLIFY           ( symb )
;

LABEL SIMPLIFYEXPLN
* symb -> symb
::                                      ( symb )
  HYP2EXPext LVARext                    ( symb' lvar )
  ( * >= 2 LN -> LNCOLLECT, 2 EXP -> TSIMP + SIMPLIFY * )
  { xEXP } HOWMANY
  ONE #> IT :: DROP TSIMP3ext LVARext ;
  { xLN } HOWMANY                       ( symb lvar # )
  ONE #> casedrop :: SYMCOLCT LNCOLCext ;
  ( * >= 2 trig func -> TEXPAND + SIMPLIFY * )
  DROP
;

LABEL SIMPLIFYSINCOS
* symb -> symb
::                                              ( symb )
  TEXPAext SIMPLIFYEXPLN TRIGext                ( symb )
;

LABEL HOWMANY
* lvar l_op -> lvar #
* count how many var in lvar have topmost operator in l_op
::
  OVER NULLCOMP? casedrop ZERO          ( -> lvar #0 )
                                        ( lvar l_op )
  TOTEMPOB 1LAMBIND                     ( lvar )
  DUPINCOMP ZEROSWAP                    ( lvar var1..varn #0 #n )
  ZERO_DO (DO)                          ( lvar var1..varn #count )
    SWAP DUPTYPESYMB? IT LASTCOMP       ( lvar var1..varn-1 #count opn )
    1GETLAM ListPos                     ( lvar var1..varn-1 #count # )
    #0= ?SKIP #1+                       ( lvar var1..varn-1 #count )
  LOOP
  ABND
;

*********************************************
* Various nullname added late for th 40
********************************************
NULLNAME REMOVEFROMASSUME
* remove object from assume list
* ob -> ob
::
  CONTEXT@ CASDIR                       ( ob rrp )
  ' ID REALASSUME DUP@                  ( ob rrp assume list TRUE )
  NcaseSIZEERR
                                        ( ob rrp assume list )
  DUPTYPELIST? ?SKIP ONE{}N             ( ob rrp assume list )
  DUP 5PICK EQUALPOSCOMP                ( ob rrp assume list # )
  DUP#0=csedrp :: 2DROP CONTEXT! ;
  SWAPINCOMP get1                       ( ob rrp assume l1..ln #n # )
  OVERSWAP #- #2+ROLL DROP              ( ob rrp assume l1.|.ln #n )
  #1- {}N SWAP STO CONTEXT!             ( ob )
;

NULLNAME REWRITEMENU
::
  { ROMPTR xDISTRIB ROMPTR xEPSX0 ROMPTR xEXPLN ROMPTR xEXP2POW 
    ROMPTR xFDISTRIB ROMPTR xLIN ROMPTR xLNCOLLECT 
    ROMPTR xPOWEXPAND ROMPTR xSINCOS ROMPTR xSIMPLIFY
    ROMPTR xXNUM ROMPTR xXQ
  }
  TOTEMPOB
;

NULLNAME MATHSMENU
::
  { ROMPTR xCMPLX ROMPTR xCONSTANTS ROMPTR xHYPERBOLIC ROMPTR xINTEGER 
    ROMPTR xMODULAR ROMPTR xPOLYNOMIAL 
    ROMPTR xTESTS }
  TOTEMPOB
;

NULLNAME INTEGERMENU
::
  { 
     ROMPTR xDIVIS ROMPTR xEULER ROMPTR xFACTOR ROMPTR xGCD 
     ROMPTR xIEGCD ROMPTR xIQUOT ROMPTR xIREMAINDER ROMPTR xISPRIME? 
     ROMPTR xLCM ROMPTR xNEXTPRIME ROMPTR xPREVPRIME
  }
  TOTEMPOB
;

NULLNAME CONSTANTSMENU
::
  { xCONSTANTe xi ROMPTR x\9F xPI } TOTEMPOB 
;

NULLNAME HYPERBOLICMENU
::
  { xACOSH xASINH xATANH xCOSH xSINH xTANH } TOTEMPOB
;

NULLNAME MODULARMENU
::
  { 
   ROMPTR xADDTMOD ROMPTR xDIVMOD ROMPTR xEXPANDMOD 
   ROMPTR xFACTORMOD ROMPTR xGCDMOD ROMPTR xINVMOD ROMPTR xMODSTO 
   ROMPTR xMULTMOD ROMPTR xPOWMOD ROMPTR xSUBTMOD 
  } TOTEMPOB
;

NULLNAME POLYNOMIALMENU
::
  {
    ROMPTR xEGCD ROMPTR xFACTOR ROMPTR xGCD ROMPTR xHERMITE 
    ROMPTR xLCM ROMPTR xLEGENDRE ROMPTR xPARTFRAC ROMPTR xPROPFRAC 
    ROMPTR xPTAYL ROMPTR xQUOT ROMPTR xREMAINDER 
    ROMPTR xTCHEBYCHEFF
  } TOTEMPOB
;


NULLNAME TESTSMENU
::
  { 
    ROMPTR xASSUME ROMPTR xUNASSUME 
    x> x>=? x< x<=? x== x#? 
    xAND xOR xNOT xIFTE 
  }
  TOTEMPOB
;

NULLNAME CHOOSE>$
* list -> list of $
::
  INNERCOMP 
ASSEMBLE
        IF      f39
RPL
  "CFG "
  COMPLEX?  ITE "C" "R" &$
  EXACT? ITE "= " "~ " &$
  RCLVX DO>STR &$ 
  stepflag SysITE " S" " D" &$
  SWAPDUP
  #1+_ONE_DO
      get1 DUPTYPELIST?
      ?SKIP DO>STR 
  SWAPLOOP

  #1+ {}N 

ASSEMBLE
        ELSE    f39
RPL
  "0.MAIN MENU" TOTEMPOB 
  SWAPDUP
  #1+_ONE_DO
      get1 DUPTYPELIST?
      ?SKIP
      ::
       DO>STR INDEX@ #>Z DO>STR
       CHR_. >T$
       SWAP&$
      ;
  SWAPLOOP

  #1+ {}N 
ASSEMBLE
        ENDIF   f39
RPL
;

* replacement for 39 syminner, cassyminner is equivalent to the 49 syminner
NULLNAME cassyminner
::
  DUPTYPESYMB? ITE INNERCOMP ONE
;

NULLNAME 2cassyminner
::
  OBJ>R cassyminner R>OBJ cassyminner
;

NULLNAME CASSYM+
:: 2cassyminner top& addt: x+ SYMBN ;

NULLNAME CASSYM-
:: 2cassyminner top& addt: x- SYMBN ;

NULLNAME CASSYM*
:: 2cassyminner top& addt: x* SYMBN ;

NULLNAME CASSYM/
:: 2cassyminner top& addt: x/ SYMBN ;

NULLNAME CHANGECASCFG
::  
  COMPLEX?  ITE "C" "R"
  EXACT? ITE "=" "~" &$
  stepflag SysITE " STEP " " DRCT " &$
  increaseflag SysITE "" "" &$
  RCLVX DO>STR &$ " " &$
  RCLMODULO DO>STR &$
  nocareflag SysITE " " " ||" &$

  FRANCAIS? ITE "Quitter cfg" "Quit config"
  COMPLEX? ITE "Real" "Complex"
  EXACT? ITE "Approx" "Exact"
  stepflag SysITE "Direct" "Step/step"
  increaseflag SysITE "...x^2+x+1" "1+x+x^2..." 
  nocareflag SysITE "Rigorous" "Sloppy"
  numfactorflag SysITE "Symb. factor" "Num. factor"
  allrealflag SysITE "Cmplx vars" "Real vars"
  FRANCAIS? ITE "English" "Franais"
  "Default cfg"
  TEN {}N  
                                        ( "" {} )
  %1 
ASSEMBLE
        IF      f39
RPL
  Ck&DoChoose                   
ASSEMBLE
        ELSE    f39
RPL
  FLASHPTR Ck&DoChoose                  
ASSEMBLE
        ENDIF   f39
RPL
                                        ( % %1 | %0 )
  %0= case CASNULL::
  COERCE DUP#1= casedrop CASNULL::
  { 
   :: complexflag SWITCHONOFF ;
   :: approxflag SWITCHONOFF ;
   :: stepflag SWITCHONOFF ;
   :: increaseflag SWITCHONOFF ;
   :: nocareflag SWITCHONOFF ;
   :: numfactorflag SWITCHONOFF ;
   :: allrealflag SWITCHONOFF ;
   :: FRANCAIS? ITE ENGLISH FRANCAIS ;
   RESETCASCFG
  }
  SWAP#1- NTHCOMPDROP EVAL CHANGECASCFG
;

LABEL SWITCHONOFF
:: DUP SysITE ClrSysFlag SetSysFlag ;

NULLNAME VARSCREEN
* ->
* manage VARs in the current directory ( HOME on the 40 )
::
  DOVARS                        ( {id} )
  ( * find value of id, except directories * )
  RECALLIDS                     ( {id} {strings} )
  BEGIN
    INVARSCREEN                 ( [ {id} {strings} false | true ] )
  UNTIL                         ( )
;

LABEL RECALLIDS
* recall non directories id
::                              ( {id} )
  DUPNULL{}? case DUP           ( -> {} {} )
                                ( {id} )
  DUPLENCOMP SWAP >R            ( # )
  ZEROZERO ROT                  ( meta-id meta-str # )
  ZERO_DO (DO)
    RSWAP 'R RSWAP
    DUP @ NcaseSIZEERR          ( meta-id meta-str id ob )
    DUPTYPERRP? ITE 2DROP RCLID ( meta-id meta-str )
  LOOP
  {}N OBJ>R {}N R>OBJ           ( {id} {str} )
;

LABEL RCLID
::                              ( meta-id meta-str id ob )
  DO>STR OVER ID>$ ": " &$ SWAP&$       ( meta-id meta-str id str-id-ob )
  SWAP OBJ>R SWAP#1+            ( meta-id meta-str' )
  psh R>OBJ SWAP#1+ psh         ( meta-id' meta-str' )
;

LABEL INVARSCREEN
* {id} {strings} -> [ {id} {strings} false | true ]
::                              ( {id} {strings} )
  DUPNULL{}? case2drop TRUE     ( -> true )
                                ( {id} {strings} )
  "CAS VARS" TOTEMPOB OVER %1   ( {id} {strings} "vars" {strings} %1 )
  DOCLLCD 
ASSEMBLE
        IF      f39
RPL
  Ck&DoChoose                   
ASSEMBLE
        ELSE    f39
RPL
  FLASHPTR Ck&DoChoose                  
ASSEMBLE
        ENDIF   f39
RPL
                                ( {id} {strings} [% %1|%0] )
  %0= case2drop TRUE            ( -> true )
                                ( {id} {strings} % )
  ( * manage var number % * )
  COERCE DOCLLCD                ( {id} {strings} # )
  2DUP NTHCOMPDROP DISPROW1     ( {id} {strings} # )
  3PICKOVER NTHCOMPDROP         ( {id} {strings} # id )
  @ DROP EDITDECOMP$ TWO FIVE Disp5x7 ( {id} {strings} # )
  "CAS" "VARS" "" "EDIT" "" "PURGE" 
  WRITEMENU                     ( {id} {strings} # )
  BEGIN
    WaitForKey DROP             ( {id} {strings} # #KeyCode )
    DUP kcMenuKey6 #>
  WHILE
    DROP DoBadKey ( % 5000 % 0.3 DOBEEP )
  REPEAT
                                ( {id} {strings} # #Keycode )
  kcMenuKey1 EQUALcasedro CASVARPURGE
*  kcMenuKey2 EQUALcasedro CASVARRCL
  kcMenuKey3 EQUALcasedro CASVAREDIT
  kcMenuKey5 EQUALcasedro DROPFALSE
  kcMenuKey6 EQUALcasedro :: 3DROP 2RDROP ;
  2DROP COLA INVARSCREEN        ( recall )
;

LABEL CASVARRCL
::
  SWAPDROP NTHCOMPDROP          ( id )
  @ DROP                        ( ob )
  2RDROP                        ( -> ob )
;

LABEL CASVAREDIT
::                                      ( {id} {strings} # )
  DOCLLCD "New value for " 
  4PICK 3PICK NTHCOMPDROP ID>$ &$       ( {id} {strings} # prompt$ )
  4PICK 3PICK NTHCOMPDROP @ DROP DO>STR ( {id} {strings} # prompt$ edit$ )
  ZEROZERO TWO ZERO
  FALSE ONE
  FALSE ZERO
  InputLine                             ( {id} {strings} # $ ? )
  NOTcasedrop INVARSCREEN
  palparse NcaseSIZEERR
                                        ( {id} {strings} # ob )
  4ROLLROT NTHCOMPDROP STO              ( {strings} )
  DROP TRUE
;

LABEL CASVARPURGE
::
  ( * purge this var * )        ( {id} {strings} # )
  1LAMBIND
  INNERCOMP 1GETLAM metasplit   ( {id} s1..si #i si+1..sn #n-i )
  psh pulldrop pshtop& {}N      ( {id} {newstrings} )
  SWAPINCOMP 1GETABND metasplit ( {strings} id1..idi #i idi+1..idn #n-i )
  psh #1-SWAP PURGE             ( {strings} idi+1..idn #n-i id1..idi-1 #i-1 )
  pshtop& {}N SWAPFALSE         ( {id} {strings} false )
;

NULLNAME ISMETACOMPLEX?
* meta -> meta flag
* search for cmp type or for xi
CODE
                GOSBVL  =SAVPTR
                C=DAT1  A
                CD0EX           D0 -> @ #of meta
                D0=D0+  5
                A=DAT0  A       A=#of meta
                B=A     A
ismetacmplp     A=B     A
                ?A#0    A
                GOYES   +
                GOVLNG  =GPPushFLoop    -> false
+               D1=D1+  5       next stack level
                A=DAT1  A
                LC(5)   =xi
                ?A#C    A
                GOYES   ++
                GOVLNG  =GPPushTLoop    -> true (i detected)
++              AD0EX
                A=DAT0  A
                LC(5)   =DOCMP
                ?A#C    A
                GOYES   ++++
                GOVLNG  =GPPushTLoop    -> true (DOCMP detected)
++++            B=B-1   A
                GOTO    ismetacmplp
ENDCODE

NULLNAME 2QPI
:: 
  SWAP OBJINT? NcaseSIZEERR SWAP OBJINT? NcaseSIZEERR 
;

NULLNAME AND39
:: 
ASSEMBLE
        IF      f39
RPL
  InCASApplication? NOTcase TWO{}N
ASSEMBLE
        ENDIF   f39
RPL
  2SYMBINCOMP top& addt: xAND CKSYMBN 
;

NULLNAME TESTEUROPE
::
ASSEMBLE
        IF      f39
RPL
  IsEurope? ?SEMI
  BINT94 ERABLEERROR
ASSEMBLE
        ENDIF   f39
RPL
;

NULLNAME DIRECTDERIV
::
  NOSTEPEVAL7 DERIVIDNT
;

NULLNAME REMOVE?x?
* remove ? x ? inside a signtable
::
  DUPLENCOMP THREE #< caseSIZEERR
  DUP >R LENCOMP #2/            ( # )
  ZEROSWAP                      ( meta # )
  FALSE 1LAMBIND                ( meta # )
  ZERO_DO (DO)                  ( meta )
    RSWAP 'R'R RSWAP            ( meta bound sign )
    DUP ?ext EQUAL              ( meta bound sign ? )
    ( * if sign is ?: if previous sign was ? remove bound * )
    ( *               else add -0 to the bound * )
    ( * else if previous sign was ? add +0 to the bound * )
    ( *      else do nothing * )
    ITE TESTADD-0 TESTADD+0 
  LOOP
  ABND 'R SWAP#1+ {}N
;

LABEL TESTADD-0
::						( meta bound sign )
  1GETLAM case2DROP				( -> meta )
  TRUE 1PUTLAM					( meta bound sign )
  INDEX@ #0=case ROT#2+
  SWAP SYMBINCOMP Z0 ' x- ROT #2+ CKSYMBN 	( meta sign bound )
  SWAPROT #2+					( meta )
;

LABEL TESTADD+0
::						( meta bound sign )
  1GETLAM NOTcase ROT#2+			( -> meta )
						( meta bound sign )
  FALSE 1PUTLAM					( meta bound sign )
  SWAP SYMBINCOMP Z0 ' x+ ROT #2+ CKSYMBN 	( meta sign bound )
  SWAPROT #2+					( meta )  
;

LABEL ROT#2+
:: ROT #2+ ;

NULLNAME CASDIR
::
*ASSEMBLE
*        IF      f39
*RPL
*  HOMEDIR
*ASSEMBLE
*        ELSE    f39
*RPL
  HOMEDIR ' ID CASDIR DUP@			( id ob true | id false )
  NOTcase LOCALNAME CREATECASDIR :: CREATEDIR COLA CASDIR ;
						( id ob )
  DUPTYPERRP? NOTcasedrop CREATECASDIR		( IF ob is not a directory... )
  SWAPDROP CONTEXT!
*ASSEMBLE
*        ENDIF   f39
*RPL
;

NULLNAME CASIDX
::
ASSEMBLE
        IF   f39
RPL
  ' ID X TOTEMPOB
ASSEMBLE
        ELSE    f39
RPL
  'IDX
ASSEMBLE
        ENDIF   f39
RPL
;

NULLNAME RESETCASVAR
::
  CONTEXT@ CASDIR
  % .0000000001 ' ID EPS STO
  'IDX DUP' ID VX STO PURGE
  pifois2 ' ID PERIOD STO
  'IDX ' ID Y ' ID t ' ID S1 ' ID S2 FIVE {}N ' ID REALASSUME STO
  ZINT 13 TOTEMPOB ' ID MODULO STO
  CONTEXT!
;

NULLNAME 2LIST2MATRIX
::
  SWAP LIST2MATRIX SWAP LIST2MATRIX
;

NULLNAME STORE
* obj, idnt -> obj
:: 
  ( * check that obj * )        ( obj idnt )
  OVERSWAP                      ( obj obj idnt )
ASSEMBLE
        IF      f39
RPL
  InCASApplication? NOTcase UserSto 
ASSEMBLE
        ENDIF   f39
RPL
  STO
;

NULLNAME CAS+
::
  CK&DISPATCH1
  2matrix MAT+
  2LIST CASLIST+LIST
  any EvalNoCKx+
;

LABEL CASLIST+LIST
:: 2LIST2MATRIX MAT+ MATRIX2LIST ;

NULLNAME CAS-
::
  CK&DISPATCH1
  2matrix MAT-
  2LIST CASLIST-LIST
  any EvalNoCKx-
;

LABEL CASLIST-LIST
:: 2LIST2MATRIX MAT- MATRIX2LIST ;

NULLNAME CAS*
::
  CK&DISPATCH1
  2matrix MAT*
  matrix SCL*MAT
  matrixob MAT*SCL
  2LIST CASLIST*LIST
  list CASOB*LIST 
  EIGHTY CASLIST*OB
  any EvalNoCKx*
;

LABEL CASOB*LIST
:: SWAP CASLIST*OB ;

LABEL CASLIST*OB
:: ' EvalNoCKx* 2Ob>Seco VUNARYOP []TO{} ;

LABEL CASLIST*LIST
:: SAMESIZE ' EvalNoCKx* VBINARYOP []TO{} ;

NULLNAME CAS/
::
  CK&DISPATCH1
  2matrix MAT/
  matrix :: MATINV SCL*MAT ;
  matrixob MAT/SCL
  2LIST CASLIST/LIST
  EIGHTY CASLIST/OB
  any EvalNoCKx/
;

LABEL CASLIST/LIST
:: SAMESIZE ' EvalNoCKx/ VBINARYOP []TO{} ;

LABEL CASLIST/OB
:: ' EvalNoCKx/ 2Ob>Seco VUNARYOP []TO{} ;

NULLNAME SAMESIZE
::
  CK&DISPATCH1
  2matrix MATSAMESIZE
  2LIST LISTSAMESIZE
;

LABEL MATSAMESIZE
:: CKSAMESIZE NOT?DIMERR ;

LABEL LISTSAMESIZE
:: OVER LENCOMP OVER LENCOMP #= NOT?DIMERR ;

NULLNAME DOTABVAR
::
  xFUNCTION DUPDUP 
  "F=" >TAG XGROBext DUP SCROLLext      ( fnct, fnct, grob1 )
  SWAP RCLVX DIRECTDERIV                ( fnct, grob1, derivee )
  SWAPOVER "F'=" >TAG                   ( fnct, derivee, grob1, tagged )
  XGROBext GROBADDext                   ( fnct, derivee, grob1' )
  SWAP COLCext DUPUNROT "->" >TAG
  DISPLAYext                            ( fnct, derivee, grob12 )
  SWAP					( fnct, grob12, derivee )
  num#0=case7 :: BINT101 ERABLEERROR ;
  SIGNEext				( fnct grob12 signtab )
* restriction du domaine de la fnct
  3PICK DOMAIN SIGNMULText              ( fnct grob12 signtab )
  ( * remove here ? x ? * )
  REMOVE?x?
* determine ici les parametres a mettre dans PPAR
  DOTABVARPPAR SWAP                     ( fnct, {}, grob12 )
  UNROT RCLVX SWAP NOASKEVAL TABVALext  ( grob123, fnct, {{}} )
  ROT "Variation table:" TOTEMPOB XGROBext
  GROBADDext                            ( fnct, {{}}, grob1234 )
  OVER INCOMPDROP                       ( fnct, {{}}, grob1234 line1 line2 )
  SWAPINCOMP RCLVX SWAP#1+ []N
  SWAPINCOMP "F" $>ID SWAP#1+ []N TWO []N
  DISPLAYext                            ( fnct, {{}}, grob12345 )
  3PICK DOSTOE
ASSEMBLE
        IF      f39
RPL
  2DROP                                 ( Remove useless elements JYA )
  "Switch to the Aplet Symbolic View to plot the function" TOTEMPOB
      BINT12 BINT3 grobAlertIcon BINT5 BINT0
** ( Message #MaxLineWidth #MinLineWidth 
**   grobIcon #MsgLineCount #MsgBoxTop --> )
      DispMsgBox
      VERYSLOW VERYSLOW VERYSLOW VERYSLOW VERYSLOW
ASSEMBLE
        ELSE    f39
RPL
  stepflag TestSysFlag
  NOT?SEMI                      ( fnct, {{}}, grob12345 )
  "Graph of F:" TOTEMPOB XGROBext GROBADDext
  DOERASE AUTOSCALE 
  FLASHPTR DoPLOT_SETUPInform
  GBUFF GROBADDext
ASSEMBLE
        ENDIF   f39
RPL
;

NULLNAME DOTABVARPPAR
* signtab -> signtab
::
ASSEMBLE
        IF      f39
RPL
ASSEMBLE
        ELSE    f39
RPL
  DUP THREE NTHCOMPDROP CASCRUNCH               ( signtab xmin )
  %MAXREAL EQUALcasedro NOP                     ( -> signtab )
  DUP %0> ITE % 0.8 % 1.25 %*                   ( signtab xmin )
  OVERDUP LENCOMP #2- NTHCOMPDROP CASCRUNCH     ( signtab xmin xmax )
  %MINREAL EQUALcasedro DROP                    ( -> signtab )
  DUP %0> ITE % 1.25 % 0.8 %*                   ( signtab xmin xmax )
  2DUP %= case2DROP
  DOXRNG                                        ( signtab )
ASSEMBLE
        ENDIF   f39
RPL
;

NULLNAME PUSHVSTACK
* obj -> obj
::
  ( Make sure we don't import symbolix with xFmMat and xFmList )
ASSEMBLE
        IF      f39
RPL
  DUPTYPESYMB? IT       ( Not a symbolic? No need to bother )
  ::
    Is38GMatrixList NOT?SEMI    ( Does it contains a list or a matrix )
    RemoveMatrixList            ( Get rid of the xFmMat and xFmList )
  ;
ASSEMBLE
        ENDIF   f39
RPL
  GetVStackProtectWord
  OVER PopMetaVStack            ( obj #protect obj meta )
  get1 SWAP#1+                  ( obj #protect meta&obj )
  PushMetaVStack&Drop           ( obj #protect )
  SetVStackProtectWord          ( obj )
;

NULLNAME POPVSTACK
* -> obj
::
  GetVStackProtectWord
  PopMetaVStack                 ( #protect meta )
  DUP#0= ITE %0 #1-SWAP         ( #protect meta-obj obj )
  STRIPTAGS                     ( #protect meta-obj obj )
  OVER#2+UNROLL                 ( #protect obj meta-obj )
  PushMetaVStack&Drop           ( #protect obj )
  SWAP SetVStackProtectWord     ( obj )
;

NULLNAME DEGREE
::
ASSEMBLE
        IF      f39
RPL
  InCASApplication? case DEGREEZ
  DEGREEZ Z>R
ASSEMBLE
        ELSE    f39
RPL
  DEGREEZ
ASSEMBLE
        ENDIF   f39
RPL

;

LABEL DEGREEZ
::
  ISPOLYNOMIAL? NOTcase TRANSCERROR
  VXLVARext                     ( symb lvar )
  VXXLext                       ( lvar P-list )
  FXNDext                       ( lvar n d )
  CSTPOLY? NcaseSIZEERR
                                ( lvar n d )
  DROPSWAPDROP                  ( n )
  num#0=case7 :: DROP Z-1 ;
  NOTLISTcase DROPZ0
  DEGREext #>Z
;

NULLNAME CKSYMB40
* symb -> ?
* obj -> true
::
ASSEMBLE
        IF      f39
RPL
  CKREWRITE40                   ( [obj true|false] )
  NOTcaseFALSE                  ( -> false )
                                ( obj )
  DROPTRUE                      ( -> true )
ASSEMBLE
        ELSE    f39
RPL
  DROPTRUE
ASSEMBLE
        ENDIF   f39
RPL
;

ASSEMBLE
        IF      f39
RPL
LABEL CKREWRITE40
* obj -> [obj' true|false]
::
  DUPTYPESYMB? NOTcaseTRUE
  INNERCOMP ckmeta40
;

LABEL ckmeta40
* meta -> [obj true|false]
::
  DUP#0=csedrp :: %0 TRUE ;
  DUP#1= casedrop CKREWRITE40
  AEQ1stcase xFmMat ckmeta40mat
  AEQ1stcase xFmList ckmeta40list
  AEQ1stcase xFCNAPPLY ckmeta40fcn
  OVER Keyword? case ckmeta40cmd
  #1-SWAP CKREWRITE40                   ( meta [obj true|false] )
  NOTcase NDROPFALSE                    ( -> false )
                                        ( meta obj )
  DUPTYPEMATRIX? NOTcasedrop ckmeta40   ( -> )
                                        ( meta [] )
  OVER#2+UNROLL ckmeta40                ( [] [obj true|false] )
  NOTcase DROPFALSE                     ( -> false )
                                        ( [] obj )
  DUPTYPEMATRIX? NOTcase DROPTRUE       ( -> [] true )
  ( * we allow only 1 [] embedded inside a symbolic * )
                                        ( [] [] )
  2DROPFALSE                            ( -> false )
;
LOCAL workonit

LABEL ckmeta40mat
::
  pshzerpsharg ckmeta40                 ( meta-mat [obj true|false] )
  NOTcase NDROPFALSE
                                        ( ... #dim xFmMat #meta obj )
  TYPEMATRIX? case NDROPFALSE
                                        ( ... #dim xFmMat #meta )
  workonit NOTcase NDROPFALSE
                                        ( meta )
  []N                                   ( [] )
  DIMS NOTcaseFALSE                     ( -> false )
  2DROP                                 ( [] )
  TRUE                          
;

LABEL ckmeta40list
::
  pshzerpsharg ckmeta40                 ( meta-mat [obj true|false] )
  NOTcase NDROPFALSE
                                        ( ... #dim xFmMat #meta obj )

  DROP                                  ( ... #dim xFmMat #meta )
  workonit NOTcase NDROPFALSE
                                        ( meta )
  {}N                                   ( [] )
  TRUE                          
;

LOCAL _cont
LABEL ckmeta40cmd
::
  pshzerpsharg ckmeta40                 ( meta-mat [obj true|false] )
  NOTcase NDROPFALSE
                                        ( ... #dim xFmMat #meta obj )

  DROP
                                        ( ... #dim xFmMat #meta )
  GOTO _cont
(;)

LABEL ckmeta40fcn
::
  pshzerpsharg ckmeta40                 ( meta-mat [obj true|false] )
  NOTcase NDROPFALSE
                                        ( ... #dim xFmMat #meta obj )

  DROP
  UNROT2DROP                            ( ... #dim xFmMat #meta )
  #2-
  LOCALNAME _cont
  workonit
  NOTcase NDROPFALSE
                                        ( meta )
  SYMBN                                 ( [] )
  TRUE                          
;

LOCALNAME workonit
::
  SYMBN EXPR> DROP COERCE               ( el1..eln #n )
  ( * check each element and rewrite matrix as [] * )
  DUP#0=csedrp FALSE
  TRUE OVER
  ZERO_DO (DO)                          ( meta ? )
    SWAP get1 CKREWRITE40               ( meta' ? #n [obj true|false] )
    ITE SWAPROT                         ( meta' obj #n ? ) 
        :: ExitAtLOOP FALSE  ( meta false ) ;
  LOOP                                  ( meta ? )
;

ASSEMBLE
        ENDIF   f39
RPL

