INCLUDE cas2romid.h
INCLUDE erextdec.h
INCLUDE cas2ext.h
INCLUDE ../CAS/keydefs.h
INCLUDE ../CAS/global.s

	STITLE Eval in bank 7

**********************************************************************
* from CAS/eval.s
**********************************************************************
**********************************************************************
* Desc:		Calls << ob2 binaryop >> on each element of M3.
*		prg1 must act like a binary operator.
*		#depth=2 if M3 is a matrix, 1 for a vector
*		For example ob2=%5 & prg1=RMULText
*		For example ob2='X' & prg1=VALext
* Stack:	( M3 ob2 #depth [runstream binaryop] --> M )
**********************************************************************
LABEL DEPTHEVAL:7
::
  'R				( M ob #depth binop )
  '
  ::				( LAM1: obj -> obj )
    3GETLAM DUP#0=csedrp
    :: 4GETLAM 2GETEVAL ;
    #1- 3PUTLAM 
    INNERDUP #1-SWAP
    ZERO_DO
       get1 1GETLAM EVAL
    SWAPLOOP
    #1+ []N
    3GETLAM #1+ 3PUTLAM
  ;				
				( M ob #depth binop prg )
  4NULLLAM{} BIND		
  1GETLAM EVAL
  ABND
;

**********************************************************************
* Desc:		Evaluate next runstream object in nocareflag mode
* Stack:
**********************************************************************
LABEL NOCAREEVAL7
::
  'R
  nocareflag TestSysFlag case EVAL
  nocareflag SetSysFlag
  EVAL
  nocareflag ClrSysFlag
;

**********************************************************************
* Desc:		Evaluate next runstream object without asking for switch
* Stack:
**********************************************************************
LABEL NOASKEVAL
::
  'R
  switchflag TestSysFlag case EVAL
  switchflag SetSysFlag
  EVAL
  switchflag ClrSysFlag
;



**********************************************************************
* Desc:		Evaluate next runstream object in complex mode.
* Stack:
**********************************************************************
LABEL COMPLEXEVAL7
::
  'R
  COMPLEX?
  OBJ>R
  SETCOMPLEX
  EVAL
  R>OBJ ?SEMI
  CLRCOMPLEX
;

**********************************************************************
* Desc:		Evaluate next runstream object in real mode.
* Stack:
**********************************************************************
LABEL REALEVAL7
::
  'R
  COMPLEX?
  OBJ>R
  CLRCOMPLEX		( prg )
  EVAL			( )
  R>OBJ NOT?SEMI	
  SETCOMPLEX
;

**********************************************************************
* Desc:		Evaluate next runstream object without step by step mode
* Stack:
**********************************************************************
LABEL NOSTEPEVAL7
::
  'R
  stepflag TestSysFlag NOTcase EVAL
  stepflag ClrSysFlag
  EVAL
  stepflag SetSysFlag
;

**********************************************************************
* Desc:		Evaluate next runstream object in non recursive mode.
* Stack:
**********************************************************************
LABEL NONRECURSIVEEVAL
::
  'R
  nonrecurflag TestSysFlag case EVAL
  nonrecurflag SetSysFlag
  EVAL
  nonrecurflag ClrSysFlag
;

