INCLUDE cas2romid.h
INCLUDE erextdec.h
INCLUDE cas2ext.h
INCLUDE keydefs.h
INCLUDE global.s

	STITLE Integration

  DEFINE savevx 18GETLAM
  DEFINE rvx 17GETLAM
  DEFINE rck 16GETLAM
  DEFINE discontinu 15GETLAM
  DEFINE rr# 14GETLAM
  DEFINE dlvar 13GETLAM
  DEFINE rprof 12GETLAM
  DEFINE rcos 11GETLAM
  DEFINE rarg 10GETLAM
  DEFINE rischflag 9GETLAM
  DEFINE coeflog 8GETLAM
  DEFINE autolog 7GETLAM
  DEFINE type 6GETLAM
  DEFINE laurent 5GETLAM
  DEFINE ratpart 4GETLAM
  DEFINE temp_stor 3GETLAM
  DEFINE lvar_val 2GETLAM
  DEFINE depth_val 1GETLAM
  DEFINE savevx! 18PUTLAM
  DEFINE rvx! 17PUTLAM
  DEFINE rck! 16PUTLAM
  DEFINE discontinu! 15PUTLAM
  DEFINE rr#! 14PUTLAM
  DEFINE dlvar! 13PUTLAM
  DEFINE rprof! 12PUTLAM
  DEFINE rcos! 11PUTLAM
  DEFINE rarg! 10PUTLAM
  DEFINE rischflag! 9PUTLAM
  DEFINE coeflog! 8PUTLAM
  DEFINE autolog! 7PUTLAM
  DEFINE type! 6PUTLAM
  DEFINE laurent! 5PUTLAM
  DEFINE ratpart! 4PUTLAM
  DEFINE temp_stor! 3PUTLAM
  DEFINE lvar_val! 2PUTLAM
  DEFINE depth_val! 1PUTLAM

LABEL casinfo!
::						( symb str )
  rischstepout					( symb )
  rvx INText					( int )
;

LABEL rischstep
* obj, # -> obj
::
  stepflag TestSysFlag NOTcaseDROP	( -> obj )
  GETERABLEMSG rischstepout		( obj )
;

NULLNAME rischstepout
* symb, str -> symb
::						( symb str )
  XGROBext OVER XGROBext GROBADDext		( symb grob )
  CONTEXT@ OBJ>R CASDIR				( symb grob )
  ' ID CASINFO DUPUNROT 			( sym id grob id )
  SAFE@ IT casinfoadd				( sym id grob )
  stepflag TestSysFlag IT :: DUP SCROLLext ;	( sym id grob )
  SWAP STO					( sym )
  R>OBJ CONTEXT!
;

LABEL casinfoadd
* grob2 grob1 -> grob1+2
* grob2 obj -> grob2
:: 
  DUPTYPEGROB? NOTcaseDROP 
  SWAP GROBADDext 
; 

NULLNAME addtSIGNonly
::
  addt: xSIGN
;

NULLNAME obj2-meta1
::
  ( obj, meta -> meta )
  get1
  DUPEQ: Z0
  casedrop metackneg
  SYMBINCOMP pshtop& addt-
;

LABEL LVARXNXSQRT
* List of var depending on x, sqrt is like a rational operator
:: 
  DUP LISTOPext ' x\v/ >TCOMP	( symb symb {} )
  LVARXNX2ext			( symb x lvarnx lvarx )
;

LABEL Tryfuu'
( symb x lvarnx lvarx -> symb TRUE )
( symb x lvarnx lvarx -> symb x lvarnx lvarx FALSE )
* Algorithm: try for all var of lvarx (except x)
* if symb/var' is a function of var, i.e. lvarx[symb/var']=var
::
  FALSE OVER LENCOMP		( symb x lvarnx lvarx false # )
*  DUP#1= caseDROP		( -> symb x lvarnx lvarx false )
				( symb x lvarnx lvarx false # )
  DUP THREE #> caseDROP		( -> symb x lvarnx lvarx false )
				( symb x lvarnx lvarx false # )
  #1+_ONE_DO (DO)		( symb x lvarnx lvarx false )
    DROP DUPINDEX@ NTHCOMPDROP	( symb x lvarnx lvarx var )
    Tryfuu'n 			( symb x lvarnx lvarx false | int true )
    :: NOTcaseFALSE ExitAtLOOP TRUE ;			
  LOOP				( symb x lvarnx lvarx false | int true )
  ( * if symb ends with / or * add tests * )
  caseTRUE
				( symb x lvarnx lvarx )
  4PICK LASTCOMP		( symb x lvarnx lvarx op )
  DUPEQ: x/ casedrop Tryfuu'/
				( symb x lvarnx lvarx op )
  EQ: x* NOTcaseFALSE
				( symb x lvarnx lvarx )
  4PICK EXPR> 2DROP		( symb x lvarnx lvarx arg1 arg2 )
  OBJ>R Tryfuu'*/		( sym x lvarnx lvarx false | int true )
  R>OBJ SWAP			( sym x lvarnx lvarx arg false | int arg true )
  case DROPTRUE			( -> int true )
  Tryfuu'*/
;

LABEL Tryfuu'*/
* like Tryfuu'! but simplify arg before and check that arg is binary op[]
::
  SIMPLIFYARG DUP LAST_BINARY6? 
  NOTcase DROPFALSE
  Tryfuu'!
;

LABEL LAST_BINARY6?
* obj -> ?
* true if obj is a symbolic ending with a binary op
::
  DUPTYPESYMB? NOTcase DROPFALSE
  LASTCOMP enumargs SWAPDROP #2=
;

LABEL Tryfuu'/
::				( symb x lvarnx lvarx )
  4PICK EXPR> 2DROP		( symb x lvarnx lvarx num deno )
  SWAPDROP Tryfuu'*/
;

LABEL Tryfuu'n
::					( symb x lvarnx lvarx var )
  4PICK EQUALcasedro FALSE		( -> symb x lvarnx lvarx flag )
    					( symb x lvarnx lvarx var )
  ( * if var is an XROOT, call SIMPLIFYARG * )
  DUP LASTCOMP EQ: xXROOT IT SIMPLIFYARG ( symb x lvarnx lvarx var )
  4PICK EQUALcasedro FALSE		( -> symb x lvarnx lvarx flag )
					( symb x lvarnx lvarx var )
  ( * first try with argument of var * )
  DUP OBJ>R				( symb x lvarnx lvarx var )
  INNERCOMP #1-SWAP OVER#2+UNROLL 	( symb x lvarnx lvarx op arg-meta )
  CKSYMBN SWAP 				( symb x lvarnx lvarx arg op )
  enumargs #1= SWAPDROP			( symb x lvarnx lvarx arg ? )
  ITE argTryfuu'! DROPFALSE		( sym x lvarnx lvarx false | int true )
  R>OBJ SWAP			( sym x lvarnx lvarx var false | int var true )
  case DROPTRUE				( -> int true )
					( symb x lvarnx lvarx var )
  ( * then try with the whole var * )
  Tryfuu'!				( -> )
;

LABEL argTryfuu'!
::					( symb x lvarnx lvarx arg )
  ( * first simplify arg: remove NEG, int power, and * or / cst * )
  SIMPLIFYARG				( symb x lvarnx lvarx arg )
  ( * test for a linear sqrt * )
  ISSQRTOFLINEAR? case ISSQRTOFLIN	( -> int true )
					( symb x lvarnx lvarx arg )
  LVARXNXext		( symb x lvarnx lvarx arg x arglvarnx arglvarx )
  UNROT2DROP				( symb x lvarnx lvarx arg arglvarx )
  DUPNULL{}? case2drop FALSE		( -> symb x lvarnx lvarx false )
  ( * if arg=arglvarx only 1 test, else 2 tests * )
  DUP CARCOMP 3PICK EQUAL		( symb x lvarnx lvarx arg arglvarx ? )
  casedrop Tryfuu'!
					( symb x lvarnx lvarx arg arglvarx )
  OBJ>R Tryfuu'! 			( sym x lvarnx lvarx false | int true )
  R>OBJ SWAP	( sym x lvarnx lvarx arglvarx false | int arglvarx true )
  case DROPTRUE				( -> int true )
					( sym x lvarnx lvarx arglvarx )
  DUPLENCOMP #1= NOTcase DROPFALSE	( -> symb x lvarnx lvarx false )
  CARCOMP Tryfuu'!
;

LABEL ISSQRTOFLINEAR?
* arg -> arg false
::
  DUPTYPESYMB? NOTcaseFALSE		( -> symb false )
  DUP LASTCOMP EQ: x\v/ NOTcaseFALSE	( -> symb false )
  DUPINCOMP pulldrop CKSYMBN		( symb arg_sqrt )
  DUP rischlin?				( symb arg a ?lin )
  NOTcase2drop FALSE			( -> symb false )
  TRUE					( symb arg a ?lin )
;

LABEL ISSQRTOFLIN
* replace var by x, x by 
::					( symb x lvarnx lvarx var arg a )
  ' x\v/ temp_stor! inv_trig_lin TRUE	( -> int true )
;

LABEL SIMPLIFYARG
* symb -> symb
::
  SYMBINCOMP DUP1LAMBIND 
  simplifyarg ABND CKSYMBN
;

LABEL simplifyarg
* meta -> meta
* lam1 must be bound
::
  M1stNEGcase simplifyargNEG
  M1st*case simplifyarg*
  M1st/case simplifyarg*
  M1st^case simplifyarg^
  AEQ1stcase xXROOT simplifyargXROOT
;

LABEL simplifyargNEG
:: pulldrop simplifyarg ;

LABEL simplifyarg*
::
  ( * test if one of both arg is cst * )
  #1-SWAP 1PUTLAM pshzerpsharg	( meta1 meta2 )
  meta_cst?			( meta1 meta2 ? )
  case NDROPsimplifyarg ( simplifyarg?/ )
  psh meta_cst?
  case NDROPsimplifyarg 
  top& 1GETLAM SWAP#1+
;

*LABEL simplifyarg?/
*:: NDROPsimplifyarg 1GETLAM EQ: x* ?SEMI addt: xINV ;

LABEL simplifyarg^
:: 
  pulldrop larg 		( meta-arg meta^ )
  simplifyarg^XROOT
;

LABEL simplifyargXROOT
::
  pulldrop pshzerpsharg 	( meta-arg meta^ )
  simplifyarg^XROOT
;

LABEL simplifyarg^XROOT
::
  ( * if meta-arg is linear wrt to X keep unchanged, else remove int power * )
  OVER TYPEZINT? NOTcase :: top& addt^ ;
  RCLVX 1PUTLAM 		( meta-arg meta^ )
  psh dup unrot			( meta-arg meta^ meta-arg )
  METADERIV METADERIV		( meta-arg meta^ meta-arg'' )
  OVER OVER#2+UNROLL NDROP	( meta-arg meta^ ob )
  Z0 EQUAL NOTcase NDROPsimplifyarg	( meta-arg )
  top& addt^			( orig-meta )
;

LABEL NDROPsimplifyarg
:: NDROP simplifyarg ;

LABEL Tryfuu'!
::					( symb x lvarnx lvarx var )
  4PICK EQUALcasedro FALSE		( -> symb x lvarnx lvarx false )
    					( symb x lvarnx lvarx var )
  5PICK OVER 				( symb x lvarnx lvarx var symb var )
  6PICK DIRECTDERIV			( symb x lvarnx lvarx var symb var' ) 
  NDXFext OVER				( sym x lvnx lvarx var symb/var' var )
  ( * if var is a trig var apply sin^2+cos^2=1 identity * )
  Tryfuu'simp				( sym x lvnx lvarx var symb/var' )
  OVER 'ID210 MEVALext			( symb x lvarnx lvarx var symb' )
  RISCHSIMP				( symb x lvarnx lvarx var symb' )
  5PICK Contains? SWAPDROP		( symb x lvarnx lvarx var symb' ? )
  case2drop FALSE			( -> symb x lvarnx lvarx false )
  					( symb x lvarnx lvarx var symb' )
  OVER BINT84 rischstep DROP		( symb x lvarnx lvarx var symb' )
  2SWAP 2DROP				( symb x var symb' )
  4ROLLDROP				( x var symb' )
  'ID210 4PICK REPLACE2BY1		( x var symb'' )
  risch0!				( x var int )
  UNROT MEVALext TRUE			( int' TRUE )
;


LABEL Tryfuu'simp
* symb, var -> symb'
* if var is SIN/COS/TAN presimplifies trig expr
::
  DUPTYPESYMB? NOTcase2DROP		( -> symb )
					( symb var )
  LASTCOMP				( symb op )
  { xTAN xCOS xSIN } TOTEMPOB ListPos	( symb # )
  DUP#0= caseDROP			( -> symb )
					( symb # )
  DUP#1= casedrop Tryfuu'tan
					( symb # )
  prefersinflag TestSysFlag UNROT	( ? symb # )
  prefersinflag SWAP #3=		( ? symb # ? )
  ?RESTOREFLAG				( ? symb )
  { x^ xTAN } TOTEMPOB
  { FLASHPTR TRIGPOW FLASHPTR sin/cos } TOTEMPOB 
  REPLACE2BY1				( ? symb' )
  prefersinflag ROT ?RESTOREFLAG	( symb' )
;

LABEL Tryfuu'tan
::					( symb )
  ' x^ ' FLASHPTR TRIGTAN^ TOTEMPOB REPLACE2BY1		( symb' )
;

LABEL ?RESTOREFLAG
( # ? -> )
* set/clear flag # according to flag ?
:: case SetSysFlag ClrSysFlag ;

LABEL rischsimpden
* simplifies symb and tests if denominator is constant
::				( symb, x, lvarnx, lvarx )
  2DUPSWAP &COMP		( symb, x, lvarnx, lvarx, lvar )
  5ROLL SWAP VXXLext		( x, lvarnx, lvarx, lvar, symb-liste )
  DUPROT lvar_val! VAL1		( x, lvarnx, lvarx, symb-liste, symb )
  5UNROLL FXNDext SWAPDROP	( symb, x, lvarnx, lvarx, deno-liste )
;

LABEL RISCHSIMP
:: ZEROSWAP LVARext VXXLext SWAP VAL2ext ; 

LABEL tan_in?
( {} -> {} FALSE | {} _tan TRUE )
::
  DUP' IS_TAN? Find1stTrue
;

LABEL IS_TAN?
::
  DUPTYPESYMB? NOTcase DROPFALSE
  LASTCOMP EQ: xTAN
;

LABEL tan_in
::					( symb x lvarnx lvarx tan )
  OVER LENCOMP #1= NOTcasedrop tan_out
  INNERCOMP pulldrop CKSYMBN		( symb x lvarnx lvarx arg_tan )
  rischlin?				( symb x lvarnx lvarx a ? )
  NOTcasedrop tan_out
  RDROP					( symb x lvarnx lvarx a )
  5UNROLL ROTDROP 			( a symb lvarnx lvarx )
  SWAP &COMP				( a symb lvar )
  SWAPOVER CARCOMP 			( a lvar symb tan )
  2SYMBINCOMP metasq+1 metadiv CKSYMBN	( a lvar symb/[1+t^2] )
  OVER RISCHPF				( a int )
  SWAP x/ext
;

LABEL tan_out
::					( symb x lvarnx lvarx )
  3DROP HYP2EXPext LVARXNXext		( symb x lvarnx lvarx )
;

LABEL nonint_pow?
( {} -> {} FALSE | {} _pow TRUE )
::
  DUP' nonint_pow_in? Find1stTrue
;

LABEL nonint_pow_in?
( obj -> flag )
::
  DUPTYPESYMB? NOTcase DROPFALSE
  DUP LASTCOMP EQ: xEXP 		( symb ? )
  NOTcase DROPFALSE
  					( symb )
  ' xLN ' EQ POSCOMP #0<>		( ? )
;

LABEL nonint_pow2
* special cases with >=2 rational powers
::					( symb x lvarnx lvarx var )
  ( * first test: if dotsimp exit with no more xroot, stop here * )
  4PICK EQUALcasedro NOP		( -> symb x lvarnx lvarx )
					( symb x lvarnx lvarx var )
  ( * now we might look for x^n*[a+b*x^m]^p or non-linear powers * )
  DROP
;

LABEL nonint_tsimp
* calls TSIMP to recognize e.g x^(3/4)=x^(1/4)^3
::					( symb x lvarnx lvarx var )
  OVER LENCOMP DUP#1= caseDROP		( -> symb x lvarnx lvarx var )
					( symb x lvarnx lvarx var # )
  #2= NOTcase nonint_dotsimp
					( symb x lvarnx lvarx var )
  OVER LASTCOMP 			( symb x lvarnx lvarx var var' )
  5PICK EQUAL 				( symb x lvarnx lvarx var var'=x )
  ?SEMI					( -> symb x lvarnx lvarx var )
  nonint_dotsimp
;

LABEL nonint_dotsimp
::					( symb x lvarnx lvarx var )
  4DROP TSIMPext EXP2POW LVARXNXext	( symb x lvarnx lvarx )
  XROOT_IN?				( symb x lvarnx lvarx [false| pow tr] )
  ?SEMI					( -> symb x lvarnx lvarx var )
					( symb x lvarnx lvarx )
  3DROP SIGMAEXPext LVARXNXext		( symb x lvarnx lvarx )
  3PICK					( symb x lvarnx lvarx x )
;

LABEL nonint_pow
::					( symb x lvarnx lvarx var )
  ( * first TSIMPlify * )
  nonint_tsimp				( symb x lvarnx lvarx var )
  ( * lvarx must be x+var * )
  DUP 5PICK TWO{}N			( symb x lvarnx lvarx var {var x} )
  3PICK 6PICK AppendList EQUAL		( symb x lvarnx lvarx var ? )
  NOTcase nonint_pow2
  ( * look if var is xroot then linear^cst * )
  EXP2POW DUP LASTCOMP 			( symb x lvarnx lvarx var op )
  DUPEQ: xXROOT 			( symb x lvarnx lvarx var op ?xroot )
  casedrop :: RDROP 5UNROLL 3DROP EXP2POW LVARXNXext 5ROLL rischxroot ;
  EQ: x^				( ... var ? )
  NOTcaseDROP
					( ... var )
  EXPR> 2DROP				( ... arg exposant )
  ( * exposant must be cst * )
  DUP rvx DIRECTDERIV Z0 EQUAL		( ... arg exposant ? )
  NOTcase2DROP
  temp_stor! 				( ... arg )
  idntlamcase nonint_powX^N
					( ... arg )
  DUP rcos! rischlin?			( ... a ? )
  NOTcaseDROP
					( symb x lvarnx lvarx a )
  ( * integrable cases are poly*x^cst * )
  ( * note that the current test does not allow over /x^integer * )
					( symb x lvarnx lvarx a )
  ( * stores a  * )
  rarg!  				( symb x lvarnx lvarx )
  rischsimpden is_cst? 			( symb x lvarnx lvarx flag )
  NOT?SEMI				( -> )
  ( * compute b * )
  rarg rvx x*ext rcos x-ext SIMPLIFY 	( symb x lvarnx lvarx -b )
  RDROP ROTDROP				( symb x lvarx -b )
  3PICK x+ext rarg x/ext		( symb x lvarx [x-b]/a )
  ROT temp_stor x^ext			( symb lvarx newx newx^n )
  SWAP TWO{}N SWAP rvx AppendList	( symb newlvarx lvarx )
  SWAP rischmeval rarg x/ext 		( symb )
  rcos SWAP risch1!			( ax+b int )
  rvx ROT REPLACE2BY1			( int )
  EXP2POW
;

LABEL nonint_powX^N
* integration of poly[X^N]: N is in temp_stor
::					( symb x lvarnx lvarx x )
  DROP rischsimpden is_cst? NOT?SEMI
					( symb x lvarnx lvarx )
  RDROP ROT AppendList SWAP &COMP	( symb lvar )
  VXXLext FXNDext SWAP			( lvar d n )
  CKINNERCOMP reversym #1- DUP#1+	( lvar d n0..nk #k #k+1 )
  ZERO_DO				( lvar d n0..nk #k )
    get1 temp_stor INDEX@ #>Z x*ext	( lvar d n1..nk #k n0 N )
    nonint_powint			( lvar d n1..nk #k n0 )
  SWAPLOOP				( lvar d n0..nk #k )
  #1+ reversym {}POLY 			( lvar d n )
  SWAP NDXFext R2SYM EXP2POW		( res )
;

LABEL nonint_powint
* n0, N -> int n0*X^N
::
  1LAMBIND 
  CKINNERCOMP reversym #1- DUP#1+	( n00..n0k #k #k+1 )
  #1+_ONE_DO				( n00..n0k #k )
    get1 1GETLAM INDEX@ #>Z x+ext	( n01..n0k #k n00 N+1 )
    x/ext				( n01..n0k #k n00/N+1 )
  SWAPLOOP				( n00 n01..n0k #k )
  ABND #1+ reversym Z0 SWAP#1+ >POLYTRIM	( n )
;

LABEL inv_trig?
( {} -> {} FALSE | {} inv_trig TRUE )
::
  DUP' inv_trig_in? Find1stTrue
;

LABEL inv_trig_in?
( obj -> flag )
::
  DUPTYPESYMB? NOTcase DROPFALSE
  LASTCOMP { xASIN xACOS xATAN } SWAP' EQ POSCOMP #0<>
;

* inv_trig function found, deno must be constant / invert function
( symb, x, lvarnx, lvarx -> symb )
LABEL inv_trig
::
  ( * put inv trig function in front of lvarx * )
				( symb x lvarnx lvarx )
  inv_trig? NOTcase INTERNALERR
				( symb x lvarnx lvarx trig )

  ( * if argument of ASIN/ACOS/ATAN is linear, then do x=sin/cos[y] * )
  DUPINCOMP #1-SWAP temp_stor! CKSYMBN	( symb x lvarnx lvarx trig arg_trig )
  ( * if argument is ATAN do IBP * )
  temp_stor EQ: xATAN casedrop RISCHIBP
				( symb x lvarnx lvarx trig arg_trig )
  DUP rischlin?			( symb x lvarnx lvarx trig arg_trig a ? )
  NOTcase2drop RISCHIBP
				( symb x lvarnx lvarx trig ax+b a )
  inv_trig_lin
;

LABEL inv_trig_lin
::				( symb x lvarnx lvarx trig ax+b a )
  SWAP SYMBINCOMP		( symb x lvarnx lvarx trig a meta-ax+b )
  DUP#2+PICK SYMBINCOMP		( symb x lvarnx lvarx trig a m-ax+b m-a )
  rvx ONE MetaMul MetaSub	( symb x lvarnx lvarx trig a meta-b )
  metasimp CKSYMBN		( symb x lvarnx lvarx trig a b )
  rvx ONE			( symb x lvarnx lvarx trig a b x #1 )
  temp_stor { xASIN xSIN xACOS xCOS x\v/ xSQ } 
  EQLookup NcaseSIZEERR
				( symb x lvarnx lvarx trig a b x #1 op )
  SWAP#1+			( symb x lvarnx lvarx trig a b meta-sin[x] )
  get1 SYMBINCOMP MetaSub	( symb x lvarnx lvarx trig a meta-sin[x]-b )
  get1 SYMBINCOMP MetaDiv	( symb x lvarnx lvarx trig meta-sin[x]-b/a )
  CKSYMBN 2SWAP 2DROP		( symb x trig sin[x]-b/a )
  ( * transform all asin/acos as asin or acos * )
  4ROLL				( x trig sin[x]-b/a symb )
  temp_stor { xASIN ACOS2Sext xACOS ASIN2Cext }
  EQLookup ITE EVAL DROP
  4PICK 4PICK			( x trig sin symb x trig )
  TWO{}N			( x trig sin symb {x,trig} )
  3PICK 6PICK TWO{}N		( x trig sin symb {x,trig} {sin,x} )
  rischmeval			( x trig sin symb' )
  SWAP rvx DIRECTDERIV x*ext	( x trig symb" )
  risch1!			( x trig integral )
  UNROT RISCHREPLACE2BY1	( integral )
;

LABEL RISCHREPLACE2BY1
::				( symb x newx )
  ' x\v/ ROT TWO{}N		( symb newx {sqrt,x} )
  ' addtSQRTonly7 ROT TWO{}N	( symb {sqrt,x} {sqrt,newx} )
  REPLACE2BY1			( result )
;

LABEL RISCHIBP
::				( symb x lvarnx lvarx trig )
  prepvarlist			( symb x lvarnx lvarx )
  ROTDROPSWAP &COMP		( symb lvar )
  OVERSWAP VXXLext		( symb lvar n/d )
  RISCH13 DUPTYPELIST?		( symb lvar P ? )
  NOTcase2drop rvxINT		( -> int[symb,x] )
  ROTDROP			( lvar P )
  OVER CDRCOMP			( lvar P lvar' )
  ONE UNROT VAL2ext		( lvar {} )
  SWAP CARCOMP			( {} trigvar )
  Z0 ROT			( trigvar res {} )
  [BEGIN]
    DUPLENCOMP #1=
  NOT_WHILE
    inv_triglp
  [REPEAT]			( trigvar res {} )
  CARCOMP risch0! x+ext		( trigvar res )
  SWAPDROP			( res )
;

LABEL rvxINT
:: rvx INText ;

LABEL inv_triglp
( trigvar res {} -> trigvar res' {}' )
* integration by part of the n-th power
::				( trigvar res {} )
  DUP CDRCOMP			( trigvar res {} {}' )
  UNROT CARCOMP			( trigvar {}' res u' )
  DUP risch0!			( trigvar {}' res u' u )
  ( * look if integration was successfull * )
  ' 
ASSEMBLE
	IF	f39
RPL
  xint
ASSEMBLE
	ELSE	f39
RPL
  xINT
ASSEMBLE
	ENDIF	f39
RPL
  Contains? SWAPDROP		( trigvar {}' res u' u flag )
  casedrop invtriglpint
  ( * int was successfull, do integration by part * )
				( trigvar {}' res u' u )
  BINT85 rischstep		( trigvar {}' res u' u )
  SWAPDROP 4PICK		( trigvar {}' res u "v" )
  2DUP				( trigvar {}' res u "v" u "v" )
  6PICK LENCOMP #>Z x^ext	( trigvar {}' res u "v" u v )
  x*ext 4ROLLSWAP x+ext		( trigvar {}' u "v" res+u*v^# )
  4UNROLL rvx DIRECTDERIV		( trigvar res' {}' u "v'" )
  3PICK LENCOMP #>Z x*ext	( trigvar res' {}' u "v'"*# )
  x*ext				( trigvar res' {}' u*"v'"*# )
  SWAPDUP CARCOMP		( trigvar res' u*"v'"*# {}' coef )
  ROT x-ext SIMP1ext		( trigvar res' {}' coef-u*"v'*#" )
  ONE ROT PUTLIST		( trigvar res' {}' )
;

LABEL invtriglpint		
::				( trigvar {}' res u' )
  2OVER LENCOMP #>Z x^ext	( trigvar {}' res u' trigvar^# )
  x*ext rvxINT x+ext		( trigvar {}' res+int[u'*trigvar^#] )
  SWAP				( trigvar res' {}' )
;

*LABEL extractP#
*:: 
*  DUP#0=csDROP			( -> ... extract )
*  SWAPDUP CARCOMP		( ... # extract extract.n )
*  ROT #1- extractP#		( ... extract extract.n' )
*  Z0 ROT LENCOMP		( ... extract.n' 0 #n )
*  #1- NDUPN #1+ {}POLY		( ... extract.n' )
*;


**************************
* For non symbolic input, we have only to test
* if object=var of integration
****************************
NULLNAME risch0!
::
  DUPTYPESYMB? case risch0symb!
  rvx 2DUP EQUALNOTcase x*ext
  DROPONE addt: xSQ addt2: Z2 x/ CKSYMBN
;

************************************
* Testing for linearity + - NEG
****************************
LABEL risch0symb!
::			( obj -> primitive )

* if pfexpaflag is set, do not test for linearity +,-,NEG

  pfexpaflag TestSysFlag case risch1!
  ' risch1! DUP
  LINEARAPPLY
;


LABEL UNARYOFLINEAR?
* symb -> int true | symb false
::
  DUPINCOMP				( symb meta )
  #1-SWAP enumargs #1=			( symb meta-args op ? )
  NOTcasedrop NDROPFALSE		( -> symb false )
  					( symb meta-arg op )
  OBJ>R dup CKSYMBN R>OBJ SWAP rischlin?	( symb meta-arg op a ? )
  NOTcase2drop NDROPFALSE		( -> symb FALSE )
  					( symb meta-arg op a )
  num#0=case7 :: 2DROP NDROP FALSE ;	( -> symb FALSE )
					( symb meta-arg op a )
  SWAP UNARYORLINEARLIST		( symb meta-arg a op {} )
  EQLookup 			( symb meta-arg a [ prg true | op false ] )
  case UNARYOFLINEAR
  2DROP NDROP FALSE			( symb false )
;

LABEL UNARYOFLINEAR
::					( symb meta-arg a prg )
  SWAP OBJ>R EVAL R>OBJ	SYMBINCOMP	( symb meta-int meta-a )
  MetaDiv CKSYMBN SWAPDROP TRUE		( int true )
;

LABEL UNARYORLINEARLIST
{ 
  xSIN INTOFSIN
  xCOS addtSIN
  xTAN INTOFTAN
  xEXP addtEXP
  xLN INTOFLN
  xSQ INTOFSQ
  x\v/ INTOFSQRT
*  xSINH addtCOSH
*  xCOSH addtSINH
*  xTANH :: addt: xCOSH addtLNrisch ;
  xASIN INTOFASIN
  xACOS INTOFACOS
  xATAN INTOFATAN
*  xABS INTOFABS
}

LABEL INTOFSIN
:: addt: xCOS MetaNeg ; 

LABEL INTOFTAN
:: addt: xCOS addtLNrisch MetaNeg ;

LABEL INTOFLN
:: dup dup addt: xLN MetaMul psh MetaSub ;

LABEL INTOFASIN
:: INTOFASINACOS xASIN MetaMul MetaAdd ;

LABEL INTOFACOS
:: INTOFASINACOS xACOS MetaMul psh MetaSub ;

LABEL INTOFASINACOS
:: dup dup meta1-sq addt: x\v/ unrot 'R SWAP#1+ ;

*LABEL INTOFABS
*:: dup addt: xABS MetaMul Z2 ONE MetaDiv ;

LABEL INTOFATAN
:: 
  dup dup metasq+1 addtLNrisch Z-2 
  ONE MetaDiv unrot addt: xATAN MetaMul MetaAdd 
;

LABEL INTOFSQ
:: Z3 SWAP#1+ addt: x^ Z3 ONE MetaDiv ;

LABEL INTOFSQRT
:: dup addt: x\v/ MetaMul Z2 Z3 ' x/ THREE psh MetaMul ;

LABEL addtLNrisch
:: COMPLEX? ?SKIP addtABSrisch addt: xLN ;

*******************************
* Main integration routine
* Dispatchs depending on integration type
*************************************
LABEL risch1!
::				( symb -> primitive )
* test unary op of linear for fast int
  UNARYOFLINEAR? ?SEMI
				( symb )
  LVARXNXext			( symb, x, lvarnx, lvarx )
  DUPNULL{}? case2drop x*ext
* teste fraction rationnelle
				( symb, x, lvarnx, lvarx )
  rvx ONE{}N
  EQUALcasedro
  :: SWAP>HCOMP			( symb, lvar )
     DUPUNROT RISCHPF
  ;
				( symb, x, lvarnx, lvarx )
* f[u]*u'?

  Tryfuu' ?SEMI
				( symb, x, lvarnx, lvarx )
  EXACT? NOTcase2drop 
  :: 
    BINT100 GETERABLEMSG 
ASSEMBLE
	IF	f39
RPL
   Ck&DoMsgBox 
ASSEMBLE
	ELSE	f39
RPL
   FLASHPTR Ck&DoMsgBox 
ASSEMBLE
	ENDIF	f39
RPL
  INText 
  ;
* tests for inverse trigo functions

  inv_trig? casedrop inv_trig
				( symb x lvarnx lvarx )
* tests for square root and xroot
				( symb x lvarnx lvarx )
  XROOT_IN? case rischxroot
				( symb x lvarnx lvarx )
  SQRT_IN?			( symb x lvarnx lvarx [varsqrt true | false] )
  case rischsqrt!
				( symb x lvarnx lvarx )
  risch2!
;

LABEL CONTAINS_LNOFX?
* symb -> ?
::					( symb )
  DUPTYPESYMB? NOTcase DROPFALSE	( -> false )
  INNERCOMP 				( meta )
  AEQ1stcase xLN :: NDROP TRUE ;	( -> true )
					( meta )
  OVER enumargs SWAPDROP #1= NcaseSIZEERR
  pulldrop CKSYMBN 			( symb )
  LVARXNXext 4UNROLL3DROP		( lvarx )
  ' CONTAINS_LN? Find1stTrue 		( false | ln true )
  NOTcaseFALSE				( -> false )
					( ln )
  DROPTRUE				( -> true )
;

LABEL risch2!
::				( symb, x, lvarnx, lvarx )
* tests for non int power
  nonint_pow?			( symb x lvarnx lvarx [var true | false] )
  IT nonint_pow			( symb x lvarnx lvarx )

* test fo TAN: if TAN[linear] alone solves else TAN -> SIN/COS of 2*angle
  tan_in? IT tan_in

* tests for "forbidden operators"
  DUP LISTOPext { xEXP xLN xSIN xCOS xSIGN xe x\pi } &COMP
  LVARDext ' ISNT_IDNT? Find1stTrue

( symb, x, lvarnx, lvarx, {}, [obj, true | false ] )

  case
  :: 4DROP DUP DO>STR " not handled" &$ casinfo! ;

* tests for LN, -> Risch algorithm

					( symb, x, lvarnx, lvarx )
  DUP' CONTAINS_LNOFX? Find1stTrue
  casedrop rrisch!

* tests for constant denominator

  rischsimpden is_cst? 			( symb, x, lvarnx, lvarx, flag )
  case rischcst!

* non constant denominator: tries to have less variables by expanding
* transcendental functions
					( symb x lvarnx lvarx )
  UNROT2DROP LENCOMP #1= ?SKIP TEXPAext	( symb )
  LVARXNXext				( symb x lvarnx lvarx )
  DUPDUP LENCOMP			( symb x lvarnx lvarx lvarx # )
  TWO #> casedrop rrisch!		( symb x lvarnx lvarx lvarx )
  INNERCOMP #1=case try_rat_frac!	( symb x lvarnx lvarx varx1 varx2 )
  DUPTYPESYMB? NOTcase2drop rrisch!
  EXPR> SWAP
  %1 %= NOTcase2drop droprrisch!
					( symb x lvarnx lvarx varx1 arg2 op )
  EQ: xCOS NOTcase2drop rrisch!
					( symb x lvarnx lvarx varx1 arg2 )
  DUP rischlin?				( symb x lvarnx lvarx varx1 arg2 a2 ?lin )
  NOTcase2drop droprrisch!
					( symb x lvarnx lvarx varx1 arg2 a2 )
  ROT					( symb x lvarnx lvarx arg2 a2 varx1 )
  DUP EXPR> SWAP %1 %= 
  NOTcase NONUNARYERR
				( symb x lvarnx lvarx arg2 a2 varx1 arg1 op )
  EQ: xSIN NOTcase2drop 2droprrisch!
					( symb x lvarnx lvarx arg2 a2 varx1 arg1 )
  4ROLL EQUAL				( symb x lvarnx lvarx a2 varx1 ?arg1=arg2 )
  NOTcase2drop rrisch!
					( symb x lvarnx lvarx a2 varx1 )
  ROTDROP 5ROLL ROT x/ext		( x lvarnx varx symb/a )
  RISCHTRIG
;


LABEL is_cst?
( lvarx, deno -> lvarx, flag )
* looks if deno is cst with respect to lvarx
::
  NOTLISTcase DROPTRUE
  ZEROSWAP				( lvarx, #0, deno )
  BEGIN
  ::
    NOTLISTcase FALSE
    DUPLENCOMP #1=
  ;
  WHILE
    CARCOMP SWAP#1+SWAP
  REPEAT
					( lvarx, #, obj )
  TYPELIST? NOTcasedrop TRUE
					( lvarx, # )
  OVER LENCOMP #< NOT
;


LABEL try_rat_frac!
::				( symb, x, lvarnx, lvarx, varx )
  symcomp DUP EXPR>		( symb, x, lvarnx, lvarx, varx, arg, %, op )
  SWAP %1 %= NOTcase NONUNARYERR
  EQ: xEXP SWAP			( symb, x, lvarnx, lvarx, varx, ?exp, arg )
  rischlin?			( symb, x, lvarnx, lvarx, varx, ?exp, a, ?lin )
  NOTcase2drop droprrisch!
				( symb, x, lvarnx, lvarx, varx, ?exp, a )
  4ROLLDROP 6ROLL 		( x, lvarnx, varx, ?exp, a, symb )
  SWAP x/ext SIMPLIFY		( x, lvarnx, varx, ?exp, symb/a )
  SWAP NOTcase RISCHTRIG

* fraction of linear exp
				( x, lvarnx, varx, symb/a )
  2SWAP 2DROP OVER x/ext	( varx, symb/a )
  LVARext ROT prepvarlist 	( symb/a lvar )
  DUPUNROT RISCHPF
;


LABEL rischlin?
::				( arg -> a, ?lineaire )
  rvx DIRECTDERIV SIMPLIFY	
  DUP rvx DIRECTDERIV
  Z0 EQUAL
;

LABEL RISCHTRIG
( x, lvarnx, varx, symb/a -> int )
* lam must be bound, see CAS/integr.s
::
( * for fr[sinx,cosx] we make the var change t=tan[x/2] )
					( x, lvarnx, varx, symb/a )
  4ROLLDROP SWAPINCOMP			( lvarnx symb/a o1 ... on #n )
  SWAPDROP ' xSIN SWAP SYMBN		( lvarnx symb/a sin )
  DUPINCOMP SWAPDROP ' xCOS SWAP SYMBN	( lvarnx symb/a sin cos )
  DUPINCOMP pulldrop meta/2 metasimp	( lvarnx symb/a sin cos meta-x/2 )
  addtTAN SYMBN				( lvarnx symb/a sin cos tan )
  4UNROLL TWO{}N			( lvarnx tan symb/a {sin cos} )
  'IDt6 ONE				( lvarnx tan symb/a {sc} tan-meta )
  dup Z2 ONE psh metasq+1 metadiv	( lvarnx tan symb/a {sc} t 2/1+t^2-m )
  CKSYMBN OVER #4+ UNROLL		( lvarnx tan 2/1+t^2 symb/a {sc} t )
  dup 2x/1+x^2 CKSYMBN OVER#2+UNROLL	( lvarnx tan 2/1+t^2 symb/a {sc} s )
  1-x^2/1+x^2 CKSYMBN			( lvarnx tan 2/1+t^2 symb/a {sc} s c )
  TWO{}N rischmeval			( lvarnx tan 2/[1+t^2] symb/a )
  x*ext					( lvarnx tan symb )
  ROTDROP LVARext			( tan symb lvar )
  'IDt6 TOTEMPOB prepvarlist		( tan symb lvar_t6 )
  VXXLext SWAP CDRCOMP UNROT		( lvar' tan fraction-l )

* "parity" testing
  PARITYTEST				( lvarnx tan/sin/cos fraction-l )
  OVER BINT90 rischstep DROP		( lvarnx tan/sin/cos fraction-l )
  UNROT >HCOMP				( fraction-l lvar_tan ) 
  SWAP NULL{}				( lvar_tan fraction-l {} )
  RISCHPF				( symb )

* add the "discontinuity killer"

				( symb )
  discontinu j#0=case7 NOP
  lvar_val CARCOMP INNERCOMP	( symb meta )
  OVER EQ: xTAN NOTcase NDROP	( -> symb )
				( symb metaTAN )
  get1 SYMBINCOMP discontinu	( metaTAN meta-symb coeff )
  VAL1M metapi metamult		( metaTAN symb-meta coeff*pi-meta )
  ( * we must multiply by the sign of the coeff of TAN * )
  rot				( symb-meta coeff*pi-meta arg-meta&TAN )
  ' x\pi ROTDROPSWAP		( symb-meta coeff*pi-meta arg-meta&pi )
  addt/ addt2: Z1 Z2
  addt/ addt+			( symb-meta coeff*pi-meta arg/pi+1/2-meta )
  ' xFLOOR SWAP#1+
  metamult metaadd CKSYMBN
;

LABEL 'IDt6
:: ' ID tt TOTEMPOB ;

LABEL intBadSqrt
::			( symb symb x )
  2DROP rvxINT
;

*****************************************
* Integration of F[x,sqrt[ax^2+bx+c]]
* where F is a rational fraction
* To improve: once we have reduced to N/D /sqrt
* make a part frac dec of N/D and use u=1/[x-root] var change 
****************************************
LABEL eventuallynotasqrt
::				( symb lvar D C P y )
  2DROP SWAPNDXF		( symb lvar n/d )
  ROTDROP NULL{}		( lvar n/d {} )
  RISCHPF			( primit )
;


LABEL rischsqrt!
::
					( symb x lvarnx lvarx varsqrt )
  ( * check that the sqrt does not contain x/ * )
  sturmflag TestSysFlag ITE 
  :: ' x/ Contains? SWAPDROP ; FALSE	( symb x lvarnx lvarx varsqrt ? )
  case2drop intBadSqrt
					( symb x lvarnx lvarx varsqrt )
  BINT86 rischstep			( symb x lvarnx lvarx varsqrt )
  ( * test for 1 square root only * )
  4ROLL TWO{}N				( symb lvarnx lvarx { varqsrt x } )
  ROTDROPSWAP DUPLENCOMP #1= 		( symb { } lvarx flag )
  ITE 2DROPTRUE EQUAL			( symb flag )
  NOTcase rvxINT			( -> int ) 
  					( symb )
  ' xSIGN TOTEMPOB
  ' addtSIGNonly TOTEMPOB
  REPLACE2BY1				( simplify symb but keep SIGN )
  DUP LVARXNXSQRT			( symb symb x lvarnx lvarx )
  DUPLENCOMP #1=			( symb symb x lvarnx lvarx flag )
  NOTcase2drop intBadSqrt
  CARCOMP 3PICK EQUAL			( symb symb x lvarnx flag )
  NOTcasedrop intBadSqrt
  SWAP>HCOMP DUP lvar_val! VXXLext	( symb lvar obj )
  FXNDext				( symb lvar N D )
  SWAP QXNDext				( symb lvar D C P y )
  num#1=case7 eventuallynotasqrt

  ( * N=C+P*sqrt[y], first extract rational part * )

  6ROLL DROP				( lvar D C P y )
  ROT 4PICK RDIVext 			( lvar D P y C/D )
  5PICK SWAP NULL{} RISCHPF		( lvar D P y symb )
  5UNROLL				( symb lvar D P y )

  ( * tests for y of order 1 * )

  DUPCKLEN{} #2= case rischsqrt1

  ( * Now extract Laurent series and true rational part * )

  DUP4UNROLL RMULText			( symb lvar y D P*y )
  SIMPext UNROT				( symb lvar P y D )
  ZERO
  BEGIN					( symb lvar P y D #l )
	OVER 4PICK NEWDIVext		( symb lvar P y D #l D/y mod[D,y] )
	Z0 EQUAL			( symb lvar P y D #l D/y flag )
  WHILE
	ROTDROPSWAP #1+			( symb lvar P y D/y #l+1 )
  REPEAT
  DROP					( symb lvar P y D #l )

  ( *    P/Dy^l = P_y/y^l + P_D/D <--> P = P_y*D + P_D*y^l,     	* )
  ( *    find P_D and P_y by Bezout, find				* )
  ( *    g = Q*D+R*y^l then Pg = P*Q*D + P*R*y^l hence             	* )
  ( *    P_D = P*R mod D/g  and  P_y = P*Q /g + [P*R div D] *y^l /g    	* )

  3PICKOVER RP#				( symb lvar P y D #l y^#l )
  DUP 6UNROLL				( ..lvar y^l P y D #l y^#l )
  3PICK EGCDext				( ..lvar y^l P y D #l g R Q )
  SWAP 7PICK RMULText			( ..lvar y^l P y D #l g Q R*P )
  5PICK PSEUDODIV			( ..lvar y^l P y D #l g Q g' quot mod )
  3PICK 6ROLL RMULText			( ..lvar y^l P y D #l Q g' quot mod d )
  7ROLL OVER RMULText			( lvar y^l P y #l Q g' quot mod d dD )
  ROTSWAP RDIVext			( lvar y^l P y #l Q g' quot d P_D/D )
  8ROLL 6ROLL RMULText			( lvar y^l y #l g' quot d P_D/D P*Q )
  5ROLL RMULText			( lvar y^l y #l quot d P_D/D P*Q*g' )
  4ROLL 7PICK RMULText RADDext		( lvar y^l y #l d P_D/D P_y*d ) 

  ( *  int[ P_y/y^l*y^-1/2 ] = Q*y^[1/2-l] + int[ C*y^-1/2 ]    	* )
  ( * degre[P]=n, degre[y]=k, find Q degre[Q]=n+1-k and C degre[C]=k-2 	* )
  ( * so that P = Q'*y + Q*y'*[1/2-l] + C y^l 				* )
  ( * to do this we represent Q by a n+2-k-vector, C by a k-1-vector 	* )
  ( * gluing Q and C we get a n+1-vector that must be solution of a  	* )
  ( * n+1*n+1 linear system. Now we build the matrix of this system  	* )
  ( * The n+2-k first columns are					* )
  ( * y'[1/2-l]  ...  x^alpha*y'*[1/2-l]+alpha*x^[alpha-1]*y ...       	* )
  ( * The k-1 last columns are						* )
  ( * y^l  ...  x^beta*y^l						* )
  ( * Note1: to avoid rational input in the matrix we multiply by 2 	* )
  ( * Note2: coef of Q and C are found in the reverse order		* )
  ( * Note3: for l!=0 n is more precisely max[deg[P],k[l+1]-2]		* )
	
					( symb lvar y^l y #l d P_D/D P_y*d )
  Z2 RMULText				( symb lvar y^l y #l d P_D/D 2*P_y*d )
  6ROLL Z2 RMULText 			( ... y #l d P_D/D P_y*d 2y^l )
  6PICK DUP PDer SWAP Z2 RMULText	( .. y #l d P_D/D P_y*d 2y^l y' 2y )
  Z1 8PICK #>Z Z2 RMULText RSUBext	( ..#l d P_D/D P_y*d 2y^l y' 2y 1-2l )
  ROT RMULText				( ..#l d P_D/D P_y*d 2y^l 2y 1-2l*y' )
  7PICK #1+ 3PICK LENCOMP #1- #* #1-	( .. P_y*d 2y^l 2y 1-2l*y' #kl+k-1 )
  5PICK DUPCKLEN{} SWAPDROP		( .. 2y^l 2y 1-2l*y' #kl+k-1 #n+1 )
  #MAX
	
* {{ y_l yfois2 yprime nplus1 }}
DEFINE y_l 4GETLAM
DEFINE yfois2 3GETLAM
DEFINE yprime 2GETLAM
DEFINE nplus1 1GETLAM
DEFINE y_l! 4PUTLAM
DEFINE yfois2! 3PUTLAM
DEFINE yprime! 2PUTLAM
DEFINE nplus1! 1PUTLAM
  4NULLLAM{} BIND			( symb lvar y #l d P_D/D P_y*d )
  ZERO nplus1 				( ... P_D/D meta-mat #n+1 )
  yfois2 LENCOMP #- #2+			( ... meta-mat #n+2-k )
  ::
    DUP#0=csDROP
    ZERO_DO (DO)			( ... meta-mat )
      yprime INNERCOMP 			( ... meta-mat meta )
      Z0 INDEX@ NDUPN top& {}POLY	( ... meta-mat y'*x^# )
      yfois2 INDEX@ DUP#0= 		( ... meta-mat y'*x^# 2y # flag )
      :: case2DROP 
         #>Z RMULText 			( ... meta-mat y'*x^# 2y*# )
         INNERCOMP Z0 INDEX@ #1- NDUPN
         top& {}POLY RADDext		( ... meta-mat y'*x^#+2y*#*x^#-1 )
      ;
      nplus1 #1- LRDMext
      SWAP#1+				( ... meta-mat )
    LOOP
  ;
  yfois2 LENCOMP #2-			( ... meta-mat #k-1 )
  ZERO_DO (DO)
    y_l CKINNERCOMP Z0 INDEX@ NDUPN
    top& {}POLY
    nplus1 #1- LRDMext
    SWAP#1+
  LOOP					( ... meta-mat )
  get1					( * must convert P to a symb arry * )
  nplus1 #1- LRDMext			( * of the right size * )
  SWAP#1+ mattran			( symb lvar y #l d P_D/D meta-M )

  ( * use of SOLVEMETASYST when CAS2/sum.s is integrated * )
	
  NULL{} ONE NOSTEPEVAL7 METAMATRED 2DROP	( ... reduced-meta-M )

  ( * solves the system * )

  DUP#1+ SWAP#1-SWAP			( ... meta' #n-1 #n+1 )
  ONE_DO 
    get1 DUP LASTCOMP 			( ... meta'' #n-1 li li.n )
    SWAPINDEX@ NTHCOMPDROP RDIVext	( ... meta'' #n-1 li.n/li.i )
  SWAPLOOP				( symb lvar y #l d P_D/D meta-sol )
  #1+ EXTRACTCOMMONDENO			( symb lvar y #l d P_D/D d' meta-s )

  ( * end of SOLVEMETASYST * )

  ( * extract Q and C * )

  yfois2 LENCOMP #2- 			( ... P_D/D d' meta-s #a )
  ( * split meta utility * )
  SWAPOVER #-				( meta-s' #a #l-a )
  OVER#2+UNROL				( meta-#l-a meta-#a )
  ( * end split utility * )
  reversym >POLYTRIM OVER#2+UNROL 
  reversym >POLYTRIM			( symb lvar y #l d P_D/D d' C Q )
  ROT ONE>POLY 5ROLL RMULText 		( symb lvar y #l P_D/D C Q d*d' )
  ABND

  ( * output the Q*y^[1/2-l] part * )

  DUPUNROT RDIVext			( symb lvar y #l P_D/D C d*d' newQ )
  6PICK VAL1M addtSQRTonly7
  DUP #6+ ROLL 
  :: DUP#0=csDROP
     #2* UNCOERCE %CHS %1+ R>Z SWAP#1+ addt^ 
  ;	( ... newQ y^l-m )
  get1 VAL1M psh metamult 		( symb lvar y P_D/D C d*d' meta )
  DUP #7+ ROLL SYMBINCOMP 		( lvar y P_D/D C d*d' meta meta )
  metaadd CKSYMBN			( lvar y P_D/D C d*d' symb )

  ( * looks for 2nd order * )

  6UNROLL RDIVext			( symb lvar y rational_part C )
  3PICK LENCOMP	#3=			( symb lvar y rational_part C flag )
  NOTcase 
   :: RADDext num#0=case7 3DROP
      VAL1M get1 VAL1M addtSQRTonly7
      metadiv CKSYMBN			( symb lvar ratpart/sqrt[y] )
      SWAPDROP rvx INText x+ext		( -> result )
   ;
  
  ( * 	2nd order: dispatch for y=ax^2+bx+c			* )
  ( *	D=b^2-4ac, d=sqrt[D], d'=sqrt[-D]			* )
  ( * 	a>0	->	x=[m^2-c]/[b-2*sqrt[a]*m]		* )
  ( *			m=sqrt[y]-sqrt[a]*x			* )
  ( * 			dx/sqrt[y]=2*dm/[b-2*sqrt[a]*m]		* )
  ( * 	a<0 and D>0 ->	x=[d*2u/[1+u^2]-b]/2a			* )
  ( *			u=[d-2*sqrt[-a]*sqrt[y]]/[2ax+b]	* )
  ( *			dx/sqrt[y]=2*du/[sqrt[-a]*[1+u^2]]	* )

					( symb lvar y rational_part C )
  4UNROLL OVER INCOMPDROP		( symb C lvar y fr a b c )
  TWICEONE>POLY				( symb C lvar y fr a b c )
  ROT ONE>POLY POSITIFext 		( symb C lvar y fr b c a ?a>0 )
  case rischsqrt2p
   					( symb C lvar y fr b c a )
  RNEGext DUP XSQRext			( symb C lvar y fr b c -a sqrt[-a] )
  SWAP Z2 RMULText			( symb C lvar y fr b c sqrt[-a] -2a )
  4PICK DUP RMULText			( symb C lvar y fr b c s -2a b^2 )
  4ROLL 3PICK RMULText			( symb C lvar y fr b s -2a b^2 -2ac )
  Z2 RMULText RADDext			( symb C lvar y fr b s -2a b^2-4ac )
  SXSQRext				( symb C lvar y fr b s -2a d )
  ZERO 6UNROLL FIVE METAVAL2 DROP	( symb C lvar y fr b s -2a d )
  6ROLL VAL1M addtSQRTonly7 		( symb C lvar fr b s -2a d v[y]-m )
  DUP #4+PICK SYMBINCOMP meta2* 	( sym C lvar fr b s -2a d v[y]-m 2s-m )
  psh metamult				( symb C lvar fr b s -2a d 2s*v[y]-m )
  pick1 SYMBINCOMP psh metasub		( sym C lvar fr b s -2a d d-2s*v[y]-m )
  DUP #3+PICK SYMBINCOMP 	( symb C lvar fr b s -2a d d-2s*v[y]-m -2a-m )
  rvx ONE metamult		( sym C lvar fr b s -2a d d-2s*v[y]-m -2a*x-m )
  pick1 OVER #+ #6+ PICK	( sym C lva fr b s -2a d d-2s*v[y]-m -2ax-m b )
  SYMBINCOMP metasub 		( ... -2ax-b-m )
  dup unrot metadiv CKSYMBN	( symb C lvar fr b s -2a d -2ax-b-m u[x] )
  RISCHSIMP OVER #7+ UNROLL 	( symb C lvar u[x] fr b s -2a d -2ax-b-m )
  pick1 SYMBINCOMP metadiv 	( symb C lvar u[x] fr b s -2a d -2ax-b/d-m )
  metasimp addtASIN CKSYMBN	( symb C lvar u[x] fr b s -2a d asin )
  9ROLL VAL1 			( symb lvar u[x] fr b s -2a d asin C )
  5PICK x/ext x*ext 		( symb lvar u[x] fr b s -2a d C/sqrt[-a]*asin )
  7UNROLL Z2 4ROLL		( symb lvar asin u[x] fr b -2a d 2 s )
  SYMBINCOMP rvx ONE metasq+1 metamult 
  #1+ addt/ CKSYMBN		( symb lvar asin u[x] fr b -2a d dx/v[y] )
  5UNROLL ROTSWAP SYMBINCOMP	( symb lvar asin u[x] dx/v[y] fr -2a b d-m )
  rvx ONE dup meta2* psh metasq+1 
  metadiv metamult		( symb lvar asin u[x] dx/v[y] fr -2a b d* )
  get1 SYMBINCOMP metaadd 
  get1 SYMBINCOMP metadiv CKSYMBN	( symb lvar asin u[x] dx/v[y] fr x[u] )
  rvx SWAP rischmeval x*ext		( symb lvar asin u[x] fr' )
  4PICK CDRCOMP 			( symb lvar asin u[x] fr' lvar' )
  ROT >HCOMP				( symb lvar asin fr' newlvar )
  SWAP4ROLL RISCHPF			( symb asin symb' )
  x+ext x+ext				( symb" )
;

LABEL rischsqrt1
::					

  ( * 	y=ax+b, x=[m^2-b]/a, m=sqrt[y], dx=2*m/a*dm 	* )

					( symb lvar D P y )
  DUP INCOMPDROP 			( symb lvar D P y a b )
  SWAP ONE>POLY SWAP ONE>POLY		( symb lvar D P y a b )
  INTERNALX2 SWAP RSUBext 		( symb lvar D P y a m^2-b )
  OVER RDIVext VAL1			( symb lvar D P y a x[m] )
  INTERNALX2 Z2 RMULText ROT RDIVext	( symb lvar D P y x[m] 2m^2/a )
  VAL1 4ROLL 5ROLL RDIVext		( symb lvar y x[m] 2m^2/a fr )
  VAL1 rvx 4ROLL rischmeval x*ext	( symb lvar y fr' )
  3PICK CDRCOMP 
  ROT VAL1M addtSQRTonly7 CKSYMBN >HCOMP	( symb lvar fr' newlvar )
  UNROTSWAP RISCHPF x+ext
;

LABEL rischsqrt2p
:: 					( symb C lvar y fr b c a )
  4ROLL 7ROLL RADDext 4UNROLL		( symb lvar y fr b c a )
  SXSQRext				( symb lvar y fr b c sqrt[a] )
  INTERNALX RMULText			( symb lvar y fr b c sqrt[a]*x )
  ROTOVER Z2 RMULText RSUBext		( symb lvar y fr c sqrt[a]*x b-2*. )
  INTERNALX2 4ROLL RSUBext		( symb lvar y fr sqrt[a]*x b-2. x^2-c )
  VAL1M pick1 VAL1M metadiv CKSYMBN	( symb lvar y fr sqrt[a]*x b-2. x[m] )
  Z2 ROT VAL1M #1+ addt/ CKSYMBN	( symb lvar y fr sqrt[a]*x x[m] dx/y )
  ROT 5ROLL VAL1M addtSQRTonly7
  get1 VAL1M metasub CKSYMBN		( symb lvar fr x[m] dx/y m[x] )
  4ROLL VAL1				( symb lvar x[m] dx/y m[x] fr )
  rvx 5ROLL rischmeval			( symb lvar dx/y m[x] fr' )
  ROT x*ext				( symb lvar m[x] fr'*dx/y )
  3PICK CDRCOMP ROT >HCOMP		( symb lvar fr'*dx/y newlvar )
  UNROTSWAP RISCHPF x+ext		( symb )
;

LABEL rischmeval
::
  vxxlflag SetSysFlag
  MEVALext
  vxxlflag ClrSysFlag
;

LABEL rischxroot
::					( symb x lvarnx lvarx varxroot )
  ( * first call TSIMP if more than 1 xroot * )
  nonint_tsimp				( symb x lvarnx lvarx varxroot )
  ( * if no more xroot, -> * )
  IDNTLAM? casedrop risch2!		( -> primitive )
  ( * test for 1 xroot only * )
  DUP 5ROLL TWO{}N			( symb lvarnx lvarx varxroot { } )
  ROT DUPLENCOMP #1= 			( symb lvarnx varxroot { } lvarx flag )
  ITE 2DROPTRUE EQUAL			( symb larnx varxroot flag )
  NOTcase intBadSqrt
					( symb larnx varxroot )
  SWAPDROP DUP EXPR> 2DROP		( symb xroot arg n )
  OBJINT?				( symb xroot arg n flag )
  NOTcasedrop intBadSqrt
					( symb xroot arg n )
  NULLID SWAP x^ext x-ext		( symb xroot arg-m^n )
  rvx DEPTH 1LAMBIND			( symb xroot arg-m^n x )
  isolflag ClrSysFlag 
  ERRSET 
    :: ISOL2ext DUPNULL{}? caseSIZEERR ;
  ERRTRAP :: DEPTH 1GETABND #-+1 NDROP RDROP intBadSqrt ;
  ABND CARCOMP				( symb xroot m x[m] )
  rvx NULLID STOVX OVER LVARXNXext ( symb xroot m x[m] x x[m] id lvarnx lvarx )
  5UNROLL 3DROP STOVX			( symb xroot m x[m] lvarx )
  XROOT_IN? SWAPDROP		( symb xroot m x[m] [ lvarx true | false ] )
  case2drop intBadSqrt			( -> int )
					( symb xroot m x[m] )
  SWAPDROP NULLID rvx rischmeval	( symb xroot x[m] )
  DUP rvx DIRECTDERIV			( symb xroot x[m] x'[m] )
  4ROLL rvx				( xroot x[m] x'[m] symb x )
  5PICK TWO{}N				( xroot x[m] x'[m] symb { x xr } )
  4ROLL rvx TWO{}N 			( xroot x'[m] symb { x xr } {} )
  rischmeval x*ext			( xroot x'[m]*symb' )
  risch0!				( xroot symb )
  rvx ROT NR_REPLACE
;

********************************************
* Integration of exp/sin/cos*polynomials
* (Denominator of symb is constant)
****************************************
LABEL rischcst!
::					( symb x lvarnx lvarx )	
* deno is constant
  4PICK BINT88 rischstep DROP 		( symb, x, lvarnx, lvarx )
  COMPLEX? NOTcase rischcsttrig
* complex mode, first we must linearize
  3DROP EXPLNext NONRECURSIVEEVAL LINEXPext		( meta )
  ZERO rcos! 
  
* then integration term by term
  Z0 SWAP #2/
  ZERO_DO (DO)		( arg-exp coef... arg_exp coef resultat )
      UNROTSWAP		( arg-exp coef...resultat coef_polynomial arg_exp )
      DUP xEXPext SWAP	( arg-exp coef...resultat coef_polynomial exp arg_exp )
      rischlinint!	( result add_to_result )
      x+ext
  LOOP

;

LABEL rischcsttrig
* deno is cst and we are in real mode, we can apply COS/SIN=RE/IM[EXP[..]]
::				( symb, x, lvarnx, lvarx )
  SETCOMPLEX
  3DROP

* sin/cos linearises 

  NONRECURSIVEEVAL LINEXPA	( meta sin/cos, coef )

* -> complex exponentials then int[poly*exp]. Test if ln present then rrisch!

  Z0 SWAP #2/
  ZERO_DO (DO)			( sin/cos coef ... sin/cos coef resultat )
    UNROTSWAP			( sin/cos coef ... resultat coef sin/cos )
    arg_trigtype!		( coef ax+b ?cos )
    rcos! rarg!			( coef )
    NONRECURSIVEEVAL LINEXPext	( meta )
    Z0 SWAP #2/
    ZERO_DO (DO)		( arg-exp coef... arg_exp coef resultat )
      UNROTSWAP		( arg-exp coef...resultat coef_polynomial arg_exp )
      DUP xEXPext SWAP	( arg-exp coef...resultat coef_polynomial exp arg_exp )
      SYMBINCOMP rarg
      SYMBINCOMP
      metai metamult metaadd
      SYMBN		( arg-exp coef...resultat coef_polynomial exp arg_exp )
      rischlinint!		( result add_to_result )
      x+ext
    LOOP
			( sin/cos coef ...sin/cos coef resultat add_to_result )
    x+ext
  LOOP
  CLRCOMPLEX
;

LABEL arg_trigtype!
( coef, sin/cos -> coef, ax+b, # )
* finds type of trig function and returns argument, #=0 (1), #1 (COS), #2 (SIN)
::	
  num#1=case7
  :: DROP Z0 ZERO		( coef, ax+b, ?cos )
  ;
  EXPR> SWAPDROP		( coef, arg, op )
  EQ: xCOS ITE ONE TWO
;

LABEL rischlinint!
::
				( ...resultat, coef_polynomial, exp, arg_exp )
  DUP rischlin?			( ...resultat coef_poly exp arg_exp a ?lin )
  NOTcasedrop argnotlinear
				( coef_polynomial, exp, arg_exp, a )
  num#0=case7 rischpolynomial
				( coef_polynomial, exp, arg_exp, a )
  SWAPDROP ROT rvx THREE{}N	( exp, a, polynomial, x )
  VXLVARext VXXLext
  INCOMPDROP DROP		( exp, lvar, a-l, poly-l )
  SWAPFXND			( exp, lvar, poly-l, a-num, a-deno )
  CKCARCOMP SWAP CKCARCOMP 	( exp, lvar, poly-l, a-deno, a-num )
  DUPROT RDIVext UNROT		( exp, lvar, a-l, poly-l, alpha=a-num )

* resolution de a*P+P'=Q dans les polynomes
* n=deg[Q], a-num^[n+1]*P=R
* on a par ordre decroissant r_k=alpha^n+1/a*q_k - (k+1)r_k+1/a avec r_n+1=0
* par ex. P'+3P=x^2+5x+7 -> r_2=9, r_1=39, r_0=50, a=3, n=2, a^n=9
* on multiplie Q par alpha^n+1/a

  SWAPFXND SWAP DUPCKLEN{}	( exp lvar a-l alpha poly-d poly-n #n+1 )
  4ROLLSWAP RP#			( exp lvar a-l poly-d poly-n alpha^#n+1 )
  DUP 5PICK RDIVext
  ONE>POLY ROT RMULText	( exp lvar a-l poly-d alpha^#n+1 alpha^n+1/a*poly-n )
  4ROLLSWAP			( exp lvar poly-d alpha^#n+1 a-l Q )
  CKINNERCOMP
  get1 SWAP get1 UNROTDUP	( ... alpha^#n+1 q_n-1...q_0 q_n a #n+1 #n+1 )
  rischlinint1! 		( ... alpha^#n+1 r_n r_n-1...r_0 a #n+1 )
  SWAPDROP {}POLY		( exp lvar poly-d alpha^#n+1 R )
  UNROT ONE>POLY
  RMULText RDIVext		( exp lvar R' )
  SWAP lvar_val! 		( exp R' )
  rischcstcommon
;

LABEL rischcstcommon
::
  rcos DUP#0=csedrp rischnotrig
  #1=case rischcostrig
				( exp R' )

* imaginary part of R'*exp=exp*(re*sin[rarg]+im*cos[rarg])

  DUP RREext VAL1M		( exp, R', meta-re )
  rarg SYMBINCOMP
  addtSIN metamult		( exp, R', meta-re*sin )
  get1 RIMext VAL1M		( exp, meta-re*sin, meta-im )
  rarg SYMBINCOMP
  addtCOS metamult metaadd	( exp, meta-re*sin+im*cos )
  get1 SYMBINCOMP metamult
  SYMBN				( add_to_result )
;

LABEL rischcostrig
* real part of R'*exp=exp*(re*cos[rarg]-im*sin[rarg])
::
					( exp, R' )
  DUP RREext VAL1M			( exp, R', meta-re )
  rarg SYMBINCOMP addtCOS metamult	( exp, R', meta-re*cos )
  get1 RIMext VAL1M			( exp, meta-re*cos, meta-im )
  rarg SYMBINCOMP
  addtSIN metamult metasub		( exp, meta-re*cos-im*sin )
  get1 SYMBINCOMP metamult SYMBN	( add_to_result )
;

LABEL rischnotrig
::					( exp, R' )
  VAL1M
  get1 SYMBINCOMP
  metamult SYMBN			( exp*R' )
;

LABEL rischlinint1!
::				( alpha^#n+1 q_n-1...q_0 q_n a #n+1 #n+1 )
  DUP#1= caseDROP
  ONE_DO (DO)			( alpha^#n+1 q_n-1...q_0 r_n a #n+1 )
     get1			( alpha^#n+1 q_n-2...q_0 r_n a #n+1 q_n-1 )
     4PICK 4PICK RDIVext 	( ... q_n-1 r_n/a )
     ISTOP-INDEX #>Z RMULText 	( ... q_n-1 n*r_n/a )
     RSUBext UNROT
  LOOP
				( alpha^#n+1 r_n r_n-1 ... r_0 a #n+1 )
;

LABEL argnotlinear
::				( ...resultat coef_poly exp arg_exp )
  SWAPDROP xEXPext x*ext ZEROZEROZERO rrisch!
  rcos #0=?SEMI
  rischflag #0<> case EVALREIMINT
  EVALREIM
;

LABEL EVALREIM
::   
  SINCOSext SYMBINCOMP
  { xSYMRE xSYMIM } rcos NTHCOMPDROP 
  EVAL
  ( * must eval the result in real mode since the integr. var. is real * )
  CKSYMBN REALEVAL7 ALGCASCOMPEVAL
;

LABEL EVALREIMINT
::
  INNERCOMP pulldrop		( o1..ok xt x #k+2 )
  #2- UNROT OBJ>R OBJ>R		( o1..ok #k )
  CKSYMBN EVALREIM		( symb )
  R>OBJ R>OBJ THREE		( symb xt x #3 )
  addt:
ASSEMBLE
	IF	f39
RPL
  xint
ASSEMBLE
	ELSE	f39
RPL
  xINT
ASSEMBLE
	ENDIF	f39
RPL
  SYMBN				( int )
;

LABEL rischpolynomial
::                ( coef_polynomial exp arg_exp a )
 2DROP SWAP            ( exp coef_poly )
 rvx RISCHext                ( exp resultat )
 rischcstcommon        ( resultat )
;

LABEL 2droprrisch!
:: 
  2DROP rrisch! 
;

LABEL droprrisch!
:: 
  DROP rrisch! 
;

*********************************************************
* Here begins the Risch algorithm
* symb should be weak normalized (calling TSIMP)
*********************************************************
LABEL rrisch!
* 1st step: research of the tower of transcendental extensions
::
				( symb, o1, o2, o3 )
  3DROP lvarxnxexpln		( symb, x,lvarnx, lvarx )

* symb, x, lvarnx, lvarx -> symb, x, newlvarnx, newlvarx

  ZERO rischflag!		( marqueur de validite de lvarx )
  ZERO rr#!			( nombre d'exponentielles )
  NULL{} SWAP			( symb, x, newlvarnx, newlvarx, lvarx )
  [BEGIN]
     DUPNULL{}?
  NOT_WHILE
     find_tower!
  [REPEAT]
				( symb, x, newlvarnx, newlvarx, {} )
  DROP				( symb, x, newlvarnx, newlvarx )
  DUP 4PICK EQUALPOSCOMP
  #0= IT :: 3PICK >TCOMP ;	( symb, x, newlvarnx, newlvarx )
  BINT89 rischstep		( symb, x, newlvarnx, newlvarx )
  SWAP &COMP			( symb, x, lvar )
  rischflag
  DUP#0= NOTcase rrisch_fail!
  DROP

* on calcule maintenant dlvar )
				( symb, x, lvar )
  NULL{} OVER
  [BEGIN]			( symb, x, lvar, dlvar, reste )
     INNERCOMP #1-{}N		( symb, x, lvar, dlvar, var, reste )
     OVER 6PICK EQUAL		( symb, x, lvar, dlvar, var, reste, ?var=x )
  NOT_WHILE
     find_dlvar!
  [REPEAT]
				( symb, x, lvar, dlvar, var, reste )
  2DROP Z1 >TCOMP		( symb, x, lvar, dlvar )
  ROTDROP			( symb, lvar, dlvar )
  NULL{} 4PICK 4PICK		( symb, lvar, dlvar, {}, symb, lvar )
  4ROLL				( symb, lvar, log, symb, lvar, dlvar )

* preparation finished, let's call the integration routine

  risch3!			( symb, lvar, coeflog, result )
  SWAPDROP rischflag #0=	( symb, lvar, result, ?ok )
  case UNROT2DROP
  2DROP
  "No closed form" casinfo!
;

LABEL find_tower!
::				( symb x newlvarnx newlvarx lvarx )
  DUP CDRCOMP SWAP CARCOMP	( symb x newlvarnx newlvarx lvarx var1 )
  ROTOVER >TCOMP		( symb x newlvarnx lvarx var newlvarx )
  UNROT				( symb x newlvarnx newlvarx lvarx var )
  DUPTYPESYMB? NOTcaseDROP
  EXPR>				( symb x newlvarnx newlvarx lvarx arg % op )
  SWAP %1 %= NOTcase2drop
  :: DROP NULL{} TWO rischflag! ;
				( newlvarnx newlvarx lvarx arg op )
  SWAP lvarxnxexpln	
		( symb x newlvarnx newlvarx lvarx op arg x argvarnx argvarx )
  2SWAP 2DROP			( symb x newlvarnx newlvar lvarx op argvarnx argvarx )
  { xEXP xLN }
  4ROLL ' EQ POSCOMP		( symb x newlvarnx newlvarx lvarx argvarnx argvarx # )
  DUP#0=csedrp
  :: 3DROP NULL{} ONE rischflag! ;
				( symb x newlvarnx newlvarx lvarx argvarnx argvarx # )
  #1=case find_tower1!		( symb x newlvarnx newlvarx lvarx argvarnx argvarx )
  ROT &COMP LVARext SWAPDROP	( symb x newlvarnx newlvarx argvarnx lvarx )
  4ROLLROT &COMP COMPRIMext	( symb x newlvarx lvarx newlvarnx )
  UNROT
;

LABEL find_tower1!
::	
  6PICK ONE{}N EQUAL	( symb x newlvarnx newlvarx lvarx argvarnx ?={x} )
  rr# ZERO #= AND
  NOTcase2drop
  :: NULL{} THREE rischflag! ;
			( symb x newlvarnx newlvarx lvarx argvarnx )
  ONE rr#!
  4ROLLSWAP &COMP	( symb x newlvarx lvarx newlvarnx )
  COMPRIMext UNROT	( symb x newlvarnx newlvarx lvarx )
  4PICK >HCOMP
  LVARext SWAPDROP
;

LABEL find_dlvar!
::				( symb x lvar dlvar var reste )
  SWAPDUP 6PICK DIRECTDERIV	( symb x lvar dlvar reste var var' )
  UNROT 2DUP >HCOMP		( symb x lvar dlvar var' reste var reste&var )
  4ROLLSWAP VXXLext		( symb x lvar dlvar reste var reste&var var' )
  UNROT2DROP			( symb x lvar dlvar reste var' )
  ROTSWAP >TCOMP SWAP
;

LABEL rrisch_fail!
::				( symb x lvar # )
  {
    "Invalid unary operator" 
    "Non unary operator" 
    "EXP>EXP/LN not handled" 
  } 
  SWAP NTHCOMPDROP		( symb x lvar $ )
  UNROT2DROP casinfo!
;

( obj -> # : #=0 unless obj is a positif integer )
LABEL risch20!
::	
  TRIMOBJext DUPTYPEZ?
  case Z>#
  dREALNcase DROPZERO
  DUPDUP %FLOOR %=
  ITE COERCE DROPZERO
;	

* exponential extension: computing the polynomial part or the Laurent part
* flag is true for Laurent and false for polynomial part
LABEL risch19!				
::	
( dlvar, Laurent, result, n/d, l=1, l>1, flag )
( ->  dlvar, Laurent, result, n/d, l=1, l>1 )

  rischflag #0= NOTcaseDROP
  6PICK LENCOMP		( dlvar Laurent result n/d l=1 l>1 flag # )
  OVER			( dlvar Laurent result n/d l=1 l>1 flag # flag )
  ITE ZERO ONE		( dlvar Laurent result n/d l=1 l>1 flag # #0/1 )
  2DUP#= case2drop DROP
  ROT NINE UNROLL
  DO			( ...flag dlvar Laurent result n/d l=1 l>1 )
    ISTOP-INDEX #>Z
    8PICK IT RNEGext 	( ...flag dlvar Laurent result n/d l=1 l>1 k )
    6ROLL INNERCOMP
    #1- {}POLY 7UNROLL	( ...flag dlvar Laurent result n/d l=1 l>1 k ak )
    risch19_1!
  LOOP
			( flag dlvar Laurent result n/d l=1 l>1 )
  7ROLL DROP
;

LABEL risch19_1!
::	
  num#0=case7 2DROP 
  risch18!		( ...flag dlvar Laurent result n/d l=1 l>1 bk )
  rischflag #0=
  NOTcasedrop ExitAtLOOP 
  ONE>POLY VAL1 Z1Z0
  ISTOP-INDEX NDUPN #1+ {}POLY
  VAL1

  ( ...flag dlvar Laurent result n/d l=1 l>1 meta-{bk} meta-{ 1 ..0 } )

  NINE PICK ITE NDXFext x*ext 
  5ROLL SWAP x+ext 4UNROLL

  ( ..., flag, dlvar, Laurent, result, n/d, l=1, l>1 )
;

* exponential extension: computing the polynomial part for a specific
* power (integer k that might be + or -) of the exponential
LABEL risch18!
::	

  ( dlvar, Laurent, result, n/d, l=1, l>1, k, ak )
  ( -> dlvar, Laurent, result, n/d, l=1, l>1, bk )
  ( teste la validite de dlvar )

  8PICK CARCOMP Z1 EQUAL 
  NOTcase2drop
  ::					( result n/d l=1 l>1 )
    THREE rischflag! Z0
  ;

  ( on factorise le denominateur de ak )

  NULL{} risch16! ROTDROP		( n/d, l=1, l>1, k, nk/dk, lfacdk )

  ( pour l'instant je ne teste pas avec la liste l=1 )
  ( qui est normalement vide )

  ::
    DUPNULL{}? case 4ROLL 
    4ROLL DUPNULL{}? ?SEMI
    ONE SQFF2ext DROP
  ;

				( n/d, l=1, k, nk/dk, lfacdk, l>1 )
  DUP 5UNROLL			( n/d, l=1, l>1, k, nk/dk, lfacdk, l>1 )

  ( on traite les facteurs tq beta<>0, alors alpha=gamma-beta )

  [BEGIN]			( lfacdk, l>1 )
      DUPNULL{}?
  NOT_WHILE
  ::				( lfacdk, l>1 )
    INNERCOMP #2- {}N 4UNROLL	( l>1, lfacdk, f, beta=#mul_l>1 )
    ROTDUP 4ROLL		( l>1, #mul_l>1, lfacdk, lfacdk, f )
    EQUALPOSCOMP		( l>1, #mul_l>1, lfacdk, # )
    DUP#0=csedrp UNROTDROP	( * gamma=0 * ) 
    2DUP #1+ NTHCOMPDROP	( l>1, #mul_l>1, lfacdk, #pos, %mul_lfacdk )
    %ABSCOERCE 4ROLL	( l>1 lfacdk #pos gamma=#mul_lfacdk beta=#mul_l>1 )
    2DUP#< IT 2DROP00
    #- SWAP#1+ ROT		( l>1, #mul_lfacdk-#mul_l>1, #pos, lfacdk )
    PUTLIST SWAP		( l>1, lfacdk )
  ;
  [REPEAT]
  DROP

  ( si beta=0, on prend gamma-1 )
				( n/d, l=1, l>1, k, nk/dk, lfacdk )
  NULL{} SWAP
  [BEGIN]			( newlfacdk, lfacdk )
      DUPNULL{}?
  NOT_WHILE
  ::    			( newlfacdk, lfacdk )
    INNERCOMP #2- {}N 4UNROLL	( lfacdk, newlfacdk,  f, m )
    DUPTYPEREAL? IT
    :: %CHS %1- COERCE ;
    DUP#0= case2drop SWAP
    UNROT >TCOMP SWAP >TCOMP SWAP
  ;
  [REPEAT]
  DROPTRUE			( n/d, l=1, l>1, k, nk/dk, lfacdk, TRUE )
  ' RMULText TOTEMPOB		( -> lam2 )
  ' RPext TOTEMPOB		( -> lam1 )
  FACTOOBJext FXNDext DROP	( n/d, l=1, l>1, k, nk/dk, D )

  ( calcul de l'equa diff polynomiale )
  ( y' + k n/d y = nk/ dk devient )
  ( D d dk Y' + [ k* n* dk* D - D' dk d ] Y = nk D d )
  ( n/d, l=1, l>1, k, nk/dk, D )

				( Suspect comments: sometimes comma was used )
				( sometimes it wasn't )

  6PICK FXNDext			( n/d l=1 l>1 k nk/dk D n d )
  4ROLL FXNDext			( dlvar Laurent result n/d l=1 l>1 k D n d nk dk )
  5PICK
  THIRTEEN PICK rischder!	( dlvar Laurent n/d l=1 l>1 k D n d nk dk D' )
  OVER5PICK RMULText		( n/d l=1 l>1 k D n d nk dk D' dk_d )
  DUP 8PICK RMULText
  NINE UNROLL			( n/d l=1 l>1 D_dk_d k D n d nk dk D' dk_d )
  RMULText SWAP			( n/d l=1 l>1 D_dk_d k D n d nk D' dk_d dk )
  7ROLL RMULText		( n/d l=1 l>1 D_dk_d D n d nk D'_dk_d k_dk )
  6PICK RMULText 5ROLL RMULText	( n/d l=1 l>1 D_dk_d D d nk D'_dk_d k_dk_D_n )
  SWAP RSUBext 4UNROLL		( n/d l=1 l>1 D_dk_d k_n_dk_D_-D'_dk D d nk )
  RMULText OVERDUP
  6UNROLL RMULText RMULText	( n/d l=1 l>1 D D_d_dk k_n_dk_D_-D'_dk_d nk_d-D^2 )
  THREE{}N
  LPGCDext LOPDext INNERCOMP	( n/d l=1 l>1 D R S T #3 )

  ( avec R Y' + S Y = T )
  ( calcul du degre de Y: deg[R]-1<deg[S] -> deg[T]-deg[S] )
  ( si > -> deg[T]-deg[R]+1 )

  ZERO_DO (DO)
     DUPTYPELIST? ?SKIP ONE{}POLY UNROT
  LOOP
				( dlvar Laurent result n/d l=1 l>1 D R S T )

  DUP DEGREext			( n/d l=1 l>1 D R S T deg[T] )
  2OVER DEGREext SWAP DEGREext	( n/d l=1 l>1 D R S T deg[T] deg[S] deg[R] )

  ::
    DUP#0=csedrp
    ::
      DUPUNROT 2DUP#<		( n/d l=1 l>1 D R S T deg[S] deg[T] deg[S] )
      NOTcase #-
      ONE rischflag!
      RDROP 7DROP Z0
    ;
				( n/d l=1 l>1 D R S T deg[T] deg[S] deg[R] )
    #1- 2DUP#= casedrop
    ::				( 8 en cas d'egalite * )
				( R, S, T, t, s )
      DUPUNROT 2DUP#<
      IT 2DROP00 #-		( R, S, T, s, t-s )
      4PICK CARCOMP
      6PICK CARCOMP
      RDIVext RNEGext		( R, S, T, s, t-s, Ss/Rr )
      risch20! #MAX
    ;
    #MAX DUPUNROT
    2DUP#< NOTcase #-
    2DROP ZERO
  ;

  ( n/d, l=1, l>1, D, R, S, T, s ou r-1, y=deg[Y] )

  ( construction des matrices S et R )
  ( taille des matrices: y+s+2 lignes, y+1 colonnes )

  #1+ DUPUNROT #+		( ..., R, S, T, y+1, y+s+1 )
  5ROLL 5ROLL			( ..., T, y+1, y+s+1, R, S )
  NULL[] 5PICK 
  ZERO_DO (DO)
	( y+1, y+s+1, R, S, matrice transposee )
	( creation de la ligne index@ en partant du bas )

	SWAPDUP Z0 >TPOLY UNROT	( y+1, y+s+1, R, S+0, matrice transposee, S )
	INDEX@
	::
	  DUP#0=csedrp NOP
				( y+1 y+s+1 R S+0 matrix_transpose S # )
	  5ROLL DUP Z0 >TPOLY	( y+1 y+s+1 S+0 matrix_transpose S # R R+0 )
	  6UNROLL
	  SWAP #>Z
	  RMULText RADDext	( y+1 y+s+1 R S+0 matrix_transpose S+#*R )
	;
				( y+1 y+s+1 R[+0] S+0 matrix_transpose S+#*R )
	5PICK #1- LRDMext >HCOMP
  LOOP
				( y+1, y+s+1, R, S, matrice transposee )
  UNROT2DROP			( ..., T, y+1, y+s+1, R+S transpose )
  SWAP 4ROLLSWAP #1-
  LRDMext >TCOMP MATTRAN	( n/d, l=1, l>1, D, y+1, matrice )

  ( rref de R Y' + S Y = T )

  NULL{} ONE ROT NOSTEPEVAL7 INXREDext
  UNROT2DROP			( n/d, l=1, l>1, D, y+1, matrice reduite )

  ( on enleve les lignes nulles )

  INNERCOMP 
  [BEGIN]
	OVER NULLVECTOR?
  [WHILE]
	pulldrop
  [REPEAT]
  ( il doit rester y+1 lignes non nulles )
  ( n/d, l=1, l>1, D, y+1, meta-matrice reduite )
  ( test de compatibilite et calcul de Y )

  get1 2DUP 
  #<>case
  ::			( n/d, l=1, l>1, D, ligne1, ..., ligney+1, #y+1, # )
    TWO rischflag!
    DROPNDROP DROPZ0
  ;
			( n/d, l=1, l>1, D, ligne1, ..., ligney+1, #y+1, #y+1 )
  #1-SWAP
  ZERO_DO (DO)
  ::				( ligne1, ..., ligney+1, #y )
    get1 
    []TO{} PTrim		( l2 .. ly+1 #y l1-{} )
    CKINNERCOMP DUP#1= 
    case
    ::
      FOUR rischflag!
      DROPSWAP ExitAtLOOP
    ;
					( ligne2...ligney+1 #y c1...cn #n )
    #2- DUPUNROT #2+UNROLL NDROP	( ligne2...ligney+1 #y c1 cn )
    SWAP RDIVext SWAP			( ligne2...ligney+1 -cn/c1 #y )
  ;
  LOOP
  #1+ EXTRACTCOMMONDENO {}POLY		( n/d, l=1, l>1, D, Yd, Y )
  UNROT ONE{}POLY QMul			( n/d, l=1, l>1, Y, D*Yd )
  rischflag #0= NOTcase2drop Z0
  RDIVext				( n/d, l=1, l>1, bk=Y/D )
;

* evaluation of a fraction at pk and return it one level deeper
( pk, n, d' -> pk, n/d'[pk] ) 
LABEL risch17!
::	
  3PICK HORNER1ext 		( pk, n, d'[pk] )
  SWAP3PICK HORNER1ext 		( pk, d'[pk], n[pk] )
  SWAP RDIVext ONE>POLY		( pk, n/d'[pk] )
;

LABEL risch16!
* factorisation, keeps only denominator factor
( symb, lvar -> n/d, lfac )
::	
  SEVEN COMPLEXEVAL7 RFACT2ext	( lvar, n/d, meta-fac )
  ( remove constant factor )
  DUP#0=csedrp NULL{}
  DUP #1-SWAP #2/
  ZERO_DO (DO)			( f1, m1, ..., fk, mk, #2k-1 )
     get1 SWAP get1 DUP %0<	( f2, ..., fk, mk, f1, #2k-1, m1, ?m1<0 )
     ITE
     SWAP
     :: DROPSWAPDROP #2-  ;
  LOOP
  #1+ {}N
;

*********************************
* Polynomial part for logarithmic extensions
******************************
LABEL risch15!
::	
( log, lvar, dlvar, result, ak, bk+1, #k -> log, lvar, dlvar, bk, result )

  rischflag #0=
  NOTcasedrop SWAPDROPSWAP
  6UNROLL			( log #k lvar dlvar result ak bk+1 )
  5PICK CDRCOMP UNROT		( ... result lvar' ak bk+1 )
  5PICK CARCOMP
  CARCOMPext RMULText		( ... result lvar' ak bk+1*theta' )
  7PICK #1+ #>Z RMULText
  RSUBext			( ... result lvar' ak-[k+1]*bk+1*theta' )
  SWAP4PICK CDRCOMP
  8PICK 4UNROLL			( ... result log ak lvar' dlvar' )
  risch3!			( ... result [k+1]*Bk+1 bk | ERREUR )

* here we must convert bk back to internal format for later use
				( log lvar dlvar result Bk+1 bk-symb )
  7PICK NULLCOMP? ITE Z0 DUP 	( log lvar dlvar result Bk+1 bk-symb bk-symb )
  6PICK CDRCOMP VXXLext		( dlvar result [k+1]*Bk+1 bk-symb lvar' bk )
  5UNROLL lvar_val!		( ...dlvar bk result [k+1]*Bk+1 bk-symb )
  SWAP 7PICK #1+ #>Z RDIVext
  VAL1M				( ...dlvar bk result bk-symb Bk+1-meta )
  DUP #6+ PICK CARCOMP		( ...dlvar bk result bk-symb Bk+1-meta x )
  SYMBINCOMP metamult
  get1 SYMBINCOMP metaadd	( ...dlvar bk result [x*Bk+1 + bk]-meta  )
  DUP #6+ ROLL
  OVER #6+ PICK CARCOMP
  SYMBINCOMP get1
		( log #k lvar dlvar bk result [x*Bk+1 + bk]-meta x-meta #  )
  DUP#0=ITE
    DROPdrop
    :: meta^ metamult ; 
				( log lvar dlvar bk result [x*Bk+1 + bk]*x^k  )
  get1 SYMBINCOMP
  psh metaadd CKSYMBN		( log lvar dlvar bk result  )
  4PICK lvar_val!
;


* tests if obj is cst up to depth #
LABEL risch8!
( obj, # -> obj )
::	
  DUP#0=csDROP
  rischflag #0= NOTcaseDROP
  OVER FXNDext				( obj, #, num, deno )
  risch8_1!				( obj, #, num )
  DUPTYPELIST? NOTcase2DROP
					( obj, #, num )
  DUPLENCOMP #1= NOTcase2drop sto7inrischflag
					( obj, #, num )
  INCOMPDROP SWAP#1- 			( obj, num, #-1 )
  risch8!				( obj, num )
  DROP 					( obj )
;

LABEL risch8_1!
::
  NOTLISTcase DROP
					( obj, #, num, deno )
  DUPLENCOMP #1=
  NOTcasedrop sto7inrischflag
  INCOMPDROP				( obj, #, num, deno )
  3PICK #1- 				( obj, #, num, deno, #-1 )
  risch8!				( obj, #, num, deno )
  DROP					( obj, #, num )
;

LABEL sto7inrischflag
::
  SEVEN rischflag!
;

NULLNAME generate_atan
::
( facteur de degre 2 en mode reel )
				( r1...rk-1 result q2 d2' q2 d2' fk )
  STRIPTAGS
  DUPLENCOMP #3= NOTcase INTERNALERR
				( ... d2' q2 d2' fk )
  SETCOMPLEX DUP4UNROLL DEG2ext ( ... d2' fk q2 d2' {} )
  INCOMPDROP DROP UNROT		( ... d2' fk rk q2 d2' )
  risch17! rprof risch8!	( ... d2' fk rk q2/d2'[rk] )
  DUP RIMext Z-2 RMULText 	( ... d2' fk rk q2/d2'[rk] -2*im[] )

* add the ATAN coefficient for RISCHTRIG

  discontinu
  OVER RADDext
  discontinu!			( ... d2' fk rk q2/d2'[rk] -2*im[] )
  4ROLLROT RREext		( ... d2' rk -2*im[] fk re[] )
  rck
  OVER Z2 RMULText RADDext
  rck! VAL1M			( ... d2' rk -2*im fk re-meta )
  get1 VAL1M
  ( * add LN but we do not need ABS here * )
  addtLN 
  metamult			( ... d2' rk -2*im ln-meta )
  get1 rotomo FXNDext		( ... d2' ln-meta im rk.N rk.D )
  SWAPDUP RIMext
  SWAP RREext RNEGext		( ... d2' ln-meta im D b -a )
  ROTSWAP TWO{}POLY
  SWAP ONE>POLY
  RDIVext VAL1M			( ... d2' ln-meta im {D -a}/{b}-meta )
  addtATAN
  get1 VAL1M psh
  metamult metaadd CKSYMBN
  CLRCOMPLEX
;

NULLNAME gen_ln_only
::
  UNROT				( r1...rk-1 result q2 d2' rk q2 d2' )
  risch17! rprof risch8!	( r1...rk-1 result q2 d2' rk q2/d2'[rk] )
  rck OVER RADDext rck! VAL1M	( r1...rk-1 result q2 d2' rk q2/d2'[rk] )
  get1 RNEGext
  Z1 SWAP TWO{}POLY VAL1M	( r1...rk-1 result q2 d2' rk q2/d2'[rk] x-rk )
  COMPLEX? ?SKIP addtABSrisch METALNEXPArisch
  metamult SYMBN		( r1...rk-1 result q2 d2' q2/d2'[rk]*ln[x-rk] )
;

LABEL addtABSrisch
::
  sturmflag TestSysFlag case addtABS
  sturmflag SetSysFlag addtABS
  sturmflag ClrSysFlag
;

LABEL METALNEXPArisch
::
  sturmflag TestSysFlag case METALNEXPA
  sturmflag SetSysFlag METALNEXPA
  sturmflag ClrSysFlag
;

NULLNAME RISCH1LOG
::	
* si 1 seul log autorise, alors on doit avoir q2/d2 = C * log'/log
					( result, lfac, q2-n, q2-d  )
  ROTDROP autolog DUP dlvar rischder!	( result, q2-n, q2-d, log, log' )
  4ROLLROT RMULText			( result, q2-d, log', q2-n*log )
  UNROT RMULText temp_stor RMULText	( result, q2-n*log, q2-d*log'*d2 )
  RDIVext rprof risch8!			( result, C )
  coeflog!
;

NULLNAME RISCHLOG
::				( result, lfac, q2-n, q2-d, d2'  )
  ROTOVER			( result, lfac, q2-d, d2', q2-n, d2'  )
  PSEUDODIV			( result, lfac, q2-d, d2', a, quotient, reste )
  ROT 5ROLL RMULText		( result, lfac, d2', quotient, reste, q2-d )
  2SWAP				( result, lfac, reste, q2-d, d2', quotient )
  num#0=case7 DROP
				( result, lfac, r, q2-d, d2', quot )
  3PICK RDIVext

  ( update de rck )

  5PICK LENCOMP #>Z OVER RMULText rck RADDext rck!
  ( result, lfac, r, q2-d, d2', quot/q2-d )
  VAL1M temp_stor 
  ( * d2 is in temp_stor, we must normalize the LN if not pure rational * ) 
  ( result, lfac, r, q2-d, d2', quot/q2-d-meta, d2 )
  rprof #0= ?SKIP RISCHLOGNORMALIZE
  ( * here we should test for a positive polynomial to avoid ABS * )
  ( result, lfac, r, q2-d, d2', quot/q2-d-meta, d2/d2.leading_coeff )
  VAL1M COMPLEX? ?SKIP addtABSrisch METALNEXPArisch metamult
  ( result, lfac, r, q2-d, d2', quot/q2-d-meta*ln[d2] )
  DUP #6+ ROLL SYMBINCOMP metaadd SYMBN 5UNROLL
; 

LABEL RISCHLOGNORMALIZE
* divide polynomial by it's leading coefficient
:: DUP CARCOMP ONE>POLY RDIVext ;

NULLNAME RISCHATAN
* Note: with the current factorization method, we must check the sign
* of b^2-4ac
* r is the constant numerator of the fraction
* q2-d is the constant denominator
* temp_stor contient le polynome
::					( result, lfac, q2-d, d2', r )
  4ROLLDROP temp_stor INCOMPDROP	( result, q2-d, d2', r, a, b, c )
  ROT RMULText
  Z4 RMULText
  SWAPDUP RMULText RSUBext		( result, q2-d, d2', r, 4ac-b^2 )
  POSITIFext ITE RISCHATAN1 RISCHATAN2 
  metamult 
  get1 SYMBINCOMP metaadd SYMBN
;

LABEL RISCHATAN1
::				( result, q2-d, d2', r, flag, 4ac-b^2 )
  SXSQRext ONE>POLY SWAP	( result, q2-d, d2', sqrt[4ac-b^2], r )
  Z2 RMULText			( result, q2-d, d2', sqrt[4ac-b^2], 2r )
  4ROLL 3PICK RMULText RDIVext	( result, d2', sqrt[4ac-b^2], 2r/q2-d*sqrt[] )

* store this coefficient to add to the discontinuity coeff for RISCHTRIG

  DUP temp_stor! VAL1M

			( result, d2', sqrt[4ac-b^2], 2r/q2-d*sqrt[]-meta )
  DUP #3+ROLL OVER #3+ROLL
			( result, 2r/q2-d*sqrt[]-meta, d2', sqrt[4ac-b^2] )
  RDIVext VAL1M 	( result, 2r/q2-d*sqrt[]-meta, d2'/sqrt[4ac-b^2]-meta )
  ( * if meta is a pure TAN then remove ATAN[TAN] and don't add coeff * )
  AEQ1stcase xTAN pulldrop
  ( * meta was not a TAN -> * )
  addtATAN 		
  discontinu temp_stor RADDext discontinu!
			
;

LABEL RISCHATAN2
::				( result, q2-d, d2', r, 4ac-b^2 )
  RNEGext SXSQRext ONE>POLY	( result, q2-d, d2', r, sqrt[b^2-4ac] )
  SWAP RNEGext 			( result, q2-d, d2', sqrt[b^2-4ac], -r )
  4ROLL 3PICK RMULText RDIVext	( result, d2', sqrt[b^2-4ac], -r/q2-d*sqrt[] )
  VAL1M			( result, d2', sqrt[b^2-4ac], -r/q2-d*sqrt[]-meta )
  DUP #3+ROLL
  OVER #3+ROLL		( result, 2r/q2-d*sqrt[]-meta, d2', sqrt[b^2-4ac] )
  SWAP RDIVext VAL1M
  1&meta dup addt+ psh addt- metadiv metasimp addtABSrisch addtLN
  ( was addtATANH*2 )
;

************************************************
* all extensions: rational, log and polyn. part
************************************************
LABEL risch3!
::	( LAM3 )
( log autorise, symb , lvar, dlvar -> coef du log, resultat  )
* 1ere etape: calcul de la partie rationnelle et log
* 2eme etape: calcul de la partie polynomiale generalisee
* attention la 2eme etape appelle recursivement risch3!
* on ne peut utiliser les var. temp. que dans la 1ere etape

  dlvar!
  Z0 DUPDUP rck! coeflog! laurent!
  ROT autolog!				( symb, lvar )
  DUPDUP lvar_val! 			( symb, lvar, lvar )

* counts vars depending on X

  DUPINCOMP ZEROSWAP
  ::
    DUP#0=csDROP
     ZERO_DO (DO)
	SWAP rvx Contains? UNROT2DROP IT #1+
     LOOP
  ; 
  rprof!				( symb, lvar, lvar )
  CARCOMP
  DUPTYPESYMB? IT
  :: DUPLENCOMP NTHCOMPDROP ;
					( symb, lvar, type )
  type! SEVEN PFext

  ( lvar, quotient, num1, deno1, f1, m1, ..., numk, denok, fk, mk, #4k )

* partie rationnelle et logarithmique
* -> lvar, quotient, result

  risch_rat&log				( lvar, p=quotient, result )
  coeflog 4ROLL DUP lvar_val!		( p, result, coeflog, lvar )
  dlvar 5ROLL				( result, coeflog, lvar, dlvar, p )
  laurent 6ROLL				( coeflog lvar dlvar p Laurent result )
  type					( coeflog lvar dlvar p Laure result x )

* Partie polynomiale

  idntlamcase idntext_poly
  EQ: xLN case lnext_poly

  ( EXP )
				( coeflog lvar dlvar p Laurent result )
  ROT RISCH13 ROT RISCH13 ROT	( cflog lvar dlvar p Laurent res )
  5PICK CARCOMP			( cflog lvar dlvar p Laurent res exp[eta] )
  INNERCOMP pulldrop SYMBN	( cflog lvar dlvar p Laurent res eta )
  DUP 7PICK CDRCOMP VXXLext
  SWAPDROP UNROT		( cflog lvar dlvar p Laurent eta-list res eta )
  rck VAL1M
  get1 SYMBINCOMP
  metamult obj2-meta1 SYMBN	( cflag lvar dlvar p Laurent eta result )

* calcul de la partie poly generalisee
* etape 1: factorisation de eta', calcul des coef beta

  SWAP 5PICK CDRCOMP rischder!	( cflog lvar dlvar p Laurent result eta' )
  NULL{} risch16! ROTDROP	( cflog lvar dlvar p Laurent result n/d lfac )

* lfac contient les polynomes suivis des coefs beta,
* on regarde pour les racines de p telles que beta=1 
* si n/d' est un entier positif

  OVER FXNDext			( cflag lvar dlvar p Laurent res n/d lfac n d )
  8PICK CDRCOMP rischder!
  NDXFext			( ... res n/d lfac n/d' )
  SWAPINCOMP get1 NULL{} DUP	( ... res n/d p1...betak #2k n/d' l=1 l>1 )
  4ROLL #2/ expext_poly		( cflag lvar dlvar p Laurent res n/d l=1 l>1 )

* on entame la boucle pour p et Laurent
* resolution de bk'+k*n/d*bk=ak
* ou ak est le coef de p ou de Laurent

  7ROLL CDRCOMP 6UNROLL		( cflag lvar p dlvar' Laurent res n/d l=1 l>1 )
  TRUE risch19!			( cflag lvar p dlvar' Laurent res n/d l=1 l>1 )
  5ROLLDROP
  6ROLL 5UNROLL			( cflag lvar dlvar' p result n/d l=1 l>1 )
  FALSE risch19!		( cflag lvar dlvar' p result n/d l=1 l>1 )
  3DROP				( cflag lvar dlvar' p result )
  rischflag #0=
  NOTcase 4UNROLL3DROP

* it remains to integrate the constant coeff of p

  NULL{} ROT CARCOMPext		( cflag lvar dlvar' result log_autorise a0 )
  num#0=case7 :: 2DROP UNROT2DROP ;
  5ROLL CDRCOMP 5ROLL risch3!	( cflag result coef symb )

* no need to embedd symb in a list since it is a user symb now

  SWAPDROP x+ext		( cflag result )
;

LABEL idntext_poly
::				( coeflog, lvar, dlvar, p, Laurent, result, x )
  DROPSWAPDROP			( coeflog, lvar, dlvar, p, result )
  ROTDROP ROT lvar_val!		( coeflog, p, result )
  SYMBINCOMP get1 RISCH13	( coeflog, result-meta, p )
  INTEGRext VAL1M metaadd
  CKSYMBN 			( coeflog, result )
;

LABEL lnext_poly
::
				( coeflog, lvar, dlvar, p, Laurent, result )
  SWAPDROPSWAP RISCH13		( coeflog, lvar, dlvar, result, p )
  4PICK INNERCOMP #1-{}N	( coeflog, lvar, dlvar, result, p, var, lvar' )
  SWAPONE OVER LENCOMP #1-
  SUBCOMP
  ( coeflog, lvar, dlvar, result, p, lvar', var sans le LN )
  SWAP VXXLext SWAPDROP

  ( coeflog, lvar, dlvar, result, p, arg du log autorise )
  ( seul log[var] est autorise )

  5UNROLL Z0 UNROT	( coeflog, log, lvar, dlvar, 0, result, p )
  DUPCKLEN{}		( coeflog, log, lvar, dlvar, bk+1, result, p, #d+1 )
  lnext_poly1		( coeflog, log, lvar, dlvar, b1, result, p )
  6ROLL DROP
  NULL{} 6UNROLL	( tous les log sont autorises )
			( coeflog, log, lvar, dlvar, b1, result, p )
  CARCOMPext		( coeflog, log, lvar, dlvar, b1, result, p )
  ROT ZERO risch15!	( coeflog, log, lvar, dlvar, b0, result )
  5UNROLL 4DROP		( coeflog, result )
;

LABEL lnext_poly1
:: 
  DUP#1= caseDROP
  ONE_DO (DO)		( coeflog, log, lvar, dlvar, bk+1, result, p )
    INNERCOMP
    #1- {}POLY		( coeflog, log, lvar, dlvar, bk+1, result, ak, p )
    7UNROLL		( coeflog, p, log, lvar, dlvar, bk+1, result, ak )
    ROT ISTOP-INDEX 	( coeflog, p, log, lvar, dlvar, result, ak, bk+1, #k )
    risch15!		( coeflog, p, log, lvar, dlvar, bk, result )
    6ROLL
  LOOP
;

LABEL expext_poly
:: 
  DUP#0=csedrp ROTDROP
  ZERO_DO (DO)	( ...n/d, p1, beta1, ..., pk, betak, n/d', lfac=1, lfac>1 )
     4ROLL %ABSCOERCE	( p1, beta1, ..., pk, n/d', lfac=1, lfac>1, #betak )
     exp_polylp		( p1, beta1, ..., n/d', lfac=1, lfac>1 )
  LOOP
			( n/d, n/d', lfac=1, lfac>1 )
  ROTDROP
;

LABEL exp_polylp
::
  DUP#0=csedrp 4ROLLDROP
  DUP#1= casedrop exp_polylp1
  >HCOMP 4ROLL >HCOMP 
;

LABEL exp_polylp1
::				( pk, n/d', lfac=1, lfac>1 )
  SWAP4ROLL			( n/d', l>1, l=1, pk )
  EVIDENText DROP {}N		( n/d', l>1, l=1, racines de pk )
  exp_polylp2			( n/d',l>1, l=1 )
  SWAP
;

LABEL exp_polylp2
::
  DUPLENCOMP DUP#0=csedrp DROP
  ZERO_DO			( l>1, l=1 , lrac )
	INNERCOMP #1-{}N	( n/d', l>1, l=1, r, lrac )
	UNROT 5PICK FXNDext	( n/d', l>1, lrac, l=1, r, n, d' )
	risch17!		( n/d', l>1, lrac, l=1, r, n/d'[pk] )
	risch20!		( l>1, lrac, l=1, r, # )
	TWO{}N &COMP		( l>1, lrac, l=1 )
  SWAPLOOP
				( l>1, l=1, lrac )
  DROP
;

LABEL risch_rat&log
::	
  Z0 SWAP DUP#0=csDROP
  FOUR #/ SWAPDROP
  ZERO_DO (DO)		( lvar, quotient, ..., numk, denok, fk, mk, result )
     5UNROLL		( lvar, quotient, ..., result, numk, denok, fk, mk )

* for exponential type, root 0 is a special case
* that must be handled using Laurent series

     type EQ: xEXP
     ITE
     :: OVER INTERNALX EQUAL ;
     FALSE
     ITE root0typeEXP root_rat&log
  LOOP
;

LABEL root0typeEXP
::
  SWAPDROP %ABSCOERCE #1-	( lvar, quotient...result, numk, denok, #mk )
  ROTSWAP RRDMext
  SWAP RDIVext laurent!		( lvar, quotient...result )
;

LABEL root_rat&log
::
			( lvar, quotient...result, numk, denok, fk, mk )
  risch_ratpart		( lvar, quotient...new-res, new q.n, new q.d, r2, r2' )
* partie logarithmique

  SWAPDUP temp_stor!
  ONE{}N 4UNROLL	( lvar, quotient...new-res, new q.n, new q.d, r2' )
  rischlogpart		( lvar, quotient...newnewres )
;


LABEL risch_ratpart
::
  %ABSCOERCE
  2DUP RP# rr#!			( lvar quo...result numk denk fk #mk )
  SWAPDUP dlvar rischder!	( lvar quo...result numk denk #mk fk fk' )
  3PICK #1=case ROTDROP
  2DUP REGCDext			( lvar quo...reslt numk denk #mk fk fk' g a b )

  ( avec g=b*fk'+a*fk )

  Z0 ratpart! Z1 temp_stor!
  6PICK
  ONE_DO (DO)

* q.n=numk, q.d=denok, fk=r2
* nouveau q2= [q2/g]*a+ [ [q2/g]*b/[i-1] ]' )
* a rajouter a result: -[q2/g]*b/[i-1]/fk^i-1 )

				( lvar quo...result numk denk # fk fk' g a b )
	8ROLL 8ROLL		( ..., #, r2, r2', g, a, b, q.n, q.d )
	4PICK 3PICK RMULText
	6PICK 3PICK RMULText
	NDXFext

* on peut mettre NDXFext en dernier si on est sur que g n'est pas un seco

				( ... # r2 r2' g a b q.n q.d q2*a/g )
	ROT 4PICK RMULText 
	6PICK
	ISTOP-INDEX #>Z RMULText
	4ROLL RMULText NDXFext	( ... # r2 r2' g a b q2*a/g q2*b/[g*[i-1]] )
	DUP dlvar rischder!	( # r2 r2' g b a q2/g*a q2/g*b/i-1 derivee )
	ROT RADDext		( # r2 r2' g b a q2/g*b/i-1 new_q2 )
	( on divise par r2#i-1 )
	rr# 8PICK QUOText DUP rr#! 
	NEWDIVext SWAPDROP FXNDext
	NINE UNROLL NINE UNROLL	( new_q.n new_q.d # r2 r2' g b a q2/g*b/i-1 )
	rr# NEWDIVext SWAPDROP	( new_q.n new_q.d # r2 r2' g b a q2/g*b/i-1 )
	temp_stor RMULText
	ratpart RADDext ratpart!	( new_q.n new_q.d # r2 r2' g b a )
	5PICK
	temp_stor RMULText temp_stor!	( new_q.n new_q.d # r2 r2' g b a )
  LOOP
  3DROP			( lvar quo...result new_q.n new_q.d # r2 r2' )
  6ROLL ratpart
  VAL1 FXNDext		( lvar quo...new_q.n new_q.d # r2 r2' res n d )
  5PICK VAL1
  7ROLL #1-
  UNCOERCE x^ext	( lvar quo...new_q.n new_q.d r2 r2' res n d r2^ )
  x*ext NDXFext x-ext	( lvar quo...new_q.n new_q.d r2 r2' new-res )
  5UNROLL		( lvar quo...new-res new_q.n new_q.d r2 r2' )
;

LABEL multder2!
::				( p-liste, liste der-lvar -> fr-liste )
  OVER TYPELIST? NOTcase2drop Z0
  INNERCOMP #1- {}N		( p-liste, der, Lreste )
  UNROT
  num#1=case7 :: DROPSWAPDROP PDer ;
					( Lreste, p-liste, der )
  SWAPINCOMP				( Lreste, der, pn, ..., p0, #n+1 )
  get1 SWAP#1+ get1 Z0 ROT #1-
  ZERO_DO (DO)				( pn...p0, der Lreste result )
	4ROLL DUPINDEX@ #>Z RMULText	( pn... der Lreste result p0 j*p0 )
	Z0 INDEX@ 
	DUP#0=ITE
	   2DROP			( il reste Z0 )
	   :: NDUPN SWAPDROP {}POLY ;
				( pn... der rlder result p0 j*p0*x^[j-1] )
	5PICK RMULText		( pn... der rlder result p0 j*p0*x'*x^[j-1] )
	SWAP4PICK		( pn... der rlder result p0*x^j' p0 rlder )
	rischder!		( pn... der rlder result p0*x^j' p0' )
	FXNDext ONE>POLY
	SWAP
	Z0 INDEX@ NDUPN #1+ {}POLY
	TRIMOBJext SWAPNDXF	( pn... der rlder result p0*x^j' p0'*x^j )
	RADDext RADDext		( pn... der rlder result )
  LOOP
  UNROT2DROP
;

LABEL rischder!
* multivariate derivative
:: 
( fr-liste, derivee-lvar -> fr-liste' )
* derivee multivariables dependant de x 
* ex: ln(x)+2x est code { 1 {2 0} } par rapport a
* lvar { LN(X) X }
* la derivee de lvar est ici { '1/{{1 0}}' 1 }
* la derivee de fr-liste est '{{2 1}}/{{1 0}}'
* ex2: si lvar={ 'EXP(LN(X)^2)' 'LN(X)' X }
* alors derivee_lvar est 
* { '{{2 0} {0}}/{{{1 0}}}' '1/{{1 0 }}' 1 }
* Attention: la derivee de LN(X)=1/X '1/{{1 0}}'
* s'exprime en fonction de lvar tronquee, ici par rapport a 
* { 'LN(X)' X } et pas par rapport a lvar complet	

  ( fr-liste, liste derivee-lvar -> fr-liste )

  DUPNULL{}? casedrop PDer
  SWAPFXND OVER					( dlvar, n, d, n )
  4PICK multder2!				( dlvar, n, d, n' )
  OVER NOTLISTcase :: RDIVext 4UNROLL3DROP ;
						( dlvar, n, d, n', d )
  RMULText OVER					( dlvar, n, d, d*n', d )
  5ROLL multder2!				( dlvar, n, d, d*n', d' )
  4ROLL RMULText RSUBext			( d, d*n'-d'*n )
  SWAPDUP RMULText RDIVext			( [n'd-nd']/d^2 )
;

LABEL addtSQRTonly7
:: addt: x\v/ ;

* From CAS/sym2r.s
LABEL lvarxnxexpln
* like LVARXNXext but sort lvarx with LN before EXP
::
  LVARXNXext
  ' FLASHPTR Exp<Ln TOTEMPOB
  SortList
;

NULLNAME Exp<Ln
* obj1 obj2 -> ?
* return false if symb1 begins with EXP and symb2 with LN
::
  CK&DISPATCH1
  # 99 Exp<Ln2symb
  any 2DROPTRUE
;

LABEL Exp<Ln2symb
* symb2 symb1 -> ?
* return false if symb1 begins with EXP and symb2 with LN
::
  LASTCOMP EQ: xEXP 			( symb2 op=ln? )
  NOTcase DROPTRUE
  					( symb2 )
  LASTCOMP EQ: xLN NOT
;

* From CAS/replace.s
**********************************************************************
* Desc:		x -> ln((1+x)/(1-x))
* Stack:	( meta --> meta' )
**********************************************************************
NULLNAME addtATANH*2
::
  1&meta dup addt+ psh addt- metadiv metasimp addtLN
;

NULLNAME 'ID210
:: ' ID  TOTEMPOB ;

NULLNAME TRIGTAN^
::					( meta meta-power )
  OVER TYPEZINT? NOTcase top&addt^only
  DROP OVER#2+UNROLL			( power meta-obj )
  AEQ1stcase xSIN TRIGSIN^
  AEQ1stcase xCOS TRIGCOS^
  get1meta^				( obj^power )
;

LABEL TRIGSIN^
::
  TRIG2LAMBIND				( meta )
  dup 1GETLAM meta^			( meta meta^mod )
  psh pulldrop addtTAN dup addtSQ	( meta^mod meta-tan meta-tan^2 )
  psh metasq+1 MetaDiv
  2GETLAM ABND meta^
  MetaMul
;

LABEL TRIGCOS^
::
  TRIG2LAMBIND				( meta )
  dup 1GETLAM meta^			( meta meta^mod )
  psh pulldrop addtTAN metasq+1		( meta^mod meta-tan^2+1 )
  2GETLAM ABND meta^
  MetaDiv
;

LABEL get1meta^
::
  get1 meta^
;

LABEL TRIG2LAMBIND
::					( z meta )
  get1 Z2 ZDIVext 			( meta-obj pow/2 pow_mod_2 )
  2LAMBIND				( meta )
;

NULLNAME pldrpSYMBNSWP1+
:: pulldrop SYMBN SWAP#1+ ;

NULLNAME SQRT1+TAN^2
::
  SYMBINCOMP addtTAN metasq+1 addtSQRTonly7 CKSYMBN 
  SIMP1ext
;

NULLNAME COS*1+TAN^2
::
  SYMBINCOMP dup addtCOS psh addtTAN metasq+1 MetaMul CKSYMBN
;

NULLNAME TRIGPOW
::					( meta meta-power )
  OVER TYPEZINT? NOTcase top&addt^only

  DROP OVER#2+UNROLL			( z meta )
  AEQ1stcase xSIN TRIGPOWSIN
  AEQ1stcase xCOS TRIGPOWCOS
  AEQ1stcase xTAN TRIGPOWTAN
  get1meta^
;

LABEL TRIGPOWSIN
::					( z meta )
  prefersinflag TestSysFlag 
  case get1meta^
					( z meta )
  TRIG2LAMBIND				( meta )
  dup pulldrop addtCOS meta1-sq 	( meta-sin meta-1-cos^2 )
  2GETLAM meta^
  psh 1GETABND meta^ metamult
;

LABEL TRIGPOWCOS
::					( z meta )
  prefersinflag TestSysFlag 
  NOTcase get1meta^
					( z meta )
  TRIG2LAMBIND				( meta )
  dup pulldrop addtSIN meta1-sq 	( meta-cos meta-1-sin^2 )
  2GETLAM meta^
  psh 1GETABND meta^ metamult
; 

LABEL TRIGPOWTAN
::					( z meta-tan )
  pulldrop get1 1LAMBIND		( meta )
  dup addt: xSIN 			( meta meta-sin )
  1GETLAM				( meta meta-sin z )
  OVER#2+UNROLL				( meta z meta )
  TRIGPOWSIN				( meta meta-sin^ )
  psh addt: xCOS			( meta-sin^ meta-cos )
  1GETABND OVER#2+UNROLL		( meta-sin^ z meta-cos )
  TRIGPOWCOS				( meta-sin^ meta-cos^ )
  metadiv				( meta )
;

LABEL top&addt^only
:: top& addt: x^ ;

* From CAS/erable.s
NULLNAME TWICEONE>POLY
:: SWAP ONE>POLY SWAP ONE>POLY ;

* From CAS/gcd.s
NULLNAME EXTRACTCOMMONDENO
* meta -> d meta'
* extract deno of meta so that no fraction remains in meta'
* after multiplication by d
::
  dup METADENOLCM			( meta-s d' )
  SWAPDUP				
  ZERO_DO (DO)
    get1 3PICK RMULText UNROT
  LOOP				
  SWAPOVER #2+UNROLL
;

**********************************************************************
* Desc:		make change in [list of] equation for SOLVE
* Stack:	( {eq} var -> {eq'} var )
**********************************************************************
NULLNAME REWRITEFORSOLVE
::
  RCLVX ' FLASHPTR REWRITE1FORSOLVE TOTEMPOB 	( {eq} var vx prog )
  2LAMBIND STOVX				( {eq} )
  DUPTYPELIST? ITE LISTSECOext :: 1GETLAM EVAL ;
  RCLVX 2GETLAM ABND STOVX			( {eq} var )
;

**********************************************************************
* Desc:		make change in 1 equation for SOLVE
* Stack:	( eq -> eq' )
**********************************************************************
NULLNAME REWRITE1FORSOLVE
::
  LVARXNXext UNROT2DROP				( eq lvarx )
  ( * if only 1 var dep. on X then OK * )
  DUPLENCOMP DUP#0= case2DROP 			( -> eq )
						( eq lvarx # )
  #1= caseDROP					( -> eq )
						( eq lvarx )
  ( * more than 1 var, try to decrease # of var * )
  ( * if LN present do LNCOLLECT * )
  DUP' CONTAINS_LN? Find1stTrue case2drop :: SYMCOLCT LNCOLCext ;
						( eq lvarx )
  SQRT_IN? case REWRITESQRTFORSOLVE
  ( * no more rewriting, try TEXPAND, should try trig simplif after * )
  DROP TEXPAext 				( eq )
  LVARXNXext UNROT2DROP				( eq lvarx )
  DUPLENCOMP #1= casedrop SYMCOLCT
  DUP' CONTAINS_EXP? Find1stTrue case2drop SYMCOLCT
  DROP HALFTAN SYMCOLCT			( eq )
;

LABEL CONTAINS_EXP?
::	
  DUPTYPESYMB? NOTcase DROPFALSE
  ' xEXP ' EQ POSCOMP #0<>
;


LABEL REWRITESQRTFORSOLVE
::						( eq lvarx varsqrt )
  ( * if varsqrt is linear wrt x rewrite var wrt to varsqrt * )
  SWAPDROPDUP EXPR> 2DROP			( eq varsqrt argsqrt )
  LINEAIRE?					( eq varsqrt arg a ? )
  NOTcase 3DROP					( -> eq )
  ( * argsqrt=a*x+b -> x=[varsqrt^2-b]/a * )
  						( eq varsqrt arg a )
  SWAPOVER RCLVX x*ext x-ext SIMPLIFY		( eq varsqrt a b )
  3PICK SYMBINCOMP Z2 ' x^ ROT #2+		( eq varsqrt a b meta )
  get1 SYMBINCOMP metasub			( eq varsqrt a meta )
  get1 SYMBINCOMP metadiv CKSYMBN		( eq varsqrt x-replace )
  RCLVX 3PICK TWO{}N				( eq varsqrt x-replace {} )
  UNROTSWAP TWO{}N MEVALext			( eq' )
;

LABEL LINEAIRE?
* symb -> symb a ?
* if symb is linear returns true, a is the derivative of symb
::
  DUP RCLVX DIRECTDERIV SIMPLIFY	
  DUP RCLVX DIRECTDERIV
  Z0 EQUAL	
;