INCLUDE cas2romid.h
INCLUDE erextdec.h
INCLUDE cas2ext.h
INCLUDE ../CAS/keydefs.h
INCLUDE ../CAS/global.s

        STITLE User menu interface

**********************************************************************
* EXPORT:
*
* MENUext       ( $6, $5, $4, $3, $2, $1  -> )
*               Displays 48S menu if displayflag is set
* WRITEMENU     ( $6, $5, $4, $3, $2, $1  -> )
*               Displays 48S menu 
*
* MENUXYext     ( #2, #1 -> {} )
*               List is made of the ROMPTR of Erable numbers between #2 and #1
*
* CFGDISPLAY    ( -> )
*               Displays Erable current config
*
* NEWVX         ( -> )
*               Change VX value
*
* NEWMODULO     ( -> )
*               Change MODULO value
*
* COMPLEXMODE   ( -> )
*               Set complex mode, refresh display
*
* REALMODE, EXACTMODE, NUMMMODE, INTARIT, POLYARIT, VERBOSEMODE,
* SILENTMODE, RECURMODE, NONRECMODE, PLUSAT0, PLUSATINFTY,
* FULLDATA, SPARSEDATA, RIGORMODE, SLOPPYMODE
*               Set the specified mode, refresh display
*
* MENUCHOOSE?   ( -> prg, TRUE )
*               ( -> FALSE )
*               Looks for a chooser (named CHOOSE2 or CHOOSE)
*
* MENUCHOOSE    ( {} -> prg )
*               Wait for user input (chooser or 48 menu from {})
*
* MENUGENE1     ( -> {} )
*               Menu for Erable
*
* MENUBASE1     ( -> {} )
*               Base algebra menu
*
* MENUCMPLX1    ( -> {} )
*               Complex menu
*
* MENUTRIG1     ( -> {} )
*               Trigo menu
*
* MENUMAT1      ( -> {} )
*               Matrix menu
*
* MENUARIT1     ( -> {} )
*               Arithmetic menu
*
* MENUSOLVE1    ( -> {} )
*               Solver menu
*
* MENUDIFF1     ( -> {} )
*               Diff calculus menu
*
* PROMPTSTO1    ( idnt/lam -> )
*               Displays idnt/lam, wait for user input, 
*               stores input in idnt/lam
*
* XGROBext      ( obj -> grob )
*               Convert object to a grob using AGROB ->GROB2 or ->GROB
*
* GROBADDext    ( grob2, grob1 -> grob )
*                      | grob2
*               grob = |
*                      | grob1
*
* DISPLAYext    ( grob, obj -> grob' )
*               Adds converted obj to grob
*
* SCROLLext     ( grob -> )
*               Stores grob in PICT and launches PICT environment
**********************************************************************

**********************************************************************
* Desc:         Display 48S menu
* Stack:        ( $6, $5, $4, $3, $2, $1  -> )
* Note:         Tests displayflag
**********************************************************************
NULLNAME MENUext
::
  displayflag TestSysFlag NOTcase 6DROP
  WRITEMENU
;

**********************************************************************
* Desc:         Display 48S menu
* Stack:        ( $6, $5, $4, $3, $2, $1  ->  )
**********************************************************************
NULLNAME WRITEMENU
::
  ZERO
  SIX ZERO_DO (DO)                      ( strings, # )
      TWENTYTWO OVER#+ UNROTSWAP
      TOTEMPOB Str>Menu
  LOOP
  DROP
;


**********************************************************************
* Desc:         Display current configuration of Erable
* Stack:        ( --> )
**********************************************************************
NULLNAME CFGDISPLAY
::
ASSEMBLE
	IF	f39
RPL
ASSEMBLE
	ELSE	f39
RPL
  "CAS CONFIG" DISPROW1
  NULL$           DISPROW2

  COMPLEX?  ITE "COMPLEX" "REAL" 
  EXACT? ITE " EXACT" " APPROX"
  &$ DISPROW3

  "Indep VX=" RCLVX     DO>STR &$ DISPROW4
  "Z/nZ, n="  RCLMODULO DO>STR &$ DISPROW5

  displayflag SysITE "VERB" "SIL."
  nonrecurflag SysITE " NON REC." " RECURS." &$ 
  stepflag SysITE " STEP" " DRCT" &$ 
  DISPROW6

  increaseflag SysITE "Incr.^" "Decr.^" 
  bigdataflag  SysITE " BIG  " " SMALL" &$
  nocareflag   SysITE " SLOPPY" " RIGOR" &$
  DISPROW7

  SetDA12Temp
ASSEMBLE
	ENDIF	f39
RPL
;

**********************************************************************
* Desc:         Input new current variable from the user
* Stack:        ( --> )
**********************************************************************
NULLNAME NEWVX
::
  "VX=" TOTEMPOB                                ( $prompt )
  RCLVX ID>$                            ( $editline )
  ZEROZERO                              ( eol, current mode )
  ZEROZERO                              ( curr, curr )
  FALSE ONE
  FALSE ZERO
  InputLine
  NOTcase CFGDISPLAY
  palparse NcaseSIZEERR
  STOVX CFGDISPLAY
;

**********************************************************************
* Desc:         Input new modulo from the user.
* Stack:        ( --> )
**********************************************************************
NULLNAME NEWMODULO
::
  "p="  TOTEMPOB                        ( $prompt )
  RCLMODULO 
*  ASSEMBLE
*	IF	f39
*  RPL
*  Z>R 
*  ASSEMBLE
*	ENDIF	f39
*  RPL 
  DO>STR                      ( $editline )
  ZEROZERO                              ( eol, current mode )
  ZEROZERO                              ( curr, curr )
  FALSE ONE
  FALSE ZERO
  InputLine
  NOTcase CFGDISPLAY
  palparse NcaseSIZEERR
*  ASSEMBLE
*	IF	f39
*  RPL
*  R>Z 
*  ASSEMBLE
*	ENDIF	f39
*  RPL 
  DUPTYPEZ? ITE STOMODULO DROP
  CFGDISPLAY
;

**********************************************************************
* Desc:         Asks the user for mode ON switching
* Stack:        ( #flag --> )
* Note:         ERROR if the user does not want to switch
**********************************************************************
NULLNAME SWITCHON
::
  DUP TestSysFlag caseDROP
  noswitchflag TestSysFlag case SWITCHNOTALLOWED
  switchflag TestSysFlag 
ASSEMBLE
	IF	f39
RPL
  InCASApplication? NOT OR
ASSEMBLE
	ENDIF	f39
RPL
  case SetSysFlag
  FLAGNAME
  ( #flag $name )
  " mode on?" &$
  SWITCHLOOP
  SetSysFlag
*  " mode" &$ DISPROW1
*  "Want to switch ON?" DISPROW2
*  ( #flag )
*  SWITCHLOOP
*  "Switched ON" DISPROW2 SetDA1Temp
*  SetSysFlag
;

**********************************************************************
* Desc:         Asks the user for mode OFF switching
* Stack:        ( #flag --> )
* Note:         ERROR if the user does not want to switch
**********************************************************************
NULLNAME SWITCHOFF
::
  DUP TestSysFlag NOTcaseDROP
  switchflag TestSysFlag 
ASSEMBLE
	IF	f39
RPL
  InCASApplication? NOT OR
ASSEMBLE
	ENDIF	f39
RPL
  case ClrSysFlag
  DUP flagnames EQLookup ?SKIP :: UNCOERCE DO>STR ;
  ( #flag $name )
  " mode off?" &$
  SWITCHLOOP
  ClrSysFlag
  
*  " mode" &$ DISPROW1
*  "Want to switch OFF?" DISPROW2
*  ( #flag )
*  SWITCHLOOP
*  "Switched OFF" DISPROW2 SetDA1Temp
*  ClrSysFlag
;

LABEL SWITCHLOOP
::
ASSEMBLE
	IF	f39
RPL
  DoQueryBox
ASSEMBLE
	ELSE	f39
RPL
  % 5000 % 0.3 DOBEEP
  AskQuestion
ASSEMBLE
	ENDIF	f39
RPL
  ?SEMI
  BINT49 ERABLEERROR
*BEGIN
        ( #flag )
*       "No" NULL$ NULL$ DUPDUP "Yes" WRITEMENU
*       % 5000 % 0.3 DOBEEP WaitForKey
*       ( #flag #keycode #keyplane )
*       DROP { kcMenuKey6 kcMenuKey1 } ListPos
*       ( #flag #0--#2 )
*       DUP#0= ITE DROPFALSE TRUE
*UNTIL
*( #flag, # )
*#2= ?SEMI
*BINT49 ERABLEERROR
;

**********************************************************************
* Desc:         Find the name of a flag
* Stack:        ( #flag --> #flag, $flag_name )
**********************************************************************
NULLNAME FLAGNAME
::
DUP flagnames EQLookup ?SEMI 
UNCOERCE DO>STR "Flag " SWAP&$
;

LABEL flagnames
{ 
  fnConstants "Const -> value"
  fnResults "Function -> num"
  SEVENTEEN "Radian"
  complexflag "Complex" 
  approxflag "Approx." 
  increaseflag "Incr. power" 
  stepflag "Step by step"
  nocareflag "ABS(X)->X"
}

**********************************************************************
* Desc:         Asks for complex mode ON
* Stack:        ( --> )
**********************************************************************
NULLNAME COMPLEXON
::
complexflag SWITCHON
;

**********************************************************************
* Desc:         Asks for complex mode OFF
* Stack:        ( --> )
**********************************************************************
NULLNAME COMPLEXOFF
::
complexflag SWITCHOFF
;

**********************************************************************
* Desc:         Asks for exact mode ON
* Stack:        ( --> )
**********************************************************************
NULLNAME EXACTON
::
  approxflag SWITCHOFF nogcdflag ClrSysFlag
;

**********************************************************************
* Desc:         Asks for exact mode OFF
* Stack:        ( --> )
**********************************************************************
NULLNAME EXACTOFF
::
  approxflag SWITCHON nogcdflag SetSysFlag
;

**********************************************************************
* Desc:         Set complex mode, refresh configuration display.
* Stack:        ( --> )
**********************************************************************
NULLNAME COMPLEXMODE
:: SETCOMPLEX CFGDISPLAY ;

**********************************************************************
* Desc:         Set complex mode
* Stack:        ( --> )
**********************************************************************
NULLNAME SETCOMPLEX
:: complexflag SetSysFlag ;

**********************************************************************
* Desc:         Test complex mode
* Stack:        ( --> flag )
**********************************************************************
NULLNAME COMPLEX?
:: complexflag TestSysFlag ;

**********************************************************************
* Desc:         Set real mode, refresh configuration display
* Stack:        ( --> )
**********************************************************************
NULLNAME REALMODE
:: CLRCOMPLEX CFGDISPLAY ;

**********************************************************************
* Desc:         Set real mode
* Stack:        ( --> )
**********************************************************************
NULLNAME CLRCOMPLEX
:: complexflag ClrSysFlag ;

**********************************************************************
* Desc:         Set exact mode, refresh configuration display
* Stack:        ( --> )
**********************************************************************
NULLNAME EXACTMODE
:: SETEXACT CFGDISPLAY ;

**********************************************************************
* Desc:         Set exact mode and gcd mode
* Stack:        ( --> )
**********************************************************************
NULLNAME SETEXACT
:: approxflag ClrSysFlag nogcdflag ClrSysFlag ;

**********************************************************************
* Desc:         Set numeric mode, refresh configuration display
* Stack:        ( --> )
**********************************************************************
NULLNAME NUMMODE
:: CLREXACT CFGDISPLAY ;

**********************************************************************
* Desc:         Clear exact mode
* Stack:        ( --> )
**********************************************************************
NULLNAME CLREXACT
:: approxflag SetSysFlag nogcdflag SetSysFlag ;

**********************************************************************
* Desc:         Test exact mode
* Stack:        ( --> flag )
**********************************************************************
NULLNAME EXACT?
* :: SYMB? NOTcaseFALSE approxflag TestSysFlag NOT ;
* changed to
:: 
  approxflag TestSysFlag                        ( ? )
  ( * this is for security! * )
  nogcdflag OVER ITE SetSysFlag ClrSysFlag      ( ? )

  NOT 
;

**********************************************************************
* Desc:         Set step by step flag, refresh conf. display
* Stack:        ( --> )
**********************************************************************
NULLNAME STEPBYSTEP
:: stepflag SetSysFlag CFGDISPLAY ;

**********************************************************************
* Desc:         Clear step by step flag, refresh conf. display
* Stack:        ( --> )
**********************************************************************
NULLNAME NOSTEPBYSTEP
:: stepflag ClrSysFlag CFGDISPLAY ;

**********************************************************************
* Desc:         Set verbose mode, refresh configuration display
* Stack:        ( --> )
**********************************************************************
NULLNAME VERBOSEMODE
:: displayflag SetSysFlag CFGDISPLAY ;

**********************************************************************
* Desc:         Set silent mode, refresh configuration display
* Stack:        ( --> )
**********************************************************************
NULLNAME SILENTMODE
:: displayflag ClrSysFlag CFGDISPLAY ;

**********************************************************************
* Desc:         Set recursive mode, refresh configuration display
* Stack:        ( --> )
**********************************************************************
NULLNAME RECURMODE
:: nonrecurflag ClrSysFlag CFGDISPLAY ;

**********************************************************************
* Desc:         Set nonrecursive mode, refresh configuration display
* Stack:
**********************************************************************
NULLNAME NONRECMODE
:: nonrecurflag SetSysFlag CFGDISPLAY ;

**********************************************************************
* Desc:         Set positive mode, refresh configuration display
* Stack:
**********************************************************************
NULLNAME PLUSAT0
:: SETPLUSAT0 CFGDISPLAY ;

**********************************************************************
* Desc:         Set positive mode
* Stack:
**********************************************************************
NULLNAME SETPLUSAT0
:: increaseflag SetSysFlag ;

**********************************************************************
* Desc:         Set positive infinity mode, refresh configuration display
* Stack:
**********************************************************************
NULLNAME PLUSATINFTY
:: CLRPLUSAT0 CFGDISPLAY ;

**********************************************************************
* Desc:         Set positive infinity mode
* Stack:
**********************************************************************
NULLNAME CLRPLUSAT0
:: increaseflag ClrSysFlag ;

**********************************************************************
* Desc:         Set full data mode, refresh configuration display
* Stack:
**********************************************************************
NULLNAME SPARSEDATA
:: bigdataflag ClrSysFlag CFGDISPLAY ;

**********************************************************************
* Desc:         Set sparse mode, refresh configuration display
* Stack:        ( --> )
**********************************************************************
NULLNAME FULLDATA
:: bigdataflag SetSysFlag CFGDISPLAY ;

**********************************************************************
* Desc:         Set rigorous mode, refresh configuration display
* Stack:
**********************************************************************
NULLNAME RIGORMODE
:: nocareflag ClrSysFlag CFGDISPLAY ;

**********************************************************************
* Desc:         Set sloppy mode, refresh configuration display
* Stack:
**********************************************************************
NULLNAME SLOPPYMODE
:: nocareflag SetSysFlag CFGDISPLAY ;

**********************************************************************
* Desc:         Test sloppy mode
* Stack:        ( -> flag )
**********************************************************************
NULLNAME SLOPPY?
:: nocareflag TestSysFlag ;

**********************************************************************
* Desc:         Return best CHOOSE command
* Stack:        ( --> prg TRUE | FALSE )
**********************************************************************
NULLNAME MENUCHOOSE?
::
ASSEMBLE
	IF f39
RPL
  ' ::						( "" {} %1 )
     OVER 4UNROLL				( {} "" {} %1 )
     ( choice{} $title choice{} %default )
     Ck&DoChoose				( {} % %1 | {} %0 )
     %0= casedrop %0				( -> %0 )
     COERCE NTHCOMPDROP
     %1						( -> prg %1 )
    ;
    TRUE
ASSEMBLE
	ELSE	f39
RPL
  "CHOOSE2" TOTEMPOB palparse NcaseSIZEERR
  DUPTYPEROMP? caseTRUE
  DROP
  "CHOOSE" TOTEMPOB palparse NcaseSIZEERR
  DUPTYPEROMP? caseTRUE
  DROPFALSE
ASSEMBLE
	ENDIF	f39
RPL
;

**********************************************************************
* Desc:         Wait for user selection
* Stack:        ( {} --> prg )
* Note:         does not evaluate object
**********************************************************************
NULLNAME MENUCHOOSE
::
  chooseflag TestSysFlag
  case :: ' ROMPTR xMAIN >TCOMP InitMenu ;
  MENUCHOOSE? NOTcase InitMenu
                                                ( liste, prg )
  SWAP CHOOSE>$					( prg liste )
  NULL$ SWAP %2 4ROLL 				( {} "" %1 prg )
  EVAL						( [ prg %1 | %0 ] )
  %0= case CASNULL::
ASSEMBLE
	IF	f39
RPL
  DUP ONE THREE SUB$ "CFG" EQUAL casedrop 
  ROMPTR xCASCFG
ASSEMBLE
	ELSE	f39
RPL
  DUP CAR$ CHR_0 EQUAL casedrop 
  ROMPTR xMAIN
                                                ( $ )
  BEGIN
     DUP CDR$ SWAP CAR$ CHR_. EQUAL
  UNTIL
ASSEMBLE
	ENDIF	f39
RPL
						( $ )
  palparse NcaseSIZEERR
*  #IF f39
*  EVAL
*  #ENDIF
 EVAL
;

**********************************************************************
* Desc:         Menu for Erable
* Stack:        ( --> {} )
**********************************************************************
NULLNAME MENUGENE1
::
{ 
  ROMPTR xCASCFG
  ROMPTR xALGB
  ROMPTR xDIFF
  ROMPTR xMATHS
  ROMPTR xTRIGO
  ROMPTR xSOLVER
ASSEMBLE
	IF	f39
RPL
ASSEMBLE
	ELSE	f39
RPL
  ROMPTR xCMPLX
  ROMPTR xARIT
  ROMPTR xEXP&LN
  ROMPTR xMATR
  ROMPTR xREWRITE
ASSEMBLE
	ENDIF	f39
RPL
}
TOTEMPOB
;

**********************************************************************
* Desc:         Base algebra menu
* Stack:        ( --> {} )
**********************************************************************
NULLNAME MENUBASE1
::
  { ROMPTR xCOLLECT ROMPTR xDEF
    ROMPTR xEXPAND ROMPTR xFACTOR ROMPTR xPARTFRAC
    ROMPTR xQUOTE ROMPTR xSTORE xWHERE ROMPTR xSUBST 
    ROMPTR xTEXPAND ROMPTR xUNASSIGN
  }
  TOTEMPOB
;

**********************************************************************
* Desc:         Complex operations menu
* Stack:        ( --> {} )
**********************************************************************
NULLNAME MENUCMPLX1
::
  { xi xABS xARG xCONJ xDROITE xFLOOR xIM xMOD xNEG xRE xSIGN } TOTEMPOB
;

**********************************************************************
* Desc:         Trigonometric operations menu
* Stack:        ( --> {} )
**********************************************************************
NULLNAME MENUTRIG1
::
  { ROMPTR xACOS2S ROMPTR xASIN2C ROMPTR xASIN2T ROMPTR xATAN2S 
    ROMPTR xHALFTAN ROMPTR xSINCOS ROMPTR xTAN2CS2 ROMPTR xTAN2SC
    ROMPTR xTAN2SC2 ROMPTR xTCOLLECT ROMPTR xTEXPAND
    ROMPTR xTLIN
    ROMPTR xTRIG ROMPTR xTRIGCOS 
    ROMPTR xTRIGSIN ROMPTR xTRIGTAN 
  }
  TOTEMPOB 
;

**********************************************************************
* Desc:         Matrix operations menu
* Stack:        ( --> {} )
**********************************************************************
NULLNAME MENUMAT1
::
  BINT69 BINT83 MENUXYext
;

**********************************************************************
* Desc:         Arithmetic operations menu
* Stack:        ( --> {} )
**********************************************************************
NULLNAME MENUARIT1
::
  { xINTEGER xMODULAR xPOLYNOMIAL } TOTEMPOB
;

**********************************************************************
* Desc:         Solver menu
* Stack:        ( --> {} )
**********************************************************************
NULLNAME MENUSOLVE1
::
  { 
    ROMPTR xDESOLVE 
    ROMPTR xISOL 
    ROMPTR xLDEC ROMPTR xLINSOLVE 
    ROMPTR xSOLVE ROMPTR xSOLVEVX 
  }
  TOTEMPOB
;

**********************************************************************
* Desc:         Exponential and ln menu (?)
* Stack:        ( --> {} )
**********************************************************************
NULLNAME MENUEXPLN1
::
  NINETEEN TWENTYTHREE MENUXYext
;

**********************************************************************
* Desc:         Differential calculus menu
* Stack:        ( --> )
**********************************************************************
NULLNAME MENUDIFF1
::
  { ROMPTR xDERIV ROMPTR xDERVX ROMPTR xDIVPC ROMPTR xFOURIER
  ROMPTR xIBP ROMPTR xINTVX ROMPTR xLIMIT ROMPTR xPREVAL 
  ROMPTR xRISCH ROMPTR xSERIES ROMPTR xTABVAR ROMPTR xTAYLOR0 ROMPTR xTRUNC }
  TOTEMPOB
;

**********************************************************************
* Desc:         Input value for the desired variable
* Stack:        ( id/lam --> )
* Note:         affiche idnt/lam, prend une entree au clavier et
*               stocke cette entree dans la variable 
**********************************************************************
NULLNAME PROMPTSTO1
::
  DUP DO>STR NULL$
  ZEROZERO                              ( eol, current mode )
  ZEROZERO                              ( curr, curr )
  FALSE ONE
  FALSE ZERO
  InputLine NcaseSIZEERR                ( idnt/lam, input )
  DUPNULL$? caseSIZEERR
  palparse NcaseSIZEERR
  DUPTYPESYMB? IT COMPEVAL              ( idnt/lam, input )
  SWAP ?STO_HERE
;

**********************************************************************
* Desc:         Convert object to a grob
* Stack:        ( ob --> grob )
**********************************************************************
NULLNAME XGROBext
::
  DUPTYPEGROB? ?SEMI
*  "AGROB" palparse NcaseTYPEERR
*  DUPTYPEROMP? case :: %2 SWAP EVAL ;
*  DROP "GROB2" palparse NcaseTYPEERR
*  DUPTYPEROMP? case :: %0 SWAP EVAL ;
*  DROP 
  ROMOBJ?TOTEMPOB
  DUPTYPECSTR? ITE %2 %0 DO>GROB
* ' x\->GROB EvalNoCK
;

**********************************************************************
* Desc:         Vertical grob addition
* Stack:        ( grob2 grob1 --> grob )
* Note:         grob 2 will be above grob 1
**********************************************************************
NULLNAME GROBADDext
::
  DUPGROBDIM                            ( g1, g2, #l2, #c2 )
  4PICK GROBDIM                         ( g1, g2, #l2, #c2, #l1, #c1 )
  ROT #MAX UNROT                        ( g1, g2, #c, #l2, #l1 )
  DUPUNROT #+ ROT                       ( g1, g2, #l1, #l1+l2, #max[c1,c2]  )
  MAKEGROB                              ( g1, g2, #l1, g )
  DUP4UNROLL ZERO ROT GROB!             ( g1, g )
  SWAPOVER ZEROZERO GROB!
;

**********************************************************************
* Desc:         Adds ob to grob after converting it to a grob.
* Stack:        ( grob ob --> grob' )
* Note:         appelle XGROB sur obj, ajoute le resultat a grob1
*               puis affiche selon stepflag
**********************************************************************
NULLNAME DISPLAYext
::
  XGROBext GROBADDext
  DUP SCROLLext
;

**********************************************************************
* Desc:         Launches PICT environment
* Stack:        ( grob --> )
**********************************************************************
NULLNAME SCROLLext
::
  stepflag TestSysFlag NOTcaseDROP
*  xPICT xSTO
*  GBUFFGROBDIM
*  DROP SIXTYFOUR
*  2DUP#> NOTcase2drop GrobView ( was DOGRAPHIC )
*  #- ZEROSWAP WINDOW# TOGDISP 
*  GRAPHICGUTS ( DOGRAPHIC )
ASSEMBLE
        IF      f39
RPL
*  RunViewObject
  FALSE SWAP ViewGrobObject DROP
ASSEMBLE
        ELSE    f39
RPL
  ViewObject 
ASSEMBLE
        ENDIF   f39
RPL
;

**********************************************************************
**********************************************************************
* Desc:         Fetch MODULO from the home directory
* Stack:        ( --> Z )
**********************************************************************
NULLNAME RCLMODULO
::
  CONTEXT@ CASDIR
  ' ID MODULO DUP@      ( rrp, 'modulo', obj, TRUE | rrp, 'modulo', false )
  IT
  ::                            ( rrp, 'modulo', obj )
     OBJINT? NOTcaseDROP        ( -> rrp 'modulo' )
                                ( rrp 'modulo' zint )
     RDROP SWAPDROPSWAP         ( zint rrp )
     CONTEXT!                   ( zint )
  ;
                        ( rrp, 'modulo' )
  ZINT 13 TOTEMPOB DUPROT STO
  SWAP CONTEXT!
;

**********************************************************************
* Desc:         Fetch PERIOD from the home directory
* Stack:        ( --> sym )
**********************************************************************
NULLNAME RCLPERIOD
::
  CONTEXT@ CASDIR
  ' ID PERIOD DUP@      ( rrp period obj TRUE | rrp period false )
  ITE
  ::                    ( rrp period obj )
     CK&DISPATCH1
     sym SWAPDROP
     real SWAPDROP
     cmp SWAPDROP
     any DROP
  ;
  TOTEMPOB
                        ( rrp period )
  SWAP CONTEXT!
;

**********************************************************************
* Desc:         Fetch VX from home directory
* Stack:        ( --> id )
**********************************************************************
NULLNAME RCLVX
::
  ( * on the 40, if not in EQW replace vx with S1 * )
ASSEMBLE
	IF	f39
RPL
  InCASApplication? NOTcase xS1
ASSEMBLE
	ENDIF	f39
RPL
  CONTEXT@ CASDIR
  ' ID VX DUP@                  ( rrp, vx, obj, TRUE | rrp, vx, false )
  IT
  ::                            ( rrp, vx, obj )
    DUPTYPELIST? IT CARCOMP
    DUPTYPEIDNT? NOTcaseDROP
    RDROP
    SWAPDROPSWAP
    CONTEXT!                    ( vx )
  ;
                                ( rrp, vx )
  CASIDX DUPROT STO
  SWAP CONTEXT!                 ( vx )
;

**********************************************************************
* Desc:         Store object in VX
* Stack:        ( ob --> )
**********************************************************************
NULLNAME STOVX
::
ASSEMBLE
	IF	f39
RPL
  InCASApplication? 
  NOTcase :: xS1 EQUAL ?SEMI BINT95 ERABLEERROR ;
  ( * store vx desactivated in HOME * )
ASSEMBLE
	ENDIF	f39
RPL
  CONTEXT@ SWAP CASDIR
  ' ID VX STO
  CONTEXT!
;

**********************************************************************
* Desc:         Store object in MODULO
* Stack:        ( ob --> )
**********************************************************************
NULLNAME STOMODULO
::
  ZABS Z2 ZNMax                 ( ob must be >=2 )
  CONTEXT@ SWAP CASDIR
  ' ID MODULO STO
  CONTEXT!
;

**********************************************************************
* Desc:         Fetch EPS from home directory
* Stack:        ( --> % )
**********************************************************************
NULLNAME RCLEPS
::
  CONTEXT@ CASDIR
  ' ID EPS DUP@         ( rrp, epsilon, obj, TRUE | rrp, epsilon, false )
  IT
  ::                                    ( rrp, epsilon, obj )
    DUPTYPEREAL? NOTcaseDROP
    num0=case DROP
    %ABS SWAPDROPSWAP
    RDROP
    CONTEXT!
  ;
                                        ( rrp, modulo )
  % 0.0000000001 TOTEMPOB DUPROT STO
  SWAP CONTEXT!
;

**********************************************************************
* Desc:         Test if id is real
* Stack:        ( id --> id ob true | id false )
* Note:         ob is the object containing id
*               it can be for example an equation like 1<x<2
*               that might be used in the futur 
**********************************************************************
NULLNAME ISIDREAL?
::
  CONTEXT@ CASDIR               ( id rrp )
  ' ID REALASSUME DUP@          ( id rrp ass ob TRUE | id rrp ass false )
  IT TESTIDREAL
                                ( id rrp ass )
  NULL{} SWAP STO               ( id rrp )
  CONTEXT! 			( id )
  TESTALLREAL			(  id ob true | id false ) 
;

LABEL TESTALLREAL
::				( id )
  allrealflag TestSysFlag 	( id ? )
  NOTcaseFALSE                	( -> id false )
  DUP TRUE			( -> id id true )
;

LABEL TESTIDREAL
::                              ( id rrp ass ob )
  DUPTYPELIST? NOTcaseDROP
                                ( id rrp ass {} )
  SWAPDROPSWAP                  ( id {} rrp )
  CONTEXT! RDROP                ( id {} )
  OVER 1LAMBIND                 ( id {} )
  ' :: 1GETLAM Contains? UNROT2DROP ;
  Find1stTrue ABND              ( id ob true | id false ) 
  caseTRUE			( -> id ob true )
  TESTALLREAL			( id ob true | id false ) 
;

**********************************************************************
* Desc:         Add idnt to the list of real var
* Stack:        ( idntlam/symb -->  )
**********************************************************************
NULLNAME ADDTOREAL
::
* quick check
  DUPTYPESYMB? case ASSUMEREAL
  IDNTLAM? NcaseSIZEERR
  ISIDREAL? case REMOVE&ADD
  PUTOBJINASSUME
;

LABEL REMOVE&ADD
::                              ( id obj )
  2DUP EQUAL case2DROP
                                ( id obj )
  REMOVEFROMASSUME              ( id ob )
  DROP PUTOBJINASSUME           ( )
;

LABEL PUTOBJINASSUME
::                              ( id )
  CONTEXT@ CASDIR               ( id rrp )
  ' ID REALASSUME DUP@          ( id rrp ass ob TRUE | id rrp ass false )
  case ADDTOREALNOW  
                                ( id rrp ass )
  ID2REAL
;

LABEL ID2REAL
::                              ( id rrp ass )
  ROT ONE{}N                    ( rrp ass {} )
  SWAP STO CONTEXT!
;

LABEL ADDTOREALNOW
::                              ( id rrp ass ob )
  DUPTYPELIST? NOTcasedrop ID2REAL
                                ( id rrp ass ob )
  4ROLL AppendList              ( rrp ass ob )
  SWAP STO CONTEXT!
;

LABEL DUPEVEN?
* # -> # ?
:: DUPTWO #/ DROP #0= ;

LABEL ASSUMEREAL
::
  DUPINCOMP DUP#1= casedrop :: SWAPDROP ADDTOREAL ;
                                        ( symb meta )
  ( * meta must be id meta-expr >|>=|<|<= * )
  OVER { x< x<= x> x>= } TOTEMPOB ListPos       ( symb meta # )
  DUP#0=csedrp SETSIZEERR
                                        ( symb meta # )
  OBJ>R pulldrop larg                   ( symb meta1 meta2 )
  NDROP CKSYMBN                         ( symb arg1 )
  R>OBJ SWAP IDNTLAM? NcaseSIZEERR      ( symb # idnt1 )
  ( * check if idnt1 is real * )
  ISIDREAL?                     ( symb # [id obj1 true | id false] )
  NOTcase2drop PUTOBJINASSUME
                                        ( symb # id obj1 )
  ( * remove obj1 from list * )
  SWAPDROP REMOVEFROMASSUME             ( symb # obj1 )
  
  ( * look at the assumptions on id1 * )
  DUPTYPESYMB? NOTcase2drop PUTOBJINASSUME
  ( * same type is replaced, otherwise AND is done * )
  ASSUMEREAL1 PUTOBJINASSUME
;

LABEL ASSUMEREAL1
::                                      ( symb # obj1 )
  SPLITHYPOTHESIS                       ( symb # x<hyp x>hyp )
  ROT THREE #<                          ( symb x<hyp x>hyp ?< )
  ITE SWAPDROP DROPSWAP                 ( x<hyp' x>hyp' )
  num#1=case7 DROP
  OVER jZ1=case7 SWAPDROP
  2SYMBINCOMP top& addt: xAND CKSYMBN
;


**********************************************************************
* Desc:         Reset CAS config
* Stack:        ( -->  )
**********************************************************************
NULLNAME RESETCASCFG
::
  RESETCASVAR 
  allrealflag displayflag DO
     INDEX@ DUP chooseflag #= ITE_DROP ClrSysFlag
  LOOP
  allrealflag SetSysFlag
  iflag SetSysFlag
  TWO ClrSysFlag
  THREE ClrSysFlag
ASSEMBLE
	IF 	f39
RPL
  stepflag SetSysFlag
ASSEMBLE
	ELSE	f39
RPL
  SETRAD
ASSEMBLE
	ENDIF	f39
RPL
;

