INCLUDE cas2romid.h
INCLUDE erextdec.h
INCLUDE cas2ext.h
INCLUDE keydefs.h
INCLUDE global.s

	STITLE Matrix utilities

NULLNAME EXACTMATIDN
* # -> symbolic identity natrix
::
  DUP#0<> NOT?DIMERR		( -> invalid dimension error )
				( # )
  ZEROSWAP 			( # meta )
  ZERO_DO (DO)			( meta-[] )
    ?ATTNQUIT			( meta-[] )
    Z0 INDEX@ NDUPN		( meta-[] 0..0 # )
    Z1 SWAP#1+			( meta-[] 0..01 # )
    Z0 ISTOP-INDEX #1- NDUPN	( meta-[] 0..01 # 0..0 # )
    top& []N 			( meta-[] [] )
    SWAP#1+
  LOOP
  []N
;

NULLNAME FLAGLU
::
;

******************************************************************
* Desc.:	compute the exact QR decomposition
* Stack:	M -> Q, R
* Note:		
******************************************************************
NULLNAME FLAGQR
::
  EXACT?QPI7
  DUPTYPEMATRIX? NcaseTYPEERR
  2DMATRIX? NcaseTYPEERR
  ' FLASHPTR QR TOTEMPOB CASFLAGEVAL
ASSEMBLE
	IF	f39
RPL
  TWO{}N
ASSEMBLE
	ENDIF	f39
RPL
;

LABEL EXACT?QPI7
::
ASSEMBLE
	IF	f39
RPL
  EXACT? IT QPI
ASSEMBLE
	ENDIF	f39
RPL
;

******************************************************************
* Desc.:	compute the exact QR decomposition
* Stack:	M -> Q, R
* Note:		Gram-Schmidt method is used
******************************************************************
NULLNAME QR
::
  INNERCOMP mattran			( v1..vn #n )
  ' :: SWAP COMPLEX? IT MATCONJ MATDOT SIMPLIFY ; 
  GRAMSCHMIDT				( meta-w meta-t-R {|wi|} )
  OBJ>R mattran R>OBJ			( meta-w meta-R {|wi|} )
  SWAPDUP				( meta-w r1..rn {|wi|} #n #n )
  #1+_ONE_DO (DO)			( meta-w r1..rn {|wi|} #n )
    get1 3PICK INDEX@ NTHCOMPDROP	( meta-w r2..rn {|wi|} #n r1 |wi|^2 )
    xvext MAT*SCL			( meta-w r2..rn {|wi|} #n r1*|wi| )
    UNROT				( meta-w r2..rn r1 {|wi|} #n )
  LOOP					( meta-w r1..rn {|wi|} #n )
  SWAPDROP []N 				( meta-w R )
  OBJ>R mattran []N R>OBJ		( Q R )
;

******************************************************************
* Desc.:	G-S orthonormalization
* Stack:	array, dot -> array
* Note:		
******************************************************************
NULLNAME CKGRAMSCHMIDT
::
  ' FLASHPTR USERGRAMSCHMIDT TOTEMPOB CASFLAGEVAL
;

******************************************************************
* Desc.:	G-S orthonormalization
* Stack:	array, dot -> array
* Note:		
******************************************************************
NULLNAME USERGRAMSCHMIDT
::					( array dot )
  ' ' DUP' ROT OVER			( array dot ' ' ROT ' )
  DUP' 4ROLL OVER			( array dot ' ' ROT ' ' 4ROLL ' )
  8ROLL					( array ' ' ROT ' ' 4ROLL ' dot )
  FIVE ' ::N ' ALGEVAL			( array ' ' ROT ' ' 4ROLL ' dot #5 ::N ALGEVAL )
  ' CKALG TWELVE ::N			( array ckdot )
  OBJ>R ARRAY2MATRIX			( array )
  INNERCOMP R>OBJ 			( meta-array ckdot )
  GRAMSCHMIDT				( t-meta-w t-meta-r {|wi|} )
  DROP NDROP []N			( array )
;

******************************************************************
* Desc.:	Gram-Schmidt orthonormalization
* Stack:	meta-v, dot -> t-meta-w, t-meta-r, { |wi|^2 }
* Note:		dot is used to compute scalar prod and norm
*		warning: line of t-meta-w and t-meta-r are vectors
*		R has i-th row equal to i-th element of t-meta-r
******************************************************************
NULLNAME GRAMSCHMIDT
::					( v1..vn #n dot )
  NULL{} 3PICK DUP 			( v1..vn #n dot list_norm #n obj )
  4NULLLAM{} BIND reversym		( vn..v1 #n )
* lam4=dot lam3=list_norm, lam2=length, lam1=vi
  ZERO OVER#2+UNROLL			( meta-R meta-w )
  DUP#1+ ONE_DO (DO)			( meta-R meta-w )
    GRAMSCHMIDTwi			( meta-R meta-w Ri )
    OBJ>R psh R>OBJ SWAP#1+ psh		( meta-R meta-w )
  LOOP					( meta-R wn..w1 #n )
  reversym 				( meta-R w1..wn #n )

  ( * normalize the basis w: divide wi by it's norm * )
  DUPDUP
  #1+_ONE_DO (DO)			( meta-R w1..wn #n #n )
    get1 				( meta-R w2..wn #n #n w1 )
    3GETLAM INDEX@ NTHCOMPDROP		( meta-R w2..wn #n #n w1 |w1|^2 )
    xvext CAS/			( meta-R w2..wn #n #n w1/|w1| )
    UNROT				( meta-R w2..wn w1/r11 #n #n )
  LOOP					( meta-R w1/r11..wn/rnn #n )
  DROP psh   				( w1..wn #n meta-R )
  3GETLAM ABND				( w1..wn #n meta-R {|wi|^2} )
;

LABEL GRAMSCHMIDTwi
* INDEX@ is the index
* compute next column Ri and wi of the R and Q matrices 
* wi= [ vi-sigma_{k<i} <w_k|v_i> |w_k>/|wk|^2 ]
* hence vi= sigma_{k<i} <w_k|v_i> |w_k> /|wk|^2+ wi, 
* giving the i-th col of R
( meta-v/w -> meta-v/w', Ri )
::				( meta-v/w )
  ( * extract INDEX@ vectors * )
  DROP INDEX@ ROLL 1PUTLAM	( vn..vi+1 wi-1..w1 )
  INDEX@ #1- dup		( vn..vi+1 wi-1..w1 #i-1 vi-1..v1 #i-1 )
  GRAMSCHMIDTvkvi		( vn..vi+1 wi-1..w1 #i-1 r1..ri-1 #i-1 rv )
  1GETLAM SWAP 			( vn..vi+1 wi-1..w1 #i-1 r1..ri-1 #i-1 vi rv )
  CAS- ' SIMPLIFY 
  TOTEMPOB rpnQOBJext 		( vn..vi+1 wi-1..w1 #i-1 r1..ri-1 #i-1 wi )
  DUPDUP 4GETLAM EVAL 		( vn..vi+1 wi-1..w1 #i-1 r1..ri-1 #i-1 wi |^2 )
  3GETLAM SWAP >TCOMP 3PUTLAM	( vn..vi+1 wi-1..w1 #i-1 r1..ri-1 #i-1 wi )
  Z1 UNROT			( vn..vi+1 wi-1..w1 #i-1 r1..ri-1 1 #i-1 wi )
  SWAP#1+SWAP OVER#2+UNROLL 	( vn..vi+1 wi-1..w1 #i-1 wi r1..ri #i )
  Z0 2GETLAM 3PICK #- 		( vn..vi+1 wi-1..w1 #i-1 wi r1..ri #i 0 #n-i )
  NDUPN top& []N		( vn..vi+1 wi-1..w1 #i-1 wi Ri )
  OBJ>R OVER#2+UNROLL		( vn..vi+1 wi wi-1..w1 #i-1 )
  DROP 2GETLAM R>OBJ		( vn..vi+1 wi wi-1..w1 #n Ri )
;

LABEL GRAMSCHMIDTvkvi
( vi..v1 #i -> r1..ri-1 #i sigma-rk.vk )
::				( vi..v1 #i )
  1GETLAM Z0 CAS*		( vi..v1 #i rv )
  OVER #0=?SEMI			( -> #0 0-vect )
				( vi..v1 #i rv )
  ZERO SWAPROT 			( vi..v1 meta rv #i )
  #1+_ONE_DO (DO)		( vi..v1 meta rv )
    rotomo			( vi..v2 meta rv v1 )
    DUP 1GETLAM 4GETLAM EVAL	( vi..v2 meta rv v1 v1.vi )
    3GETLAM INDEX@ NTHCOMPDROP	( vi..v2 meta rv v1 v1.vi |v1|^2 )
    CAS/			( vi..v2 meta rv v1 v1.vi/|v1|^2 )
    DUP4UNROLL CAS*		( vi..v2 meta v1.vi/ rv v1*v1.vi/ )
    CAS+			( vi..v2 meta v1.vi/ rv+v1*v1.vi/ )
    ROT #1+SWAP			( vi..v2 meta rv' )
  LOOP
				( r1..ri #i rv )
;

******************************************************************
* Desc.:	unary_op[M]
* Stack:	M unary_op/symb -> M'
* Note:		currently M must be diagonalizable, return a symb mat
******************************************************************
NULLNAME MATOP
::
  SWAP MATEGV			( unary_op mat diag )
  ROT SECOEXEC			( P unary_op[diag] )
  DUPLENCOMP  			( P unary_op[diag] # )
  DUPDUP TWO{}N 		( P unary_op[diag] # {##} )
  DUP4UNROLL MATRIXDIAG>	( P D )
  OVER MATINV			( P D P^-1 )
  MAT* MAT*
;

NULLNAME MATOPSYMB
* symb/unary_op -> unary_op
::
  DUPTYPECOL? ?SEMI
  RCLVX ' ROT ' MEVALext FOUR ::N
;

******************************************************************
* Desc.:	find isometry type
* Stack:	M -> u, theta | 
* Note:		
******************************************************************
NULLNAME CKISOMETRIE
::
  EXACT?QPI7
  ' FLASHPTR ISOMETRIE TOTEMPOB CASFLAGEVAL
ASSEMBLE
	IF	f39
RPL
  TWO{}N
ASSEMBLE
	ENDIF	f39
RPL
;

******************************************************************
* Desc.:	find isometry type
* Stack:	3-d M -> rotation {0}, +1 or { u theta } , +1  
*		         rotation and symetry {pi}, -1  or { u theta }, -1
*		         or u, -1 if theta=0
* 		2-d M -> rotation theta, +1 | symetry n, -1
*		3x4 M -> rotation and // translation { A u theta t }, +1
*		         symetry { A n }, -1
*		2x3 M -> translation v, +1 | rotation { A theta }, +1
*		         symetry { A n }, -1  
******************************************************************
NULLNAME ISOMETRIE
::
  DUP MDIMS NOT?DIMERR
					( M #n #c )
  2DUP#= NOT?DIMERR			( 2x3 and 3x4 to be handled later )
					( M #n #c=#n )
  3PICK CKORTHOGONAL NcaseTYPEERR
					( M #n #c=#n )
  DROP TWO EQUALcasedro ISOLIN2
					( M #n )
  #3= NOT?DIMERR
  ( * 3x3 isometry * )
  ( * first compute determinant * )
  ARRAY2MATRIX DUP MATDET ZSIGNE	( M +-1 )
  ( * compute axis of rotation * )
  2DUP MAT*SCL 
ASSEMBLE
	IF	f39
RPL
  DUPLENCOMP EXACTMATIDN
ASSEMBLE
	ELSE	f39
RPL
  DUP MATIDN 
ASSEMBLE
	ENDIF	f39
RPL
  MAT-		( M +-1 +-M-I )
  MATRREF				( M +-1 rref+-M-I )
  INNERCOMP 2DROP			( M +-1 l1 l2 )
  ( * if l2=0 M=+-1 * )
  DUP SIGMAxi^2 num#0=case7 ISOLIN3TRIVIAL
					( M +-1 l1 l2 |l2| )
  DROPDUP TWO NTHCOMPDROP		( M +-1 l1 l2 a22 )
  ( * if a22==0 then z must be 0 * )
  num#0=case7 ISOLIN3z=0
					( M +-1 l1 l2 a22 )
  ( * a22!=0 hence a22=1 and a11=1, z=-1, y=a23, x=a13-a23*a12 * )
  DROP THREE NTHCOMPDROP		( M +-1 l1 a23 )
  DUPROT INCOMPDROP ROTDROP		( M +-1 a23 a23 a12 a13 )
  UNROT x*ext x-ext SIMPLIFY		( M +-1 a23 a13-a23*a12 )
  SWAP Z-1 THREE []N			( M +-1 u )
  ( * u.z=-1 hence [1 0 0] is not colinear to u * )
  ONE 1LAMBIND ISOLIN3END
;

NULLNAME SIGMAxi^2
::
  INNERCOMP Z0 SWAP
  ZERO_DO (DO)
    SWAPDUP RCONJext RMULText RADDext
  LOOP
;

LABEL ISOLIN3TRIVIAL
::					( M +-1 l1 l2 0 )
  3DROP SWAPDROPDUP 			( +-1 +-1 )
  SYMACOS ONE{}N SWAP			( {pi} -1 | {0} 1 )
;

LABEL ISOLIN3z=0
::					( M +-1 l1 l2 0 )
  ( * z=0, x=-a12 and y=a11 * )
  2DROP INNERCOMP 2DROP			( M +-1 a11 a12 )
  QNeg SWAP 				( M +-1 -a12 a11 )  
  Z0 THREE []N				( M +-1 [] )
  ( * lam1 contains a coordinate # such that the #-th trivial basis vector * )
  ( * is not colinear with u. Here #3 is ok since u.z=0 * )
  THREE 1LAMBIND			( M +-1 [] )
  ISOLIN3END
;

LABEL ISOLIN3END
::					( M +-1 u )
  3PICK MATTRACE			( M +-1 u +-1+2costheta )
  3PICK x-ext Z2 x/ext SIMPLIFY		( M +-1 u costheta )
  num#-1=case7 ISOLIN3PI
  SYMACOS 				( M +-1 u |theta| )
  num#0=case7 ISOLIN30
  ( * find sign of theta = sign of det[u,e,Me] * )
  Z0 1GETLAM #1- NDUPN			( M +-1 u |theta| meta )
  Z1 SWAP#1+				( M +-1 u |theta| meta&1 )
  Z0 THREE 1GETABND #- NDUPN top& []N	( M +-1 u |theta| e )
  5ROLL OVER MAT*			( +-1 u |theta| e Me )
  4PICK THREE []N MATDET ZSIGNE	x*ext	( +-1 u theta )
  TWO{}N SWAP				( {} +-1 )
;

LABEL ISOLIN30
::					( M +-1 u |theta| )
  DROP ROTDROPSWAP			( u +-1 )
;

LABEL ISOLIN3PI
::					( M +-1 u -1 )
  DROP pi 4ROLLDROP 			( +-1 u pi )
  TWO{}N SWAP				( { u pi } +-1 )
;

LABEL ISOLIN2
::					( M )
  DUP MATDET ZSIGNE			( M +-1 )
  num#1=case7 ISOLIN2ROT
  SWAP
ASSEMBLE
	IF	f39
RPL
  DUPLENCOMP EXACTMATIDN
ASSEMBLE
	ELSE	f39
RPL
  DUP MATIDN 
ASSEMBLE
	ENDIF	f39
RPL
  MAT+					( -1 M+Id )
  XEQARRY> 3DROP 			( -1 ny -nx )
  QNeg SWAP TWO []N SWAP		( [nx ny] -1 )
;

LABEL ISOLIN2ROT
::					( M 1 )
  SWAP XEQARRY> 3DROP			( 1 cos -sin )
  ZSIGNE QNeg SWAP SYMACOS		( 1 +-1 |theta| )
  QMul SWAP				( theta 1 )
;

NULLNAME CKORTHOGONAL
* M -> flag
* check for M to be orthogonal
::					( M )
  DUP MATTRAN IMMMULT 			( M*tM )
ASSEMBLE
	IF	f39
RPL
  DUPLENCOMP EXACTMATIDN
ASSEMBLE
	ELSE	f39
RPL
  DUP MATIDN 
ASSEMBLE
	ENDIF	f39
RPL
  	 				( M*tM I )
  2DUP EQUAL case2drop TRUE		( -> flag )
					( M*tM I )
  MAT- MATFNORM TRIGext			( |M*tM-I| )
  CRUNCHNUM RCLEPS %<			( flag )
;

******************************************************************
* Desc.:	make isometry type
* Stack:	3-d M <- rotation {0}, +1 or { u theta } , +1  
*		         rotation and symetry {pi}, -1  or { u theta }, -1
* 		2-d M <- rotation theta, +1 
*		n-d M <- symetry n, -1
* 
*		3x4 M <- rotation and // translation { A u theta t }, +1
*		         symetry { A n }, -1
*		2x3 M <- translation v, +1 | rotation { A theta }, +1
*		         symetry { A n }, -1  
******************************************************************
NULLNAME MKISOMETRIE
::
  num#1=case7 MKDIRECTISO
  num#-1=case7 MKINDIRECTISO
  SETSIZEERR
;

LABEL MKINDIRECTISO
::
  SWAP				( -1 {} | -1 n )
  CK&DISPATCH1
  list MK3DCK
  arry MKnDINDIRECT
;

LABEL MKnDINDIRECT		
::				( -1 n )
  SWAPDROPDUP VECTtVECT		( n n^t*n )
  SWAP SIGMAxi^2		( n^t*n |n|^2 )
  Z2 SWAP x/ext			( n^t*n 2/|n|^2 )
  MAT*SCL			( 2*n^t*n/|n|^2 )
  DUPLENCOMP EXACTMATIDN SWAP MAT-	( M )
;

LABEL MKDIRECTISO
::
  SWAP					( 1 {} | 1 theta )
  CK&DISPATCH1
  list MK3DCK
  sym  MK2DDIRECT
;

LABEL MK3DCK	
::					( +-1 { 1 } | +-1 { n theta } )
  INNERCOMP DUP#1= case2drop :: THREE EXACTMATIDN SWAP MAT*SCL ;
  #2= NOT?DIMERR
					( +-1 n theta )
  CK&DISPATCH1
  # 4A ( arrysym ) MK3D
;

LABEL MK3D
::					( +-1 n theta )
  SWAP ARRAY2MATRIX 			( +-1 theta n )
  DUP MATFNORM MAT/SCL
  DUPINCOMP #3= NOT?DIMERR
					( +-1 theta n a b c )
  ( * make the antisymmetric part * )
  Z0 OVER QNeg 				( +-1 theta n a b c 0 -c )
  4PICK THREE []N			( +-1 theta n a b c [0 -c b] )
  SWAP Z0				( +-1 theta n a b [0 -c b] c 0 )
  5PICK QNeg THREE []N			( +-1 theta n a b [] [c 0 -a] )
  ROT QNeg 4ROLL Z0 THREE []N		( +-1 theta n [] [c 0 -a] [-b a 0] )
  THREE []N				( +-1 theta n antisym )
  3PICK SYMSIN MAT*SCL			( +-1 theta n sin*antisym )
  ( * symmetric part * )
  ROT SYMCOS 				( +-1 n sin*antisym cos )
  ROT VECTtVECT				( +-1 sin*antisym cos ut*u )
  4ROLL 3PICK x-ext MAT*SCL		( sin*antisym cos +-1-cos*ut*u )
  THREE EXACTMATIDN ROT MAT*SCL		( sin*antisym +-1-cos*ut*u cos*Id )
  MAT+ MAT+				( res )
;

LABEL MK2DDIRECT			
* 2-d rotation of angle theta
::					( +1 theta )
  SWAPDROPDUP SYMCOS SWAP SYMSIN	( cos sin )
  2DUP QNeg TWO []N			( cos sin [c -s] )
  SWAPROT TWO[]N			( [c -s] [s c] )
  TWO []N				( M )
;

******************************************************************
* Desc.:	make transposed(u)*u
* Stack:	vector -> matrix
******************************************************************
NULLNAME VECTtVECT
::
  ARRAY2MATRIX DUP 			( v v )
  ONE mattran				( v meta-v^t )
  []N SWAPONE []N			( v^t v )
  MMMULT				( v^t*v )
;

******************************************************************
* Desc.:	matrix multiplication in inner format
* Stack:	M1, M2 -> M1*M2
******************************************************************
NULLNAME IMAT*
::				( M1 M2 )
  SAMEMATRIX NOTcase 48MAT*
  TWO TOLISText MAT* 		( lvar M1*M2 )
  MATDEPTH UNROTSWAP		( # M1*M2 lvar )
  VAL2ext			( M1*M2 )
;

******************************************************************
* Desc.:	matrix division
* Stack:	M1, M2 -> M2^-1*M1
* Note:		More efficient than / for symbolic data
******************************************************************
NULLNAME IMAT/
::					( M1 M2 )
  SAMEMATRIX NOTcase 
ASSEMBLE
	IF	f39
RPL
  48MAT/
ASSEMBLE
	ELSE	f39
RPL
  FLASHPTR 48MAT/
ASSEMBLE
	ENDIF	f39
RPL
  DUP MDIMS NOT?DIMERR
					( M1 M2 #r2 #c2 )
  DUP #= NOT?DIMERR
					( M1 M2 #n )
  1LAMBIND				( M1 M2 )
  ARRAY2MATRIX INNERCOMP mattran	( M1 m21..m2n #n )
  get1 ARRAY2MATRIX			( m21..m2n #n M1 )
  2DMATRIX? DUP OBJ>R			( m21..m2n #n M1 ? )
  ITE :: INNERCOMP mattran ; ONE 	( m21..m2n #n m11..m1k #k )
  top& mattran []N 			( M2&M1 )
  MATRREF				( I&M2^-1*M1 )
  INNERCOMP mattran 			( columns of I&M2^-1*M1 )
  1GETLAM #- R>OBJ			( columns of I&M2^-1*M1 # ? )
  ITE :: mattran []N ; DROP		( meta-I' M2^-1*M1 )
  1GETABND DUPUNROT #2+UNROLL		( M2^-1*M1 meta-I )
  []N DUPLENCOMP EXACTMATIDN MAT- MATFNORM 		( M2^-1*M1 |I-I| )
  CRUNCHNUM RCLEPS %< ?SEMI		( M2^-1*M1 ? )
  BINT83 ERABLEERROR 			( not invertible )
;


******************************************************************
* Desc.:	return 0 if not a symb matrix, 
*		1 for a symb vector, 2 for a symb matrix
* Stack:	M -> M, #
******************************************************************
NULLNAME MATDEPTH
::
  DUPTYPEMATRIX? NOTcase ZERO
  2DMATRIX? case TWO ONE
;

******************************************************************
* Desc.:	symb matrix multiplication in inner format
* Stack:	M1, M2 -> M1*M2
******************************************************************
NULLNAME IMMMULT
::
  TWO BINEVAL7 MMMULT
;


******************************************************************
* Desc.:	symb matrix multiplication in inner format
* Stack:	M, v -> M*v
******************************************************************
NULLNAME IMVMULT
::
  ONE BINEVAL7 MVMULT
;

**********************************************************************
* Desc:		Like MONOEVALext but for a binary operator.
* Stack:	( o1, o2, #depth -> o1 operator o2 )
**********************************************************************
LABEL BINEVAL7
::
  UNROT TWO TOLISText
  'REVAL SWAP
  VAL2ext
;

******************************************************************
* Desc.:	kern of a linear application
* Stack:	M -> basis
******************************************************************
NULLNAME KER
::
  EXACT?QPI7
  2DMATRIX? NcaseSIZEERR
  MATRREF ARRAY2MATRIX INNERCOMP 		( meta-eq )
  OVER LENCOMP 					( meta-eq # )
  1LAMBIND THROWNULLLINES			( meta-eq )
  DUP#0=csedrp :: 1GETABND EXACTMATIDN ARRAY2MATRIX []TO{} ;
  						( meta-eq )
  DUP 1GETLAM #< 				( meta-eq ?#eq<#var )
  NOTcase :: NDROP ABND NULL{} ;
						( meta-eq )
  ( * strategy: put the matrix in a square form where * )
  ( * the first non zero elements of each row are on the diagonal * )
  ( * then a basis of the Ker is made of columns with a 0 on *)
  ( * the diagonal if the diagonal 0 is replaced by a -1 * )
  DUP OBJ>R []N ZERO R>OBJ ROT >R		( meta # )
  ZERO_DO (DO)
    ( * get the line * )
    RSWAP 'R RSWAP				( meta eq )
    ( * find it's first non-zero coeff * )
    DUPDUP ' :: DROP j#0=case7 FALSE TRUE ; POSCOMP	( meta eq #pos )
    ( * make the 0 lines with -1 on the diagonal * )
    3PICK #1+					( meta eq #pos # )
    MAKE0LINES					( meta eq meta )
    ( * add eq and add to the meta * )
    get1 SWAP#1+ top&				( meta )
  LOOP						( meta )
  ( * add final 0 lines * )
  1GETLAM #1+ OVER #1+ MAKE0LINES top&		( meta )
  mattran					( meta-basis_candidate )
  ( * keep only lines such that the diagonal element is -1 * )
  DUP #1+_ONE_DO (DO)				( v1..vn #n )
    #1- get1					( v2..vn #n-1 v1 )
    DUPINDEX@ NTHCOMPDROP			( v2..vn #n-1 v1 v11 )
    Z-1 EQUAL ITE SWAP#1+ DROP			( v2..vn #n-1 | v2..vn v1 #n )
  LOOP
  {}N ABND
;

LABEL MAKE0LINES
::						( #pos # )
  ( * just in case of numerical bad approximation * )
  2DUP#< caseSIZEERR
  ( * if #pos=#meta+1 nothing to do * )
  2DUP#= case2drop ZERO				( -> null-meta )
  ZERO UNROT					( meta #end #begin )
  DO						( meta )
    Z0 INDEX@ #1- NDUPN				( meta 0..0# )
    Z-1 SWAP#1+					( meta 0..0-1# )
    Z0 1GETLAM INDEX@ #- NDUPN 			( meta 0..0-10..0# )
    top& []N SWAP#1+				( meta )    
  LOOP
;


******************************************************************
* Desc.:	image of a linear application
* Stack:	M -> basis
******************************************************************
NULLNAME IMAGE
::
  EXACT?QPI7
  2DMATRIX? NcaseSIZEERR
  MATTRAN MATRREF ARRAY2MATRIX INNERCOMP	( meta-v )
  THROWNULLLINES {}N				( basis )
;

******************************************************************
* Desc.:	Basis of the vector space spanned by a family
* Stack:	list -> list
* Note:		
******************************************************************
NULLNAME BASIS
::
  EXACT?QPI7
  ( * numeric vectors to symbolic vectors * )
  ' ARRAY2MATRIX TOTEMPOB 
  1LAMBIND LISTSECOext ABND			( list )

  CKCOHERENTLIST
  {}TO[] 2DMATRIX? NcaseSIZEERR
						( arry )
  MATRREF ARRAY2MATRIX
  INNERCOMP THROWNULLLINES {}N
;

******************************************************************
* Desc.:	Check that all elements of list are compatible vectors/obj
* Stack:	list -> list
* Note:		
******************************************************************
NULLNAME CKCOHERENTLIST
::	
ASSEMBLE
	IF	f39
RPL				
				( []/list )
  DUPTYPELIST?
  case ::
   DUPDUP CARCOMP LENMATRIX		( []/list [] len )
   ' :: SWAP LENMATRIX #<> ; POSCOMP	( []/list #1st_time_#len<>_element )
   #0= NOT?DIMERR
  ;
  DIMS NOT?DIMERR 
  2DROP
ASSEMBLE
	ELSE	f39
RPL
  DUPDUP CARCOMP LENMATRIX		( []/list [] len )
  ' :: SWAP LENMATRIX #<> ; POSCOMP	( []/list #1st_time_#len<>_element )
  #0= NOT?DIMERR
ASSEMBLE
	ENDIF	f39
RPL
;

******************************************************************
* Desc.:	Basis of the intersect of 2 vector spaces
* Stack:	list list -> list
* Note:		
******************************************************************
NULLNAME IBASIS
::						( l1 l2 )
  SWAP EXACT?QPI7 SWAP EXACT?QPI7		( l1 l2 )
  OBJ>R DUPINCOMP				( l1 meta1 )
  R>OBJ INNERCOMP top& []N CKCOHERENTLIST	( l1 [] )
  MATTRAN KER					( l1 {} )
  DUPNULL{}? case UNROT2DROP
  ( * for each element in the basis of the ker compute el of basis of inter * )
  DUP >R LENCOMP 				( l1 # )
  SWAPOVER					( # l1 # )
  2LAMBIND					( # )
  ZERO_DO (DO)
    RSWAP 'R RSWAP				( e1..ei-1 bi )
    2GETLAM INNERCOMP get1			( e1..ei-1 l11..l1n #n bi )
    3PICK Z0 MAT*SCL ROT			( e1..ei-1 l11..l1n bi res # )
    ZERO_DO (DO)				( e1..ei-1 l11..l1k bi res )
      ROT 3PICK ISTOP-INDEX NTHCOMPDROP	  ( e1..ei-1 l11..l1k-1 bi res lk bik )
      MAT*SCL MAT+				( e1..ei-1 l11..l1k-1 bi res )
    LOOP					
    SWAPDROP					( e1..ei-1 res )
  LOOP
  1GETABND []N 
  MATRREF INNERCOMP THROWNULLLINES {}N
;

******************************************************************
* Desc.:	Add ob2 to the tail of arry1
* Stack:	arry1 ob2 -> ob
* Note:		
******************************************************************
NULLNAME AUGMENT
::
  SWAP ARRAY2MATRIX DUP MDIMS 		( ob arry [#n #m true | #n false] )
  NOTcasedrop AUGMENTVECTOR
					( ob arry #n #m )
  ( * ob must be an array * )
  SWAPDROP ROT				( arry #m ob )
  CK&DISPATCH1
  arry AUGMENTMATRIX
;

LABEL AUGMENTMATRIX
::				( arry1 #m1 arry2 )
  ARRAY2MATRIX DUP MDIMS	( arry1 #m1 arry2 #n2 #m2 true | #n2 false )
  NOTcase AUGMENTMATVECT
  SWAPDROP			(  arry1 #m1 arry2 #m2 )
  ROT #= NOT?DIMERR
  &COMP
;

LABEL AUGMENTMATVECT
::				( arry1 #m1 arry2 #n2 )
  ROT #= NOT?DIMERR
  >TCOMP
;

LABEL AUGMENTVECTOR
::					( ob vector )
  SWAP					( vector1 ob )
  CK&DISPATCH1
  real >TCOMP
  cmp  >TCOMP
  sym  >TCOMP
  arry AUGMENTVECTVECT
;

LABEL AUGMENTVECTVECT
::					( vector1 vect2 )
  ( * vector1 -> matrix1 and call again augment * )
  SWAPONE []N SWAP AUGMENT
;

******************************************************************
* Desc.:	"trim" a meta of vectors
* Stack:	meta-v -> meta-v
******************************************************************
NULLNAME THROWNULLLINES
::
  [BEGIN]
     OVER NULLVECTOR? OVER #0<> AND
  [WHILE]
     pulldrop
  [REPEAT]
;

******************************************************************
* Desc.:	system to matrix
* Stack:	S v -> M
* Note:		M v -> S is done using *
******************************************************************
NULLNAME SYST2MAT
::				( S v )
  OVER 2DMATRIX? caseSIZEERR
  TYPEMATRIX? NcaseSIZEERR
  2DMATRIX? caseSIZEERR
  DTYPEMATRIX? NcaseSIZEERR
				( S v )
  MAKESYSText			( S M v ? )
  NcaseSIZEERR
  DROPSWAPDROP			( M )
;


******************************************************************
* Desc.:	Cholesky decomp
* Stack:	M -> P / tran[P]*P=M
* Note:		Done using Sylvester
******************************************************************
NULLNAME CHOLESKY
::					( M )
  EXACTON QPI
  ' FLASHPTR CHOLESKYNOCK TOTEMPOB CASFLAGEVAL
;

NULLNAME CHOLESKYNOCK
::
  complexflag SWITCHOFF			( M )
  noswitchflag SetSysFlag
  SYLVESTER 				( D P' / M=tran[P]'*D*P' )
  SWAP' xvext TOTEMPOB 
  1LAMBIND LISTSECOext ABND		( P' sqrt[D] )
  ' MAT*SCL TOTEMPOB VBINARYOP		( sqrt[D]*P' )
  noswitchflag ClrSysFlag
; 

******************************************************************
* Desc.:	Minimal polynomial
* Stack:	M -> M'
* Note:		Done using row reduction
******************************************************************
NULLNAME PMINI
::
  EXACT?QPI7
  ARRAY2MATRIX
  DUP MDIMS NOT?DIMERR			( M #n #m )
  OVER #= NOT?DIMERR			
					( M #n )
  DUP EXACTMATIDN 3LAMBIND			( )
* lam3=M lam2=#n lam1=M^k
  1GETLAM MATEXPLODE DROP 		( m11..mnn )
  Z1 PMINn^2+1 []N
  2GETLAM
  #1+_ONE_DO (DO)				( I..M^k )
    3GETLAM 1GETLAM MAT*			( I..M^k M^k*M )
    DUP 1PUTLAM MATEXPLODE DROP			( I..M^k m11.mnn )
    RCLVX INDEX@ #>Z x^ext PMINn^2+1 []N	( I..M^k M^k+1 )
  LOOP					( I..M^n )
  2GETLAM #1+ ABND []N			( [] )
  lastcolflag TestSysFlag
  lastcolflag SetSysFlag		( [] ? )
  SWAPONE MATREFRREF SWAPDROP		( ? M )
  SWAP ?SEMI lastcolflag ClrSysFlag	( -> M )
;

LABEL PMINn^2+1
::
  2GETLAM DUP #* #1+
;

******************************************************************
* Desc.:	Equation de droite
* Stack:	cmp1 cmp2 -> equation
* Note:		show line in step by step mode
******************************************************************
NULLNAME DROITE
::
  SETCOMPLEX
  2DUP SWAP DROITECRUNCH SWAP DROITECRUNCH	( cmp1 cmp2 C% C% )
  CK&DISPATCH1
  cmpcmp DROITEOK
;

LABEL DROITECRUNCH
::
  CASCRUNCH DUPTYPEREAL? NOT?SEMI %0 %>C%
;

LABEL DROITEOK
::					( cmp1 cmp2 C%1 C%2 )
  2DUP EQUALcase :: BINT92 ERABLEERROR ;
  ( * first draw the segment * )
ASSEMBLE
	IF	f39
RPL
  2DROP
ASSEMBLE
	ELSE	f39
RPL
  stepflag SysITE :: DOERASE DODRAX LINEC% ; 2DROP	( cmp1 cmp2 )
ASSEMBLE
	ENDIF	f39
RPL
  OVER 2SYMBINCOMP MetaSub		( cmp1 meta-A-B )
  dup xSYMIM psh xSYMRE			( cmp1 im re )
  ( * look for x=cst line * )
  OVER j#0=case7 DROITEX
					( cmp1 im re )
  MetaDiv get1				( pente cmp1 )
  DUP OBJ>R RCLVX TOTEMPOB SWAP SYMBINCOMP	( pente x cmp1-meta )
  xSYMRE #1+ addt: x-			( pente x-cmp1-meta )
  MetaMul R>OBJ				( pente*[x-x0] cmp1 )
  SYMBINCOMP xSYMIM MetaAdd ' ID Y TOTEMPOB	( equ-meta y )
  OVER#2+UNROLL #1+ addt: x=		( y=equ )
  DROITEEND
;

LABEL DROITEEND
::					( y=equ-meta )
  CKSYMBN				( y=equ )
ASSEMBLE
	IF	f39
RPL
ASSEMBLE
	ELSE	f39
RPL
  stepflag TestSysFlag NOT?SEMI
  ( * add equ grob to the current grob and display * )
  GBUFF OVER XGROBext GROBADDext 
  SCROLLext
ASSEMBLE
	ENDIF	f39
RPL
;

LABEL DROITEX
::					( cmp1 im 0-meta )
  2DROP NDROP				( cmp1 )
  ' ID x SWAP SYMBINCOMP xSYMRE		( x re )
  #1+ addt: x= 				( x=equ-meta )
  DROITEEND
;

