**miscdoc+*******************************************^******
************************************************************
**
** File:    InputForm.h Version 1.25, 05/04/93
** Machine: Alcuin
**
** Input Form macros and equates
**
************************************************************
**+miscdoc**************************************************

**
** Input form event messages:
**
DEFINE IFM_DISPTITLE		ONE
DEFINE IFM_SETTITLEGROB	   	TWO
DEFINE IFM_SETTITLEDECOMP	THREE
DEFINE IFM_DISPCLIENT	    	FOUR
DEFINE IFM_SETCLIENTBACK	FIVE
DEFINE IFM_DISPLABEL		SIX
DEFINE IFM_DISPFIELD		SEVEN
DEFINE IFM_SETIFKEYOB	   	EIGHT
DEFINE IFM_SETFGROB	   	NINE
DEFINE IFM_SETFDECOMP	   	TEN
DEFINE IFM_DISPHELP		ELEVEN
DEFINE IFM_SETHELPGROB	   	TWELVE
DEFINE IFM_SETHELPDECOMP	THIRTEEN
DEFINE IFM_SETINITFOCUSFID	FOURTEEN
DEFINE IFM_SETINPFORMMENU	FIFTEEN
DEFINE IFM_SETAPPMENUKEYS	SIXTEEN
DEFINE IFM_POSTCREATE		SEVENTEEN
DEFINE IFM_SETKEYOB	   	EIGHTEEN
DEFINE IFM_LOSTFOCUS	 	NINETEEN
DEFINE IFM_GOTFOCUS	 	TWENTY
DEFINE IFM_UNSHOWSEL		TWENTYONE
DEFINE IFM_SHOWSEL		TWENTYTWO
DEFINE IFM_EDITFIELD	 	TWENTYTHREE
DEFINE IFM_PREPARSE	 	TWENTYFOUR
DEFINE IFM_POSTPARSE	   	TWENTYFIVE
DEFINE IFM_CHOOSE	 	TWENTYSIX
DEFINE IFM_CHECK	  	TWENTYSEVEN
DEFINE IFM_QUIT		 	TWENTYEIGHT
DEFINE IFM_DONE		 	TWENTYNINE
DEFINE IFM_CALC	   	  	THIRTY
DEFINE IFM_RESET	    	THIRTYONE
DEFINE IFM_SETRESETCHOICES	THIRTYTWO
DEFINE IFM_RESETFIELD	   	THIRTYTHREE
DEFINE IFM_RESETALL	    	THIRTYFOUR
DEFINE IFM_DISPOBTYPES	   	THIRTYFIVE
DEFINE IFM_SETOBTYPEDESCS    	THIRTYSIX
DEFINE IFM_GETCHOICE	   	THIRTYSEVEN
DEFINE IFM_CHOOSENEXT	  	THIRTYEIGHT
DEFINE IFM_CHOOSEBYCHR	 	THIRTYNINE
DEFINE IFM_SETCHOICES	 	FORTY
DEFINE IFM_SETUSERVALUE		FORTYONE
DEFINE IFM_SETEDLINEMENU    	FORTYTWO
DEFINE IFM_SETAPPEDLMENUKEYS	FORTYTHREE
DEFINE IFM_ENDEDIT&STO	    	FORTYFOUR
DEFINE IFM_CHKOBTYPE	   	FORTYFIVE
DEFINE IFM_CHKOBVALUE	   	FORTYSIX
DEFINE IFM_POSTCHANGE		FORTYSEVEN
DEFINE IFM_SETDOWNFID	   	FORTYEIGHT
DEFINE IFM_SETUPFID	   	FORTYNINE
DEFINE IFM_SETFARDOWNFID	FIFTY
DEFINE IFM_SETFARUPFID		FIFTYONE
DEFINE IFM_SETNEXTFID		FIFTYTWO
DEFINE IFM_SETPREVFID		FIFTYTHREE
DEFINE IFM_SETNEXTFOCUSFID   	FIFTYFOUR
DEFINE IFM_SETFOCUSOK?	   	FIFTYFIVE
DEFINE IFM_POSTDONE	   	FIFTYSIX

** 
** Input form display area management:
**
** Title=DA1 Client=DA2a Help=DA2b(no edit) Edit=DA2b(edit) Menu=DA3
**
DEFINE TitleOK?		DA1OK?
DEFINE ClientOK?	:: DA2aOK? DA2aLess1OK? ClrNewEditL OR ;
DEFINE EditOK?		:: NoEditLine? caseTRUE   DA2bOK? ;
DEFINE HelpOK?		:: EditLExists? caseTRUE  DA2bOK? ;
DEFINE MenuOK?		DA3OK?
DEFINE HelpTemp?	DA2bTemp?
DEFINE ClientBad?	DA2aBad?
DEFINE HelpBad?		DA2bBad?
DEFINE SetTValid	SetDA1Valid
DEFINE SetCValid	SetDA2aValid
DEFINE SetEValid	SetDA2bValid
DEFINE SetHValid	SetDA2bValid
DEFINE SetMValid	SetDA3Valid
DEFINE SetTNoCh		SetDA1NoCh
DEFINE SetCNoCh		SetDA2aNoCh
DEFINE SetENoCh		SetDA2bNoCh
DEFINE SetHNoCh		SetDA2bNoCh
DEFINE SetMNoCh		SetDA3NoCh
DEFINE SetCTemp		SetDA2aTemp
DEFINE SetETemp		SetDA2bTemp
DEFINE SetHTemp		SetDA2bTemp
DEFINE SetTBad		SetDA1Bad
DEFINE SetCBad		SetDA2aBad
DEFINE SetEBad		SetDA2bBad
DEFINE SetHBad		SetDA2bBad
DEFINE SetMBad		SetDA3Bad
**
DEFINE SetTCEMNoCh	:: SetTNoCh SetCNoCh SetENoCh SetMNoCh ;
DEFINE SetTCENoCh	:: SetTNoCh SetCNoCh SetENoCh ;
DEFINE SetTCHNoCh	:: SetTNoCh SetCNoCh SetHNoCh ;
DEFINE SetTCMNoCh	:: SetTNoCh SetCNoCh SetMNoCh ;
DEFINE SetTCNoCh	:: SetTNoCh SetCNoCh ;
DEFINE SetCMNoCh	:: SetCNoCh SetMNoCh ;
DEFINE SetTMNoCh	:: SetTNoCh SetMNoCh ;
DEFINE SetTHMNoCh	:: SetTNoCh SetHNoCh SetMNoCh ;
DEFINE SetAllNoCh	SetDAsNoCh
DEFINE SetCHMBad	:: SetCBad SetHBad SetMBad ;
DEFINE ClrAllOK		ClrDAsOK


**
** Input form field types:
**
DEFINE FTYPE_NA		ZERO

DEFINE FTYPE_TEXT	ONE
DEFINE FTYPE_TTAUTOALG  TWO
DEFINE FTYPE_ALGTEXT    THREE

DEFINE FTYPE_LIST	FOUR
DEFINE FTYPE_LTFIXED	EIGHT
DEFINE FTYPE_LTMEMOB	SIXTEEN
DEFINE FTYPE_FIXEDLIST	TWELVE
DEFINE FTYPE_MEMOBLIST	TWENTY

DEFINE FTYPE_CHECK	THIRTYTWO

DEFINE FTYPE_AT		THREE
DEFINE FTYPE_TL		FIVE
DEFINE FTYPE_ATL	SEVEN
DEFINE FTYPE_TFL	THIRTEEN
DEFINE FTYPE_TML	TWENTYONE
DEFINE FTYPE_ATML	TWENTYTHREE

DEFINE FTYPE_TLC	THIRTYSEVEN  ( for internal use only )

**
** Input form object types:
**
DEFINE OBTYPE_NA	MINUSONE

DEFINE OBTYPE_ANY	MINUSONE

DEFINE OBTYPE_REAL	ZERO
DEFINE OBTYPE_CMP	ONE
DEFINE OBTYPE_STR	TWO
DEFINE OBTYPE_RARRAY	THREE
DEFINE OBTYPE_CARRAY	FOUR
DEFINE OBTYPE_LIST	FIVE
DEFINE OBTYPE_ID	SIX
DEFINE OBTYPE_USERPRGM	EIGHT
DEFINE OBTYPE_SYMB	NINE
DEFINE OBTYPE_HXS	TEN
DEFINE OBTYPE_UNIT	THIRTEEN

**
** Input form decompile formats:
**
DEFINE FMT_NA		MINUSONE
DEFINE FMT_NONE		ONE
DEFINE FMT_DFLT		TWO
DEFINE FMT_STD		FOUR

DEFINE FMT_1STCHAR	EIGHT

DEFINE FMT_PART1	SIXTEEN
DEFINE FMT_PART2	THIRTYTWO

DEFINE FMT_NONE&1STCH	NINE
DEFINE FMT_P1&NONE	SEVENTEEN
DEFINE FMT_P1&DFLT	EIGHTEEN
DEFINE FMT_P1&STD	TWENTY
DEFINE FMT_P2&NONE	THIRTYTHREE
DEFINE FMT_P2&DFLT	THIRTYFOUR
DEFINE FMT_P2&STD	THIRTYSIX
DEFINE FMT_P1&NONE&1STCH  TWENTYFIVE

**
** Input form label and field standard rows and columns:
**
DEFINE LROW1		TEN
DEFINE LROW2		NINETEEN
DEFINE LROW3		TWENTYEIGHT
DEFINE LROW4		THIRTYSEVEN
DEFINE LROW5		FORTYSIX

DEFINE FROW1		EIGHT
DEFINE FROW2		SEVENTEEN
DEFINE FROW3		TWENTYSIX
DEFINE FROW4		THIRTYFIVE
DEFINE FROW5		FORTYFOUR

DEFINE COL1		ONE
DEFINE COL1+C		EIGHT
DEFINE COL1.5		FOUR
DEFINE COL1.5+C		ELEVEN
DEFINE COL2		SEVEN
DEFINE COL2+C		FOURTEEN
DEFINE COL2.5		TEN
DEFINE COL3		THIRTEEN
DEFINE COL3.5		SIXTEEN
DEFINE COL4		NINETEEN
DEFINE COL4.5		TWENTYTWO
DEFINE COL4.5+C		TWENTYNINE
DEFINE COL5		TWENTYFIVE
DEFINE COL5+C		THIRTYTWO
DEFINE COL5.5		TWENTYEIGHT
DEFINE COL6		THIRTYONE
DEFINE COL6.5		THIRTYFOUR
DEFINE COL7		THIRTYSEVEN
DEFINE COL7.5		FORTY
DEFINE COL7.5+C		FORTYSEVEN
DEFINE COL8		FORTYTHREE
DEFINE COL8+C		FIFTY
DEFINE COL8.5		FORTYSIX
DEFINE COL9		FORTYNINE
DEFINE COL9+C		FIFTYSIX
DEFINE COL9.5		FIFTYTWO
DEFINE COL10		FIFTYFIVE
DEFINE COL10+C		SIXTYTWO
DEFINE COL10.5		FIFTYEIGHT
DEFINE COL11		SIXTYONE
DEFINE COL11.5		SIXTYFOUR
DEFINE COL11.5+C	71
DEFINE COL12		FOURTHREE ( decimal 67 )
DEFINE COL12+C		SEVENTYFOUR
DEFINE COL12.5		SEVENTY
DEFINE COL13		73
DEFINE COL13+C		EIGHTY
DEFINE COL13.5		76
DEFINE COL14		SEVENTYNINE
DEFINE COL14+C		FIVESIX ( decimal 86 )
DEFINE COL14.5		LISTCMP ( decimal 82 )
DEFINE COL15		2LIST ( decimal 85 )
DEFINE COL15+C		92
DEFINE COL15.5		88
DEFINE COL15.5+C	95
DEFINE COL16		BINT_91d
DEFINE COL16+C		NINETYEIGHT
DEFINE COL16.5		94
DEFINE COL16.5+C	SIXFIVE ( decimal 101 )
DEFINE COL17		IDREAL ( decimal 97 )
DEFINE COL17+C		104
DEFINE COL17.5		IDARRY ( decimal 100 )
DEFINE COL17.5+C	107
DEFINE COL18		103
DEFINE COL18+C		110
DEFINE COL18.5		106
DEFINE COL18.5+C	LAMREAL ( decimal 113 )
DEFINE COL19		109
DEFINE COL19+C		BINT_116d
DEFINE COL19.5		lamany ( decimal 112 )
DEFINE COL19.5+C	119
DEFINE COL20		BINT_115d
DEFINE COL20+C		BINT_122d
DEFINE COL20.5		118
DEFINE COL21		121
DEFINE COL21.5		124
DEFINE COL22		127

**
** Input form standard field widths and heights:
**
DEFINE FWIDTH_C		SIX ( check width )
DEFINE CHECK_WIDTH+1	SEVEN
DEFINE FWIDTH_CHR	SIX ( field character width )

DEFINE FWIDTH1		SEVEN
DEFINE FWIDTH2		THIRTEEN
DEFINE FWIDTH3		NINETEEN
DEFINE FWIDTH4		TWENTYFIVE
DEFINE FWIDTH5		THIRTYONE
DEFINE FWIDTH6		THIRTYSEVEN
DEFINE FWIDTH7		FORTYTHREE
DEFINE FWIDTH8		FORTYNINE
DEFINE FWIDTH9		FIFTYFIVE
DEFINE FWIDTH10		SIXTYONE
DEFINE FWIDTH11		FOURTHREE ( decimal 67 )
DEFINE FWIDTH12		73
DEFINE FWIDTH13		SEVENTYNINE
DEFINE FWIDTH14		2LIST ( decimal 85 )
DEFINE FWIDTH15		BINT_91d
DEFINE FWIDTH16		IDREAL ( decimal 97 )
DEFINE FWIDTH17		103
DEFINE FWIDTH18		109
DEFINE FWIDTH19		BINT_115d
DEFINE FWIDTH20		121
DEFINE FWIDTH21		127

DEFINE FHEIGHT1		NINE
DEFINE FHEIGHT2		EIGHTEEN


**
** Input form display area metrics:
**
DEFINE HELP_AREA_TOP	FORTYSIX
DEFINE HELP_MSG_TOP	FIFTY
DEFINE HELP_BOTTOM	FIFTYFIVE
DEFINE HELP_HEIGHT	TEN

DEFINE CLIENT_TOP	SEVEN
DEFINE CLIENT_TOP+1	EIGHT
DEFINE CLIENT_HEIGHT	THIRTYNINE


**
** Miscellany:
**
DEFINE NULL		MINUSONE

DEFINE FVAL_NA		MINUSONE
DEFINE FVAL_NULL	MINUSONE
DEFINE FVALS_NULL	MINUSONE

DEFINE CHOICES_NULL	MINUSONE

DEFINE ID_NULL		MINUSONE

DEFINE OPTDATA_NULL	MINUSONE


*************************************************************************
*	
*	Simple DEFINEs to GETLAMs and PUTLAMs
*	
*************************************************************************

DEFINE GetTotalCount		1GETLAM
DEFINE GetFieldOffset		2GETLAM
DEFINE GetLabelOffset		3GETLAM
DEFINE GetMyFieldId		4GETLAM
DEFINE GetFocus			5GETLAM
DEFINE GetIFKeyOb		6GETLAM
DEFINE GetIFMenuRow		7GETLAM
DEFINE GetIFMenu		8GETLAM
DEFINE GetFAreaStates		9GETLAM
DEFINE GetClientBack		10GETLAM
DEFINE GetIFExit		11GETLAM
*
DEFINE GetFormProc		13GETLAM
DEFINE GetFieldCount		14GETLAM
DEFINE GetLabelCount		15GETLAM

DEFINE SetTotalCount		1PUTLAM
DEFINE SetFieldOffset		2PUTLAM
DEFINE SetLabelOffset		3PUTLAM
DEFINE SetMyFieldId		4PUTLAM
DEFINE SetFocus			5PUTLAM
DEFINE SetIFKeyOb		6PUTLAM
DEFINE SetIFMenuRow		7PUTLAM
DEFINE SetIFMenu		8PUTLAM
DEFINE SetFAreaStates		9PUTLAM
DEFINE SetClientBack		10PUTLAM
DEFINE SetIFExit		11PUTLAM
DEFINE SetTitle			12PUTLAM
DEFINE SetFormProc		13PUTLAM
DEFINE SetFieldCount		14PUTLAM
DEFINE SetLabelCount		15PUTLAM

*************************************************************************
*	
*	DEFINEs for secondaries with crunched names.
*	
*************************************************************************

DEFINE GetTitle			gFormTitle

DEFINE GetLabelText		gLblText
DEFINE GetLabelCol		gLblCol
DEFINE GetLabelRow		gLblRow
DEFINE GetLabelLoc		gLblLoc
DEFINE SetLabelText		sLblText
DEFINE SetLabelCol		sLblCol
DEFINE SetLabelRow		sLblRow
DEFINE SetLabelLoc		sLblLoc
DEFINE GetFieldProc		gFldProc
DEFINE GetFieldCol		gFldCol
DEFINE GetFieldRow		gFldRow
DEFINE GetFieldWidth		gFldWidth
DEFINE GetFieldHeight		gFldHeight
DEFINE GetFieldType		gFldType
DEFINE GetFieldObTypes		gFldObTypes
DEFINE GetFieldFormat		gFldFormat
DEFINE GetFieldHelp		gFldHelp
DEFINE GetFieldOptData1		gFldOptDat1
DEFINE GetFieldOptData2		gFldOptDat2
DEFINE GetFieldResetVal		gFldResetVal
DEFINE GetFieldVal		gFldVal
DEFINE GetFieldLoc		gFldLoc
DEFINE GetFieldSize		gFldSize
DEFINE SetFieldProc		sFldProc
DEFINE SetFieldCol		sFldCol
DEFINE SetFieldRow		sFldRow
DEFINE SetFieldWidth		sFldWidth
DEFINE SetFieldHeight		sFldHeight
DEFINE SetFieldType		sFldType
DEFINE SetFieldObTypes		sFldObTypes
DEFINE SetFieldFormat		sFldFormat
DEFINE SetFieldHelp		sFldHelp
DEFINE SetFieldOptData1		sFldOptDat1
DEFINE SetFieldOptData2		sFldOptDat2
DEFINE SetFieldResetVal		sFldResetVal
DEFINE SetFieldVal		sFldVal
DEFINE SetFieldLoc		sFldLoc
DEFINE SetFieldSize		sFldSize
