#include <stdio.h>
#include <strings.h>

void adds(char *s, char *s2)
{ strcat(s, s2); strcat(s, " "); }

char *find2(char *s, char *Token, char *Output, char *deph, int newline)
{
  char *p, *p2= NULL, ts[100];
  p= strstr(s, Token);
  if (p!=0)
  {
    p= p+strlen(Token);
    while (*p!=0 && *p<=' ') p++;
    p2= p;
    while (*p!=0 && *p>' ') p++;
    *p= 0;
    if (newline)
      sprintf(ts, " \\\n\t%s/%s", deph, p2);
    else
    {
      if (deph==NULL && p2[0]=='.' && p2[1]=='.' && p2[2]=='/') 
        sprintf(ts, "%s ", p2+3);
      else
        sprintf(ts, "%s/%s ", deph, p2);
    }
    strcat(Output, ts);
  }
  return(p2);
}

int readmain2(FILE *out, char *sloadfile, char *preout, char *prein, char *outfilename, char *extradep, int head, char *make)
{  
  FILE *in;
  char Output[10000]="", Input[10000]="",
       otherdepths[1000]= "", libs[1000]="";

  if ((in= fopen(sloadfile, "r"))==NULL) return(0);

  while (!feof(in))
  {
    char s[256];
    fgets(s, sizeof(s), in);
    if (find2(s, "OUTPUT", Output, NULL, 0) ||
        find2(s, "LLIST", Output, prein, 0) ||
        find2(s, "SEARCH", Input, prein, 1) ||
        find2(s, "REL", Input, prein, 1) || (!head) ||
        find2(s, "ROMPHEAD", libs, prein, 0) ||
        find2(s, "TABLE", libs, prein, 0) || 
        find2(s, "FINISH", libs, prein, 0));
  }
  fclose(in);
  
  if (head)
  {
    char *p;
    while ((p=strstr(libs, ".a"))!=0) p[1]='o';
    fprintf(out, "#from file: %s\n"
                 "%s: %s\n"
                 "%s: %s %s \\\n\t%s \\\n"
                 "\t%s\n\n", 
                  sloadfile,
                  extradep, Input,
                  Output, make, Input, extradep, libs);
  }
  else
    fprintf(out, "#from file: %s\n"
                 "%s: %s %s \\\n\t%s\n\n", sloadfile, Output, make, Input, extradep);
  
  return(1);
}

char *find(char *s, char *Token, char *ROMOutput, char *NOROMOutput, int InRom, int NInRom, int newline)
{
  char *p, *p2= NULL, ts[100];
  p= strstr(s, Token);
  if (p!=0)
  {
    p= p+strlen(Token);
    while (*p!=0 && *p<=' ') p++;
    p2= p;
    while (*p!=0 && *p>' ') p++;
    *p= 0;
    if (newline)
      sprintf(ts, " \\\n\t%s", p2);
    else
      sprintf(ts, "%s ", p2);
    if (InRom)  strcat(ROMOutput, ts);
    if (NInRom) strcat(NOROMOutput, ts);
  }
  return(p2);
}

int readmain(FILE *out, char *sloadfile, char *preout, char *outfilename)
{  
  FILE *in;
  char ROMOutput[10000]="", ROMInput[10000]="", 
       NOROMOutput[10000]="", NOROMInput[10000]="",
       Dirs[10000]= "DIRS += ",
       otherdepths[10000]= "", Include[10000]="";

  if ((in= fopen(sloadfile, "r"))==NULL) return(1);

  while (!feof(in))
  {
    char s[256];
    char *d;
    int InRom= 1, NInRom= 1;

    fgets(s, sizeof(s), in);

    if (strstr(s, "IF NOT ROM")!=0) InRom= 0;
     if (strstr(s, "IF ROM")!=0)     NInRom= 0;

    if (!(find(s, "OUTPUT", ROMOutput, NOROMOutput, InRom, NInRom, 0) ||
          find(s, "LLIST", ROMOutput, NOROMOutput, InRom, NInRom, 0) ||
          find(s, "SEARCH", ROMInput, NOROMInput, InRom, NInRom, 1)))
      if (d= find(s, "REL", ROMInput, NOROMInput, InRom, NInRom, 1))
      {
        char *p;
        char s1[200], s2[200], s3[200];
        FILE *t;
        while ((p= strstr(d, "/"))!=NULL) d= p+1;
        if ((p=strstr(d,"."))!=NULL) *p= 0;

        sprintf(s3, "%s/Makefile", d);
        t= fopen(s3, "r");
        if (t!=NULL) { adds(Include, s3); fclose(t); } else s3[0]= 0;

        sprintf(s1, "%s/sload.nn", d);
        sprintf(s2, "%s/sload.n", d);
        if (readmain2(out, s1, preout, d, outfilename, s2, 1, s3))
          adds(otherdepths, s1);
        else
          if (readmain2(out, s2, preout, d, outfilename, s2, 0, s3))
            adds(otherdepths, s2);
          else
            return(1);
  
        adds(Dirs, d);
      }
  }
  fclose(in);

  fprintf(out, "#from file: %s\n", sloadfile);
  fprintf(out, "%s: %s %s\n\n", ROMOutput, sloadfile, ROMInput);
  fprintf(out, "%s: %s %s\n\n", NOROMOutput, sloadfile, NOROMInput);
  fprintf(out, "%s: %s %s\n", outfilename, sloadfile, otherdepths);  
  if (strlen(Include)!=0) fprintf(out, "include %s\n", Include);
  fprintf(out, "%s\n\n", Dirs);
  fprintf(out, "CLEANFILES += %s\n", ROMOutput);
  
  return(0);
}

int main(int argc, char **argv)
{
  FILE *out;
  if (argc!=4)
  {
    fprintf(stderr, "%s: generate dependency file from a top level sload file\n"
                    "usage: %s outfile (stdout) sload_File objdir dependency_header otherdeps", argv[0], argv[0]);
    return(1);
  }

  if ((out= (strcmp(argv[1], "stdout")==0)?stdout:fopen(argv[1], "w"))==NULL) return(1);

  readmain(out, argv[2], argv[3], argv[1]);
  fclose(out);
  return(0);
}
